/*->c.new */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "transform.h"

#include "err.h"
#include "fsx.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "bf.h"
#include "etc.h"
#include "deb.h"


#include "constants.h"
#include "str.h"
#include "reslink.h"

#include "obj.h"

#include "object.h"
#include "chain.h"

#include "main.h"
#include "file.h"
#include "view.h"
#include "viewo.h"
#include "viewr.h"
#include "xcolour.h"

#include "xprint.h"


#include "undo.h"
#include "frameflow.h"


#include "txstr.h"
#include "txprivate.h"
#include "fl.h"


#include "style.h"
#include "pref.h"

#include "dscript.h"

#include "page.h"
#include "xpage.h"
#include "mpage.h"
#include "section.h"
#include "select.h"

#include "new.h"
#include "newx.h"
#include "dbnew.h"
#include "modchap.h"
#include "chsect.h"


#include "text.h"





/* create a map for master section, use data in doc section */
/* master section map is definitve                          */

os_error * createsectionmap(int ndsection,int nmsection,
                                                 int undo,filestr * file)
{
 newmapstr newmap;

 newmap.dsection=ndsection;
 newmap.msection=nmsection;
 newmap.undo=undo;

 return(event(EVENT_CREATESECTIONMAP,file,(int)&newmap));
}



/* copy map for master section to doc section */
/* use to discard unused sources              */

os_error * updatesectionmap(int ndsection,int nmsection,
                                                 int undo,filestr * file)
{
 newmapstr newmap;

 newmap.dsection=ndsection;
 newmap.msection=nmsection;
 newmap.undo=undo;

 return(event(EVENT_UPDATESECTIONMAP,file,(int)&newmap));
}





static os_error * createtextbox(objectloc * loc,curvestr * c,
                                                newstr * xnew,int hand)
{
 unpackedtextdatastr textdata;

 textdata=deflttextdata;
 textdata.columns=xnew->columns[hand];
 textdata.columndata=xnew->columndata[hand];
 textdata.header=xnew->headermargin[hand];
 textdata.footer=xnew->footermargin[hand];

 textdata.repeat=1;

 return(createtexts(loc,c,&textdata,&deflttextflow));
}


/* loc gives object,page,section, of a principle frame  */
/* we also fix up dual section, but assume this is null */
/* if it does not exist                                 */


os_error * setupmainframe(objectloc * loc)
{
 os_error   * err;
 filestr    * file;
 sectionstr * sectionp;
 pagestr    * pagep;
 int          dual;
 int          hand;


 file=loc->file;

 pagep=(pagestr*)fob_find(loc->page,file);

 if(pagep->chain.prev) hand=1;
 else                  hand=0;

 err=fob_mod(loc->section,file,(fobjptr)&sectionp);
 sectionp->data.mainkey[hand]=loc->object;

 dual=sectionp->dual;
 if(dual)
 {
  err=fob_mod(dual,file,(fobjptr)&sectionp);
  sectionp->data.mainkey[hand]=loc->object;
 }

 return(err);
}



os_error * createpageboxes(objectloc * loc,newstr * xnew,int hand)
{
 os_error * err;
 curvestr   fcurve;
 int        mainheight;

 fcurve.type=CBOX;
 fcurve.box.x=xnew->leftmargin[hand];
 fcurve.box.w=xnew->sectiondata.width-xnew->leftmargin[hand]-
                                     xnew->rightmargin[hand];

 fcurve.box.y=xnew->topmargin[hand];
 fcurve.box.h=mainheight=xnew->sectiondata.height-xnew->topmargin[hand]-
                                                 xnew->botmargin[hand];

 err=createtextbox(loc,&fcurve,xnew,hand);

 xnew->sectiondata.mainkey[hand]=loc->object;

 return(err);
}





/* create a new section in master branch */

static os_error * newmastersection(filestr * file,newstr * xnew)
{
 os_error   * err;
 objectloc    loc;
 sectionstr * section;
 pagestr    * page;
 int          leftpage;
 int          leftbox;
 newpagestr   newpage;


 leftbox=0;  /* compiler */


 memset(&loc,0,sizeof(objectloc));
 loc.file=file;
 loc.branch=1;


 err=objectnew(&loc,OSECTION,&xnew->sectiondata);
 if(!err)
 {
  file->hdr.section[MST]=loc.object;  /* link here */

  file->hdr.ns[MST]=1;                /* maybe not init var */
  file->hdr.maxpagewidth[MST]=xnew->sectiondata.width;
  file->hdr.maxpageheight[MST]=xnew->sectiondata.height;

  loc.section=loc.object;

  newpage.pagenumber=0;  /* left hand page */
  newpage.data=xnew->sectiondata;

  err=objectnew(&loc,OPAGE,&newpage);
  loc.page=loc.object;

  file->hdr.np[MST]++;

  section=(sectionstr*)fob_find(loc.section,file);
  section->chain.child=loc.page;
  section->np++;

  page=(pagestr*)fob_find(loc.page,file);
  page->section=loc.section;

  loc.after=0;
  leftpage=loc.parent=loc.page;
  loc.chain=0;
  loc.copymode=LOCNEW;

  if(xnew->principleframe[0])
  {
   frflstart(file);
   err=createpageboxes(&loc,xnew,0);
   setupmainframe(&loc);
   leftbox=loc.object;
   frflend(file);
  }

  if(!err && xnew->sectiondata.dble)
  {
   newpage.pagenumber=1;  /* right hand page */

   err=objectnew(&loc,OPAGE,&newpage);
   if(!err)
   {
    loc.page=loc.object;

    file->hdr.np[MST]++;

    section=(sectionstr*)fob_find(loc.section,file);
    section->np++;

    page=(pagestr*)fob_find(loc.page,file);
    page->section=loc.section;

    page->chain.prev=leftpage;

    page=(pagestr*)fob_find(leftpage,file);
    page->chain.next=loc.page;

    loc.parent=loc.page;
    loc.copymode=LOCNEW;     /* new source created */

    if(xnew->principleframe[1])
    {
     frflstart(file);
     err=createpageboxes(&loc,xnew,1);
     setupmainframe(&loc);
     textlink(leftbox,loc.object,file); /* remove it here */
     frflend(file);
    }
   }
  }

  if(!err) err=flowvalidsection(loc.section,file);
 }
 return(err);
}



/* mst is a master section */
/* doc is a new section    */

static os_error * makedocumentsectionfrommaster(filestr * file,int mst,int doc)
{
 os_error     * err;
 objectloc      src;
 objectloc      dest;
 sectionstr   * section;
 pagestr      * page;
 newpagestr     newpage;
 transformstr   tr;
 int            np;
 int            dble;
 int            pagek;
 int            left;
 int            message;
	int            omit;


/* dprintf(6,"makedocumentsectionfrommaster"); */

 /* sort out starting page number and copy correct page */

 section=(sectionstr*)fob_find(doc,file);
 left=section->data.pagenumber.left;  /* left hand page */

 /* hmm first chapter need not have start set true... */

 if(section->data.pagenumber.start) np=section->data.pagenumber.number;
 else
 if(!section->chain.prev) np=1;

 else
 {
  section=(sectionstr*)fob_find(section->chain.prev,file);
  np=section->np;
  page=(pagestr*)fob_find(section->chain.child,file);
  np+=page->data.number;
 }


 createsectionmap(doc,mst,0,file);

 section=(sectionstr*)fob_find(mst,file);
 newpage.data=section->data;
 newpage.pagenumber=np; 
 section->data.pagenumber.number=np;

 dest.file=file;
 dest.section=doc;
 dest.page=0;
 dest.branch=0;
 dest.object=0;

 err=objectnew(&dest,OPAGE,&newpage);

 section=(sectionstr*)fob_find(doc,file);
 section->chain.child=dest.object;
 section->np=1;
 section->data.pagenumber.number=np;


 file->hdr.np[DOC]++;

 section=(sectionstr*)fob_find(mst,file);

 src.file=file;
 src.section=mst;

 pagek=section->chain.child;
 dble=section->data.dble;
	omit=section->data.pagenumber.omitfooter || section->data.pagenumber.omitheader;

 if(dble)
 {
  if(!left)
  {
   page=(pagestr*)fob_find(pagek,file);
   pagek=page->chain.next;
  }
 }

 src.page=pagek;

 src.branch=1;
 src.object=src.page;
 src.parent=src.page;
 src.after=0;
 src.chain=0;

 section=(sectionstr*)fob_find(doc,file);

 dest.file=file;
 dest.section=doc;
 dest.page=section->chain.child;
 dest.branch=0;
 dest.object=0;
 dest.parent=dest.page;
 dest.after=0;
 dest.chain=0;
 dest.copymode=LOCNEW|LOCFLOWDATA;

 tr_setidentity(&tr);

/* frflstart(file); */

 err=objectcopy(&src,&dest,&tr);

/* frflend(file); */

 updatesectionmap(doc,mst,0,file);

 relinkpage(dest.page,doc,file);

 if(dble && !left)
 {
  message=OM_REFLOW;
  objectchainmessage(dest.page,file,&message,
                      (void*)(TXREFLOWZERO|FLDELTA));

  flowvalidsection(dest.section,file);
 }

 if(omit) checkheaderfooter(doc,1,file);		// new, cope with omit header/footer


 return(err);
}




os_error * makemastersectionfrommaster(filestr * sfile,int s,int smode,
                                      filestr * dfile,int d,int dmode)
{
 os_error     * err;
 objectloc      src;
 objectloc      dest;
 sectionstr   * section;
 pagestr      * pagep;
 newpagestr     newpage;
 transformstr   tr;
 int            index;
 int            object;
 int            leftpage;
 int            dpage;
 mlinkstr       mlink;
 int            message;


 memset(&src,0,sizeof(objectloc));
 memset(&dest,0,sizeof(objectloc));

 /* sort out starting page number and copy correct page */

 section=(sectionstr*)fob_find(s,sfile);

 newpage.data=section->data;
 newpage.pagenumber=0;  /* left hand page */

 dest.file=dfile;
 dest.section=d;
 dest.page=0;
 dest.branch=1;
 dest.object=0;

 err=objectnew(&dest,OPAGE,&newpage);

 section=(sectionstr*)fob_find(d,dfile);
 section->chain.child=leftpage=dest.object;
 section->np=1;

 dfile->hdr.np[MST]++;

 section=(sectionstr*)fob_find(s,sfile);

 src.file=mlink.sfile=sfile;
 src.section=s;
 src.page=mlink.spage[0]=section->chain.child;
 src.branch=1;
 src.object=src.page;
 src.parent=src.page;
 src.after=0;
 src.chain=0;
 src.copymode|=smode;

 dest.file=mlink.dfile=dfile;
 dest.section=d;
 dest.page=mlink.dpage[0]=leftpage;
 dest.branch=1;
 dest.object=0;
 dest.parent=dest.page;
 dest.after=0;
 dest.chain=0;
 dest.copymode=LOCNEW|LOCFLOWDATA|dmode;

 tr_setidentity(&tr);

/* frflstart(dfile); */ /*worried that this leads to problems when not linked*/
 err=objectcopy(&src,&dest,&tr);
/* frflend(dfile); */

 index=objectindex(newpage.data.mainkey[0],src.page,sfile);
 object=objectfindindex(index,dest.page,dfile);
 section=(sectionstr*)fob_find(d,dfile);
 section->data.mainkey[0]=object;


 if(newpage.data.dble)
 {
  newpage.pagenumber=1;  /* right hand page */

  err=objectnew(&dest,OPAGE,&newpage);
  if(!err)
  {
   dfile->hdr.np[MST]++;

   section=(sectionstr*)fob_find(dest.section,dfile);
   section->np++;

   pagep=(pagestr*)fob_find(src.page,sfile);
   src.page=mlink.spage[1]=pagep->chain.next;
   src.object=src.page;
   src.parent=src.page;
   src.after=0;
   src.chain=0;
   src.copymode|=smode;

   pagep=(pagestr*)fob_find(dest.object,dfile);
   pagep->chain.prev=leftpage;
   pagep=(pagestr*)fob_find(leftpage,dfile);
   pagep->chain.next=dest.object;

   dest.page=mlink.dpage[1]=dest.object;
   dest.object=0;
   dest.parent=dest.page;
   dest.after=0;
   dest.chain=0;
   dest.copymode=LOCNEW|LOCFLOWDATA|dmode;

 /*  frflstart(dfile); */
   err=objectcopy(&src,&dest,&tr);
 /*  frflend(dfile);   */

   index=objectindex(newpage.data.mainkey[1],src.page,sfile);
   object=objectfindindex(index,dest.page,dfile);
   section=(sectionstr*)fob_find(d,dfile);
   section->data.mainkey[1]=object;
  }
 }
 else
 {
  mlink.spage[1]=mlink.dpage[1]=0;
 }

 if(!err)
 {
  message=OM_MRELINK;

  for(mlink.hand=0;mlink.hand<2;mlink.hand++)
  {
   dpage=mlink.dpage[mlink.hand];
   if(dpage)
   {
    pagep=(pagestr*)fob_find(dpage,dfile);
    err=objectchainmessage(pagep->chain.child,dfile,&message,&mlink);
   }
  }
 }

 return(err);
}




static os_error * makedocumentfrommaster(filestr * file)
{
 os_error   *   err;
 int            ns;
 int            i;
 int            mst;  /* section key */
 int            doc;  /* section key */
 sectionstr *   section;
 sectiondatastr sectiondata;
 objectloc      loc;
 int            dprev;


 err=NULL;


 ns=file->hdr.ns[MST];
 mst=file->hdr.section[MST];
 doc=file->hdr.section[DOC];
 dprev=0;

/* dprintf(7,"makedocumentfrommaster ns=%d",ns); */

 file->hdr.maxpagewidth[DOC]=file->hdr.maxpagewidth[MST];
 file->hdr.maxpageheight[DOC]=file->hdr.maxpageheight[MST];


 for(i=0;i<ns;i++)
 {
  section=(sectionstr*)fob_find(mst,file);
  sectiondata=section->data;

  loc.file=file;
  loc.branch=0;

  err=objectnew(&loc,OSECTION,&sectiondata);
  if(err) break;

  doc=loc.object;
  section=(sectionstr*)fob_find(doc,file);
  section->dual=mst;
  section->chain.prev=dprev;

  section=(sectionstr*)fob_find(mst,file);
  section->dual=doc;

  /* link in new section */

  file->hdr.ns[DOC]++;
  if(dprev)
  {
   section=(sectionstr*)fob_find(dprev,file);
   section->chain.next=doc;
  }
  else
  {
   file->hdr.section[DOC]=loc.object;
  }

  err=makedocumentsectionfrommaster(file,mst,doc);
  if(err) break;

  section=(sectionstr*)fob_find(mst,file);
  mst=section->chain.next;
  if(!mst) break;
  dprev=doc;
 }

 return(err);
}





static os_error * newloadstyle(int eventn,int user,filestr * file,void * data)
{
 os_error * err;

 err=makedocumentfrommaster(file);

 return(err);

 USE(eventn);
 USE(user);
 USE(data);
}




/* make a copy of all master pages/sections          */
/* NB s==source d==dest.                             */
/* effectively make master of one doc from another   */

static os_error * makemasterfrommaster(filestr * sfile,filestr * dfile)
{
 os_error   *   err;
 int            s;  /* section key */
 int            d;
 int            dprev;
 sectionstr *   sectionp;
 sectiondatastr sectiondata;
 objectloc      loc;
 int            i;
 int            ns;


 err=NULL;

 ns=sfile->hdr.ns[MST];
 s=sfile->hdr.section[MST];
 dprev=0;

 dfile->hdr.maxpagewidth[MST]=sfile->hdr.maxpagewidth[MST];
 dfile->hdr.maxpageheight[MST]=sfile->hdr.maxpageheight[MST];


 for(i=0;i<ns;i++)
 {
  sectionp=(sectionstr*)fob_find(s,sfile);
  sectiondata=sectionp->data;

  loc.file=dfile;
  loc.branch=1;

  err=objectnew(&loc,OSECTION,&sectiondata);
  if(err) break;

  d=loc.object;

  /* link in new section */

  dfile->hdr.ns[MST]++;

  if(!dprev)
  {
   dfile->hdr.section[MST]=loc.object;
  }
  else
  {
   sectionp=(sectionstr*)fob_find(dprev,dfile);
   sectionp->chain.next=d;
   sectionp=(sectionstr*)fob_find(d,dfile);
   sectionp->chain.prev=dprev;
  }

  err=makemastersectionfrommaster(sfile,s,0,dfile,d,0);
  if(err) break;

  sectionp=(sectionstr*)fob_find(s,sfile);
  s=sectionp->chain.next;
  if(!s) break;
  dprev=d;
 }

 return(err);
}





/* make a copy of all master pages/sections          */
/* NB s==source d==dest.                             */
/* effectively make master of one doc from another   */


static os_error * newmkstyle(int eventn,int user,filestr * dfile,
                                                 filestr * sfile)
{
 os_error   *   err;

 err=makemasterfrommaster(sfile,dfile);

 return(err);

 USE(eventn);
 USE(user);
}




/* use the contents of the new structure to create a new file */

os_error * createnewdoc(newstr * xnew,filestr ** filep,char * name)
{
 os_error    * err;
 filestr     * file;
 filehdr     * hdr;
 int           i;
 prefdatastr * pref;


 err=newfile(filep);
 if(!err)
 {
  file=*filep;

		if(xnew) file->compatability=xnew->compatability;
		else					file->compatability=workcompatability;

  err=ob_createdomain((domainstr**)&file->domain);
  if(!err)
  {
   err=fob_create(sizeof(filehdr),file,OFILEHDR,(fobjptr)&hdr);
   if(!err)
   {
    file->hdr=*hdr;

    for(i=EVENT_NEWDOC0;i<=EVENT_NEWDOC7;i++)
    {
     err=event(i,file,(int)deffile);
     if(err) break;
     if(i==EVENT_NEWDOC1 && xnew)
     {
      prefunits(xnew->units,file);
     }
    }


    if(!err) 
    {
     if(xnew) 
     {
      pref=prefp(file);

      xnew->sectiondata.number=pref->chapterstart;
      xnew->sectiondata.pagenumber.start=0;
      xnew->sectiondata.pagenumber.number=1;
      xnew->sectiondata.mainkey[0]=xnew->sectiondata.mainkey[1]=0;

      err=newmastersection(file,xnew);
     }
     else
     {
      err=makemasterfrommaster(deffile,file);
     }
    }


    if(!err) err=makedocumentfrommaster(file);
    if(!err) gennewname(file,name);

    if(!err)
    {
     for(i=EVENT_NEWDOC9;i<=EVENT_NEWDOCF;i++)
     {
      err=event(i,file,(int)deffile);
      if(err) break;
     }
    }
   }
  }

  if(err)
  {
   event(EVENT_FSCRAP,file,0);
   ob_deletedomain((domainstr**)&file->domain);
   deletefile(file);
  }

 }
 return(err);
}



os_error * createdefnewdoc(filestr ** filep,char * name)
{
 defnewdata.units=defprefdata.units;
	defnewdata.compatability=workcompatability;
 return(createnewdoc(deffile?NULL:&defnewdata,filep,name));
}


/* create a new default file, open a window on it */

os_error * newdocument(void)
{
 os_error * err;
 filestr  * file;

          err=createdefnewdoc(&file,NULL);
          event(EVENT_FOPEN,file,0);
 if(!err) err=createnewview(file,DOC,NULL,0);

 return(err);
}


/************************************************************************/


os_error * relinkpage(int page,int section,filestr * file)
{
 os_error   * err;
 linkstr      link; 
 sectionstr * sectionp;
 int          msection;
 int          n;
 int          child;
 pagestr    * pagep;
 int          message;
 int          base;



 err=NULL;

 if(page)
 {
  pagep=(pagestr*)fob_find(page,file);
  n=pagep->data.number;
  child=pagep->chain.child;

  link.dprev=pagep->chain.prev;
  link.dpage=page;
  link.dnext=pagep->chain.next;
  link.dsection=section;

/*
 dprintf(0,"relink page=%d prev=%d next=%d",link.dpage,link.dprev,link.dnext);
*/

  sectionp=(sectionstr*)fob_find(section,file);
  base=getpagebase(sectionp);

  msection=sectionp->dual;
  sectionp=(sectionstr*)fob_find(msection,file);

  link.mprev=link.mnext=0;
  link.mpage=sectionp->chain.child;
  link.msection=msection;

  if(sectionp->data.dble)
  {
   pagep=(pagestr*)fob_find(link.mpage,file);

   if(!islhpnb(n,base))
   {
    link.mprev=link.mnext=link.mpage;
    link.mpage=pagep->chain.next;
   }
   else
   {
    link.mprev=link.mnext=pagep->chain.next;
   }
  }

  message=OM_RELINK;

  err=objectchainmessage(child,file,&message,&link);                 
 }

 return(err);
}





os_error * relinkpagerange(int page,int np,int section,filestr * file)
{
 os_error * err;
 pagestr  * pagep;

 err=NULL;

 while(np && page && !err)
 {
  pagep=(pagestr*)fob_find(page,file);
  page=pagep->chain.next;
  err=relinkpage(pagep->key,section,file);
  np--;
 }

 return(err);
}






os_error * renumbersections(filestr * file)
{
 os_error       * err;
 int              section;
 int              section_number;
 int              pageno;
 sectionstr     * sectionp;
 prefdatastr    * pref;
 sectiondatastr   data;
 int              left;

 err=NULL;


/* dprintf(0,"renumbersections"); */

 pref=prefp(file);
 section_number=pref->chapterstart;

 section=file->hdr.section[DOC];

 err=fob_mod(section,file,(fobjptr)&sectionp);

 if(!sectionp->data.pagenumber.start)
 {
/* sectionp->data.pagenumber.start=1; */
  sectionp->data.pagenumber.number=1;
 }

 pageno=sectionp->data.pagenumber.number;
 left=sectionp->data.pagenumber.left;

 while(section)
 {
  fob_mod(section,file,(fobjptr)&sectionp);
  sectionp->data.number=section_number++;

/*  dprintf(0,"number=%d left=%d sectionp->data.pagenumber=%d",
         sectionp->data.number,left,sectionp->data.pagenumber.left); */

  if(sectionp->data.pagenumber.start)
  {
   pageno=sectionp->data.pagenumber.number;
  }
  else
  {
   if(left!=(int)sectionp->data.pagenumber.left && 
      sectionp->data.pagenumber.blanks) pageno++;

   sectionp->data.pagenumber.number=pageno;
  }

/*  dprintf(1,"pageno=%d",pageno); */

  left=sectionp->data.pagenumber.left;
  left=(left+sectionp->np) & 0x1;
  pageno+=sectionp->np;
  section=sectionp->chain.next;
  data=sectionp->data;

  fob_mod(sectionp->dual,file,(fobjptr)&sectionp);
  sectionp->data=data;
 }

 return(err);
}



os_error * changechapterstart(filestr * file)
{
 return(renumbersections(file));
}


/* snags renumbering headers and footers                                 */
/* change size of window because numbers of pages change for double docs */
/* if called with NULL, start from sect                                  */
/* stop when numbers don't change                                        */
/* it is assumed to be called on a good page                             */



os_error * renumberpages(int page,int section,int flags,filestr * file)
{
 os_error   * err;
 int          number;
 sectionstr * sectionp;
 pagestr    * pagep;
 int          nextpage;
 int          left;

/* dprintf(0,"renumberpages flags=%x",flags); */

 err=NULL;

 if(section)
 {
  if(!page)
  {
   sectionp=(sectionstr*)fob_find(section,file);
   number=sectionp->data.pagenumber.number;
   page=sectionp->chain.child;
  }
  else
  {
   pagep=(pagestr*)fob_find(page,file);
   number=pagep->data.number+1;
   page=pagep->chain.next;
  }

  while(section)
  {
/* dprintf(0,"start section number=%d page %d",number,page); */

   while(page)
   {
    err=fob_mod(page,file,(fobjptr)&pagep);
    nextpage=pagep->chain.next;

    if(pagep->data.number!=number)
    {
     pagep->data.number=number;
     if(flags & RENFLOW) pagereflowpage(page,file);
    }
    else
    if((flags & (RENSECT|RENPLUS1)))
    {
     /* continue */

    }
    else
    {
     /* if the loop break ends, can't trust 'number', so don't */
     /* break; */
    }

    page=nextpage;
    number++;
   }


 /*  dprintf(0,"finish number=%d",number); */

   sectionp=(sectionstr*)fob_find(section,file);
   section=sectionp->chain.next;
   left=(sectionp->data.pagenumber.left+sectionp->np) & 0x1;


   if(section)
   {
    sectionp=(sectionstr*)fob_find(section,file);
    if(sectionp->data.pagenumber.start || (flags & RENSECT)) break;


    if(left!=(int)sectionp->data.pagenumber.left && 
             sectionp->data.pagenumber.blanks) number++;

/*    dprintf(0,"section nu %d",sectionp->data.number);
    dprintf(0,"left=%d sectionp->data.pagenumber.left=%d number=%d",left,
                     sectionp->data.pagenumber.left,number); */


    page=sectionp->chain.child;
    flags&=~RENPLUS1;
   }
  }
 }

 return(err);
}


/*****************************************************************************/

/* create a master section, link it in   */
/* copy across pages and data            */

static os_error * addsection(sectiondatastr * sectiondata,int * newp,int old,
                                      int after,int branch,filestr *file)
{
 os_error     * err;
 objectloc      loc;
 sectionstr   * sectionp;
 int            section;
 int            news;

 err=NULL;

 sectionp=(sectionstr*)fob_find(old,file);

 loc.file=file;
 loc.branch=branch;

 if(sectionp->chain.prev || after)
 {
  if(!after) section=sectionp->chain.prev;
  else       section=old;
  err=objectnew(&loc,OSECTION,sectiondata);
  news=loc.object;
  insafter(news,section,0,0,file);
 }
 else
 {
  err=objectnew(&loc,OSECTION,sectiondata);
  news=loc.object;
  file->hdr.section[branch]=news;
  sectionp=(sectionstr*)fob_find(news,file);
  sectionp->chain.next=old;
  sectionp=(sectionstr*)fob_find(old,file);
  sectionp->chain.prev=news;
 }


 file->hdr.ns[branch]++;

 *newp=news;

 return(err);
}





/* passed master section, change number of columns */

static os_error * fixcolumns(int section,int columns,filestr * file)
{
 int              page;
 pagestr        * pagep;
 sectionstr     * sectionp;
 sectiondatastr   sectiondata;
 int              hand;

 sectionp=(sectionstr*)fob_find(section,file);
 sectiondata=sectionp->data;
 page=sectionp->chain.child;

 for(hand=0;hand<2;hand++)
 {
  if(sectiondata.mainkey[hand] && 
     objectinobject(sectiondata.mainkey[hand],page,file))
  {
   textchangecolumns(sectiondata.mainkey[hand],columns,file);
  }
  pagep=(pagestr*)fob_find(page,file);
  page=pagep->chain.next;
 }

 return(NULL);
}





/* called to create a new chapter, either after or before, section      */

os_error * newchapter(int oldsection,int after,pagenumberstr * pagenumber,
                                viewstr * view,int columns,int basechapter)
{
 os_error     * err;
 int            oldmaster;
 int            olddoc;
 int            newmaster;
 int            newdoc=0;
 sectiondatastr sectiondata;
 sectionstr   * sectionp;
 filestr      * file;
 int            basemaster;

 file=view->file;


 basemaster=findsection(basechapter,file,MST);
 if(!basemaster) err=geterror(ECH2);
 else err=modfile(file,oldsection); /* should only do this on master section*/


 if(!err)
 {
  sectionp=(sectionstr*)fob_find(oldsection,file);

  if(sectionp->branch)
  {
   oldmaster=oldsection;
   olddoc=sectionp->dual;
  }
  else
  {
   oldmaster=sectionp->dual;
   olddoc=oldsection;
  }

  sectionp=(sectionstr*)fob_find(basemaster,file);
  sectiondata=sectionp->data;
  if(pagenumber) sectiondata.pagenumber=*pagenumber;

           err=addsection(&sectiondata,&newmaster,oldmaster,after,MST,file);
  if(!err) err=makemastersectionfrommaster(file,basemaster,0,file,newmaster,0);
  if(!err)
  {
   if(columns>0) err=fixcolumns(newmaster,columns,file);
  }

  if(!err) /* ensure mainkey[] is copied across to document section */
  {
   sectionp=(sectionstr*)fob_find(newmaster,file);
   sectiondata=sectionp->data;
  }

  if(!err) err=addsection(&sectiondata,&newdoc,olddoc,after,DOC,file);
  if(!err) 
  {
   sectionp=(sectionstr*)fob_find(newdoc,file);
   sectionp->dual=newmaster;
   sectionp=(sectionstr*)fob_find(newmaster,file);
   sectionp->dual=newdoc;

   err=makedocumentsectionfrommaster(file,newmaster,newdoc);


   renumbersections(file);

   renumberpages(0,newdoc,RENPLUS1,file);

   if(!err)
   {
    if(file->viewn[MST]) err=createoldmaster(newdoc,newmaster,file);
   }
  }

  fileresetviews(file,FRVREFRESH);

  if(!err)
  {
   undostart(file);

   undowritefn(file,UDSECT,NULL,0);
   undowrite(file,&newmaster,sizeof(int));
   undowrite(file,&newdoc,sizeof(int));
   
   undoend(file);


   if(view->branch) oldsection=newmaster;
   else             oldsection=newdoc;
   sectionp=(sectionstr*)fob_find(oldsection,file);

   gotopagek(view,sectionp->chain.child,oldsection);
  }
 }

 return(err);
}




static os_error * deletesectionsub(int doc,int master,filestr * file)
{
 os_error   * err;
 sectionstr * sectionp;
 int          prevmaster;
 int          prevdoc;
 int          nextmaster;
 int          nextdoc;
 int          nm;
 int          nd;


 sectionp=(sectionstr*)fob_find(master,file);
 prevmaster=sectionp->chain.prev;
 nextmaster=sectionp->chain.next;
 nm=sectionp->np;

 sectionp=(sectionstr*)fob_find(doc,file);
 prevdoc=sectionp->chain.prev;
 nextdoc=sectionp->chain.next;
 nd=sectionp->np;


 undowritefn(file,UISECT,NULL,0);
 undowrite(file,&master,sizeof(int));
 undowrite(file,&doc,sizeof(int));
 undowrite(file,&prevmaster,sizeof(int));
 undowrite(file,&prevdoc,sizeof(int));

 if(prevmaster) 
 {
  unlinkobject(master,0,file);
  unlinkobject(doc,0,file);
 }
 else
 {
  file->hdr.section[DOC]=nextdoc;
  file->hdr.section[MST]=nextmaster;

  fob_mod(nextmaster,file,(fobjptr)&sectionp);
  sectionp->chain.prev=0;
  fob_mod(nextdoc,file,(fobjptr)&sectionp);
  sectionp->chain.prev=0;
 }


 file->hdr.ns[DOC]--;
 file->hdr.ns[MST]--;
 file->hdr.np[DOC]-=nd;
 file->hdr.np[MST]-=nm;


 renumbersections(file);
 renumberpages(0,nextdoc,0,file);

 recalcmaxpagesize(file,-1);

 err=fileresetviews(file,FRVREFRESH);

 return(err);
}




/* tagged to UDSECT */

static os_error * undeletesection(filestr * file)
{
 os_error * err;
 int        master;
 int        doc;

 undoread(file,&master,sizeof(int));
 undoread(file,&doc,sizeof(int));

 err=deletesectionsub(doc,master,file);

 return(err);
}



/* tagged to UISECT */

static os_error * uninsertsectionscrap(filestr * file)
{
 int          master;
 int          doc;
 int          prevmaster;
 int          prevdoc;

 undoread(file,&master,sizeof(int));
 undoread(file,&doc,sizeof(int));
 undoread(file,&prevmaster,sizeof(int));
 undoread(file,&prevdoc,sizeof(int));

 scrapsection(file,master);
 return(scrapsection(file,doc));
}


static os_error * uninsertsection(filestr * file)
{
 os_error   * err;
 int          master;
 int          doc;
 int          prevmaster;
 int          nextmaster;
 int          prevdoc;
 int          nextdoc;
 sectionstr * sectionp;
 int          nm;
 int          nd;


 undoread(file,&master,sizeof(int));
 undoread(file,&doc,sizeof(int));
 undoread(file,&prevmaster,sizeof(int));
 undoread(file,&prevdoc,sizeof(int));

 undowritefn(file,UDSECT,NULL,0);
 undowrite(file,&master,sizeof(int));
 undowrite(file,&doc,sizeof(int));

 if(prevmaster) 
 {
  insafter(master,prevmaster,0,0,file);
  insafter(doc,prevdoc,0,0,file);
 }
 else
 {
  nextmaster=file->hdr.section[MST];
  nextdoc=file->hdr.section[DOC];
  file->hdr.section[DOC]=doc;
  file->hdr.section[MST]=master;

  fob_mod(nextmaster,file,(fobjptr)&sectionp);
  sectionp->chain.prev=master;
  fob_mod(nextdoc,file,(fobjptr)&sectionp);
  sectionp->chain.prev=doc;
 }

 sectionp=(sectionstr*)fob_find(master,file);
 nm=sectionp->np;
 sectionp=(sectionstr*)fob_find(doc,file);
 nd=sectionp->np;

 file->hdr.ns[DOC]++;
 file->hdr.ns[MST]++;
 file->hdr.np[DOC]+=nd;
 file->hdr.np[MST]+=nm;

 renumbersections(file);
 renumberpages(0,doc,RENPLUS1,file);

 recalcmaxpagesize(file,-1);

 err=fileresetviews(file,FRVREFRESH);

 return(err);
}



os_error * remchapter(int section,viewstr * view)
{
 os_error   * err;
 filestr    * file;
 int          master;
 int          doc;
 sectionstr * sectionp;

 file=view->file;

 err=NULL;

 if(file->hdr.ns[DOC]<=1) err=geterror(ECH0);
 if(!err) err=modfile(file,section); /*should only do this on master section*/
 if(!err)
 {
  err=undostart(file);
  if(!err)
  {
   sectionp=(sectionstr*)fob_find(section,file);

   if(sectionp->branch)
   {
    master=section;
    doc=sectionp->dual;
   }
   else
   {
    master=sectionp->dual;
    doc=section;
   }

   clearselectionff(file,master,-1,-1);
   clearselectionff(file,doc,-1,-1);

   deletesectionsub(doc,master,file);

   undoend(file);
  }
 }

 return(err);
}



/*****************************************************************************/


static int xgettarget;


static os_error * searchfn(textboxstr * textp,filestr * file,int * message)
{
 if(textp->type==OTEXTBOX && 
    (textp->key==xgettarget || textp->master==xgettarget))
 {
  xgettarget=textp->key;
  *message=0;
 }
 return(NULL);

 USE(file);
}


os_error * getmainframe(int section,filestr * file,int * object)
{
 os_error   * err;
 sectionstr * sectionp;
 pagestr    * pagep;
 int          mpage;
 newstr       xnew;
 int          hand;
 int          page;
 int          message;


 err=NULL;

 *object=0;

 if(section)
 {
  sectionp=(sectionstr*)fob_find(section,file);
  page=sectionp->chain.child;

  if(!sectionp->branch)
  {
   section=sectionp->dual;
   sectionp=(sectionstr*)fob_find(section,file);
  }

  mpage=sectionp->chain.child;

  xnew.sectiondata=sectionp->data;

  for(hand=0;hand<2;hand++)
  {                                                                                /* in theory, don't need && mpage - seemingly do in reality though */

   if(xnew.sectiondata.mainkey[hand] && mpage &&
                   objectinobject(xnew.sectiondata.mainkey[hand],mpage,file))
   {
    pagep=(pagestr*)fob_find(page,file);
    xgettarget=xnew.sectiondata.mainkey[hand];
 
    message=OM_FUNCTION;
    err=objectchainmessage(pagep->chain.child,file,&message,(void *)searchfn);
    if(!message)
    {
     *object=xgettarget;
     break;
    }
   }

   pagep=(pagestr*)fob_find(mpage,file);
   mpage=pagep->chain.next;
   if(!mpage) break;
  }
 }

 return(err);
}






os_error * getnewdata(newstr * xnew,int section,filestr * file)
{
 sectionstr * sectionp;
 int          page;
 int          hand;
 pagestr    * pagep;
 textboxstr * textp;
 int          header;
 int          footer;
 texhdr     * texhp;


 *xnew=defnewdata;
 xnew->units=prefp(file)->units;

 sectionp=(sectionstr*)fob_find(section,file);
 if(!sectionp->branch)
 {
  section=sectionp->dual;
  sectionp=(sectionstr*)fob_find(section,file);
 }


 xnew->sectiondata=sectionp->data;
 page=sectionp->chain.child;


 for(hand=0;hand<2;hand++)
 {
  if(objectinobject(xnew->sectiondata.mainkey[hand],page,file))
  {
   textp=(textboxstr*)fob_find(xnew->sectiondata.mainkey[hand],file);

   xnew->principleframe[hand]=1;
   xnew->columns[hand]=textp->data.columns;
   xnew->columndata[hand]=textp->data.columndata;
   xnew->topmargin[hand]=textp->box.y;
   xnew->botmargin[hand]=xnew->sectiondata.height-textp->box.h-textp->box.y;
   xnew->leftmargin[hand]=textp->box.x;
   xnew->rightmargin[hand]=xnew->sectiondata.width-textp->box.x-textp->box.w;

   header=textp->data.header;
   footer=textp->data.footer;

   if(header || footer)
   {
    texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
    header=texhp->header;
    footer=texhp->footer;
   }

   xnew->headermargin[hand]=header;
   xnew->footermargin[hand]=footer;
  }
  else
  {
   xnew->principleframe[hand]=0;
  }

  if(!xnew->sectiondata.dble) break;

  pagep=(pagestr*)fob_find(page,file);
  page=pagep->chain.next;
 }


 if(!xnew->sectiondata.dble) xnew->mode=NEWMODEBOTH;
 else
 if((xnew->columns[0]==xnew->columns[1]) &&
    (xnew->principleframe[0]==xnew->principleframe[1]) &&
    (xnew->topmargin[0]==xnew->topmargin[1]) &&
    (xnew->botmargin[0]==xnew->botmargin[1]) &&
    (xnew->leftmargin[0]==xnew->rightmargin[1]) &&
    (xnew->rightmargin[0]==xnew->leftmargin[1]) &&
    (xnew->headermargin[0]==xnew->headermargin[1]) &&
    (xnew->footermargin[0]==xnew->footermargin[1]) &&
    !memcmp(&xnew->columndata[0],&xnew->columndata[1],sizeof(columnstr)) &&
    !cmpcolourval(&xnew->sectiondata.colour[0],&xnew->sectiondata.colour[1]) &&
    !memcmp(&xnew->sectiondata.fill[0],
            &xnew->sectiondata.fill[1],sizeof(fillstr)))xnew->mode=NEWMODEBOTH;
 else                                                  xnew->mode=NEWMODELEFT;


/*

 dprintf(0,"col=%d pframe=%d top=%d bot=%d left=%d right=%d h=%d f=%d cold=%d colou %d fill %d",
         (xnew->columns[0]==xnew->columns[1]),
         (xnew->principleframe[0]==xnew->principleframe[1]),
         (xnew->topmargin[0]==xnew->topmargin[1]),
         (xnew->botmargin[0]==xnew->botmargin[1]) ,
    (xnew->leftmargin[0]==xnew->rightmargin[1]),
    (xnew->rightmargin[0]==xnew->leftmargin[1]) ,
    (xnew->headermargin[0]==xnew->headermargin[1]) ,
    (xnew->footermargin[0]==xnew->footermargin[1]) ,
    !memcmp(&xnew->columndata[0],&xnew->columndata[1],sizeof(columnstr)) ,
    !cmpcolourval(&xnew->sectiondata.colour[0],&xnew->sectiondata.colour[1]) ,
    !memcmp(&xnew->sectiondata.fill[0],
            &xnew->sectiondata.fill[1],sizeof(fillstr)));

 dprintf(1,"left %d %d right %d %d",xnew->leftmargin[0],xnew->leftmargin[1],
                                    xnew->rightmargin[0],xnew->rightmargin[1]);

*/

 return(NULL);
}








/****************************************************************************/

#define UNDOS 16


static undofnstr undos[UNDOS]=
{                   
 uninsertsection,uninsertsectionscrap, UISECT,            "{UINSERTSECTION}",
 undeletesection,   NULL,              UDSECT,            "{UDELETESECTION}",

 undeletepages,     NULL,              UDPAGE,            "{UDELETEPAGE}",
 uninsertpages,     uninsertpagescrap, UIPAGE,            "{UINSERTPAGE}",

 undogomaster,      NULL,              UNDOGOMASTER,      "{UGOMASTER}",
 undoregomaster,    NULL,              UNDOREGOMASTER,    "{UGOMASTER}",

 undoquitmaster,    undoquitscrap,     UNDOQUITMASTER,    "{UQUITMASTER}",
 undorequitmaster,  NULL,              UNDOREQUITMASTER,  "{UQUITMASTER}",

 unflushms,         NULL,              UNFLUSHMS,         NULL,
 unflushmf,         NULL,              UNFLUSHMF,         NULL,
 unflushps,         NULL,              UNFLUSHPS,         NULL,
 unflushpf,         NULL,              UNFLUSHPF,         NULL,

 uuforcemaster,     NULL,              UUFORCEMASTER,     NULL,
 urforcemaster,     NULL,              URFORCEMASTER,     NULL,

 uuaddmaster,       NULL,              UUADDMASTER,       NULL,
 uraddmaster,       NULL,              URADDMASTER,       NULL,
};



os_error * newinit(void)
{
 os_error * err;

 err=undoaddblock(undos,UNDOS);

 if(!err) err=addevent(EVENT_MKSTYLE8,(eventfn)newmkstyle,0);
 if(!err) err=addevent(EVENT_LOADSTYLE8,(eventfn)newloadstyle,0);

 if(!err) err=modchapinit();
 if(!err) err=chsectinit();


 return(err);
}

