/*->c.objectdb */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"

#include "err.h"
#include "fsx.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "colour.h"
#include "etc.h"


#include "constants.h"
#include "str.h"
#include "object.h"


#include "units.h"

#include "viewr.h"
#include "view.h"
#include "file.h"
#include "chain.h"
#include "xredraw.h"
#include "curve.h"
#include "posn.h"

#include "select.h"


#include "txstr.h"
#include "new.h"
#include "newx.h"
#include "dbnew.h"



#include "dbgroup.h"

#include "objectdb.h"



int content_menu(int fp)
{
 char      * name;
 int         open;
 int         result;
 int         subcode;

 name=NULL;
 event(EVENT_CONTENTMENU,menufile,(int)&name);
 if(!name) name="text_menu";
 open=stack[fp];
 xexec(name,&result,"I/R",open,&subcode);
 return(subcode);

 return(0);   /* default contents */
}



int content_name(int fp)
{
 char       * name;
 char         temp[128];

 name=NULL;
 event(EVENT_CONTENTNAME,menufile,(int)&name);
 if(!name) name="{TX03}";

 tsprintf(sizeof(temp),temp,name);

 return(createstring(temp));   /* default contents */

 USE(fp);
}




int content_menuname(int fp)
{
 char       * name;
 char         temp[128];

 name=NULL;
 event(EVENT_CONTENTMENUNAME,menufile,(int)&name);
 if(!name) name="{TX06}";

 tsprintf(sizeof(temp),temp,name);

 return(createstring(temp));   /* default contents */

 USE(fp);
}




/* this *is* needed to get around key press problems */

void openobjectcontentsbox(int fp)
{
 event(EVENT_CONTENTBOX,menufile,(int)menuview);
 USE(fp);
}



void openobjectbox(int fp)
{
 objectdbstr  cont;
 int          object;
 objhdrstr  * objhdr;

 if(selectiontype(&object,menufile)>0)
 {
  cont.type=ODB_MODIFY;
  objhdr=(objhdrstr*)fob_find(object,menufile);
  objectdb(objhdr,menufile,menuview,&cont);
 }
 else
 if(object)
 {
  objhdr=(objhdrstr*)fob_find(object,menufile);
  opengroupbox((sobjectstr*)objhdr,menufile,menuview);
 }

 USE(fp);
}



int selection_name(int fp)
{
 int           object;
 objectdbstr   cont;
 char          string[ODBCONLEN];
 char        * name;
 sobjectstr  * sob;
 int           n;

 strcpy(string,"{SEL01}");

 name=NULL;
 event(EVENT_CONTENTSELECTEDNAME,menufile,(int)&name);
 if(name)
 {
  strcpy(string,name);
 }
 else
 {
  n=nselected(&object,menufile);
  if(n)
  {
   cont.name=string;

   if(n==1)
   {
    cont.type=ODB_OBJECTNAME;
    sob=(sobjectstr*)fob_find(object,menufile);
    objectdb((objhdrstr*)sob,menufile,menuview,&cont);
   }
   else
   if(selectiontype(&object,menufile)>0)
   {
    cont.type=ODB_OBJECTNAMEPLURALC;
    sob=(sobjectstr*)fob_find(object,menufile);
    objectdb((objhdrstr*)sob,menufile,menuview,&cont);
   }
  }
 }

 trans(string,sizeof(string));

 return(createstring(string)); 

 USE(fp);
}



int ustring(int fp)
{
 char * p;
 int units;
 units=stack[fp+1];
 if(units<0) 
 {
  if(menuview) units=menuview->data.units;
  else         units=cnew.units;
 }
 p=unitstostring(stack[fp],units);
 return(createstring(p));
}


int stringu(int fp)
{
 int val;
 int units;
 units=stack[fp+1];
 if(units<0) 
 {
  if(menuview) units=menuview->data.units;
  else         units=cnew.units;
 }
 stringtounits(stringptr(stack[fp]),&val,units);
 return(val);
}


/* convert 0x10000 based int to n dp string */
/* dpstring(int val,int dp)                 */

int dpstring(int fp)
{
 char * p;
 p=numbertostringxdp(stack[fp],stack[fp+1],0);
 return(createstring(p));
}

/* convert string with dp's into 0x10000 based int */

int stringdp(int fp)
{
 int val;
 stringtonumberxdp(stringptr(stack[fp]),&val,5,0);
 return(val);
}

