/*->h.select */

/* message that is sent to object to be selected */

#define SELECTOBJECT 0x100

/* message that object which gets original SELECTOBJECT sends to parent */

#define SELECT1      0x1

/* message that parent claiming SELECT1 message sends back to child */

#define SELECT0      0x0



/* message that is sent to object to be deselected */

#define DESELECTOBJECT 0x200


/* bits returned by transform function */

#define SFIXBOTTOM 0x10000
#define SFIXRIGHT  0x20000



#define SELECTION_FILLCOLOUR   1
#define SELECTION_BORDERCOLOUR 2
#define SELECTION_SHADOWCOLOUR 3
#define SELECTION_SUBCOLOUR    4




extern os_error * undodeleteobject(filestr * file,int object);
extern os_error * addselection(int object,filestr * file,int seltype);
extern os_error * remselection(int object,filestr * file,int seltype);
extern os_error * clearselection(void);
extern os_error * clearselectionlo(void);
extern os_error * clearselectionf(filestr * file);
extern os_error * clearselectionff(filestr * file,int section,
                                                 int page,int branch);
extern os_error * deleteselection(filestr * file);
extern os_error * changeselection(posnstr * posn,int type,int clear);
extern os_error * redrawselection(viewredrawstr * v);
extern os_error * redrawselectiont(viewredrawstr *v,transformfn trf,int flags);
extern os_error * transformselection(transformfn trf,int flags);
extern os_error * updateflowselection(objectflowstr * flow);
extern os_error * duplicateselection(filestr * file,int times,int dx,int dy);
extern os_error * copyselection(filestr * sfile);
extern os_error * moveselection(posnstr * s,posnstr * d,int copy,
                                         transformfn trf,transformstr * tr);
extern os_error * shapeselection(int shape,int data);
extern os_error * selectobject(int object,int page,int section,filestr * file);
extern os_error * ssaveselection(filestr * file);



typedef os_error * (*modifyfn)(int object,filestr * file);
extern os_error  * modifyselection(modifyfn modfn);

extern os_error  * transformselections(transformfn trf,int flags,
                                                     modifyfn modfn);


extern void selsetpagesection(int pagek,int sectionk,filestr * file);

extern int  findboxhandle(posnstr * posn);
extern int  nselected(int * object,filestr * file);
extern int  nselectedobject(int n,filestr * file);
extern int  isselected(int object,filestr * file);
extern int  isselectedbig(int object,filestr * file);
extern int  isselectedpage(int page,filestr * file);
extern int  selectiontype(int * object,filestr * file);
extern int  selectedparent(int object,filestr * file);
extern int  selectedbranch(filestr * file,int branch);


extern colourvalue selcv;


typedef struct selectedobjectstr
{
 int object;
 int seltype;

} selectedobjectstr;


extern int                 selpagek;
extern int                 selsectk;
extern int                 selmaster;
extern filestr           * selfile;
extern int                 selectn;
extern selectedobjectstr * selection;

extern int                 crosshairs;


extern os_error * makeaselectionlist(int ** list,int * listn,
                                                int * sect,int * page);
extern os_error * clearaselectionlist(int ** list);
extern int        inslist(int object,int * list,int listn);
extern void       sortselectionlist(filestr * file,int ** list,int listn);
extern void       getslistbox(boxstr * box,filestr * file,
                                                   int ** list,int listn);

extern int        getfirstselected(filestr * file,int page);
extern int        getselectionbox(boxstr * box,filestr * file);

extern filestr *  getselection(int * page,int * section,
                             selectedobjectstr ** selectionp,int * selectnp);

extern os_error * selectionmessage(filestr * file,int * message,void * data);


extern void       makeselectionlocal(int fp);
extern void       makeselectionmaster(int fp);
extern int        canmakelocal(int fp);
extern int        canmakemaster(int fp);

extern int        cancopy(int fp);
extern int        canshape(int fp);
extern int        canmodify(int fp);
extern int        candelete(int fp);
extern int        canduplicate(int fp);



extern void       snaptogrid(int fp);
extern int        xnselected(int fp);
extern int        selectionfile(int fp);

extern void       xtrans(int fp);

#define CHECKC_CHAIN 0x1

extern os_error * checkcompatability(filestr * sfile,int object,int flags,filestr * dfile);

extern os_error * selectinit(void);

