/*->c.viewr */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "flex.h"
#include "bbc.h"
#include "transform.h"

#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "temp.h"
#include "alloc.h"
#include "fsx.h"
#include "bf.h"
#include "dbhi.h"

#include "trans.h"
#include "xmath.h"
#include "etc.h"
#include "colour.h"
#include "redraw.h"
#include "deb.h"

#include "str.h"
#include "mhi.h"
#include "reslink.h"
#include "xredraw.h"
#include "file.h"
#include "object.h"
#include "posn.h"
#include "geometry.h"
#include "chain.h"

#include "page.h"
#include "grid.h"
#include "tools.h"
#include "select.h"
#include "xprint.h"
#include "xxcolour.h"
#include "xcolour.h"

#include "view.h"
#include "viewo.h"
#include "viewr.h"




void initviewredraw(viewredrawstr * v)
{
 memset(v,0,sizeof(viewredrawstr));
 tr_setidentity(&v->tr);


}



static void checkpageignore(int pageignore,viewredrawstr * v)
{
 pagestr    * pagep;
 sectionstr * sectionp;
 filestr    * file;
 int          n;

 if(pageignore)
 {
  file=v->file;
  v->pageignore=pageignore;

  sectionp=(sectionstr*)fob_find(v->section,file);
  n=sectionp->data.number;

  sectionp=(sectionstr*)fob_find(v->sectignore,file);

  if(sectionp->data.number<n) v->pageignore=0;
  else
  if(sectionp->data.number==n)
  {
   pagep=(pagestr*)fob_find(v->page,file);
   n=pagep->data.number;

   pagep=(pagestr*)fob_find(pageignore,file);

   if(pagep->data.number<n) v->pageignore=0;
  }
 }
}


/* redraw a page */

static os_error * redrawpage(int ghost,viewredrawstr * v)
{
 os_error    * err;
 pagestr     * page;
 int           layer;
 int           onelayer;
 wimp_box      scrapbox;
 void        * handle;
 int           visible;

/* int        time=clock(); */

 err=NULL;


 if(!(v->xps>v->xhiz || 
      v->xpe<v->xloz || 
      v->yps>v->yhiz || 
      v->ype<v->yloz || v->pageignore))
 {
  layer=v->layer;
  onelayer=v->onelayer;

  startredraw();

  getpageoscoords(v);    /* think about prjob */


  if((v->sobject /*&& !v->szone*/) || (!v->sobject && v->ignore))
  {
   if(!ghost)
   {
    setclipwindow(&v->redrawstr,&v->pagebox,&scrapbox,&handle,&visible);
    if(visible)
    {
     if(layer<=VRTOOLS2)    toolredraw(v);
     if(layer<=VRSELECTION) redrawselection(v);
     if(layer<=VRPRINT)     redrawprint(v);
     if(layer<=VRGRID)      redrawgrid(v);

     resetclipwindow(&v->redrawstr,&scrapbox,handle);
    }
   }
  } 


  if(layer<=VRBACK)
  {
   if(ghost || !v->page)
   {
    err=redrawghost(v,v->xps>0);
   }
   else
   {
    page=(pagestr*)fob_find(v->page,v->file);
    err=objectredraw(v,(objhdrstr*)page);
   }
  }


  if(!ghost /*&& !(v->sobject && v->szone)*/)
  {
   setclipwindow(&v->redrawstr,&v->pagebox,&scrapbox,&handle,&visible);
   if(visible)
   {
    if(onelayer)
    {
     if(layer==VRGRID)      redrawgrid(v);
     if(layer==VRPRINT)     redrawprint(v);
     if(layer==VRSELECTION) redrawselection(v);
     if(layer==VRTOOLS)     toolredraw(v);
     if(layer==VRTOOLS2)    toolredraw(v);
    }
    else
    {
     if(layer<=VRGRID)      redrawgrid(v);
     if(layer<=VRPRINT)     redrawprint(v);
     if(layer<=VRSELECTION) redrawselection(v);
     if(layer<=VRTOOLS2)    toolredraw(v);
    }

    resetclipwindow(&v->redrawstr,&scrapbox,handle);
   }
  }
 }

 if(v->pageignore==v->page && !ghost) v->pageignore=0;

/* dprintf(0,"time=%d",time-clock()); */

 return(err);
}



void firstxcoord(viewredrawstr * v)
{
 viewstr * view;
/* filestr * file;
 pagestr * pagep; */

 view=v->view;
 v->xps=0;
 v->xpo=view->border.leftborder+view->border.leftpb;

/* if(view->data.dble)
 {
  file=view->file;
  pagep=fob_find(v->page,file);
  v->xpo+=file->hdr.maxpagewidth[view->branch]-pagep->box.w;
 } */
}


void nextxcoord(viewredrawstr * v)
{
 viewstr * view;
 view=v->view;
 v->xps=v->xpe;
 v->xpo=v->xps+view->border.vmidborder+view->border.mid2pb;
}


void setxcoord(viewredrawstr * v)
{
 filestr * file;
 viewstr * view;

 file=v->file;
 view=v->view;


 if(view->data.dble)
 {
  v->xpe=v->xps+file->hdr.maxpagewidth[view->branch];

  if(v->xps>0)
  {
   v->xpe+=view->border.mid2pb+view->border.rightpb;
   v->xpe+=view->border.vmidborder+view->border.rightborder;
  }
  else
  {
   v->xpe+=view->border.leftpb+view->border.mid1pb;
   v->xpe+=view->border.leftborder;
  }
 }
 else
 {
  v->xpe=v->xps+file->hdr.maxpagewidth[view->branch];
  v->xpe+=view->border.leftpb+view->border.rightpb;
  v->xpe+=view->border.leftborder+view->border.rightborder;
 }

 v->xhi=v->xpe;
 v->xlo=v->xps;

 if(v->xhi>v->xhiz) v->xhi=v->xhiz;
 if(v->xlo<v->xloz) v->xlo=v->xloz;

 v->xlos=v->xlo-v->xpo;
 v->xhis=v->xhi-v->xpo;
}



void nextycoord(viewredrawstr * v)
{
 v->yps=v->ype;
}


void setycoord(viewredrawstr * v)
{
 int yshift;

 v->yhi=v->ype=v->yps+viewpageheight(v->view,v->page,v->section,&yshift);
 v->ylo=v->yps;
 v->ypo=v->yps+yshift;

/* cprintf("yhi=%d ylo=%d ypo=%d",v->yhi,v->ylo,v->ypo);
 cprintf("yhiz=%d yloz=%d",v->yhiz,v->yloz);
*/
 if(v->yhi>v->yhiz) v->yhi=v->yhiz;
 if(v->ylo<v->yloz) v->ylo=v->yloz;

 v->ylos=v->ylo-v->ypo;
 v->yhis=v->yhi-v->ypo;

// cprintf("ylos=%d yhis=%d",v->ylos,v->yhis);
}



static os_error * viewredrawsub(viewredrawstr * v,int more)
{
 os_error     * err;
 int            ghost;
 pagestr      * page;
 sectionstr   * section;
 viewstr      * view;
 filestr      * file;
 int            wasignore;
 int            pageignore;
 int            wasshortcut;
 int            ex0;
 int            ey1;

 view=v->view;
 file=v->file;

 err=NULL;


 wasignore=v->ignore;
 pageignore=v->pageignore;
 wasshortcut=v->sshortcuts;

// cprintf("vrdsub");

 while(more && !err)
 {

  v->ox=v->redrawstr.box.x0-v->redrawstr.scx;
  v->oy=v->redrawstr.box.y1-v->redrawstr.scy;

//	cprintf("v->ox %d oy %d scx %d scy %d",v->ox,v->oy,v->redrawstr.scx,v->redrawstr.scy);

//  cprintf("win x0=%d ext x0=%d gx0=%d",view->window.x0,view->extent.x0,v->redrawstr.g.x0);

#ifdef NEVER
  if(v->redrawstr.g.x0<(view->mainwindow.x0-view->extent.x0)) //mainpane
  {
   wimp_setcolour(WIMPWHITE);
   bbc_rectanglefill(v->redrawstr.g.x0,v->redrawstr.g.y0,
                     v->redrawstr.g.x1-v->redrawstr.g.x0,
                     v->redrawstr.g.y1-v->redrawstr.g.y0);
  }
  else
#endif
  {
   v->ylox=(v->redrawstr.g.y1-v->oy);
   v->yhix=(v->redrawstr.g.y0-v->oy);

   /* fix up for objects that are smaller than min window dims */


   if(v->yhix<view->extent.y0 && v->layer<=VRBACK)
   {
    wimp_setcolour(WINFILLCOLOUR);
    bbc_rectanglefill(v->redrawstr.g.x0,v->oy+view->extent.y0,
               v->redrawstr.g.x1-v->redrawstr.g.x0,v->yhix-view->extent.y0);
   }

   v->yhix=-v->yhix+cvdu.extray;

   ey1=view->extent.y1-view->top;
   if(v->ylox>ey1 && v->layer<=VRBACK)
   {
    wimp_setcolour(WINFILLCOLOUR);
    bbc_rectanglefill(v->redrawstr.g.x0,v->oy+ey1,
                      v->redrawstr.g.x1-v->redrawstr.g.x0,v->ylox-ey1);
   }

   v->ylox=-v->ylox-cvdu.extray;



   v->xlox=v->redrawstr.g.x0-v->ox-cvdu.extrax;
   v->xhix=v->redrawstr.g.x1-v->ox;


   /* fix up for objects that are smaller than min window dims */

   if(v->xhix>view->extent.x1 && v->layer<=VRBACK)
   {
    wimp_setcolour(WINFILLCOLOUR);
    bbc_rectanglefill(v->ox+view->extent.x1,v->oy+view->extent.y1,
                      v->xhix-view->extent.x1,view->extent.y0-view->extent.y1);
   }

   v->xhix+=cvdu.extrax;


   ex0=view->extent.x0+view->left;
   if(v->xlox<ex0 && v->layer<=VRBACK)
   {
    wimp_setcolour(WINFILLCOLOUR);
    bbc_rectanglefill(v->ox+ex0,v->oy+view->extent.y1,
                      v->xlox-ex0,view->extent.y0-view->extent.y1);
   }


   v->yloz=ourunits(v->ylox,view);
   v->yhiz=ourunits(v->yhix,view);
   v->xloz=ourunits(v->xlox,view);
   v->xhiz=ourunits(v->xhix,view);

//   cprintf("yhiz=%d yloz=%d",v->yhiz,v->yloz);

   v->page=view->page;
   v->section=view->section;

   checkpageignore(pageignore,v);

   v->yps=view->ps;
   firstxcoord(v);
   setxcoord(v);
   setycoord(v);

//   cprintf("vrd2");

   do
   {
    v->ignore=wasignore;
    v->sshortcuts=wasshortcut;

    ghost=isghost(view,v->page,v->section,v->xps);

 //   cprintf("vrd3");

    err=redrawpage(ghost,v);                   /* left hand page */
    if(err) break;

    if(view->data.dble)
    {
     /* redrawvert(0,0); */
     nextxcoord(v);                        /* then right hand page */

     page=(pagestr*)fob_find(v->page,file);
     section=(sectionstr*)fob_find(v->section,file);

     if(!ghost && (page->chain.next || section->chain.next))
     {
      if(page->chain.next) v->page=page->chain.next;
      else
      {
       v->section=section->chain.next;
       section=(sectionstr*)fob_find(v->section,file);
       v->page=section->chain.child;
      }
     }

     v->ignore=wasignore;
     v->sshortcuts=wasshortcut;

     ghost=isghost(view,v->page,v->section,v->xps);
     setxcoord(v);
     err=redrawpage(ghost,v);
     if(err) break;

     firstxcoord(v);
     setxcoord(v);
    }

    if(v->yhi>=v->yhiz) break;  /* there isn't going to be another page */
    nextycoord(v);
  
    page=(pagestr*)fob_find(v->page,file);
    section=(sectionstr*)fob_find(v->section,file);

    if(!ghost)
    {
     if(page->chain.next) v->page=page->chain.next;
     else
     if(section->chain.next)
     {
      v->section=section->chain.next;
      section=(sectionstr*)fob_find(v->section,file);
      v->page=section->chain.child;
     }
     else 
     {       /* no more pages to redraw */
      break;
     }
    }

    setycoord(v);

   } while(v->ylo<v->yhiz);

  }

//  cprintf("getrect");
  wimp_get_rectangle(&v->redrawstr,&more);
 }

//	cprintf("view redraw sub ex");

 if(err) viewopencrash(view);

 return(err);
}



os_error * viewredraw(int handle,int userhandle)
{
 os_error     * err;
 viewredrawstr  v;
 int            more;
 viewstr      * view;
 filestr      * file;

 initviewredraw(&v);

 view=(viewstr*)userhandle;
 file=view->file;
 v.redrawstr.w=handle;
 v.view=view;
 v.file=file;
 v.layer=VRBACK;

 err=wimp_redraw_wind(&v.redrawstr,&more);
 if(!err) err=viewredrawsub(&v,more);

 return(err);
}






/* given a view, set the coords for a page if page happens to be in view */

int setcoords(viewredrawstr * v,int xpage)
{
 int          ghost;
 viewstr    * view;
 filestr    * file;
 pagestr    * page;
 sectionstr * section;

 view=v->view;
 file=v->file;

 v->page=view->page;
 v->section=view->section;

 v->yps=view->ps;
 firstxcoord(v);
 setxcoord(v);
 setycoord(v);

 while(1)
 {
  ghost=isghost(view,v->page,v->section,v->xps); /* left hand page */ 
  if(!ghost && v->page==xpage) break;

  if(view->data.dble)
  {
   nextxcoord(v);                        /* then right hand page */

   page=(pagestr*)fob_find(v->page,file);
   section=(sectionstr*)fob_find(v->section,file);

   if(!ghost)
   {
    if(page->chain.next) v->page=page->chain.next;
    else
    {
     v->section=section->chain.next;
     if(v->section)
     {
      section=(sectionstr*)fob_find(v->section,file);
      v->page=section->chain.child;
     }
     else break;
    }
   }
   ghost=isghost(view,v->page,v->section,v->xps);
   setxcoord(v);

   if(!ghost && v->page==xpage) break;

   firstxcoord(v);
   setxcoord(v);
  }

  nextycoord(v);

  page=(pagestr*)fob_find(v->page,file);
  section=(sectionstr*)fob_find(v->section,file);

  if(!ghost)
  {
   if(page->chain.next) v->page=page->chain.next;
   else
   {
    v->section=section->chain.next;
    if(v->section)
    {
     section=(sectionstr*)fob_find(v->section,file);
     v->page=section->chain.child;
    }
    else break;
   }
  }
  setycoord(v);
 }

 return(v->section!=0);
}



/* can have 0 page or section to force look up */

os_error * viewrefreshobject(int object,int section,int page,filestr * file)
{
 os_error     * err;
 viewredrawstr  v;
 int            more;
 viewstr      * view;
 sobjectstr   * objectp;
 int            opaque;
 colourvalue    cv;


 err=NULL;

 initviewredraw(&v);

 objectp=(sobjectstr*)fob_find(object,file);

 objectread(OREADFILL,(objhdrstr*)objectp,file,&cv);

 if(!page || !section)
 {
  pagesectionof((chainobject *)objectp,file,&page,&section);
 }

 view=file->view;
 while(view)
 {
  v.view=view;
  v.file=file;

  opaque=(vfindcolour(view,&cv)!=-1);

  v.redrawstr.w=view->handle;//mainpane

  if(v.redrawstr.w)
  {
   if(setcoords(&v,page))
   {
    objectp=(sobjectstr*)fob_find(object,file);

    v.redrawstr.box.x0=osunits(v.xpo+objectp->box.x,view)-cvdu.extrax;
    v.redrawstr.box.x1=osunits(v.xpo+objectp->box.x+objectp->box.w,
                                                        view)+cvdu.extrax;
    v.redrawstr.box.y0=-osunits(v.ypo+objectp->box.y+objectp->box.h,
                                                        view)-cvdu.extray;
    v.redrawstr.box.y1=-osunits(v.ypo+objectp->box.y,view)+cvdu.extray;

    v.ignore=opaque;
    v.layer=VRBACK;
    v.object=object;

    err=wimp_update_wind(&v.redrawstr,&more);
    if(!err) err=viewredrawsub(&v,more);
   }
  }
  view=view->next;
 }

 return(err);

 USE(section);
}




os_error * viewrefreshsobject(viewredrawstr * v,aboxstr * bbox,
                                                transformstr * tr)
{
 os_error     * err;
 int            more;
 viewstr      * view;
 aboxstr        rbox;
 aboxstr        sbox;
 int            page;
 aboxstr      * aboxp;
 int            ignore;

 err=NULL;

 view=(v->file)->view;
 page=v->page;

 ignore=v->ignore;

 while(view)
 {
  v->view=view;

  v->redrawstr.w=view->handle; //mainpane

  if(v->redrawstr.w)
  {
   if(setcoords(v,page))
   {
    if(v->sflush)
    {
     sbox=*bbox;
    /* dprintf(0,"sbox x0=%d x1=%d y0=%d y1=%d s=%d",
                    sbox.x0,sbox.x1,sbox.y0,sbox.y1,v->ssub); */

     vxcget(view,v->sobject,v->ssub,0,&aboxp);
     if(aboxp)
     {
     /* dprintf(0,"merge %d",v->sflush);
      dprintf(0,"abox x0=%d x1=%d y0=%d y1=%d",
                    aboxp->x0,aboxp->x1,aboxp->y0,aboxp->y1); */

      if(v->sflush==2) sbox=*aboxp;
      else             getsumabox(&sbox,aboxp);

     /* dprintf(0,"mbox x0=%d x1=%d y0=%d y1=%d",
                    sbox.x0,sbox.x1,sbox.y0,sbox.y1); */

      vxcrem(view,v->sobject,v->ssub);
     }
     getmaxabox(&rbox,&sbox,tr);
    }
    else
    {
     getmaxabox(&rbox,bbox,tr);
    }

 /*  dprintf(2,"rbox->y0=%d bbox->y0=%d rbox->y1=%d bbox->y1=%d",
              rbox.y0,bbox->y0,rbox.y1,bbox->y1);  */

    v->redrawstr.box.x0= osunits(v->xpo+rbox.x0,view);
    v->redrawstr.box.x1= osunits(v->xpo+rbox.x1,view)+cvdu.extrax;
    v->redrawstr.box.y0=-osunits(v->ypo+rbox.y1,view)-cvdu.extray;
    v->redrawstr.box.y1=-osunits(v->ypo+rbox.y0,view)+cvdu.extray;

    v->layer=VRBACK;
    v->onelayer=0;
    v->object=v->sobject;
    v->xobject=0;
    v->isprinter=0;
    v->ignore=ignore;

    err=wimp_update_wind(&v->redrawstr,&more);
    if(!err) err=viewredrawsub(v,more);
   }
 /* else dprintf(2,"set coords failes v->page=%d page=%d",v->page,page); */
  }
  view=view->next;
 }

 return(err);
}





int boxinredraw(viewredrawstr * v,boxstr * box)
{
 int x0;
 int x1;
 int y0;
 int y1;

 x0=MAX(box->x,v->xlos);
 x1=MIN((box->x+box->w),v->xhis);
 y0=MAX(box->y,v->ylos);
 y1=MIN((box->y+box->h),v->yhis);

 return(x0<=x1 && y0<=y1);
}



os_error * getpagecoords(viewstr * view,int xpage,int xsection,
                                                 int * xpo,int * ypo)
{
 sectionstr * sectionp;
 int          section;
 int          nextsection;
 pagestr    * pagep;
 int          page;
 filestr    * file;
 int          xs;
 int          ys;
 int          first;
 int          np;
 int          snp;
 int          pageno;
 int          maxwidth;
 int          right;
 int          height;
 int          oldheight;
 int          base;
 int          ghost1;
 int          snp1;


 height=0; /* compiler */

 file=view->file;
 xs=ys=0;
 first=1;

 maxwidth=file->hdr.maxpagewidth[view->branch];
 section=file->hdr.section[view->branch];

 if(view->data.dble)
 {
  right=0;

  while(section)
  {
   sectionp=(sectionstr*)fob_find(section,file);
   snp=sectionp->np;
   base=getpagebase(sectionp);

   nextsection=sectionp->chain.next;
   oldheight=height;
   height=sectionp->data.height;
   pageno=view->branch?0:sectionp->data.pagenumber.number;
   if(section==xsection)
   {
    pagep=(pagestr*)fob_find(xpage,file);
    snp=pagep->data.number-pageno;
   }

   if(right) /* mate left and right pages from sections */
   {
    ghost1=isghostleft(islhpnb(pageno,base),right);
    snp1=snp;

    /* consider a chapter which ends on left, next chapter starts */
    /* on right, and you want to goto first page in it            */

    if(!ghost1 && snp1)
    {
     oldheight=MAX(oldheight,height);
     snp--;
     pageno++;
    }

    /* just add the previous page */

    if(ghost1 || snp1)
    {
     if(first) 
     {
      ys+=oldheight+view->border.toppb+view->border.botpb+
                                      view->border.firstborder;
      first=0;
     }
     else
     {
      ys+=oldheight+view->border.toppb+view->border.botpb+
                                      view->border.hmidborder;
     }
    }
    right=0;
   }

   if(isghostleft(islhpnb(pageno,base),right)) right=1;

   /* find out how many strips of 2 pages this section makes */

   if(snp)
   {
    np=(snp+right)/2;
    right=(snp+right) & 0x1;

    if(np)
    {
     if(first) 
     {
      ys+=height+view->border.toppb+view->border.botpb+
                                    view->border.firstborder;
      np--;
      first=0;
     }

     ys+=(height+view->border.toppb+view->border.botpb+
                                   view->border.hmidborder)*np;
    } 
   }

   if(section==xsection) break;
   section=nextsection;
  }

  xs=view->border.leftpb+view->border.leftborder;
  if(right) xs+=maxwidth+view->border.vmidborder+
                view->border.mid1pb+view->border.mid2pb;
 }
 else
 {
  xs=view->border.leftborder+view->border.leftpb;

  while(section)
  {
   sectionp=(sectionstr*)fob_find(section,file);
   np=sectionp->np;
   nextsection=sectionp->chain.next;

   if(section==xsection)
   {
    page=sectionp->chain.child;
    pagep=(pagestr*)fob_find(page,file);

    np=pagep->data.number;
    pagep=(pagestr*)fob_find(xpage,file);
    np=pagep->data.number-np;
   }

   if(np)
   {
    if(first) 
    {
     ys+=sectionp->data.height+view->border.toppb+view->border.botpb+
                               view->border.firstborder;
     np--;
     first=0;
    }

    ys+=(sectionp->data.height+view->border.toppb+view->border.botpb+
                               view->border.hmidborder)*np;
   }
   if(section==xsection) break;
   section=nextsection;
  }
 }

 if(first) ys+=view->border.firstborder;
 else      ys+=view->border.hmidborder;
 ys+=view->border.toppb;

 *xpo=xs;
 *ypo=ys;

 return(NULL);
}








/* supply a number of areas, and do redraw on them */
/* v->sboxn anchor to v->sbox                      */

/* note this changes page,section on v during redraw */

os_error * viewrefreshareas(filestr * file,viewredrawstr * v,int layer)
{
 os_error     * err;
 int            more;
 viewstr      * view;
 aboxstr        abox;
 int            i;
 int            page;
 int            section;


 err=NULL;

 abox=v->sbox[0].box;
 for(i=1;i<v->sboxn;i++)
 {
  getsumabox(&abox,&v->sbox[i].box);
 }

 page=v->page;
 section=v->section;

 view=file->view;
 while(view)
 {
  v->view=view;
  v->file=file;

  v->redrawstr.w=view->handle; //mainpane

  if(v->redrawstr.w)
  {
   if(setcoords(v,page))
   {
    v->redrawstr.box.x0=osunits(v->xpo+abox.x0,view)-cvdu.extrax;
    v->redrawstr.box.x1=osunits(v->xpo+abox.x1,view)+cvdu.extrax;

    v->redrawstr.box.y0=-osunits(v->ypo+abox.y1,view)-cvdu.extray;
    v->redrawstr.box.y1=-osunits(v->ypo+abox.y0,view)+cvdu.extray;

    v->pageignore=0;
    v->ignore=0;
    v->layer=(layer & (~VRONELAYER));
    v->onelayer=(layer & VRONELAYER)!=0;
    v->xobject=0;
    v->sobject=0;
    v->isprinter=0;

//    cprintf("update wind");
    err=wimp_update_wind(&v->redrawstr,&more);
    if(!err) err=viewredrawsub(v,more);
   }
  }
  view=view->next;
 }

 v->page=page;
 v->section=section;

 return(err);
}

/***************************************************************************/


#define VRCHUNK 32*sizeof(sboxstr)

#define MAXVX 2

static viewredrawstr vx[MAXVX];


os_error * vxstartn(filestr * file,int page,int section,int n)
{
 os_error * err;

 if(!vx[n].sbox)
 {

  initviewredraw(&vx[n]);
  err=flex_alloc((flex_ptr)&vx[n].sbox,VRCHUNK);
 }
 else
 {
  err=flex_chunk((flex_ptr)&vx[n].sbox,VRCHUNK,VRCHUNK);
 }

 vx[n].sboxn=0;
 vx[n].page=page;
 vx[n].section=section;
 vx[n].file=file;

 return(err);
}


os_error * vxstart(filestr * file)
{
 return(vxstartn(file,0,0,0));
}



os_error * vxscrap(void)
{
 os_error  * err;
 int         i;

 err=NULL;

 for(i=0;i<MAXVX;i++)
 {
  flex_free((flex_ptr)&vx[i].sbox);
 }
 return(err);
}



os_error * vxflushn(int layer)
{
 os_error  * err;
 int         i;

 err=NULL;

 for(i=0;i<MAXVX;i++)
 {
  if(vx[i].sbox)
  {
   if(vx[i].sboxn)
   {
    err=viewrefreshareas(vx[i].file,&vx[i],layer);
   }
  }
 }
 return(err);
}


os_error * vxendn(int layer)
{
 os_error * err;

 err=vxflushn(layer);
 vxscrap();
 return(err);
}



os_error * vxflush(filestr * file,int layer,int page,int section)
{
 vx[0].page=page;
 vx[0].section=section;
 vx[0].file=file;

 return(vxflushn(layer));
}



os_error * vxend(filestr * file,int layer,int page,int section)
{
 os_error * err;
 err=vxflush(file,layer,page,section);
 vxscrap();
 return(err);
}






static os_error * vxaddns(sobjectstr ** sob,filestr * file,int n)
{
 os_error * err;
 int        key;

 err=NULL;

 if(vx[n].sbox)
 {
  key=(*sob)->key;

  box2abox(&(*sob)->box,&vx[n].sbox[vx[n].sboxn++].box);

  err=flex_chunk((flex_ptr)&vx[n].sbox,
                           (vx[n].sboxn+1)*sizeof(sboxstr),VRCHUNK);

  *sob=(sobjectstr*)fob_find(key,file);
 }

 return(err);
}


/* called by objects that intersect with the object that has changed */

os_error * vxadd(sobjectstr ** sob,filestr * file)
{
 return(vxaddns(sob,file,0));
}


os_error * vxaddn(sobjectstr ** sob,filestr * file,int page)
{
 int i;

 for(i=0;i<MAXVX;i++)
 {
  if(vx[i].sbox && vx[i].page==page && vx[i].file==file)
  {
   return(vxaddns(sob,file,i));
  }
 }

 return(NULL);
}



os_error * vxgetareas(viewredrawstr * v,int * sboxn,sboxstr *** sboxp)
{
 int i;

 *sboxn=0;

 for(i=0;i<MAXVX;i++)
 {
  if(vx[i].sbox && vx[i].page==v->page && vx[i].file==v->file)
  {
   *sboxn=vx[i].sboxn;
   *sboxp=&vx[i].sbox;
  }
 }

 return(NULL);
}

/****************************************************************************/



/* abox is an absolute area to refresh */
/* works in all views                  */
/* no abox==redraw whole page          */

os_error * viewrefresharea(filestr * file,int page,aboxstr * abox,int layer)
{
 os_error     * err;
 viewredrawstr  v;
 aboxstr        xbox;
 viewstr      * view;
 int            more;


 err=NULL;


// cprintf("viewrefresharea");

 if(abox)
 {
  xbox.x0=MIN(abox->x0,abox->x1);
  xbox.x1=MAX(abox->x0,abox->x1);
  xbox.y0=MIN(abox->y0,abox->y1);
  xbox.y1=MAX(abox->y0,abox->y1);
 }


 view=file->view;
 while(view)
 {
  initviewredraw(&v);

  v.view=view;
  v.file=file;

  v.redrawstr.w=view->handle; //mainpane;

  if(v.redrawstr.w)
  {
   if(setcoords(&v,page))
   {

    if(abox)
    {
     v.redrawstr.box.x0=osunits(v.xpo+xbox.x0,view)-cvdu.extrax;
     v.redrawstr.box.x1=osunits(v.xpo+xbox.x1,view)+cvdu.extrax;
     v.redrawstr.box.y0=-osunits(v.ypo+xbox.y1,view)-cvdu.extray;
     v.redrawstr.box.y1=-osunits(v.ypo+xbox.y0,view)+cvdu.extray;
    }
    else
    {
     v.redrawstr.box.x0=osunits(v.xps,view)-cvdu.extrax;
     v.redrawstr.box.x1=osunits(v.xpe,view)+cvdu.extrax;
     v.redrawstr.box.y0=-osunits(v.ype,view)-cvdu.extray;
     v.redrawstr.box.y1=-osunits(v.yps,view)+cvdu.extray;
    }


    v.pageignore=0;
    v.ignore=0;
    v.layer=(layer & (~VRONELAYER));
    v.onelayer=(layer & VRONELAYER)!=0;
    v.xobject=0;
    v.sobject=0;
    v.isprinter=0;

//    cprintf("update1");
    err=wimp_update_wind(&v.redrawstr,&more);
    if(!err) err=viewredrawsub(&v,more);
   }
  }
  view=view->next;
 }

 return(err);
}





/* abox is an absolute area to refresh */
/* works in one view                   */

os_error * viewrefreshaarea(viewstr * view,aboxstr * abox,int layer)
{
 os_error     * err;
 viewredrawstr  v;
 int            more;

 err=NULL;

 initviewredraw(&v);

 v.view=view;
 v.file=view->file;

 v.redrawstr.w=view->handle; //mainpane;

 v.redrawstr.box.x0=osunits(abox->x0,view);
 v.redrawstr.box.x1=osunits(abox->x1,view)+cvdu.extrax;
 v.redrawstr.box.y0=-osunits(abox->y0,view)-cvdu.extray;
 v.redrawstr.box.y1=-osunits(abox->y1,view)+cvdu.extray;

 v.layer=(layer & (~VRONELAYER));
 v.onelayer=(layer & VRONELAYER)!=0;

 err=wimp_update_wind(&v.redrawstr,&more);
 if(!err) err=viewredrawsub(&v,more);

 return(err);
}



os_error * viewrefreshview(viewstr * view,int layer)
{
 os_error      * err;
 viewredrawstr   v;
 int             more;

 err=NULL;

 initviewredraw(&v);

 v.redrawstr.w=view->handle; //mainpane;

 if(v.redrawstr.w)
 {
  v.redrawstr.box.x0=view->mainwindow.scx;        //mainpane
  v.redrawstr.box.y1=view->mainwindow.scy;
  v.redrawstr.box.x1=v.redrawstr.box.x0+view->mainwindow.x1-view->mainwindow.x0;
  v.redrawstr.box.y0=v.redrawstr.box.y1-(view->mainwindow.y1-view->mainwindow.y0);

  v.layer=(layer & (~VRONELAYER));
  v.onelayer=(layer & VRONELAYER)!=0;

  v.view=view;
  v.file=view->file;
   
  err=wimp_update_wind(&v.redrawstr,&more);


  if(!err) err=viewredrawsub(&v,more);
 }

 return(err);
}


/* branch can be -1 == Both or MST/DOC */

os_error * viewrefreshall(filestr * file,int branch,int layer)
{
 os_error     * err;
 viewstr      * view;

 err=NULL;

 view=file->view;
 while(view && !err)
 {
  if(branch<0 || branch==view->branch) err=viewrefreshview(view,layer);

  view=view->next;
 }

 return(err);
}




/* refresh any window space that appears after this page */

os_error * viewrefreshpageplus(int page,int section,int branch,filestr * file)
{
 os_error     * err;
 viewstr      * view;
 viewredrawstr  v;
 int            more;
 pagestr      * pagep;
 sectionstr   * sectionp;


 err=NULL;

 initviewredraw(&v);

 if(branch & VPPREV)
 {
  if(page)
  {
   pagep=(pagestr*)fob_find(page,file);
   page=pagep->chain.prev;
   if(!page)
   {
    sectionp=(sectionstr*)fob_find(section,file);
    if(sectionp->chain.prev)
    {
     section=sectionp->chain.prev;
     page=lastpageinsection(section,file);
    }
   }
  }
 }


 branch&=0x1;

 view=file->view;
 while(view)
 {
  if(branch==view->branch)
  {
   initviewredraw(&v);

   v.redrawstr.w=view->handle; //mainpane;

   if(v.redrawstr.w)
   {
    v.redrawstr.box.x0=view->mainwindow.scx;    // mainpane
    v.redrawstr.box.y1=view->mainwindow.scy;
    v.redrawstr.box.x1=v.redrawstr.box.x0+view->mainwindow.x1-view->mainwindow.x0;
    v.redrawstr.box.y0=v.redrawstr.box.y1-(view->mainwindow.y1-view->mainwindow.y0);

    v.layer=VRBACK;
    v.pageignore=page;
    v.sectignore=section;

    v.view=view;
    v.file=view->file;
   
    err=wimp_update_wind(&v.redrawstr,&more);

    if(!err) err=viewredrawsub(&v,more);
   }
  }
  view=view->next;
 }

 return(err);
}



/****************************************************************************/

typedef struct vxcblockstr
{
 aboxstr obox;
 aboxstr sbox;
 int     object;
 int     content;
 int     branch;
 int     page;
 int     section;
 int     sub;
} vxcblockstr;


#define VXCCHUNK (16*sizeof(vxcblockstr))


os_error * vxcadd(viewredrawstr * v,int object,int sub,int content,
                                            aboxstr * obox,aboxstr * sbox)
{
 os_error    * err;
 viewstr     * view;
 vxcblockstr * rvx;
 vxcblockstr * lvx;

 err=NULL;

 view=v->view;

 rvx=lvx=NULL;

 if(view->vxcache && view->vxcachen)
 {
  rvx=(vxcblockstr*)view->vxcache;
  lvx=rvx+view->vxcachen;

  while(rvx<lvx)
  {
   if(rvx->object==object && rvx->sub==sub)
   {
    getsumabox(&rvx->obox,obox);
    getsumabox(&rvx->sbox,sbox);
    break;
   }
   rvx++;
  }
 }

 if(rvx==lvx)
 {
  if(view->vxcache) err=flex_chunk((flex_ptr)&view->vxcache,
                           (view->vxcachen+1)*sizeof(vxcblockstr),VXCCHUNK);
  else              err=flex_alloc((flex_ptr)&view->vxcache,VXCCHUNK);

  if(!err)
  {
   rvx=(vxcblockstr*)view->vxcache;
   rvx+=view->vxcachen;

   rvx->object=object;
   rvx->sub=sub;
   rvx->content=content;
   rvx->obox=*obox;
   rvx->sbox=*sbox;
   rvx->branch=view->branch;
   rvx->page=v->page;
   rvx->section=v->section;

   view->vxcachen++;
  }
 }

 return(err);
}



os_error * vxcrem(viewstr * view,int object,int sub)
{
 os_error    * err;
 vxcblockstr * rvx;
 vxcblockstr * wvx;
 vxcblockstr * lvx;
 vxcblockstr * bvx;

 err=NULL;

/* dprintf(0,"vxcrem object=%d sub=%d",object,sub); */

 if(view->vxcache && view->vxcachen)
 {
  wvx=rvx=bvx=(vxcblockstr*)view->vxcache;
  lvx=rvx+view->vxcachen;

  while(rvx<lvx)
  {
   if(rvx->object==object && (rvx->sub==sub || sub==-1)) rvx++;
   else
   {
    *wvx++=*rvx++;
   }
  }

  view->vxcachen=wvx-bvx;

/*  dprintf(0,"vxcachen=%d",view->vxcachen); */
 }

 return(err);
}






os_error * vxcget(viewstr * view,int object,int sub,int n,aboxstr ** sbox)
{
 vxcblockstr * rvx;
 vxcblockstr * lvx;

 *sbox=NULL;

 if(n==0)
 {
  if(view->vxcache && view->vxcachen)
  {
   rvx=(vxcblockstr*)view->vxcache;
   lvx=rvx+view->vxcachen;

   while(rvx<lvx)
   {
    if(rvx->object==object && (rvx->sub==sub || sub==-1))
    {
     *sbox=&rvx->sbox;
     break;
    }
    rvx++;
   }
  }
 }

 return(NULL);
}


/* called when view is going to be closed */

os_error * vxcclose(viewstr * view)
{
 if(view->vxcache) return(flex_free((flex_ptr)&view->vxcache));
 else              return(NULL);
}


/* called when view is going to be repainted */

os_error * vxcrefresh(viewstr * view)
{
 view->vxcachen=0;
 return(NULL);
}


/* called when view is reopened */

os_error * vxcopen(viewstr * view)
{
 vxcblockstr * rvx;
 vxcblockstr * wvx;
 vxcblockstr * lvx;
 vxcblockstr * bvx;
 int           xlo;
 int           xhi;
 int           ylo;
 int           yhi;

 if(view->vxcache && view->vxcachen)
 {
  wvx=rvx=bvx=(vxcblockstr*)view->vxcache;
  lvx=rvx+view->vxcachen;

  xlo=ourunits(view->mainwindow.x0-view->mainwindow.bx,view);
  xhi=ourunits(view->mainwindow.x1-view->mainwindow.bx,view);
  ylo=ourunits(-(view->mainwindow.y1-view->mainwindow.by),view);
  yhi=ourunits(-(view->mainwindow.y0-view->mainwindow.by),view);

  while(rvx<lvx)
  {
   if((rvx->obox.x0<xlo) ||
      (rvx->obox.x1>xhi) ||
      (rvx->obox.y1>yhi) ||
      (rvx->obox.y0<ylo)) {rvx++;/*dprintf(5,"window cut");*/}
   else
   {
    *wvx++=*rvx++;
   }
  }

  view->vxcachen=wvx-bvx;
 }

 return(NULL);
}


os_error * vxcflush(filestr * file,int content,int * object,int * sub)
{
 viewstr     * view;
 vxcblockstr * rvx;
 vxcblockstr * lvx;

 view=file->view;
 while(view)
 {
  if(view->vxcache && view->vxcachen)
  {
   rvx=(vxcblockstr*)view->vxcache;
   lvx=rvx+view->vxcachen;

   while(rvx<lvx)
   {
    if(rvx->content==content)
    {
     *object=rvx->object;
     *sub=rvx->sub;
     return(NULL);
    }
    rvx++;
   }
  }
  view=view->next;
 }

 *object=NULL;

 return(NULL);
}



os_error * vxcclear(filestr * file,int object,int sub)
{
 viewstr     * view;

 view=file->view;
 while(view)
 {
  vxcrem(view,object,sub);
  view=view->next;
 }

 return(NULL);
}

