#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <ctype.h>

#include "os.h"
#include "bbc.h"
#include "font.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "transform.h"
#include "deb.h"

#include "err.h"
#include "etc.h"
#include "bits.h"
#include "xmath.h"
#include "bf.h"
#include "poll.h"
#include "colour.h"
#include "xprocess.h"
#include "dbhi.h"
#include "drawmod.h"
#include "redraw.h"
#include "imlib.h"
#include "bmpim.h"


#include "str.h"
#include "constants.h"

#include "object.h"
#include "file.h"
#include "view.h"
#include "undo.h"

#include "dscript.h"


#include "xredraw.h"
#include "splink.h"
#include "xxcolour.h"
#include "xcolour.h"
#include "chart.h"
#include "cconv.h"
#include "colsep.h"

#include "curve.h"


#include "prstr.h"

#include "postscript.h"












os_error * render_draw_stroke(int * path,int thickness,int flags,int * caps,transformstr * tr,int style,int flatness,viewredrawstr * v)
{
 os_error * err;

 if(v && v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))
 {
  err=ps_draw_stroke(path,thickness,flags,caps,tr,style,flatness);
 }
 else
 {
  transformstr result;

  if(v) tr_multiply(&result,tr,&v->tr);
  else  result=*tr;
  
  err=Draw_Stroke(path,thickness,flags,caps,&result,style,flatness);
 }

 
 return(err);
}




os_error * render_draw_fill(int * path,transformstr * tr,int windingrule,int flatness,int flags,viewredrawstr * v)
{
 os_error * err;

 if(v && v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))
 {
  err=ps_draw_fill(path,tr,windingrule,flatness,flags);
 }
 else
 {
  transformstr result;

  if(v) tr_multiply(&result,tr,&v->tr);
  else  result=*tr;

  err=Draw_Fill(path,&result,windingrule,flatness,flags);
 }

 return(err);
}



os_error * render_setclipcurve(curvestr * c,transformstr * tr,viewredrawstr * v)
{
 os_error * err;

 if(v && v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))
 {
  err=ps_setclipcurve(c,tr,v);
 }
 else
 {

  err=setclipcurve(c,tr,v);
 }

 return(err);
}



os_error * render_clearclipcurve(viewredrawstr * v)
{
 os_error * err;

 if(v && v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))
 {
  err=ps_clearclipcurve();
 }
 else
 {
  err=clearclipcurve();
 }

 return(err);
}



os_error * render_getdrtr(transformstr * tr,transformstr * itr,viewredrawstr * v)
{
 os_error * err;

 err=NULL;

 getdrtr(tr,itr,v);

 return(err);
}



os_error * render_gwinrectdr(int x0,int y0,int x1,int y1,int * visible,viewredrawstr * v)
{
 os_error * err;

 if(v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))
 {
  err=ps_gwinrectdr(x0,y0,x1,y1,visible);
 }
 else
 {
  coordstr cx[2];

  cx[0].x=x0;
  cx[1].x=x1;
  cx[0].y=y0;
  cx[1].y=y1;

  if(v) tr_transformset(cx,2,&v->tr);



  err=bbc_gwinrectdr(cx[0].x,cx[0].y,cx[1].x,cx[1].y,visible);

//  cprintf("gwin %d %d %d %d vis %d",cx[0].x,cx[0].y,cx[1].x,cx[1].y,*visible);
 }

 return(err);
}



os_error * render_gwindowdr(int x0,int y0,int x1,int y1,viewredrawstr * v)
{
 os_error * err;

 if(v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))
 {
  err=ps_gwindowdr(x0,y0,x1,y1);
 }
 else
 {
  coordstr cx[2];

  cx[0].x=x0;
  cx[1].x=x1;
  cx[0].y=y0;
  cx[1].y=y1;

  if(v) tr_transformset(cx,2,&v->tr);

 
  err=bbc_gwindowdr(cx[0].x,cx[0].y,cx[1].x,cx[1].y);
 }

 return(err);
}



os_error * render_saveclippath(void ** handle,viewredrawstr * v)
{
 os_error * err;

 if(v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))
 {
  err=ps_saveclippath(handle);
 }
 else
 {
  err=bbc_saveclippath(handle);
 }

 return(err);
}



os_error * render_loadclippath(void * handle,viewredrawstr * v)
{
 os_error * err;

 if(v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))
 {
  err=ps_loadclippath(handle);
 }
 else
 {
  err=bbc_loadclippath(handle);
 }

 return(err);
}



static void orderbox(wimp_box * box)
{
 if(box->x0>box->x1) SWOP(box->x0,box->x1);
 if(box->y0>box->y1) SWOP(box->y0,box->y1);
}



os_error * render_setclipwindow(wimp_redrawstr * redrawstr,wimp_box * box,
                                wimp_box * scrapbox,void ** handle,int * visible,viewredrawstr * v)
{
 os_error * err;

// return(NULL);

 if(v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))
 {
  err=ps_setclipwindow(redrawstr,box,scrapbox,handle,visible);
 }
 else
 {
  wimp_box box2;

  if(v)
  {
   box2=*box;

   tr_transformset((coordstr*)&box2,2,&v->tr);
   orderbox(&box2);
   tr_transformset((coordstr*)&redrawstr->g,2,&v->tr);
   orderbox(&redrawstr->g);

   err=setclipwindow(redrawstr,&box2,scrapbox,handle,visible);

   tr_inverseset((coordstr*)&redrawstr->g,2,&v->tr);
   orderbox(&redrawstr->g);

//   cprintf("set clip win %d",*visible);
  }
  else
  {
   err=setclipwindow(redrawstr,box,scrapbox,handle,visible);
  }
 }

 return(err);
}



os_error * render_resetclipwindow(wimp_redrawstr * redrawstr,
                                  wimp_box * scrapbox,void * handle,viewredrawstr * v)
{
 os_error * err;

// return(NULL);

 if(v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))
 {
  err=ps_resetclipwindow(redrawstr,scrapbox,handle);
 }
 else
 {
  err=resetclipwindow(redrawstr,scrapbox,handle);
 }

 return(err);
}



os_error * render_setcolour(colourvalue * cv,int * transparent,viewredrawstr * v)
{
 os_error * err;

 if(v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))
 {
  err=ps_setcolour(cv,transparent,v->view);
 }
 else
 {
  err=vsetcolour(cv,transparent,v->view);
 }

 return(err);
}



os_error * render_setwimpcolour(int colour,viewredrawstr * v)
{
 os_error * err;

 if(v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))
 {
  err=ps_setgcol(cvdu.vdupal.c[colour & 0xF].word,0);
 }
 else
 {
  err=rwimp_setcolour(colour);
 }

 return(err);
}





os_error * render_setgcol(int pal,int action,viewredrawstr * v)
{
 os_error * err;

 if(v && v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))
 {
		err=ps_setgcol(pal,action);
 }
 else
 {
  err=rsetgcol(pal,action);
 }

 return(err);
}



os_error * render_string(char * font,int xsize,int ysize,int fcol,char * string,int options,int x,int y,viewredrawstr * v)
{
 os_error * err;

// x,y are relative to the bottom left corner of the paper
// since cbox.y1 is at 0,0 in graphics coords we can convert using it

 if(v && v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))
 {
  err=ps_string(font,xsize,ysize,fcol,string,options,x,y,v);
 }
 else
 {
  int      fonthandle;
  coordstr cx;

  if(xsize==ysize) xsize=0;

  if(ISW9X)
  {
   transformbitstr  bits;

   tr_getbits(&v->tr,&bits);
   xsize=scale(xsize,bits.xscale,0x10000);
   ysize=scale(ysize,bits.yscale,0x10000);
   
   err=font_find1(font,(xsize*16)/1000,(ysize*16)/1000,bits.angle,&fonthandle);
 		if(!err)
 		{
    if(fonthandle)
    {
     paperstr * p=PRJOBPP(((prjobstr*)v->prjob),((prjobstr*)v->prjob)->pn);

     font_setcolour(fonthandle,0xFFFFFF00,fcol,14);

     cx.x=v->ox+(x-osunits(p->cbox.x0,v->view));
     cx.y=v->oy+(y-osunits(p->cbox.y1,v->view));

     tr_transformset(&cx,1,&v->tr);

     font_paint(string,options,cx.x,cx.y);

     font_lose(fonthandle);
    }
   }
  }
  else
  {
   err=font_find(font,(xsize*16)/1000,(ysize*16)/1000,0,0,&fonthandle);
 		if(!err)
 		{
    if(fonthandle)
    {
     paperstr * p=PRJOBPP(((prjobstr*)v->prjob),((prjobstr*)v->prjob)->pn);

     font_setcolour(fonthandle,0xFFFFFF00,fcol,14);

     cx.x=v->ox+(x-osunits(p->cbox.x0,v->view));
     cx.y=v->oy+(y-osunits(p->cbox.y1,v->view));

     tr_transformset(&cx,1,&v->tr);

     font_painttrans(string,options,cx.x,cx.y,(font_transform*)&v->tr);

     font_lose(fonthandle);
    }
   }
		}
 }

 return(err);
}



os_error * render_sp(newsprite_header * sp,transformstr * tr,processstr * pr,
                    int * claimed,viewredrawstr * v)
{
 os_error * err;
 

 if(v && v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))
 {
  err=ps_sprender(sp,tr,pr,claimed);
 }
 else
 {
  transformstr result;

  if(v) tr_multiply(&result,tr,&v->tr);
  else  result=*tr;
  
  err=sp_enhanced_render(sp,&result,pr,claimed);
 }

 return(err);
}



os_error * render_jp(char * data,int len,transformstr * tr,processstr * pr,
                     int * claimed,viewredrawstr * v)
{
 os_error * err;

 if(v && v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))
 {
  err=ps_jprender(data,len,tr,pr,claimed);
 }
 else
 {
  transformstr result;

  if(v) tr_multiply(&result,tr,&v->tr);
  else  result=*tr;

  err=jp_enhanced_render(data,len,&result,pr,claimed);
 }

 return(err);
}



os_error * render_bmp(void * data,transformstr * tr,aboxstr * abox,processstr * pr,viewredrawstr * v)
{
 os_error * err;

// if(pr->isprinter && pr->prjob && (((prjobstr*)pr->prjob)->prtype==PRPS) && (((prjobstr*)pr->prjob)->bits & PSDIRECT))
 if(v && v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))
 { 
  framestr   frame;

  bmpgetframedata(&frame,data);

  err=ps_renderframe(&frame,tr,pr);
 }
 else
 {
  coordstr     cx[4];
  transformstr result;

  cx[0].x=abox->x0;
  cx[0].y=abox->y0;
  cx[1].x=abox->x1;
  cx[1].y=cx[0].y;
  cx[2].x=cx[1].x;
  cx[2].y=abox->y1;
  cx[3].x=cx[0].x;
  cx[3].y=cx[2].y;

  if(v) tr_multiply(&result,tr,&v->tr);
  else  result=*tr;

  tr_transformset(cx,4,&result);

  err=bmppaintbox(data,cx,pr);
 }

 return(err);
}


