/*->c.dbborder */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"



#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "etc.h"
#include "dbhi.h"
#include "redraw.h"
#include "colour.h"
#include "fsx.h"
#include "bf.h"
#include "trans.h"
#include "bits.h"
#include "deb.h"



#include "str.h"

#include "units.h"
#include "reslink.h"
#include "mhi.h"
#include "view.h"
#include "file.h"
#include "object.h"
#include "select.h"

#include "xcolour.h"
#include "dbcolour.h"

#include "dbscale.h"

#include "line.h"
#include "dbline.h"


#include "mhi.h"

#include "border.h"

#include "dbborder.h"


extern dboxstr     borderbox[3];

static os_error * optfn(int handle,int userhandle,wimp_mousestr * m);


static filestr   * cfile;
static viewstr   * cview;


static borderdatastr cborder;
static borderdatastr oborder;

static int           selectedbordern;
static int           focusn;


#define PANESTEP       96
#define PANEHEIGHT     72
#define PANEWIDTH      300
#define PANELEFTMARGIN 16
#define PANEBLOCKDX    12
#define PANETOPMARGIN  16

#define PANETHICKNESS  (32*256)


#define DEFBORDERMODE 0xF
#define DEFSHADOWMODE (2+1)







static os_error * paneopenat(int n,int handle)
{
 os_error * err;
 windowstr  window;

 err=getw(handle,&window);

 openatscroll(handle,0,
              -(PANETOPMARGIN+n*PANESTEP)+(window.y1-window.y0)/2);

 return(err);
}



static os_error * paneredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error * err;
 int        ox;
 int        oy;
 int        ylo;
 int        yhi;
 int        n;
 int        y;
 err=NULL;

 while(more)
 {
  ox=redrawstr->box.x0-redrawstr->scx;
  oy=redrawstr->box.y1-redrawstr->scy;

  ylo=-(redrawstr->g.y1-oy);            /* small number, top of window */
  yhi=-(redrawstr->g.y0-oy);            /* bigger, bottom of window */

  n=(ylo-PANETOPMARGIN)/PANESTEP;
  if(n<0) n=0;
  y=n*PANESTEP+PANETOPMARGIN;

  while(y<=yhi && n<borderdefn)
  {
   wimp_setcolour(n==selectedbordern?WIMPBLACK:WIMPWHITE);
   bbc_rectanglefilli(ox+PANELEFTMARGIN-PANEBLOCKDX,oy-y,
                        PANEWIDTH+2*PANEBLOCKDX,-PANEHEIGHT);

   if(n==focusn)
   {
    wimp_setcolour(WIMPBLACK);
    bbc_setstyle(1);
    bbc_rectanglei(ox+PANELEFTMARGIN-PANEBLOCKDX,oy-y,PANEWIDTH+2*PANEBLOCKDX,-PANEHEIGHT);
   }

   sampleborder((ox+PANELEFTMARGIN)*256,(oy-y)*256,PANEWIDTH*256,
                 PANEHEIGHT*256,PANETHICKNESS,n,n==selectedbordern);

   y+=PANESTEP;
   n++;
  }

  wimp_get_rectangle(redrawstr,&more);
 }

 return(err);
 handle=handle;
}


static os_error * paneredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;

 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) paneredrawsub(handle,&redrawstr,more);
 return(err);

 USE(userhandle);
}


static void panerefreshline(int handle,int n)
{
 wimp_redrawstr r;
 int more;

 r.box.x0=PANELEFTMARGIN-PANEBLOCKDX;
 r.box.x1=r.box.x0+PANEWIDTH+2*PANEBLOCKDX+cvdu.extrax;
 r.box.y1=-(n*PANESTEP+PANETOPMARGIN)+cvdu.extray;
 r.box.y0=r.box.y1-PANEHEIGHT-2*cvdu.extray;
 r.w=handle;

 wimp_update_wind(&r,&more);
 paneredrawsub(handle,&r,more);
}




static os_error * optmfn(int handle,int userhandle,wimp_mousestr * m)
{
 if(!cborder.border[SHADOW].active && !cborder.border[BORDER].active)
 {
  cborder.border[BORDER].active=1;
  dbchangevalue(&cborder.border[BORDER].active,borderbox);
 }
 return(NULL);

 USE(handle);
 USE(userhandle);
 USE(m);
}




/* on repeat/stretch buttons */

static os_error * optxfn(int handle,int userhandle,wimp_mousestr * m)
{


 return(NULL);

 USE(handle);
 USE(userhandle);
 USE(m);
}



/* on design width button */

/* called below from newborderselected(int n) with m=NULL */

static os_error * optzfn(int handle,int userhandle,wimp_mousestr * m)
{
 int      type;
 int      width;

 type=getborderinfo(selectedbordern,&width);

 if(type==BDRFANCY)
 {
  if(cborder.border[BORDER].active & BDRDES)
  {
   cborder.border[BORDER].width=(25*width)/16;
   dbchangevalue(&cborder.border[BORDER].width,borderbox);
  }

  shadeiconst(handle,18,cborder.border[BORDER].active & BDRDES);
  shadeiconst(handle,19,cborder.border[BORDER].active & BDRDES);
  shadeiconst(handle,30,cborder.border[BORDER].active & BDRDES);
 }

 return(NULL);

 USE(handle);
 USE(userhandle);
 USE(m);
}



static os_error * newborderselected(int n)
{
 int      type;
 int      width;

 type=getborderinfo(n,&width);

 if(type==BDRFANCY)
 {
  dbshade(3,0,borderbox);

  optzfn(borderbox[0].handle,0,NULL);
 }
 else
 {
  /* shade repeat, stretch and design size icons, group 3 */

  dbshade(3,DBSHADEG,borderbox);
  unshadeicon(borderbox[0].handle,18);
  unshadeicon(borderbox[0].handle,19);
  unshadeicon(borderbox[0].handle,30);
 }

 return(NULL);
}



static void checkstate(int s)
{
 if(!(cborder.border[s].active & BDRACT))
 {
  cborder.border[s].active|=BDRACT;
  dbchangevalue(&cborder.border[s].active,borderbox);
  optfn(borderbox[0].handle,0,NULL);
 }
}



static os_error * paneselectn(int handle,int n)
{
 os_error * err;
 int        oldn;

 oldn=selectedbordern;
 selectedbordern=n;
 if(focusn>=0) focusn=selectedbordern;
 newborderselected(n);
 panerefreshline(handle,oldn);
 panerefreshline(handle,selectedbordern);

 err=setfocus(handle);

 return(err);
}






static os_error * paneopenline(int handle,int n)
{
 wimp_wstate wblock;
 int         top;
 int         bot;

 wimp_get_wind_state(handle,&wblock);

 top=-((n)*PANESTEP+PANETOPMARGIN);
 bot=-((n+1)*PANESTEP+PANETOPMARGIN);

 if(top>wblock.o.y) wblock.o.y=top;

 if(bot<(wblock.o.y-(wblock.o.box.y1-wblock.o.box.y0))) wblock.o.y=bot+(wblock.o.box.y1-wblock.o.box.y0);

// wblock.o.y=-(n+1)*(PANESTEP)+(PANESTEP>>1)+((wblock.o.box.y1-wblock.o.box.y0)>>1);


 return(wimp_open_wind(&wblock.o));
}





static os_error * panecaret(int handle,int userhandle,int gain)
{
 os_error * err;
 int        oldfocusn;

 err=NULL;


 if(gain)
 {
  focusn=selectedbordern;
  panerefreshline(handle,focusn);
 }
 else
 {
  oldfocusn=focusn;
  focusn=-1;
  panerefreshline(handle,oldfocusn);
 }


 return(err);

 USE(userhandle);
}



static os_error * panekey(int panehandle,int userhandle,int icon,int * key)
{
 int ch;
 int n;
 int mainhandle;

 
 mainhandle=borderbox[0].handle;

 ch=*key;


 if(ch==CUP || ch==CDOWN)
 {
  n=focusn;
  n+=((*key==CDOWN)?1:-1);
  if(n<0) n=0;
  if(n>=borderdefn) n=borderdefn-1;

  if(n!=selectedbordern)
  {
   paneselectn(panehandle,n);
   paneopenline(panehandle,n);
  }
  *key=-1;
 }
 else
 if(ch==TAB || ch==SHFT_TAB)
 {
  setnexttabw(mainhandle,panehandle,ch==SHFT_TAB);
  *key=-1;
 }


 return(NULL);

 USE(icon);
 USE(userhandle);
}








static os_error * paneicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        n;
 windowstr  window;

 err=getw(handle,&window);
 if(!err)
 {
  n=((window.by-m->y)-PANETOPMARGIN)/PANESTEP;

  if((n!=selectedbordern || n!=focusn) && n<borderdefn && n>=0)
  {
   paneselectn(handle,n);
  }

  checkstate(BORDER);

  if(m->bbits==0x400) err=dbclose(borderbox,DBOK);
 }
 return(err);

 USE(userhandle);
}




#define BCOLOURICON 16
#define SCOLOURICON 22


static os_error * colredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error * err;

 err=NULL;

 while(more)
 {
  redrawblock(redrawstr,handle,BCOLOURICON,
                     vfindcolour2(NULL,cfile,&cborder.border[BORDER].colour));
  redrawblock(redrawstr,handle,SCOLOURICON,
                     vfindcolour2(NULL,cfile,&cborder.border[SHADOW].colour));

  wimp_get_rectangle(redrawstr,&more);
 }
 return(err);
}


static os_error * redraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;

 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) colredrawsub(handle,&redrawstr,more);
 return(err);

 USE(userhandle);
}



static os_error * setpaneextent(int handle)
{
 os_error * err;
 windowstr  window;
 int        height;
 int        width;

 err=getw(handle,&window);
 if(!err)
 {
  width=window.x1-window.x0;
  height=MAX(window.y1-window.y0,PANETOPMARGIN+borderdefn*PANESTEP);
  err=extent(handle,0,-height,width,0);
 }
 return(err);
}



static os_error * borderclose(int code)
{
 os_error            * err;
 modifyborderdatastr   modborder;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  getbordername(cborder.name,selectedbordern);
  borderchange(&modborder,&cborder,&oborder);
  borderselection(&modborder,cfile);
  oborder=cborder;
 }

 if(code!=DBAPPLY)
 {
  remcaretevent(panecaret,borderbox[1].handle,0);
 }

 return(err);
}




static void bpickclose(colourvalue * colourp)
{
 cborder.border[BORDER].colour=*colourp;
 wimp_set_icon_state(borderbox->handle,BCOLOURICON,
                                   (wimp_iconflags)0,(wimp_iconflags)0);
 checkstate(BORDER);
}


static void spickclose(colourvalue * colourp)
{
 cborder.border[SHADOW].colour=*colourp;
 wimp_set_icon_state(borderbox->handle,SCOLOURICON,
                                   (wimp_iconflags)0,(wimp_iconflags)0);
 checkstate(SHADOW);
}



static os_error * bordergetwidth(int * width)
{
 *width=cborder.border[BORDER].width;
 return(NULL);
}

static os_error * bordersetwidth(int width)
{
 checkstate(BORDER);
 cborder.border[BORDER].width=width;
 return(dbchangevalue(&cborder.border[BORDER].width,borderbox));
}

static os_error * shadowgetwidth(int * width)
{
 *width=cborder.border[SHADOW].width;
 return(NULL);
}

static os_error * shadowsetwidth(int width)
{
 checkstate(SHADOW);
 cborder.border[SHADOW].width=width;
 return(dbchangevalue(&cborder.border[SHADOW].width,borderbox));
}


static os_error * bordericon(int handle,int userhandle,wimp_mousestr * m)
{

 if(m->i==30) return(openlinewidthmenu(bordersetwidth,bordergetwidth,handle));
 else
 if(m->i==31) return(openlinewidthmenu(shadowsetwidth,shadowgetwidth,handle));
 else
 if(m->i==17) return(pickcolour(cfile,&cborder.border[BORDER].colour,
                                                    bpickclose,borderbox));
 else
 if(m->i==23) return(pickcolour(cfile,&cborder.border[SHADOW].colour,
                                                   spickclose,borderbox));
 else         return(NULL);

 USE(userhandle);
 USE(handle);
}




static os_error * wrthick(int value,char * string)
{
 if(value) strcpy(string,unitstostring(value,cview->data.units));
 else      tsprintf(32,string,"{THIN}");
 return(NULL);
}



static os_error * rdthick(int * value,char * string)
{
 os_error * err;
 char       temp[64];

 err=NULL;

 tsprintf(sizeof(temp),temp,"{THIN}");
 if(!cstrcmp(temp,string)) *value=0;
 else                      err=stringtounits(string,value,cview->data.units);

 return(err);
}





static dbiconstr bordericondefs[]=
{
 /* N   &V           Type     Grp   Flags   Msk Key   ESG   -   clickfn 0 */


   20,  &cborder.border[BORDER].active,
                      DBTOGGLE, 0,   0,BDRACT,   F7,  2,0,(dbreadfn)optfn, 0,

   21,  &cborder.border[SHADOW].active,
                      DBTOGGLE, 1,   0,BDRACT,   F8,  2,0,(dbreadfn)optfn, 0,

   34,  &cborder.border[BORDER].active,
                      DBTOGGLE, 3,   0,BDRREP,   F9,  0,0,(dbreadfn)optxfn, 0,

   35,  &cborder.border[BORDER].active,
                      DBTOGGLE, 3,   0,BDRSTR,   F10, 0,0,(dbreadfn)optxfn, 0,

   36,  &cborder.border[BORDER].active,
                      DBTOGGLE, 3,   0,BDRDES,   F11, 0,0,(dbreadfn)optzfn, 0,



 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

    19,  &cborder.border[BORDER].width,    
                      DBWRITE,  0,   0,   -1, -1, -1, -1, rdthick,  wrthick,
    25,  &cborder.border[SHADOW].width,
                      DBWRITE,  1,   0,   -1, -1, -1, -1, rdthick,  wrthick,


 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,          DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,          DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,
    3, NULL,          DBACTION, 0,   0,      DBAPPLY,-1, 0,0,NULL, 0,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

    0, NULL,          DBTEXT,   1,  0,       -1, -1, -1, -1, NULL, NULL,
   22, NULL,          DBTEXT,   1,  0,       -1, -1, -1, -1, NULL, NULL,
   23, NULL,          DBTEXT,   1,  0,       -1, -1, -1, -1, NULL, NULL,
   24, NULL,          DBTEXT,   1,  0,       -1, -1, -1, -1, NULL, NULL,
   31, NULL,          DBTEXT,   1,  0,       -1, -1, -1, -1, NULL, NULL,


   -1, NULL,          0,       0,    0,      0,  0,  0,  0,  0,      0
};






static int oldshadow;



static dbiconstr borderbicondefs[]=
{
    3,  &cborder.border[BORDER].mode,  
                      DBTOGGLE, 1,   0,BDRLEFT,  F2, 1,0,(dbreadfn)optmfn, 0,
    4,  &cborder.border[BORDER].mode,  
                      DBTOGGLE, 1,   0,BDRRIGHT, F3, 1,0,(dbreadfn)optmfn, 0,
    5,  &cborder.border[BORDER].mode,  
                      DBTOGGLE, 1,   0,BDRTOP,   F5, 1,0,(dbreadfn)optmfn, 0,
    6,  &cborder.border[BORDER].mode,  
                      DBTOGGLE, 1,   0,BDRBOT,   F6, 1,0,(dbreadfn)optmfn, 0,

   -1, NULL,          0,       0,    0,      0,  0,  0,  0,  0,      0
};


static dboxstr borderb=
{
 0,
 TBORDERB,
 DBPANE,
 0,
 NULL,
 NULL,
 NULL,
 NULL,
 borderbicondefs,
 0,
 0,
 0,
 NULL,
 0,
 0,
};




static dbiconstr bordersicondefs[]=
{
    3,  &cborder.border[SHADOW].mode,  
                      DBRADIO, 1,   0,BDRLEFT+BDRTOP,  F2, 1,0,(dbreadfn)optmfn, 0,
    4,  &cborder.border[SHADOW].mode,  
                      DBRADIO, 1,   0,BDRRIGHT+BDRTOP, F3, 1,0,(dbreadfn)optmfn, 0,
    5,  &cborder.border[SHADOW].mode,  
                      DBRADIO, 1,   0,BDRLEFT+BDRBOT,   F5, 1,0,(dbreadfn)optmfn, 0,
    6,  &cborder.border[SHADOW].mode,  
                      DBRADIO, 1,   0,BDRRIGHT+BDRBOT,  F6, 1,0,(dbreadfn)optmfn, 0,

   -1, NULL,          0,       0,    0,      0,  0,  0,  0,  0,      0
};





static dboxstr borders=
{
 0,
 TBORDERS,
 DBPANE,
 0,
 NULL,
 NULL,
 NULL,
 NULL,
 bordersicondefs,
 0,
 0,
 0,
 NULL,
 0,
 0,
};




static dboxstr borderbox[3]=
{
 0,
 TBORDER,
 DBFIX,
 0,
 borderclose,
 bordericon,
 NULL,
 redraw,
 bordericondefs,
 0,
 0,
 0,NULL,
 0,
 0,


 0,
 TBORDERP,
 DBPANE,
 0,
 NULL,
 paneicon,
 panekey,
 paneredraw,
 NULL,
 0,
 0,
 0,
 NULL,
 0,
 0,


 0,
 TBORDERS,
 DBPANE,
 0,
 NULL,
 NULL,
 NULL,
 NULL,
 bordersicondefs,
 0,
 0,
 0,
 NULL,
 0,
 0,

};



static os_error * optfn(int handle,int userhandle,wimp_mousestr * m)
{
// setbordericons(cborder.border[SHADOW].active,handle);

 if(cborder.border[SHADOW].active!=oldshadow)
 {
  if(cborder.border[SHADOW].active)
  {
   dbchangepane(borderbox+2,&borders,borderbox);
  }
  else
  {
   dbchangepane(borderbox+2,&borderb,borderbox);
  }
  oldshadow=cborder.border[SHADOW].active;
 }
 return(NULL);

 USE(handle);
 USE(userhandle);
 USE(m);
}










static colourvalue defbordercolour={OURBLACK};



#define OM_BORDERTYPE   0x5000
#define OM_NEWBORDER    0x5001


/* script function opens the new document dialogue box */

void openborderbox(int fp)
{
 os_error      * err;
 int             message;
 int             border;
 borderlinestr * borderp;
 outlineinfostr  oinfo;
 int             n;
 int             object;

 cfile=menufile;
 cview=menuview;

 message=OM_BORDERTYPE;

 selectionmessage(menufile,&message,&border);
 if(!message)
 {
  focusn=-1;
  if(!border)
  {
   selectedbordern=0;
   cborder.border[BORDER].colour=defbordercolour;
   cborder.border[SHADOW].colour=defbordercolour;
   cborder.border[BORDER].width=MMSIZE;
   cborder.border[SHADOW].width=MMUNITS(2); 
   cborder.border[BORDER].mode=DEFBORDERMODE;
   cborder.border[SHADOW].mode=DEFSHADOWMODE;
   cborder.border[BORDER].active=0;
   cborder.border[SHADOW].active=0;
  }
  else
  {
   borderp=(borderlinestr*)fob_find(border,cfile);
   cborder=borderp->data;
   selectedbordern=getborderindex(borderp->data.name);
  } 

  oborder=cborder;

  oldshadow=cborder.border[SHADOW].active;
  *(borderbox+2)=oldshadow?borders:borderb;

  err=dodboxspparent(borderbox,3,borderbox,&dbviewstack,cview->handle);
  if(!err) err=setpaneextent(borderbox[1].handle);
  if(!err) err=paneopenat(selectedbordern,borderbox[1].handle);
  if(!err) err=wimp_setwindowbackground(borderbox[1].handle,CCRGB|PALWHITE);
  if(!err) err=addcaretevent(panecaret,borderbox[1].handle,0);
  if(!err) err=wimp_setwindowflags(borderbox[1].handle,WINDOWNOTDIALOGUE,0);


  n=0;
  while((object=nselectedobject(n++,cfile))!=0)
  {
   objectoread(SELECTINFO,object,cfile,&oinfo);
   if(oinfo.fcurve.type!=CBOX) break;
  }
  dbshade(1,object?DBSHADEG:0,borderbox);

  newborderselected(selectedbordern);
 }

 USE(fp);
}

