/*->c.dbmacros */


#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>



#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "flex.h"
#include "sprite.h"
#include "transform.h"


#include "filetype.h"
#include "fsx.h"
#include "wos.h"
#include "poll.h"
#include "etc.h"
#include "key.h"
#include "wimptext.h"
#include "temp.h"
#include "sp.h"
#include "applet.h"
#include "bits.h"
#include "err.h"
#include "trans.h"
#include "save.h"
#include "xhelp.h"
//#include "txcb.h"
#include "colour.h"
#include "deb.h"


#include "xext.h"


#include "str.h"
#include "constants.h"
#include "reslink.h"
#include "units.h"

#include "dbhi.h"

#include "file.h"
#include "view.h"
#include "caret.h"

#include "macros.h"
#include "buttons.h"

#include "dbmacros.h"



/*****************************************************************************/
/* code for macros windows */

                        /* step between each macro entry in window */
#define MACDY   56
                        /* step between top of window and first macro */
#define MACFY   12
                        /* height of macro definitions */
#define MACHY   52

#define MACFX    8
#define MACSX    12*16+MACFX+8

#define MACSTRW  48


#define MACFXW   12*16
#define MACSXW   16*MACSTRW

#define MACWIDTH 1024

#define XICON 10


#define TMODE 2
#define KMODE 1
#define BMODE 0



static int     macroselectt;   /* number of selected macro */
static int     macroselectn;

extern dboxstr macrobox[2];

static int     macrorecord;      /* global, are we recording a macro */
static int     macromode=BMODE;  /* text/key/button                  */
static int     oldmode;

static int     macrosscroll;


typedef os_error * (*createfn)(char * name,char * defn,int type,
                                                       char * data,int over);


static wimp_icon * modeicons[3][4];
static int         mboffset;


static int         curtot;


static dbstackstr  macdbstack;

static os_error  * macrosextent(void);


static viewstr   * cview;


static int         panemaxx;
static int         paneminy;
static int         macromaxx;
static int         macrominy;



#define MACADDSELECT 0x1
#define MACADDUPDATE 0x2

static os_error * macrosaddwindow(char * name,char * defn,int mtype,char * data,char * help,char * aname,char * ttip,int flags,int over);





/****************************************************************************/

static int ci2total(int ci)
{
 int i;
 int index;

 index=-1;

 if(ci>=0)
 {
  for(i=0;i<macrostot;i++)
  {
   if((macros[i].type==TYPETEXT && macromode==TMODE) ||
      (macros[i].type==TYPEBUTTON && macromode==BMODE) ||
      (macros[i].type==TYPEKEY && macromode==KMODE))
   {
    index++;
   }

   if(index==ci) return(i);
  }
 }

 return(-1);
}


/* current button to total index */
/*

static int cb2total(int ci)
{
 int i;
 int index;

 index=-1;

 if(ci>=0)
 {
  for(i=0;i<macrostot;i++)
  {
   if(macros[i].type==TYPEBUTTON && (macros[i].flags & MACACTIVE))
   {
    index++;
   }

   if(index==ci) return(i);
  }
 }

 return(-1);
}

*/


static int total2ci(int total)
{
 int ci;
 int i;

 ci=-1;

 for(i=0;i<=total;i++)
 {
  if((macros[i].type==TYPETEXT && macromode==TMODE) ||
     (macros[i].type==TYPEBUTTON && macromode==BMODE) ||
     (macros[i].type==TYPEKEY && macromode==KMODE))
  {
   ci++;
  }
 }

 return(ci);
}

/***************************************************************************/


#define MACWINDOW  0x1
#define MACBUTTONS 0x2
#define MACEXTENT  0x4
#define MACCOMPACT 0x8


static int macupdatebits;


static void maczero(int userhandle)
{

 if(macupdatebits & MACCOMPACT)
 {
  flex_extend((flex_ptr)&macros,macrostot*sizeof(macro));
  flex_extend((flex_ptr)&mstrings,mstringsize);
 }

 if(macrobox[1].handle)
 {
  if(macupdatebits & MACWINDOW) refreshwindow(macrobox[1].handle);
  if(macupdatebits & MACEXTENT) macrosextent();
 }

 if(macupdatebits & MACBUTTONS)
 {
  buttonschanged(1);
 }

 remzeroevent(maczero,0);
 macupdatebits=0;

 USE(userhandle);
}



static int buttonviews(void)
{
 filestr * file;

 file=firstfile;
 while(file)
 {
  if(file->view) return(1);
  file=file->next;
 }

 return(0);
}



static void queuemacupdate(int bits)
{
 if(bits & MACBUTTONS)
 {
  if(!buttonviews()) 
  {
   buttonschanged(1);
   bits&=~MACBUTTONS;
  }
 }

 if(bits)
 {
  if(!macupdatebits) addzeroevent(maczero,0);
  macupdatebits|=bits;
 }
}


/****************************************************************************/

static char     newname[MNLEN];
static char     newdata[MDLEN];
static int      usesprite;


static os_error * wrnewbuttonname(int value,char * string)
{
 strcpy(string,newname);
 return(NULL);
 value=value;
}


static os_error * wrnewdata(int value,char * string)
{
 strcpy(string,newdata);
 return(NULL);
 value=value;
}


static os_error * rdnewbuttonname(int * value,char * string)
{
 xzstrncpy(newname,string,sizeof(newname));
 return(NULL);
 USE(value);
}






extern dboxstr editmacrobox;
static int     extendedevents;
static int     extendedtext;
static int     extextwidth;
static int     editmacron;
static int     editmtype;





static os_error * editmacrosp(char * name)
{
 xzstrncpy(newdata,name,sizeof(newdata));
 usesprite=1;
 dbchangevalue(&usesprite,&editmacrobox);
 return(NULL);
}



static os_error * editmacrobutton(int handle,int userhandle,wimp_mousestr * m)
{
 return(getabutton(editmacrosp,handle));
 USE(userhandle);
 USE(handle);
 USE(m);
}








static os_error * editmacroclose(int code)
{
 os_error * err;
	char       buffer[4096];
	char     * help;
	char     * tips;
	char     * defn;
	char     * applet;
	char     * lt;
	int        mtype;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
		lt=buffer+NITEM(buffer);

  err=readicon(editmacrobox.handle,20,buffer,NITEM(buffer));
		defn=buffer;
		help=defn+strlen(defn)+1;
  err=readicon(editmacrobox.handle,21,help,lt-help);
		applet=help+strlen(help)+1;
  err=readicon(editmacrobox.handle,23,applet,lt-applet);
		tips=applet+strlen(applet)+1;
  err=readicon(editmacrobox.handle,22,tips,lt-tips);

	 mtype=editmtype;

		mtype&=~TYPEBUTTONEXTEND;
		if(extendedevents) mtype|=TYPEBUTTONEXTEND;

		mtype&=~TYPEBUTTONEXTEXT;
		if(extendedtext) mtype|=TYPEBUTTONEXTEXT;

		mtype&=~TYPEBUTTONTXWIDTH;
		if(extendedtext)	mtype|=(extextwidth<<TYPEBUTTONTXSHIFT);


  macrosaddwindow(newname,defn,editmtype,usesprite?newdata:"",help,applet,tips,MACADDSELECT|MACADDUPDATE,1);
 }

 return(err);
}



static os_error * wrno(int value,char * string)
{
 strcpy(string,numbertostring(value));
 return(NULL);
}

static os_error * rdno(int * value,char * string) 
{
 return(stringtonumber(string,value));
}






static dbiconstr editmacroicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    5, NULL,         DBTEXT,  0,   0,     -1, -1, -1,-1,  NULL,wrnewbuttonname,

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0, NULL ,0,

    4, NULL,         DBACTION, 1,   0,      0,  0,  0,  0,(dbreadfn)editmacrobutton,0,

    3,&usesprite,    DBTEXT,   1,   0,     -1, -1, -1,-1, NULL, wrnewdata,
    0,&usesprite,    DBTOGGLE, 1,   0,      1, F4,  0, 0, NULL, 0,

   14,&extendedevents,DBTOGGLE, 0,   0,      1, F4,  0, 0, NULL, 0,
			15,&extendedtext, DBTOGGLE, 1,   0,      1, F4,  0, 0, NULL, 0,
			16,&extextwidth,		DBWRITE,  1,   0,	     0,  0,  0,  0,(dbreadfn)rdno,wrno,


  /*  7,&gapbefore,    DBTOGGLE, 0,   0,      1, F4,  0, 0, NULL, 0, */

   -1, NULL,         0,        0,   0,      0,  0,  0,  0,  0,      0
};


static dboxstr editmacrobox=
{
 0,
 TEDITBUTTON,
 DBFIX,
 DBCARETRESET,
 editmacroclose,
 NULL,
 NULL,
 NULL,
 editmacroicondefs,
 0,
 0,
 0,NULL,
 0,0,
};



static os_error * editmacro(int n)
{
	os_error * err;
	char     * p;


	editmacron=n;

	xzstrncpy(newname,macros[n].name,MNLEN);

	if(macros[n].type==TYPEBUTTON && (*macros[n].data.data))
 {
  xzstrncpy(newdata,macros[n].data.data,MDLEN);
  usesprite=1;
 }
 else
 {
  *newdata=0;
  usesprite=0;
 }

 editmtype=macroextbits(n);

 extendedevents=((editmtype & TYPEBUTTONEXTEND)!=0);
 extendedtext=((editmtype & TYPEBUTTONEXTEXT)!=0);
 extextwidth=(editmtype>>TYPEBUTTONTXSHIFT) & TYPEBUTTONTXWIDTH;

 err=dodboxsp(&editmacrobox,1,macrobox,&macdbstack);
	if(!err)
	{
		p=mstrings+macros[n].defn;
		writeicon(editmacrobox.handle,20,p);
		p+=strlen(p)+1;
	 writeicon(editmacrobox.handle,21,p);
		p+=strlen(p)+1;
	 writeicon(editmacrobox.handle,23,p);
		p+=strlen(p)+1;
	 writeicon(editmacrobox.handle,22,p);

  dbshade(1,(editmtype & TYPEMASK)!=TYPEBUTTON,&editmacrobox);

	}



	return(err);
}




/*****************************************************************************/




extern dboxstr newbuttonbox;


static createfn createx;


/*static int      gapbefore;*/

static int      wasactive;


static os_error * newbuttonsp(char * name)
{
 xzstrncpy(newdata,name,sizeof(newdata));
 usesprite=1;
 dbchangevalue(&usesprite,&newbuttonbox);
 return(NULL);
}


static os_error * newbut(int handle,int userhandle,wimp_mousestr * m)
{
 return(getabutton(newbuttonsp,handle));
 USE(userhandle);
 USE(handle);
 USE(m);
}




static os_error * newbuttonclose(int code)
{
 os_error * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  err=createx(newname,"",TYPEBUTTON|
                         /* (gapbefore?TYPEBUTTONG:0)| */
                         (wasactive?TYPEBUTTONA:0),
                         usesprite?newdata:"",0);
 }

 return(err);
}




static dbiconstr newbuttonicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    5, NULL,         DBWRITE,  0,   0,     -1, -1, -1,-1,rdnewbuttonname,wrnewbuttonname,

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0, NULL ,0,

    4, NULL,         DBACTION, 0,   0,      0,  0,  0,  0,(dbreadfn)newbut,0,

    3,&usesprite,    DBTEXT,   0,   0,     -1, -1, -1,-1, NULL, wrnewdata,
    0,&usesprite,    DBTOGGLE, 0,   0,      1, F4,  0, 0, NULL, 0,




  /*  7,&gapbefore,    DBTOGGLE, 0,   0,      1, F4,  0, 0, NULL, 0, */

   -1, NULL,         0,        0,   0,      0,  0,  0,  0,  0,      0
};


static dboxstr newbuttonbox=
{
 0,
 TNEWBUTTON,
 DBFIX,
 DBCARETRESET,
 newbuttonclose,
 NULL,
 NULL,
 NULL,
 newbuttonicondefs,
 0,
 0,
 0,NULL,
 0,0,
};


static os_error * newbutton(createfn cfx,char * title,char * data,int flags)
{
 os_error      * err;

 createx=cfx;

 if(data && *data) 
 {
  xzstrncpy(newdata,data,sizeof(newdata));
  usesprite=1;
 }
 else
 {
  *newdata=0;
  usesprite=0;
 }

 *newname=0;

/* gapbefore=((flags & MACGAP)!=0); */
 wasactive=((flags & MACACTIVE)!=0);

 err=dodboxsp(&newbuttonbox,1,macrobox,&macdbstack);

 writetitle(newbuttonbox.handle,title);

 return(err);
}

/****************************************************************************/
/* create a new key macro */

static int     keypress;
extern dboxstr newkeybox;


static os_error * newkeyclose(int code)
{
 os_error * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  if(keypress>=0) xzstrncpy(newname,keystring(keypress),sizeof(newname));
  else                  *newname=0;
  err=createx(newname,"",TYPEKEY,NULL,0);
 }


 return(err);
}


static os_error * wrnewkeyname(int value,char * string)
{
 if(value>=0)
  strcpy(string,keylongstringcanonical(keycode2canonical(value)));
 else
  *string=0;

 return(NULL);
}


// we'd like to take TAB out too but there's no key press return from custom icon
// so you end up tabbing away with no way back

static os_error * newkeypress(int handle,int userhandle,int icon,int * key)
{
// cprintf("ccode %x",*key);

	if(*key==RETPRESS || *key==ESCPRESS) return(NULL);
 
 keypress=*key;
 *key=-1;
 dbchangevalue(&keypress,&newkeybox);
 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(icon);
}



static dbiconstr newkeyicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0, NULL ,0,
    3, &keypress,    DBTEXT,   0,   0,     -1, -1, -1,  -1,NULL,wrnewkeyname,

   -1, NULL,         0,        0,   0,      0,  0,  0,  0,  0,      0
};


static dboxstr newkeybox=
{
 0,
 TNEWKEY,
 DBFIX,
 DBGRAB,
 newkeyclose,
 NULL,
 newkeypress,
 NULL,
 newkeyicondefs,
 0,
 0,
 0,NULL,
 0,0,
};


static os_error * newkey(createfn cfx,char * title)
{
 os_error  * err;

 keypress=-1;
 createx=cfx;

 err=dodboxsp(&newkeybox,1,macrobox,&macdbstack);

 if(!err && newkeybox.handle)
 {
  writetitle(newkeybox.handle,title);
 }

 return(err);
}

/****************************************************************************/

static os_error * newtextclose(int code)
{
 os_error * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  err=createx(newname,"",TYPETEXT,"",0);
 }
 return(err);
}

static os_error * wrnewtextname(int value,char * string)
{
 strcpy(string,"");
 return(NULL);
 value=value;
}

static os_error * rdnewtextname(int * value,char * string)
{
 xzstrncpy(newname,string,sizeof(newname));
 return(NULL);
 USE(value);
}

static dbiconstr newtexticondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0, NULL ,0,
    3, NULL,         DBWRITE,  0,   0,     -1, -1, -1,  -1,rdnewtextname,
                                                           wrnewtextname,

   -1, NULL,         0,        0,   0,      0,  0,  0,  0,  0,      0
};


static dboxstr newtextbox=
{
 0,
 TNEWMACRO,
 DBFIX,
 DBCARETRESET,
 newtextclose,
 NULL,
 NULL,
 NULL,
 newtexticondefs,
 0,
 0,
 0,NULL,
 0,0,
};


static os_error * newtext(createfn cfx,char * title)
{
 os_error * err;

 createx=cfx;
 err=dodboxsp(&newtextbox,1,macrobox,&macdbstack);

 if(!err)
 {
  writetitle(newtextbox.handle,title);
 }

 return(err);
}


/*****************************************************************************/
/* code for handling macro windows */

#define MAXICONLEN (MACLEN+64)


static void posnicon(wimp_icon * isblock,int n,int dy,int ox,int oy)
{
 int h;
// int w;

 h=isblock->box.y1-isblock->box.y0;
// w=isblock->box.x1-isblock->box.x0;

 isblock->box.y1=oy-MACFY-n*MACDY-dy;
 isblock->box.y0=isblock->box.y1-h;
// isblock->box.x0=ox;
// isblock->box.x1=isblock->box.x0+w;

 USE(ox);
}


static void xmcpystring(int dlen,char * dest,char * s1,char * s2)
{
 int    ch;
 char * lt;

 lt=dest+dlen-2;
 xzstrncpy(dest,s1,dlen);
 dest=dest+strlen(dest);

 while(1)
 {
  ch=*s2++;
  if(ch=='{') *dest++='{';
  if(ch=='\\') *dest++='\\';
  *dest++=(char)ch;
  if(ch==0) break;
  if(dest>=lt)
  {
   *dest=0;
   break;
  }
 }

}




static os_error * redtext(int n,int ox,int oy)
{
 wimp_icon  * isblock;
 int          t;
 char         string[MAXICONLEN];
 char       * oldbuffer;


 t=ci2total(n);

 if(macros[t].type==TYPETEXT)
 {
  isblock=modeicons[TMODE][0];
  posnicon(isblock,n,0,ox,oy);

  oldbuffer=isblock->data.indirecttext.buffer;
  xmcpystring(sizeof(string),string,oldbuffer,macros[t].name);
  isblock->data.indirecttext.buffer=string;
  wimp_ploticon(macrobox[1].handle,isblock,buttonarea);
  isblock->data.indirecttext.buffer=oldbuffer;

  if(n!=macroselectn)
  {
   isblock=modeicons[TMODE][1];
   posnicon(isblock,n,0,ox,oy);

   oldbuffer=isblock->data.indirecttext.buffer;
   xmcpystring(sizeof(string),string,oldbuffer,mstrings+macros[t].defn);
   isblock->data.indirecttext.buffer=string;
   wimp_ploticon(macrobox[1].handle,isblock,buttonarea);
   isblock->data.indirecttext.buffer=oldbuffer;
  }
 }

 return(NULL);
}





static os_error * redbutton(int n,int ox,int oy)
{
 wimp_icon  * isblock;
 char         string[MAXICONLEN];
 char       * oldbuffer;
 int          t;


 t=ci2total(n);

 if(macros[t].type==TYPEBUTTON)
 {
  isblock=modeicons[BMODE][0];
  posnicon(isblock,n,0,ox,oy);

  oldbuffer=isblock->data.indirecttext.buffer;
  xmcpystring(sizeof(string),string,oldbuffer,macros[t].name);
  isblock->data.indirecttext.buffer=string;
  wimp_ploticon(macrobox[1].handle,isblock,buttonarea);
  isblock->data.indirecttext.buffer=oldbuffer;

  if(strlen(macros[t].data.data))
  {
   isblock=modeicons[BMODE][1];
   posnicon(isblock,n,0,ox,oy);

   oldbuffer=isblock->data.indirecttext.buffer;
   xmcpystring(sizeof(string),string,oldbuffer,macros[t].data.data);
   isblock->data.indirecttext.buffer=string;
   wimp_ploticon(macrobox[1].handle,isblock,buttonarea);
   isblock->data.indirecttext.buffer=oldbuffer;
  }

  if(n!=macroselectn)
  {
   isblock=modeicons[BMODE][2];
   posnicon(isblock,n,0,ox,oy);

   oldbuffer=isblock->data.indirecttext.buffer;
   xmcpystring(sizeof(string),string,oldbuffer,mstrings+macros[t].defn);
   isblock->data.indirecttext.buffer=string;
   wimp_ploticon(macrobox[1].handle,isblock,buttonarea);
   isblock->data.indirecttext.buffer=oldbuffer;
  }

  isblock=modeicons[BMODE][3];
  posnicon(isblock,n,mboffset,ox,oy);

  if(macros[t].flags & MACACTIVE) isblock->flags=(wimp_iconflags)(isblock->flags | wimp_ISELECTED);
  else                            isblock->flags=(wimp_iconflags)(isblock->flags & (~wimp_ISELECTED));

  wimp_ploticon(macrobox[1].handle,isblock,(sprite_area*)sprites);
 }
 return(NULL);
}



static os_error * redkey(int n,int ox,int oy)
{
 wimp_icon  * isblock;
 char         string[MAXICONLEN];
 char       * oldbuffer;
 int          t;


 t=ci2total(n);

 if(macros[t].type==TYPEKEY)
 {
  isblock=modeicons[KMODE][0];
  posnicon(isblock,n,0,ox,oy);

  oldbuffer=isblock->data.indirecttext.buffer;
  xmcpystring(sizeof(string),string,oldbuffer,keylongstringcanonical(keycode2canonical(macros[t].data.value)));
  isblock->data.indirecttext.buffer=string;
  wimp_ploticon(macrobox[1].handle,isblock,buttonarea);
  isblock->data.indirecttext.buffer=oldbuffer;

  if(n!=macroselectn)
  {
   isblock=modeicons[KMODE][1];
   posnicon(isblock,n,0,ox,oy);

   oldbuffer=isblock->data.indirecttext.buffer;
   xmcpystring(sizeof(string),string,oldbuffer,mstrings+macros[t].defn);
   isblock->data.indirecttext.buffer=string;
   wimp_ploticon(macrobox[1].handle,isblock,buttonarea);
   isblock->data.indirecttext.buffer=oldbuffer;
  }
 }

 return(NULL);
}




/* redraw macros pane */

static os_error * macrosredrawsub(int handle,wimp_redrawstr * redrawstr,
                                                                 int more)
{
 int oy;
 int ox;
 int ylo;
 int yhi;
 int n;
 int y;

 while(more)
 {
  ox=redrawstr->box.x0-redrawstr->scx;
  oy=redrawstr->box.y1-redrawstr->scy;

  if(1)
  {
   ylo=-(redrawstr->g.y1-oy);            /* small number, top of window */
   yhi=-(redrawstr->g.y0-oy);            /* bigger, bottom of window */

   n=(ylo-MACFY)/MACDY;
   if(n<0) n=0;
   y=n*MACDY+MACFY;

   while(y<=(yhi+MACFY) && n<curtot)
   {
    if(macromode==TMODE) redtext(n,ox,oy);
    else
    if(macromode==BMODE) redbutton(n,ox,oy);
    else
    if(macromode==KMODE) redkey(n,ox,oy);

    y+=MACDY;
    n++;
   } 
  }
  wimp_get_rectangle(redrawstr,&more);
 }

 return(NULL);
 USE(handle);
}



static os_error * macrosredraw(int handle,int userhandle)
{
 os_error       * err;
 wimp_redrawstr   redrawstr;
 int              more;

 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) macrosredrawsub(handle,&redrawstr,more);
 return(err);
 USE(userhandle);
}





static void macrosrefreshentry(int n)
{
 wimp_redrawstr r;
 int            more;

 r.box.x0=0;
 r.box.x1=MACWIDTH;
 r.box.y1=/*-MACFY*/-n*MACDY+cvdu.deltay;
 r.box.y0=r.box.y1-MACHY-cvdu.deltay-MACFY;
 r.w=macrobox[1].handle;

 wimp_update_wind(&r,&more);
 macrosredrawsub(macrobox[1].handle,&r,more);
}





/* scroll window to show entry */

static void displaymacro(int n)
{
 int yhi=-MACFY-n*MACDY;
 int ylo=-MACFY-(n+1)*MACDY;
 int wlo;
 int whi;
 windowstr window;

 getw(macrobox[1].handle,&window);

 whi=window.by-window.y1;
 wlo=window.by-window.y0;

 if(ylo<wlo || yhi>whi)
   openatscroll(macrobox[1].handle,0,
                           -MACFY-n*MACDY-MACDY/2+(window.y1-window.y0)/2);
}





static os_error * macrosextent(void)
{
 os_error * err;
 int        sety;
 int        i;

 curtot=0;

 for(i=0;i<macrostot;i++)
 {
  if(macromode==TMODE && macros[i].type==TYPETEXT) curtot++;
  else
  if(macromode==BMODE && macros[i].type==TYPEBUTTON) curtot++;
  else
  if(macromode==KMODE && macros[i].type==TYPEKEY) curtot++;
 }


 sety=MACFY+MACDY*curtot;
 if(sety<paneminy) sety=paneminy;

          err=extent(macrobox[1].handle,0,-sety,panemaxx,0);
 if(!err) err=extent(macrobox[0].handle,0,-macrominy,macromaxx,sety-paneminy);

 if(!err) err=reopenw(macrobox[1].handle);
 if(!err) err=reopenw(macrobox[0].handle);

 return(err);
}



/* takes the selected macro, and stashes it */

void macrosstash(void)
{
 char string[MAXICONLEN];

 if(macroselectt>=0)
 {
  readicon(macrobox[1].handle,XICON,string,sizeof(string));
  updatemacro(macroselectt,string,NULL,NULL,NULL);
 }
}


/* we use this to put an icon over the given macro        */
/* n can be -1 in which case the icon goes somewhere safe */

static void macrosselectone(int t,int x)
{
 wimp_icon     * isblock;
 int             n;
 windowstr       window;
 wimp_icon       result;

 n=total2ci(t);

 if(n>=0)
 {
  if(macromode==TMODE || macromode==KMODE) isblock=modeicons[macromode][1];
  else                                     isblock=modeicons[macromode][2];

  getw(macrobox[1].handle,&window);

  posnicon(isblock,n,0,window.scx,-window.scy);

  wimp_move_icon(macrobox[1].handle,XICON,isblock,WMOVEICONSIZE);
  writeicon(macrobox[1].handle,XICON,mstrings+macros[t].defn);

  iecarrot(macrobox[1].handle,XICON);

  if(x<0) report(iecarrot(macrobox[1].handle,XICON));
  else    report(caret(macrobox[1].handle,XICON,x,0,-1,-1));
 }
 else
 {
  wimp_get_icon_info(macrobox[1].handle,XICON,&result);
  if(result.box.y0<0)
  {
   result.box.y0=-result.box.y0;
   result.box.y1=-result.box.y1;
   wimp_move_icon(macrobox[1].handle,XICON,&result,0);
  }
 }
}



static void macrosnewselect(int t,int x)
{
 int oldn;

 oldn=macroselectn;
 macrosstash();

 macrosselectone(t,x);

 macroselectt=t;
 macroselectn=total2ci(t);

 macrosrefreshentry(macroselectn);

 if(oldn>=0) macrosrefreshentry(oldn);
}


static void macrosnewselectx(int t)
{
 macrosnewselect(t,-1);
 displaymacro(macroselectn);
}



static int typeerror[]={MAC6,MAC7,MAC8};


static os_error * macrosaddwindow(char * name,char * defn,int mtype,
                                  char * data,char * help,char * aname,char * ttip,int flags,int over)
{
 os_error * err;
 int        value;
 int        t=0;
 int        n;
 int        type;

 err=NULL;
 value=-1; /* compiler */

 type=mtype & TYPEMASK;

 if(!*name) err=geterror(MACA);
 else
 if(macrofindtoken(name)>=0) err=geterrorf(MACB,name);
 else
 if(cstrcmp(name,"clear") && cstrcmp(name,"fraction") && macrofindglyph(name)>=0) err=geterrorf(MACE,name);
 else
 {
  value=keytype(name);

  if(value>=0)
  {
   if(type!=TYPEKEY) err=geterrorf(MAC9,name);
   else
   {
    data=NULL;
   }
  }
 }

 if(!err)
 {
  n=findmacro(name,value);
  if(n>=0)
  {
   if(type!=macros[n].type || !over) err=geterror(typeerror[macros[n].type]);
   else 
   if(macros[n].type==TYPEBUTTON && (macros[n].flags & MACACTIVE)) 
                                                  queuemacupdate(MACBUTTONS);
  }
 }

 if(!err) err=addmacro(mtype,name,defn,value,data,help,aname,ttip,&t);
 if(!err)
 {
  queuemacupdate(MACCOMPACT);

  if(macrobox[1].handle)
  {
   if((flags & MACADDUPDATE) && t==macroselectt)
   {
    macrosselectone(-1,-1);
    macroselectt=-1;
    macroselectn=-1;
   }
  
   /* assume select is never used from scripts */

   if((flags & MACADDSELECT))
   {
    macrosextent();

    n=total2ci(t);
    macrosrefreshentry(n);
   
    macrosnewselectx(t);
   }
   else
   {
    queuemacupdate(MACWINDOW|MACEXTENT);
   }
  }
 }

 if(!err && macros[t].type==TYPEBUTTON && (macros[t].flags & MACACTIVE)) 
                                                 queuemacupdate(MACBUTTONS);
 return(err);
}



/* key presses */

static os_error * macroskey(int handle,int userhandle,int icon,int * key)
{
 int t;
 int ch;

 ch=*key;

// cprintf("macroskey %x",ch);

 switch(ch)
 {
  case   CUP:
  case SHFT_TAB:
             if(macroselectn>0)
             {
              t=ci2total(macroselectn-1);
              macrosnewselectx(t);
             }
             break;

  case    TAB:
  case  CDOWN:
  case RETURN:
             if(macroselectn<(curtot-1))
             {
              t=ci2total(macroselectn+1);
              macrosnewselectx(t);
             }
             break;

     default:
//             return(txcbkey(key,handle,icon));
			 return(NULL);
             break;
 }


 *key=-1;
 return(NULL);

 USE(handle);
 USE(userhandle);
 USE(icon);
}



/* removes a macro definition */

static void macrodelete(void)
{
 int t;
 int i;
 int change;

 if(macroselectt>=0)
 {
  change=macros[macroselectt].type==TYPEBUTTON && 
               (macros[macroselectt].flags & MACACTIVE);

  if(change && (macros[macroselectt].flags & MACNL))
  {
   macros[macroselectt].flags&=~MACNL;
   i=nextbuttonmacro(macroselectt);
   if(i!=-1) macros[i].flags|=MACNL;
  }

  delmacron(macroselectt);
  macrosextent();

  if(change) buttonschanged(0);

  if(macroselectn>=curtot)
  {
   macroselectt=t=ci2total(macroselectn=(curtot-1));
  }
  else
  {
   macroselectt=t=ci2total(macroselectn);
  }

  macrosselectone(t,-1);

  refreshwindow(macrobox[1].handle);
 }
}




static os_error * savemacfn(char * name,int type)
{
 return(macrossave(name,1));
 USE(type);
}


#ifdef NEVER
static os_error * savemacint(mousestr * m,char * name,int type)
{
 return(NULL);
 USE(m);
 USE(name);
 USE(type);
}

#endif


static os_error * openmacrossave(void)
{
 os_error * err;
 TCHAR       name[FILENAMELEN];

 xzstrncpyu(name,TEXT("Macros"),NITEM(name));
 err=opensaveparent(name,NITEM(name),SCRIPT2,savemacfn,macrobox[0].handle);

 return(err);
}



static os_error * macrosmainicon(int handle,int userhandle,wimp_mousestr * m)
{

 if(m->bbits==2)
 {
  return(openmacrossave());
 }

 return(NULL);

 USE(handle);
 USE(userhandle);
}



/* click on macros pane */

static os_error * macrosicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error  * err;
 int         n;
 int         i;
 int         t;
 windowstr   window;
 int         x;
 int         y;
 wimp_icon * isblock;

 err=NULL;

 if(m->bbits==2)
 {
  err=openmacrossave();
 }
 else
 {
  getw(handle,&window);

  y=m->y-window.by;
  n=(-y-MACFY)/MACDY;
  if(!(n<0 || n>=curtot)) 
  {
   x=m->x-window.bx;

   if(m->bbits==wimp_BLEFT || m->bbits==wimp_BRIGHT)
   {
    if(macromode==TMODE || macromode==KMODE) isblock=modeicons[macromode][1];
    else                                     isblock=modeicons[macromode][2];

    if(x>=isblock->box.x0 && x<=isblock->box.x1)
    {
     t=ci2total(n);
     macrosnewselect(t,x);
    }
    else
    if(macromode==BMODE)
    {
     isblock=modeicons[macromode][3];

     if(x>=isblock->box.x0 && x<=isblock->box.x1)
     {
      t=ci2total(n);
      macros[t].flags^=MACACTIVE;
      if(macros[t].flags & MACNL)
      {
       macros[t].flags&=~MACNL;
       i=nextbuttonmacro(n);
       if(i!=-1) macros[i].flags|=MACNL;
      }

      macrosrefreshentry(n);
      buttonschanged(0);
     }
    }
   }
   else
   if(m->bbits==wimp_DOUBLELEFT)
   {
    isblock=modeicons[macromode][0];
    if(x>=isblock->box.x0 && x<=isblock->box.x1)
    {
     t=ci2total(n);
     if(cview)
     {
      macrosstash();
      err=expandtoolmacro(t,cview,MACENVINT);
     }
    }
   }
  }
 }

 return(err);

 USE(userhandle);
}



static os_error * macroscaret(int handle,int userhandle,int gain)
{
// cprintf("caret %d",gain);
 
 if(!gain) 
 {
//  macrosstash();
 }

 return(NULL);

 USE(userhandle);
 USE(handle);
}



#ifdef NEVER

/* swop around 2 macros n1 and n2 are n'th active macros */

os_error * macrosswop(int t1,int t2)
{
 os_error * err;
 macro      temp;
 int        active;
 int        hit1;
 int        hit2;

 err=NULL;

 if(t1!=t2)
 {
  active=(macromode==BMODE) && (macrobox[0].handle);
  hit1=(macroselectt==t1);
  hit2=(macroselectt==t2);

  if(active && (hit1 || hit2)) macrosnewselect(-1,-1);
                                                                                 
  temp=macros[t1];
  macros[t1]=macros[t2];
  macros[t2]=temp;

  err=buttonschanged(0);

  if(active)
  {
   if(hit1) macrosnewselect(t2,-1);
   else
   if(hit2) macrosnewselect(t1,-1);

   refreshwindow(macrobox[1].handle);
  }
 }

 return(err);
}


#endif


/* insert macro t1 before macro t2 */

os_error * macrosinsert(int t1,int t2)
{
 os_error * err;
 macro      temp;
 int        active;
 int        hit;
 int        t;

 err=NULL;

 if(t1!=t2)
 {
  active=(macrobox[0].handle!=0);
  hit=(macroselectt>=t1 && macroselectt<=t2) || 
      (macroselectt>=t2 && macroselectt<=t1);

  if(active && hit) macrosnewselect(-1,-1);
  if(t1>t2)
  {
   temp=macros[t1];
   for(t=t1;t>t2;t--) macros[t]=macros[t-1];
   macros[t]=temp;
   if(macroselectt==t1) macroselectt=t2;
   else
   if(macroselectt<t1 && macroselectt>=t2) macroselectt++;
  }
  else /* if(t1<t2) */
  {
   temp=macros[t1];
   for(t=t1;t<(t2-1);t++) macros[t]=macros[t+1];
   macros[t]=temp;
   if(macroselectt==t1) macroselectt=t2;
   else
   if(macroselectt>t1 && macroselectt<t2) macroselectt--;
  }

//  err=buttonschanged(0);

  if(active)
  {
   if(hit) macrosnewselect(macroselectt,-1);
   refreshwindow(macrobox[1].handle);
  }
 }

 return(err);
}











/* close macros window */

static os_error * macrosclose(int code)
{
 os_error    * err;
 windowstr     window;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  macrosstash();
 }
 else
 if(code==DBCANCEL)
 {
  loadmacros();
  buttonschanged(1);
 }


 if(!err)
 {
  if(code!=DBAPPLY) 
  {
   macrorecord=0;
   getw(macrobox[1].handle,&window);
   macrosscroll=window.scy;
   clearmacros();
   remcaretevent(macroscaret,macrobox[1].handle,0);
   remkeyeventicon(macrobox[1].handle,XICON);
  }
  else
  if(code==DBAPPLY)
  {
   savemacros();
  }
 }


 return(err);
}


/* change of macro mode        */
/* called with zero args below */

static os_error * optfn(int handle,int userhandle,wimp_mousestr * m)
{
 
 if(oldmode!=macromode)
 {
  oldmode=macromode;
  macrosstash();
  macrosselectone(-1,-1);
  macroselectt=macroselectn=-1;
  macrosextent();
  refreshwindow(macrobox[1].handle);

//  dbshade(1,macromode!=BMODE,&macrobox[0]);
 }

 return(NULL);

 USE(userhandle);
 USE(handle);
 USE(m);
}


static os_error * createnewmac(char * name,char * defn,int type,
                                                       char * data,int over)
{
 return(macrosaddwindow(name,defn,type,data,NULL,NULL,NULL,MACADDSELECT,over));
}


static os_error * createcopymac(char * name,char * defn,
                                            int type,char * data,int over)
{
 os_error * err;
 char       buffer[4096];
	char     * lt;
	int        offset;
	char     * help;
	char     * applet;
	char     * tips;

 err=NULL;

 if(macroselectt>=0)
 {
  macrosstash();

		lt=buffer+NITEM(buffer);

		defn=buffer;
		offset=macros[macroselectt].defn;
  xzstrncpy(buffer,mstrings+offset,lt-defn);
		help=defn+strlen(defn)+1;
		offset+=strlen(mstrings+offset)+1;
  xzstrncpy(help,mstrings+offset,lt-help);
		applet=help+strlen(help)+1;
		offset+=strlen(mstrings+offset)+1;
  xzstrncpy(applet,mstrings+offset,lt-applet);
		tips=applet+strlen(applet)+1;
		offset+=strlen(mstrings+offset)+1;
  xzstrncpy(tips,mstrings+offset,lt-tips);

  err=macrosaddwindow(name,defn,type,data,help,applet,tips,MACADDSELECT,over);
 }

 return(err);

 USE(defn);
}


static char * newnames[]=
{
 "{MAC2}",
 "{MAC1}",
 "{MAC0}",
};


static os_error * newmac(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 char       string[64];

 err=NULL;

 tsprintf(sizeof(string),string,newnames[macromode]);

 switch(macromode)
 {
  case BMODE:
             err=newbutton(createnewmac,string,NULL,0);
             break;

  case KMODE:
             err=newkey(createnewmac,string);
             break;

  case TMODE:
             err=newtext(createnewmac,string);
             break;
 }

 return(err);

 USE(userhandle);
 USE(handle);
 USE(m);
}




static os_error * delmac(int handle,int userhandle,wimp_mousestr * m)
{
 macrodelete();
 return(NULL);
 USE(userhandle);
 USE(handle);
 USE(m);
}





static char * copynames[]=
{
 "{MAC5}",
 "{MAC4}",
 "{MAC3}",
};



static os_error * copymac(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 char       string[64];

 err=NULL;

 if(macroselectt>=0)
 {
  tsprintf(64,string,copynames[macromode]);
  strcat(string," '");

  if(macromode==KMODE) strcat(string,keylongstringcanonical(keycode2canonical(macros[macroselectt].data.value)));
  else                 strcat(string,macros[macroselectt].name);

  strcat(string,"'");

  switch(macromode)
  {
   case BMODE:
              err=newbutton(createcopymac,string,macros[macroselectt].data.data,macros[macroselectt].flags);
              break;

   case KMODE:
              err=newkey(createcopymac,string);
              break;

   case TMODE:
              err=newtext(createcopymac,string);
              break;
  }
 }

 return(err);

 USE(userhandle);
 USE(handle);
 USE(m);
}



static os_error * editmac(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;


 err=NULL;

 if(macroselectt>=0)
 {
		err=editmacro(macroselectt);
 }

 return(err);

 USE(userhandle);
 USE(handle);
 USE(m);
}





static os_error * savemac(int handle,int userhandle,wimp_mousestr * m)
{
 dbclose(macrobox,DBAPPLY);
 return(savedefaultmacros());
 USE(userhandle);
 USE(handle);
 USE(m);
}


static os_error * savemacas(int handle,int userhandle,wimp_mousestr * m)
{
 return(openmacrossave());
 USE(userhandle);
 USE(handle);
 USE(m);
}





static os_error * machelp(int handle,int userhandle,int icon,char ** p)
{
 windowstr   window;
 mousestr    mouse;
 wimp_icon * isblock;
 int         x;
 int         i;

 icon=-1;

 getw(handle,&window);
 getpointer(&mouse);

 x=mouse.x-window.bx;

 for(i=0;i<(macromode==BMODE?4:3);i++)
 {
  isblock=modeicons[macromode][i];
  if(isblock->box.x0<=x && isblock->box.x1>=x)
  {
   icon=(macromode<<4)|i;
   break;
  }
 }

 *p=helpfindtagstring(userhandle,icon);

 return(NULL);
}




static dbiconstr macroicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,
    6, NULL,         DBACTION, 0,   0,      0,  0,  0,  0,(dbreadfn)savemac,0,
    7, NULL,         DBACTION, 0,   0,      0,  0,  0,  0,(dbreadfn)delmac,0,
    8, NULL,         DBACTION, 0,   0,      0,  0,  0,  0,(dbreadfn)copymac,0,
    9, NULL,         DBACTION, 0,   0,      0,  0,  0,  0,(dbreadfn)newmac,0,
   10, NULL,         DBACTION, 0,   0,      0,  0,  0,  0,(dbreadfn)editmac,0,
   13, NULL,         DBACTION, 0,   0,      0,  0,  0,  0,(dbreadfn)savemacas,0,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

    0, &macrorecord, DBTOGGLE, 0,    0,      1, F4,  0, 0,     NULL,   0,

    4, &macromode,    DBRADIO,0,    0,BMODE,0,1,0,   (dbreadfn)optfn,   0,
    5, &macromode,    DBRADIO,0,    0,KMODE,0,1,0,   (dbreadfn)optfn,   0,
    3, &macromode,    DBRADIO,0,    0,TMODE,0,1,0,   (dbreadfn)optfn,   0,

    -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr macrobox[2]=
{
 0,
 TMACROS,
 DBFIX,
 0,
 macrosclose,
 macrosmainicon,
 macroskey,
 NULL,
 macroicondefs,
 0,
 0,
 0,NULL,
 0,
 0,


 0,
 TMACROSP,
 DBPANE,
 0,
 NULL,
 macrosicon,
 macroskey,
 macrosredraw,
 NULL,
 0,
 0,
 0,NULL,
 machelp,
 0,
};



/* click on menu, display macro window */
/* called with zero arg below          */

void openmacros(int fp)
{
 os_error * err;
 windowstr  window;
 wimp_icon  result;
 int        pane;


 err=NULL;

 cview=menuview;
 oldmode=macromode;

 if(macrobox[0].handle)
 {
  dboxforward(macrobox);
 }
 else
 {
  err=savemacros();
  if(!err)
  {
   err=dodboxspparent(macrobox,2,macrobox,&macdbstack,cview->handle);
   if(!err) 
   {
    getw(macrobox[0].handle,&window);
    macromaxx=window.x1-window.x0;
    macrominy=window.y1-window.y0;

    pane=macrobox[1].handle;

    getw(pane,&window);
    panemaxx=window.x1-window.x0;
    paneminy=window.y1-window.y0;

    wimp_lose_icon_info(&modeicons[TMODE][0]);
    wimp_get_icon_info(pane,0,&result);
    wimp_copy_icon_info(&modeicons[TMODE][0],&result);
    wimp_delete_icon(pane,0);

    wimp_lose_icon_info(&modeicons[TMODE][1]);
    wimp_get_icon_info(pane,1,&result);
    wimp_copy_icon_info(&modeicons[TMODE][1],&result);
    wimp_delete_icon(pane,1);

    wimp_lose_icon_info(&modeicons[KMODE][0]);
    wimp_get_icon_info(pane,2,&result);
    wimp_copy_icon_info(&modeicons[KMODE][0],&result);
    wimp_delete_icon(pane,2);

    wimp_lose_icon_info(&modeicons[KMODE][1]);
    wimp_get_icon_info(pane,3,&result);
    wimp_copy_icon_info(&modeicons[KMODE][1],&result);
    wimp_delete_icon(pane,3);

    wimp_lose_icon_info(&modeicons[BMODE][0]);
    wimp_get_icon_info(pane,4,&result);
    wimp_copy_icon_info(&modeicons[BMODE][0],&result);
    wimp_delete_icon(pane,4);

    wimp_lose_icon_info(&modeicons[BMODE][1]);
    wimp_get_icon_info(pane,5,&result);
    wimp_copy_icon_info(&modeicons[BMODE][1],&result);
    wimp_delete_icon(pane,5);

    wimp_lose_icon_info(&modeicons[BMODE][2]);
    wimp_get_icon_info(pane,6,&result);
    wimp_copy_icon_info(&modeicons[BMODE][2],&result);
    wimp_delete_icon(pane,6);

    wimp_lose_icon_info(&modeicons[BMODE][3]);
    wimp_get_icon_info(pane,7,&result);
    wimp_copy_icon_info(&modeicons[BMODE][3],&result);
    wimp_delete_icon(pane,7);

    mboffset=modeicons[BMODE][2]->box.y1-modeicons[BMODE][3]->box.y1;

//    cprintf("mb x0=%d x1=%d",modeicons[BMODE][3]->box.x0,modeicons[BMODE][3]->box.x1);


    err=macrosextent();
    macroselectt=macroselectn=-1;
    macrosselectone(-1,-1);

    if(macrobox[1].handle)
    {
     addcaretevent(macroscaret,macrobox[1].handle,0);
     addkeyeventicon(macrobox[1].handle,XICON);
     openatscroll(macrobox[1].handle,0,macrosscroll);
    }
   }
  }
 }

 zreport(err);
 USE(fp);
}



os_error * macrodisplay(int n,viewstr * view)
{
 menuview=view;
 menufile=view->file;

 if(macromode!=BMODE)
 {
  macromode=BMODE;
  if(macrobox[0].handle)
  {
   dbchangevalue(&macromode,macrobox);
   optfn(0,0,NULL);
  }
 }

 openmacros(0);
 macrosnewselectx(n);

 return(NULL);
}







int macrorecordermacro(void)
{
 if((macrorecord && macroselectt>=0))
 {
  return(macroselectt);
 }
 return(-1);
}


/* passed key presses, might like to record them */
/* return number of macro added to if any */

/*
   on Windows we have problems, we're passed key presses and
   possibly later characters. We could just record key presses
   but problems like Shift keys, or ALT 0123 sequences
   The solution adopted is to only record key codes or presses that
   the program uses.
   Another way might be to define a class of keys we will record.
   e.g. function keys, control + letters, others assume are text.
*/


int macrorecorder(int ch)
{
 char   string[12];
 char   xstring[MAXICONLEN];

 if((macrorecord && macroselectt>=0))
 {
  if(ch>=32 && ch<160 && ch!=127) uncode(string,ch);
  else
  if(ch<256 && ch>=160)
  {
   string[0]=(char)ch;
   string[1]=0;
  }
  else
  {
   sprintf(string,"{%s}",keystring(ch)); 
  }

  readicon(macrobox[1].handle,XICON,xstring,sizeof(xstring));

  if((strlen(xstring)+strlen(string)+1)<MACLEN)
  {
   strcat(xstring,string);
   writeicon(macrobox[1].handle,XICON,xstring);
 //   macrosrefreshentry(macroselectn);
  }

  return(macroselectt);
 }
 return(-1);
}






/* trash all macros */

void delallmacros(int fp)
{

 macrostot=curtot=mstringsize=0;

 if(macrobox[1].handle)
 {
  if(macroselectt>=0) macrosselectone(-1,-1);
  macroselectt=macroselectn=-1;
  queuemacupdate(MACWINDOW);
 }
 queuemacupdate(MACBUTTONS|MACCOMPACT);
 
 USE(fp);
}



/* delete a named macro */

void delmacro(int fp)
{
 char * p;
 int    nm;
 int    change;

 p=stringptr(stack[fp]);
 nm=findmacro(p,0);
 if(nm>=0)
 {
  change=macros[nm].type==TYPEBUTTON && (macros[nm].flags & MACACTIVE);

  delmacron(nm);

  if(change) queuemacupdate(MACBUTTONS);

  if(nm==macroselectt) macroselectt=macroselectn=-1;

  if(macrobox[1].handle)
  {
   macrosselectone(macroselectt,-1);
   queuemacupdate(MACWINDOW);
  }
 }
}


/* define macro */

static os_error * defmacros(int fp,int argx)
{
 char   name[MNLEN];
 char   defn[256];
 char * p;
 char * q;
 char * r;
 char * h;
 char * a;
	char * tt;
 int    type;
 char   data[MDLEN];
 char   help[256];
 char   aname[64];
	char   ttip[80];



 type=stack[fp+0];
 p=stringptr(stack[fp+1]);
 q=stringptr(stack[fp+2]);
 r=stringptr(stack[fp+3]);
 h=(argx>0)?stringptr(stack[fp+4]):NULL;
 a=(argx>1)?stringptr(stack[fp+5]):NULL;
	tt=(argx>2)?stringptr(stack[fp+6]):NULL;

 if(strlen(p)<MNLEN)
 {
  strcpy(name,p);
  if(strlen(q)<256)
  {
   strcpy(defn,q);
   if(strlen(r)<MDLEN)
   {
    strcpy(data,r);
    if(!h || strlen(h)<256)
    {
     if(h) 
     {
      strcpy(help,h);
      h=help;
     }

     if(!a || strlen(a)<sizeof(aname))
     {
      if(a) 
      {
       strcpy(aname,a);
       a=aname;
      }

// if(a && *a) cprintf("applet macro %s %d",a,appletstatus(appletfindname(a)));
						if(!tt || strlen(tt)<sizeof(ttip))
						{
						 if(tt)
							{
        strcpy(ttip,tt);
        tt=ttip;
//								cprintf("ttip %s",tt);
							}

       if(!a || *a==0 || appletstatus(appletfindname(a))==0)
       {
        return(macrosaddwindow(name,defn,type,data,h,a,tt,MACADDUPDATE,1));
       }
						}
     }
    }
   }
  }
 }

 return(NULL);
}


/* define macro */

void defmacro(int fp)
{
 zreport(defmacros(fp,0));
}

void defmacro2(int fp)
{
 zreport(defmacros(fp,1));
}

void defmacro3(int fp)
{
 zreport(defmacros(fp,2));
}

void defmacro4(int fp)
{
//	cprintf("=========== defmacro4");

 zreport(defmacros(fp,3));
}





static os_error * macroevent(int eventn,int userhandle,void * data,int data1)
{
 if(cview==(viewstr*)data)
 {
  cview=0;
  dbstacksmash(&macdbstack);
 }
 return(NULL);

 USE(userhandle);
 USE(data1);
 USE(eventn);
}



os_error * dbmacrosinit(void)
{
 os_error      * err;
 
 err=addevent(EVENT_VCLOSE,macroevent,0);

 return(err);
}


