/*->c.dscript */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "font.h"
#include "transform.h"
#include "xprocess.h"

#include "err.h"
#include "filetype.h"
#include "fsx.h"
#include "task.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "etc.h"
#include "bits.h"
#include "timex.h"
#include "bf.h"
#include "avl.h"
#include "key.h"
#include "keylegacy.h"
#include "hourglass.h"
#include "deb.h"


#include "str.h"
#include "constants.h"


#include "geometry.h"
#include "xredraw.h"
#include "curve.h"
#include "curvelo.h"
#include "units.h"

#include "object.h"

#include "obj.h"

#include "select.h"


#include "txstr.h"
#include "text.h"

#include "xprint.h"
#include "undo.h"
#include "xcolour.h"

#include "main.h"
#include "view.h"

#include "file.h"

#include "posn.h"

#include "pref.h"

#include "new.h"
#include "newx.h"



#include "dsint.h"

#include "dscript.h"





/*
   Allocations


   0x0            DScript
   0x100          DScript
   0x200          Colour
   0x300          Line
   0x400          New/section/page
   
   0x600          Text
   0x700          Text
   0x900          GLine
   0x1000         Pictures
   0x1100         Group
   0x1200         Impex
   0x1300         Border

   0x1400         Fill

   0x1500         Colseps

   0x1600         text prefs
   0x1700         general pref

 */




static dscreator * dsroot;



#define DSHEAPCHUNK  0x200
#define DSSTACKCHUNK 0x8000


       int     * dsstack;
static int       dssp;

static char    * dsheap;
static int       dsheapsize;

static int       dsheaproot;

static objectloc dsloc;

static char    * dsexecname;



typedef struct   dsidstr
{
 int            parent;
 int            sibls[2];
 int            balance;
 int            idlen;
} dsidstr;


static dscreator * dsfind(int type);


#define DS00 0x800  /* Unknown object creator at %d */
#define DS01 0x801  /* Identifier needed at %d      */
#define DS02 0x802  /* = needed at %d               */
#define DS03 0x803  /* Object already created at %d */
#define DS04 0x804  /* Unknown object at %d         */
#define DS05 0x805  /* Unexpected end of file at %d */
#define DS06 0x806  /* Syntax error at %d           */
#define DS07 0x807  /* Object creator needed at %d  */
#define DS08 0x808  /* Incomplete document          */
#define DS09 0x809  /* unused - free                */




static errtag errortable[]=
{
 DS00,"{DS00}",
 DS01,"{DS01}",
 DS02,"{DS02}",
 DS03,"{DS03}",
 DS04,"{DS04}",
 DS05,"{DS05}",
 DS06,"{DS06}",
 DS07,"{DS07}",
 DS08,"{DS08}",
 DS09,"{DS09}",

 ELAST ,""
};

static errlink errorlink;




int * dsstackptr(void)
{
 return(dsstack);
}


static int dscmpcf(void * key1,void * key2)
{
 return(strcmp((char*)key1,*((char**)key2)));
}



static int dscmpcs(void * key1,void * key2)
{
 return(strcmp(*((char**)key1),*((char**)key2)));
}


static int dsheapcmpf(void * key1,void * key2)
{
 return(strcmp((char*)key1,((char*)key2)+sizeof(int)));
}


static int dsheapcmps(void * key1,void * key2)
{
 return(strcmp(((char*)key1)+sizeof(int),((char*)key2)+sizeof(int)));
}



/* problem with self referencing declarations */
/* value is not set up correctly              */


static os_error * dsvalue(void)
{
 os_error  * err;
 int         len;
 int         type;
 int         offset;
 dscreator * ds;


/* dprintf(11,"dstoken=%d ssp=%d",dstoken,dssp);  */

 err=NULL;

 if(dstoken==DSNUMBER)
 {
  dsstack[dssp++]=DSTINT;
  dsstack[dssp++]=3*sizeof(int);
  dsstack[dssp++]=dslexn;

 }
 else
 if(dstoken==DSSTRING)
 {
  dsstack[dssp++]=DSTSTR;
  len=strlen(dstokstart)+1;
  len=(len+0x3)&(~0x3);
  dsstack[dssp++]=len+2*sizeof(int);
  strcpy((char*)(dsstack+dssp),dstokstart);
  dssp+=len/sizeof(int);
 }
 else
 if(dstoken==DSID)
 {
  offset=avlfind(dstokstart,dsheaproot,dsheap,dsheapcmpf);
  if(offset>=0)
  {
   len=((dsidstr*)(dsheap+offset))->idlen;
   offset+=sizeof(dsidstr)+len;
   len=((dsobjectstr*)(dsheap+offset))->len;
   type=((dsobjectstr*)(dsheap+offset))->type;

   ((dsobjectstr*)(dsstack+dssp))->type=type;
   ((dsobjectstr*)(dsstack+dssp))->len=len;                                   

   XMEMCPYX(((dsobjectstr*)(dsstack+dssp))->data.string,
                    ((dsobjectstr*)(dsheap+offset))->data.string,len);

   ds=dsfind(type);
   if(ds && (ds->flags & DSCREATECOPY) && ds->create)
                                       err=ds->create(dssp,DSCOPY,&dsloc);

  /* dprintf(0,"ds=%x flags=%x create=%x",ds,ds->flags,ds->create); */

   dssp+=len/sizeof(int);
  }
  else return(dslexerror(DS04));
 }
 else
 if(dstoken==DSEOF) return(dslexerror(DS05));
 else               return(dslexerror(DS06));

 return(err);
}





static os_error * dslist(void)
{
 os_error  * err;
 dscreator * dsp;
 int         fp;
 int         argc;
 int         immediate;
 int         preserveloc;
 int         object=0;

 dsgettoken();                                     /* creator */
 if(dstoken==DSEOF) return(dslexerror(DS05));
 else
 if(dstoken!=DSID) return(dslexerror(DS07));

 dsp=(dscreator*)avlfind(dstokstart,(int)dsroot,0,dscmpcf);

 if((int)dsp==-1) return(dslexerror(DS00));

 preserveloc=(dsp->flags & DSPRESERVELOC);
 immediate=(dsp->flags & DSCREATEIMMEDIATE);

 if(preserveloc) object=dsloc.object;

 fp=dssp;

 dsstack[dssp++]=dsp->type;
 dsstack[dssp++]=3*sizeof(int);      /* len */

 err=NULL;
 argc=0;

 if(immediate && dsp->create)
 {
  dsp->create(fp,DSIMMINIT,&dsloc);
 }

 while(1)
 {
  dsgettoken();

  if(dstoken==DSOPEN) 
  {
   err=dslist();
   argc++;
  }
  else
  if(dstoken==DSCLOSE) break;
  else
  if(dstoken==DSEOF) 
  {
   err=dslexerror(DS06);
  }
  else
  {
   err=dsvalue();
   argc++;
  }

  if(immediate && dsp->create)
  {
   if(err) dsp->create(fp,DSIMMERR,&dsloc);
   else    err=dsp->create(fp,argc,&dsloc);
   dssp=fp+2;
  }

  if(err) break;
 }

 if(!err)
 {
  dsstack[fp+1]=(dssp-fp)*sizeof(int);

  if(dsp->create)
  {
   if(immediate) err=dsp->create(fp,DSIMMLAST,&dsloc);
   else          err=dsp->create(fp,argc,&dsloc);
   dssp=(dsstack[fp+1]/sizeof(int))+fp;
   if(err) return(err);
  }
 }


 if(preserveloc) dsloc.object=object;

 return(err);
}





static os_error * dsdeclaration(void)
{
 os_error * err;
 int        len;
 int        offset;
 dsidstr  * dsidp;
 int        fp;

	err=NULL;

 while(1)
 {
  fp=dssp;

  dsgettoken();
  if(dstoken==DSEOF) return(NULL);

  if(dstoken!=DSID) return(dslexerror(DS01));

  len=strlen(dstokstart)+1;
  len=(len+0x3)&(~0x3);


  err=flex_chunk((flex_ptr)&dsheap,dsheapsize+len+sizeof(dsidstr)+2*sizeof(int),DSHEAPCHUNK);
		if(err) break;

  dsidp=(dsidstr*)(dsheap+dsheapsize);
  dsidp->idlen=len;
  strcpy(dsheap+dsheapsize+sizeof(dsidstr),dstokstart);

  offset=avlsearch(dsheapsize,&dsheaproot,dsheap,dsheapcmps);

  if(offset==dsheapsize)
  {
   dsheapsize+=len+sizeof(dsidstr);
   /* ensure that any attempt by this declaration to reference itself */
   /* gives a sensible answer                                         */
   ((dsobjectstr*)(dsheap+dsheapsize))->type=DSTSELF;
   ((dsobjectstr*)(dsheap+dsheapsize))->len=2*sizeof(int);
  }
  else
  {
   return(dslexerror(DS03));
  }

  dsgettoken();
  if(dstoken!=DSEQUAL) return(dslexerror(DS02));

  dsgettoken();
  if(dstoken==DSOPEN)
  {
   err=dslist();
   if(err) return(err);
  }
  else
  {
   err=dsvalue();
   if(err) return(err);
  }

  /* copy value from stack to heap */

  len=((dsobjectstr*)(dsstack+fp))->len;

  flex_chunk((flex_ptr)&dsheap,dsheapsize+len,DSHEAPCHUNK);

  ((dsobjectstr*)(dsheap+dsheapsize))->type=
                                       ((dsobjectstr*)(dsstack+fp))->type;

  ((dsobjectstr*)(dsheap+dsheapsize))->len=len;

  XMEMCPYX(((dsobjectstr*)(dsheap+dsheapsize))->data.string,
              ((dsobjectstr*)(dsstack+fp))->data.string,len-2*sizeof(int));

  /* have to do copy, because structure is a lot bigger */

  dsheapsize+=len;
  dssp=fp;
 }

 return(err);
}



os_error * dsneeddoc(objectloc * loc)
{
 os_error   * err;
 filestr    * file;
 sectionstr * sectionp;

 err=NULL;

 if(!loc->file)
 {
  event(EVENT_DDLEND,dsloc.file,0);

  err=createdefnewdoc(&file,NULL);

  cprintf("need doc %s",file->name);

  if(!err)
  {
   loc->file=file;
   loc->section=file->hdr.section[DOC];
   sectionp=(sectionstr*)fob_find(loc->section,file);
   loc->page=sectionp->chain.child;

   getmainframe(loc->section,file,&loc->object);

   event(EVENT_DDLSTART,dsloc.file,0);

/*   dprintf(4,"object=%d",loc->object); */
  }
 }

 return(err);
}




/* create a new document */

static os_error * dsnewdoc(int sp,int n,objectloc * loc)
{
 os_error   * err;
 filestr    * file;
 int          i;
 filehdr    * hdr;
 dsobjectstr * ds;
 dsobjectstr * ds1;

 event(EVENT_DDLEND,dsloc.file,0);

 memset(loc,0,sizeof(objectloc));

 loc->copymode=LOCNOUPDATE;

 err=newfile(&file);
 if(!err)
 {
  loc->file=file;
		file->compatability=workcompatability;

		sp+=2;

		if(n==1)
		{
   ds=(dsobjectstr*)(dsstack+sp);
   ds1=(dsobjectstr*)(dsstack+sp+2);

			if(ds->type==DSTFEATURE)
			{
		  file->compatability=CUT(ds1->data.integer,COMPATABILITY,MAXCOMPATABILITY);
//				cprintf("setting comp %d",file->compatability);
			}
		}


  err=ob_createdomain((domainstr**)&file->domain);
  if(!err)
  {
   err=fob_create(sizeof(filehdr),file,OFILEHDR,(fobjptr)&hdr);
   if(!err)
   {
    file->hdr=*hdr;
    xzstrncpyu(file->name,fs_leaf(dsexecname),FILENAMELEN);
    fs_newextension(file->name,"dpd");

    for(i=EVENT_BAREDOC0;i<=EVENT_BAREDOCF;i++)
    {
     err=event(i,file,(int)deffile);
     if(err) break;
    }

    event(EVENT_DDLSTART,dsloc.file,0);
   }
  }
 }

 return(err);
}



os_error * dsexec(char * name,int mode)
{
 os_error * err;

 err=flex_alloc((flex_ptr)&dsheap,DSHEAPCHUNK);
 if(!err)
 {
  err=flex_alloc((flex_ptr)&dsstack,DSSTACKCHUNK);
  if(!err)
  {
   if(mode==0) dsexecname=name;
			else								dsexecname="";

   dsheaproot=-1;
   dsheapsize=0;
   dssp=0;

   event(EVENT_DDLSTART,dsloc.file,0);

   err=dslexstart(name,mode);
   if(!err)
   {
    err=dsdeclaration();
    dslexend(mode);
   }

   event(EVENT_DDLEND,dsloc.file,0);

   flex_free((flex_ptr)&dsstack);
  }
  flex_free((flex_ptr)&dsheap);
 }

 return(err);
}



os_error * dsloadfile(char * name,int type,int userhandle,int xvolatile)
{
 os_error   * err;

 hourglasson();

 cprintf("dsload %s %x",name,type);

 memset(&dsloc,0,sizeof(objectloc));

 err=dsexec(name,0);

// cprintf("dsload name %s",dsloc.file->name);

 if(!err &&
    (!dsloc.file	||
     !dsloc.file->hdr.ns[DOC] ||
     !dsloc.file->hdr.ns[MST] ||
     !dsloc.file->hdr.np[DOC] ||
     !dsloc.file->hdr.np[MST])) err=geterror(DS08);

 if(err)
 {
  if(dsloc.file)
  {
   event(EVENT_FSCRAP,dsloc.file,0);
   ob_deletedomain((domainstr**)&(dsloc.file)->domain);
   deletefile(dsloc.file);
  }
 }
 else
 {
  event(EVENT_FOPEN,dsloc.file,0);

  textvbreflow(dsloc.file);

  unmodfile(dsloc.file);
  dsloc.file->saved=0;
  xloadfile=dsloc.file; /* because called in c.file, loadanyfile() */
                        /* uses xloadfile */

  err=createnewview(dsloc.file,DOC,NULL,0);
 }

// cprintf("dsload name %s",dsloc.file->name);

 hourglassoff();

 return(err);

 USE(type);
 USE(userhandle);
 USE(xvolatile);
}



os_error * dsloadfilepost(int userhandle)
{
 os_error * err;

 err=NULL;

 USE(userhandle);

 return(err);
}





os_error * dsinsertloadpost(posnstr * posn)
{
 return(NULL);

 USE(posn);
}




os_error * dsinsertload2(char * name,int xvolatile,posnstr * posn,char * basename,int postflags)
{
 os_error        * err;
 int               message;
 objhdrstr       * objhdr;
 dslocmessagestr   dm;

	cprintf("insertload %s",name);


 err=modfile(posn->file,posn->section);
 if(!err)
 {
  dsloc.file=posn->file;
  dsloc.section=posn->section;
  dsloc.page=posn->page;
  dsloc.branch=posn->master;
  dsloc.object=posn->object;
  dsloc.after=posn->object;
  dsloc.parent=0;
  dsloc.copymode=0;
  dsloc.chain=0;

  message=OM_DSLOC;
  objhdr=(objhdrstr*)fob_find(dsloc.object,dsloc.file);
  dm.loc=&dsloc;
  dm.posn=posn;
		if(postflags & OBCARETLOAD)	dm.posn=NULL;

  objectmessage(objhdr,dsloc.file,&message,&dm);

		dsloc.offset=dm.loc->offset;
		dsloc.u=dm.loc->u;

		cprintf("offset %d unit %d",dsloc.offset,dsloc.u);

  err=dsexec(name,0);

  if(err)
  {
   if(dsloc.file && dsloc.file!=posn->file) // we created a file
   {
    event(EVENT_FSCRAP,dsloc.file,0);
    ob_deletedomain((domainstr**)&(dsloc.file)->domain);
    deletefile(dsloc.file);
   }
  }
		else
		{
   if(dsloc.file && dsloc.file!=posn->file) // we created a file
			{
    event(EVENT_FOPEN,dsloc.file,0);

    xzstrncpyu(dsloc.file->name,fs_leaf(basename),FILENAMELEN);
    fs_newextension(dsloc.file->name,"dpd");

    textvbreflow(dsloc.file);

    unmodfile(dsloc.file);
    dsloc.file->saved=0;
    xloadfile=dsloc.file; /* because called in c.file, loadanyfile() */
                          /* uses xloadfile */

    err=createnewview(dsloc.file,DOC,NULL,0);

    initposn(posn,dsloc.file->view,dsloc.file,NULL);
				posn->page=dsloc.page;
				posn->section=dsloc.section;
			}
		}
 }

 return(err);

 USE(xvolatile);
}


os_error * dsinsertload(char * name,int xvolatile,posnstr * posn,char * basename)
{
	return(dsinsertload2(name,xvolatile,posn,basename,0));
}



os_error * dsinserttype(posnstr * posn,int * method)
{
 *method=1;
 return(NULL);
 USE(posn);
}


/**************************************************************************/

/* ddl(string & ddl); */

void dscode(int fp)
{
 os_error        * err;
 int               message;
 objhdrstr       * objhdr;
 dslocmessagestr   dm;
 int               object;


 if(selectn)
 {
  err=modfile(selfile,selsectk);
  if(!err)
  {
   nselected(&object,selfile);

   dsloc.file=selfile;
   dsloc.section=selsectk;
   dsloc.page=selpagek;
   dsloc.branch=selmaster;
   dsloc.object=object;
   dsloc.after=object;
   dsloc.parent=0;
   dsloc.copymode=0;
   dsloc.chain=0;

   message=OM_DSLOC;
   objhdr=(objhdrstr*)fob_find(dsloc.object,dsloc.file);
   dm.loc=&dsloc;
   dm.posn=NULL;
   objectmessage(objhdr,dsloc.file,&message,&dm);

   err=dsexec((char*)fp,1);

   if(err)
   {
    if(dsloc.file && dsloc.file!=selfile)
    {
     event(EVENT_FSCRAP,dsloc.file,0);
     ob_deletedomain((domainstr**)&(dsloc.file)->domain);
     deletefile(dsloc.file);
    }
   }
			else
			{
    if(dsloc.file && dsloc.file!=selfile) // we created a file
		 	{
     event(EVENT_FOPEN,dsloc.file,0);

     textvbreflow(dsloc.file);

     unmodfile(dsloc.file);
     dsloc.file->saved=0;
     xloadfile=dsloc.file; /* because called in c.file, loadanyfile() */
                          /* uses xloadfile */

     err=createnewview(dsloc.file,DOC,NULL,0);
 			}
			}
  }

  zreport(err);
 }
}


/***************************************************************************/

static os_error * dsmkpath(int fp,int argc,objectloc * loc)
{
 os_error    * err;
 curvestr      c;
 int           sp;
 int           nsp;
 dsobjectstr * ds;
 int           xp;
 int           size;
 pathstr     * path;

 sp=fp+2; /* skip leading type/len */
 xp=sp;

 while(argc--)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);

  switch(ds->type)
  {
   case DSTMOVE:
                dsstack[xp++]=DRAWMOVE;
                ds=(dsobjectstr*)(dsstack+sp+2);
                dsstack[xp++]=ds->data.integer;
                ds=(dsobjectstr*)(dsstack+sp+2+3);
                dsstack[xp++]=ds->data.integer;
                break;

   case DSTDRAW:
                dsstack[xp++]=DRAWDRAW;
                ds=(dsobjectstr*)(dsstack+sp+2);
                dsstack[xp++]=ds->data.integer;
                ds=(dsobjectstr*)(dsstack+sp+2+3);
                dsstack[xp++]=ds->data.integer;
                break;

   case DSTCURVE:
                dsstack[xp++]=DRAWCURVE;
                ds=(dsobjectstr*)(dsstack+sp+2);
                dsstack[xp++]=ds->data.integer;
                ds=(dsobjectstr*)(dsstack+sp+2+3);
                dsstack[xp++]=ds->data.integer;
                ds=(dsobjectstr*)(dsstack+sp+2+6);
                dsstack[xp++]=ds->data.integer;
                ds=(dsobjectstr*)(dsstack+sp+2+9);
                dsstack[xp++]=ds->data.integer;
                ds=(dsobjectstr*)(dsstack+sp+2+12);
                dsstack[xp++]=ds->data.integer;
                ds=(dsobjectstr*)(dsstack+sp+2+15);
                dsstack[xp++]=ds->data.integer;
                break;

   case DSTCLOSE:
                 dsstack[xp++]=DRAWCLOSE;
                 break;

   case   DSTEND:
                 dsstack[xp++]=DRAWEND;
                 break;
  }
  sp=nsp;
 }

 size=(xp-(fp+2))*sizeof(int);

 memset(&c,0,sizeof(curvestr));
 c.type=CPATH;
 err=fob_create(sizeof(pathstr)+size,loc->file,OPATH,(fobjptr)&path);
 c.data.path.path=path->key;
 XMEMCPYX(path->data,&dsstack[fp+2],size);
 validpath(&c.box,&c.data.path.flags,path->data);

 ds=(dsobjectstr*)(dsstack+fp);
 ds->data.curve=c;
 ds->len=sizeof(curvestr)+2*sizeof(int);

 return(err);
}





static void dsgetbox(curvestr * c,int sp)
{
 dsobjectstr * ds;
 int           nsp;
 int           i;

 sp+=2;

 for(i=0;i<4;i++)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);

  switch(ds->type)
  {
   case  DSTX:
              ds=(dsobjectstr*)(dsstack+sp+2);
              c->box.x=ds->data.integer;
              break;

   case  DSTY:
              ds=(dsobjectstr*)(dsstack+sp+2);
              c->box.y=ds->data.integer;
              break;

   case  DSTW:
              ds=(dsobjectstr*)(dsstack+sp+2);
              c->box.w=ds->data.integer;
              break;

   case  DSTH:
              ds=(dsobjectstr*)(dsstack+sp+2);
              c->box.h=ds->data.integer;
              break;
  }

  sp=nsp;
 }
}



static os_error * dsmkcurve(int fp,int argc,objectloc * loc)
{
 curvestr      c;
 int           sp;
 int           nsp;
 dsobjectstr * ds;

 nullcurve(&c);

 sp=fp+2; /* skip leading type/len */

 while(argc--)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);

  switch(ds->type)
  {
   case      DSTBOX:
                    dsgetbox(&c,sp);
                    c.type=CBOX;
                    break;

   case  DSTELLIPSE:
                    dsgetbox(&c,sp);
                    c.type=CELLIPSE;
                    break;

   case     DSTPATH:
                    c=ds->data.curve;
                    c.type=CPATH;
                    break;
  }
  sp=nsp;
 }

 ds=(dsobjectstr*)(dsstack+fp);
 ds->data.curve=c;
 ds->len=sizeof(curvestr)+2*sizeof(int);

 return(NULL);

 USE(loc);
}



static os_error * dsint(int fp,int argc,objectloc * loc)
{
 int           sp;
 dsobjectstr * ds;
 dsobjectstr * ds1;
                 
 sp=fp+2; /* skip leading type/len */
 ds=(dsobjectstr*)(dsstack+fp);
 ds1=(dsobjectstr*)(dsstack+sp);

 ds->data.integer=ds1->data.integer;
 ds->len=3*sizeof(int);

 return(NULL);
 USE(loc);
 USE(argc);
}

static os_error * dsstr(int fp,int argc,objectloc * loc)
{
 int           sp;
 dsobjectstr * ds;
 dsobjectstr * ds1;
                 
 sp=fp+2; /* skip leading type/len */
 ds=(dsobjectstr*)(dsstack+fp);
 ds1=(dsobjectstr*)(dsstack+sp);

 ds->len=ds1->len;
 strcpy(ds->data.string,ds1->data.string);

 return(NULL);
 USE(loc);
 USE(argc);
}

static os_error * dskey(int fp,int argc,objectloc * loc)
{
 int           sp;
 int           ktype;
 dsobjectstr * ds;
 dsobjectstr * ds1;
                 
 sp=fp+2; /* skip leading type/len */
 ds=(dsobjectstr*)(dsstack+fp);
 ds1=(dsobjectstr*)(dsstack+sp);

 if(argc)
 {
  ktype=keytype(ds1->data.string);
//   cprintf("ktype %d",ktype);
  ktype=keylegacyfromcode(ktype);
 }
 else ktype=-1;

// cprintf("ktype %d",ktype);

 ds->len=3*sizeof(int);
 ds->data.integer=ktype;

 return(NULL);
 USE(loc);
}




static os_error * dsunicode(int fp,int argc,objectloc * loc)
{
 int              sp;
 int              type;
 dsobjectstr    * ds;
 dsobjectstr    * ds1;
	unsigned short   temp[512];
	int              i;
	int              c;
	int              nsp;
	char           * p;
                 
 sp=fp+2; /* skip leading type/len */
 ds=(dsobjectstr*)(dsstack+fp);
	i=0;


 while(argc-- && i<(NITEM(temp)-1))
 {
  ds1=(dsobjectstr*)(dsstack+sp);
  type=ds1->type;
  nsp=sp+ds1->len/sizeof(int);

		switch(type)
		{
			case	DSTINT:
															temp[i++]=(unsigned short)ds1->data.integer;
															break;


 		case	DSTSTR:
															p=ds1->data.string;
															while((c=*p++)!=0) temp[i++]=(unsigned short)c;
															break;
		}

  sp=nsp;
 }

	temp[i++]=0;

	XMEMCPYX(ds->data.unistring,temp,i*sizeof(unsigned short));

	ds->type=DSTUNISTR;
 ds->len=2*sizeof(int)+((i*sizeof(unsigned short)+3)&~0x3);

 return(NULL);
 USE(loc);
}







static int dsboxlist[]={
                        DSTW|DSTCOMPULSORY,
                        DSTH|DSTCOMPULSORY,
                        DSTX|DSTCOMPULSORY,
                        DSTY|DSTCOMPULSORY,
                        DSTENDLIST
                       };



static int dszerolist[]={
                         DSTENDLIST
                        };



static int dsonestringlist[]={
                              DSTSTR|DSTCOMPULSORY,
                              DSTENDLIST
                             };



static int dsoneintlist[]={
                           DSTINT|DSTCOMPULSORY,
                           DSTENDLIST
                          };


static int dstwointlist[]={
                           DSTINT|DSTCOMPULSORY,
                           DSTINT|DSTCOMPULSORY,
                           DSTENDLIST
                          };


static int dssixintlist[]={
                           DSTINT|DSTCOMPULSORY,
                           DSTINT|DSTCOMPULSORY,
                           DSTINT|DSTCOMPULSORY,
                           DSTINT|DSTCOMPULSORY,
                           DSTINT|DSTCOMPULSORY,
                           DSTINT|DSTCOMPULSORY,
                           DSTENDLIST
                          };


static int dspathlist[]={
                         DSTMOVE,
                         DSTDRAW,
                         DSTCURVE,
                         DSTCLOSE,
                         DSTEND,
                         DSTENDLIST
                        };


static int dscurvelist[]={
                          DSTBOX,
                          DSTELLIPSE,
                          DSTPATH,
                          DSTENDLIST
                         };


static int dscolourvlist[]={
                            DSTCOLOUR,
                            DSTINT,
                            DSTENDLIST
                           };



static dscreator dsdefs[]=
{
 0,0,0,0, "int",       dsint,    0, DSTINT,        dsoneintlist,
 0,0,0,0, "string",    dsstr,    0, DSTSTR,        dsonestringlist,

 0,0,0,0, "box",       NULL,     0, DSTBOX,        dsboxlist,
 0,0,0,0, "ellipse",   NULL,     0, DSTELLIPSE,    dsboxlist,
 0,0,0,0, "path",      dsmkpath, 0, DSTPATH,       dspathlist,
 0,0,0,0, "fcurve",    dsmkcurve,0, DSTFCURVE,     dscurvelist,
 0,0,0,0, "ocurve",    dsmkcurve,0, DSTOCURVE,     dscurvelist,
 0,0,0,0, "pcurve",    dsmkcurve,0, DSTPCURVE,     dscurvelist,
 0,0,0,0, "move",      NULL,     0, DSTMOVE,       dstwointlist,
 0,0,0,0, "draw",      NULL,     0, DSTDRAW,       dstwointlist,
 0,0,0,0, "curve",     NULL,     0, DSTCURVE,      dssixintlist,
 0,0,0,0, "close",     NULL,     0, DSTCLOSE,      dszerolist,
 0,0,0,0, "end",       NULL,     0, DSTEND,        dszerolist,
 0,0,0,0, "angle",     NULL,     0, DSTANGLE,      dsoneintlist,
 0,0,0,0, "skew",      NULL,     0, DSTSKEW,       dsoneintlist,
 0,0,0,0, "name",      NULL,     0, DSTNAME,       dsonestringlist,
 0,0,0,0, "w",         NULL,     0, DSTW,          dsoneintlist,
 0,0,0,0, "h",         NULL,     0, DSTH,          dsoneintlist,
 0,0,0,0, "x",         NULL,     0, DSTX,          dsoneintlist,
 0,0,0,0, "y",         NULL,     0, DSTY,          dsoneintlist,

 0,0,0,0, "icurve",    dsmkcurve,0, DSTICURVE,     dscurvelist,
 0,0,0,0, "document",  dsnewdoc, 0, DSTDOC,        dszerolist,
 0,0,0,0, "linecolour",NULL,     0, DSTLINECOLOUR, dscolourvlist,
 0,0,0,0, "fillcolour",NULL,     0, DSTFILLCOLOUR, dscolourvlist,
 0,0,0,0, "thickness", NULL,     0, DSTTHICKNESS,  dsoneintlist,
 0,0,0,0, "radius",    NULL,     0, DSTRADIUS,     dsoneintlist,
 0,0,0,0, "inset",     NULL,     0, DSTINSET,      dsoneintlist,
 0,0,0,0, "textflow",  NULL,     0, DSTTEXTFLOW,   dszerolist,
 0,0,0,0, "colourvalue",NULL,    0, DSTCOLOURVALUE,dscolourvlist,
 0,0,0,0, "type",      NULL,     0, DSTTYPE,       dsoneintlist,
 0,0,0,0, "keypress",  dskey,    0, DSTKEY,        dsonestringlist,
 0,0,0,0, "master",    NULL,     0, DSTMASTER,     dsoneintlist,
 0,0,0,0, "local",     NULL,     0, DSTLOCAL,      dsoneintlist,
 0,0,0,0, "aspect",    NULL,     0, DSTASPECT,     dszerolist,
 0,0,0,0, "scale",     NULL,     0, DSTSCALE,      dszerolist,
 0,0,0,0, "lock",      NULL,     0, DSTLOCK,       dszerolist,
 0,0,0,0, "spread",    NULL,     0, DSTSPREAD,     dszerolist,
 0,0,0,0, "featurelevel",NULL,   0, DSTFEATURE,    dszerolist,
 0,0,0,0, "u",         dsunicode,0, DSTUNICODE,    dszerolist,

};



typedef struct dsblockstr
{
 dscreator * ds;
 int         n;
 int         min;
 int         max;
} dsblockstr;


#define DSBLOCKCHUNK (16*sizeof(dsblockstr))


static dsblockstr * dsblock;
static int          dsblockn;




static int blockcmpfn(const void * p1,const void * p2)
{
 dsblockstr * b1;
 dsblockstr * b2;

 b1=(dsblockstr *)p1;
 b2=(dsblockstr *)p2;

 if(b1->max<b2->min) return(-1);
 else
 if(b1->min>b2->max) return(1);
 else                return(0);
}


static int creatorcmpfn(const void * p1,const void * p2)
{
 return(((dscreator*)p1)->type-((dscreator*)p2)->type);
}







os_error * dsaddblock(dscreator * ds,int n)
{
 os_error * err;
 int        i;
 int        min;
 int        max;
 int        type;
 int        order;


 if(dsblock) err=flex_chunk((flex_ptr)&dsblock,
                            (dsblockn+1)*sizeof(dsblockstr),DSBLOCKCHUNK);
 else        err=flex_alloc((flex_ptr)&dsblock,DSBLOCKCHUNK);


 min=max=0; /* compiler */

 order=0;
 for(i=0;i<n;i++)
 {
  type=ds[i].type;

/* dprintf(0,"type=%x",type); */

  if(i==0)
  {
   min=max=type;
  }
  else
  if(type>=max) max=type;
  else
  {
   order=1;
   if(type<min) min=type;
  }
 }

 if(order) qsort(ds,n,sizeof(dscreator),creatorcmpfn);

 for(i=0;i<dsblockn;i++)
 {
  if(dsblock[i].min>min) break;
 }

 memmove(dsblock+i+1,dsblock+i,(dsblockn-i)*sizeof(dsblockstr));

 dsblock[i].min=min;
 dsblock[i].max=max;
 dsblock[i].n=n;
 dsblock[i].ds=ds;
 dsblockn++;

/* dprintf(0,"dsadd n=%d bln=%d min=%x max=%x order=%d",
                                       n,dsblockn,min,max,order); */
                 
 while(n--)
 {
  avlsearch((int)ds,(int*)&dsroot,0,dscmpcs);
  ds++;
 }

 return(err);
}



static dscreator * dsfind(int type)
{
 dscreator    ctarget;
 dscreator  * cptr;
 dsblockstr   btarget;
 dsblockstr * bptr;

 ctarget.type=type;
 btarget.min=btarget.max=type;

 bptr=(dsblockstr*)bsearch(&btarget,dsblock,dsblockn,sizeof(dsblockstr),blockcmpfn);
 if(bptr) cptr=(dscreator*)bsearch(&ctarget,bptr->ds,bptr->n,
                                        sizeof(dscreator),creatorcmpfn);
 else     cptr=NULL;

/* dprintf(0,"bptr=%x cptr=%x name=%s",bptr,cptr,cptr->name); */

 return(cptr);
}


/****************************************************************************/

typedef struct dsmapstr
{
 int value;
 int count;
} dsmapstr;


static dsmapstr * dsmap;
static int        dsmapn;


#define DSMAPCHUNK (32*sizeof(dsmapstr))


os_error * dsmapadd(int value,int * count)
{
 os_error * err;
 int        i;

 for(i=0;i<dsmapn;i++)
 {
  if(dsmap[i].value==value)
  {
   *count=++dsmap[i].count;
   return(NULL);
  }
 }

 err=flex_chunk((flex_ptr)&dsmap,(dsmapn+1)*sizeof(dsmapstr),DSMAPCHUNK);
 if(!err)
 {
  dsmap[dsmapn].value=value;
  *count=dsmap[dsmapn++].count=0;
 }

 return(err);
}


os_error * dsmapinit(void)
{
 dsmapn=0;
 return(flex_alloc((flex_ptr)&dsmap,DSMAPCHUNK));
}


os_error * dsmapfinit(void)
{
 return(flex_free((flex_ptr)&dsmap));
}


/*****************************************************************************/



os_error * dschain(int next,filestr * file,buffer * bf)
{
 os_error      * err;
 chainobject   * chain;
 int             message;
 char            string[32];

 err=NULL;
 message=OM_DSNAME;

 while(next && !err)
 {
  chain=(chainobject*)fob_find(next,file);
  next=chain->chain.next;
  objectmessage((objhdrstr*)chain,file,&message,string);
  bf_printf(bf,string);
  if(next) bf_printf(bf," ");
 }

 return(err);
}


os_error * dsbox(boxstr * box,transformstr * tr,buffer * bf)
{
 boxbitstr  bits;

 getboxbits(box,tr,&bits);

 bf_printfeol(bf,"{x %d}",bits.orgx);
 bf_printfeol(bf,"{y %d}",bits.orgy);
 bf_printfeol(bf,"{w %d}",bits.width);

 return(bf_printfeol(bf,"{h %d}",bits.height));
}


os_error * dstransform(boxstr * box,transformstr * tr,buffer * bf)
{
 boxbitstr  bits;

 getboxbits(box,tr,&bits);
 
 bf_printfeol(bf,"{angle 0x%x}",-bits.angle);

 return(bf_printfeol(bf,"{skew 0x%x}",-bits.skew));
}




static os_error * dspath(curvestr * cv,int * path,
                                       transformstr * tr,buffer * bf)
{
 boxbitstr       bits;
 transformstr    tr2;
 int             c;
 coordstr        cx[3];
 coordstr        c1;
 coordstr        c2;

 getboxbits(&cv->box,tr,&bits);
 tr_setscale(&tr2,cv->box.w,bits.width,cv->box.h,bits.height);

 c1.x=cv->box.x;
 c1.y=cv->box.y;
 c2=c1;
 tr_transformset(&c1,1,&tr2);
 tr_transformset(&c2,1,tr);

 tr2.e=c2.x-c1.x;
 tr2.f=c2.y-c1.y;

 bf_printf(bf,"{path ");

 while(1)
 {
  c=*path++;

  if(c==DRAWEND)
  {
   bf_printf(bf,"{end}");
   break;
  }
  else
  if(c==DRAWCLOSE)
  {
   bf_printf(bf,"{close}");
  }
  else
  if(c==DRAWMOVE)
  {
   XMEMCPYX(cx,path,2*sizeof(int));
   tr_transformset(cx,1,&tr2);
   bf_printf(bf,"{move %d %d}",cx[0].x,cx[0].y);
   path+=2;
  }
  else
  if(c==DRAWDRAW)
  {
   XMEMCPYX(cx,path,2*sizeof(int));
   tr_transformset(cx,1,&tr2);
   bf_printf(bf,"{draw %d %d}",cx[0].x,cx[0].y);
   path+=2;
  }
  else
  if(c==DRAWCURVE)
  {
   XMEMCPYX(cx,path,6*sizeof(int));
   tr_transformset(cx,3,&tr2);
   bf_printf(bf,"{curve %d %d %d %d %d %d}",cx[0].x,cx[0].y,
                                            cx[1].x,cx[1].y,
                                            cx[2].x,cx[2].y);
   path+=6;
  }
 }

 return(bf_printf(bf,"}"));
}



os_error * dscurve(curvestr * c,transformstr * tr,char * tag,buffer * bf,
                                                              filestr * file)
{
 pathstr * pathp;
 int       path[16];

 bf_printf(bf,"{%s ",tag);

 switch(c->type)
 {
      case CBOX:
     case CBOXR:
                bf_printf(bf,"{box ");
                dsbox(&c->box,tr,bf);
                bf_printf(bf,"}");
                break;

  case CELLIPSE:
                bf_printf(bf,"{ellipse ");
                dsbox(&c->box,tr,bf);
                bf_printf(bf,"}");
                break;

     case CPATH:
                pathp=(pathstr*)fob_find(c->data.path.path,file);
                dspath(c,pathp->data,tr,bf);
                break;

     case CLINE:
    case CLINEX:
    case CLINER:
   case CLINEXR:
                linepath(path,c,c->type);
                dspath(c,path,tr,bf);
                break;
 }

 return(bf_printfeol(bf,"}"));

}


os_error * dstextflow(textflowstr * f,buffer * bf,filestr * file)
{
 return(bf_printfeol(bf,"{textflow %d %d %d}",f->fmode,f->omode,f->o));
 USE(file);
}



os_error * dssavefile(char * name,filestr * file)
{
 os_error * err;
 buffer     bf;
 int        i;

 hourglasson();

 err=bf_open(name,'w',DEFBUFFSIZE,&bf);

 if(!err)
 {
  err=dsmapinit();
  if(!err)
  {
   stdfileheader(&bf,fs_leaf(name));

   for(i=EVENT_DSSAVE0;i<=EVENT_DSSAVEF;i++)
   {
    event(i,file,(int)&bf);
   }

   dsmapfinit();
  }
  err=bf_closec(&bf,err,name,DTYPE2);
 }

 hourglassoff();

 return(err);
}



os_error * dsinit(void)
{
 dsroot=(dscreator*)(-1);
 dsaddblock(dsdefs,sizeof(dsdefs)/sizeof(dscreator));

 return(adderrortable(errortable,&errorlink));
}

