/*->c.linetool */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  
#include <ctype.h>
#include <time.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"


#include "transform.h"
#include "xprocess.h"

#include "etc.h"
#include "err.h"
#include "wos.h"
#include "poll.h"
#include "key.h"
#include "colour.h"
#include "xmath.h"
#include "trans.h"
#include "bits.h"
#include "deb.h"


#include "constants.h"
#include "str.h"
#include "object.h"
#include "units.h"


#include "reslink.h"

#include "file.h"
#include "view.h"
#include "viewr.h"


#include "xredraw.h"
#include "curve.h"

#include "posn.h"
#include "toolstr.h"
#include "tools.h"
#include "caret.h"
#include "pref.h"
#include "select.h"
#include "chain.h"
#include "clip.h"

#include "line.h"
#include "dbline.h"

#include "linetool.h"



static int lxpass;
static int lxclaim;

static int       lxobject;
static filestr * lxfile;

/*****************************************************************************/


#define LIPTHICK  0

static iconmap lipmap[]=
{
  5,0,0,IP_TIPS,  /* thickness        0 */
  3,0,0,0,        /* dec angle        1 */

  0,0,0,0,       /* terminator */
};




static os_error * linedbgetwidth(int * width)
{
 linestr * linep;

 linep=(linestr*)fob_find(lxobject,lxfile);
 *width=linep->data.thickness;

 return(NULL);
}


static os_error * linedbsetwidth(int width)
{
 if(width>=0) return(linechangewidths(width));
 else         return(NULL);
}




static os_error * lxstep(int step)
{
 int width;

 linedbgetwidth(&width);
 return(linedbsetwidth(width+step));
}



static os_error * rdthick(int * value,char * string,viewstr * view)
{
 os_error * err;
 char       temp[64];

 err=NULL;

 tsprintf(sizeof(temp),temp,"{THIN}");
 if(!cstrcmp(temp,string)) *value=0;
 else                      err=stringtounits(string,value,view->data.units);

 return(err);
}




static os_error * lipkey(int handle,int userhandle,int icon,int * key)
{
 os_error * err;
 viewstr  * view;
 char     * p;
 int        width;

 err=NULL;

 cprintf("lipkey %d",*key);

 if(*key==13)
 {
  view=(viewstr *)userhandle;

  err=iconaddr(handle,lipmap[LIPTHICK].realicon,&p);
  if(!err)
  {
   err=rdthick(&width,p,view);
   if(!err) err=linedbsetwidth(width);
  }

  *key=-1;
 }

 return(err);
 USE(icon);
}





static os_error * lipclick(int handle,int userhandle,wimp_mousestr * m)
{
 viewstr    * view;
 filestr    * file;

 view=(viewstr *)userhandle;
 file=view->file;

 switch(m->i)
 {
  case  3: /* dec angle */
          openlinewidthmenu(linedbsetwidth,linedbgetwidth,handle);
          break;
 }

 return(NULL);

 USE(handle);
}




static os_error * liprefresh(viewstr * view,int handle,int code)
{
 char          string[32];
 linestr     * linep;
 filestr     * file;
 int           value;

 file=view->file;
 linep=(linestr*)fob_find(lxobject,file);
 value=linep->data.thickness;

 if(value) strcpy(string,unitstostring(value,view->data.units));
 else      tsprintf(32,string,"{THIN}");

 writeiconc(handle,lipmap[LIPTHICK].realicon,string);

 return(NULL);

 USE(code);
}




static ipstr lipstr=
{
 lipclick,     /* click    */
 lipkey,       /* key      */
 lipmap,       /* icon map */
 TLINETOOL,    /* template */
 0,            /* code     */
 liprefresh,   /* refresh  */
};





static os_error * lxkey(toolboxstr * toolbox,int * key,fkeyfn * fk)
{
 os_error * err;

 err=NULL;


 if(lxpass && lxobject)
 {
  if(*key==keycanonical2code(COMMAINDEX|KEYCTRL))
  {
   lxstep(-MMSIZE/2);
   *key=-1;
  }
  else
  if(*key==keycanonical2code(POINTINDEX|KEYCTRL))
  {
   lxstep(MMSIZE/2);
   *key=-1;
  }
 }

 return(err);
 USE(toolbox);
 USE(fk);
}








static os_error * lxselect(toolboxstr * toolbox,viewstr * view,
                                                filestr * file,int select)
{
 int          n;
 sobjectstr * sob;
 int          object;

 if((lxpass && select) || (!lxpass && !select))
 {
  n=nselected(&object,file);
  if(n==1)
  {
   sob=(sobjectstr*)fob_find(object,file);
   if(sob->type==OLINE)
   {
    if(select)
    {
     ipchangepane(toolbox,IP_PANE2,&lipstr);
     lxobject=object;
     lxfile=file;
    }
    else
    {
     ipchangepane(toolbox,IP_PANE2,NULL);
     lxobject=0;
     lxfile=NULL;
    }
   }
  }
 }

 return(NULL);

 USE(view);
 USE(file);
 USE(select);
 USE(toolbox);
}



static subtoolstr lxtool=
{
 TL_SELECT,
 NULL,
 NULL,
 lxselect,
 NULL,
 NULL,
 NULL,
 NULL,
 NULL,
 lxkey,
 NULL,
 NULL,
 NULL,
 &lxpass,
 &lxclaim
};




static os_error * lxselection(int eventn,int user,filestr * file,int object)
{
 toolboxstr * toolbox;
 int          n;
 sobjectstr * sob;

 toolbox=file->toolbox;

 if(eventn==EVENT_OBJECTSELECTED0)
 {
  if(lxobject && file==lxfile && object!=lxobject && 
                 !objectinobject(lxobject,object,file))
  {
   ipchangepane(toolbox,IP_PANE2,NULL);
   lxobject=0;
   lxfile=NULL;
  }
 }
 else
 if(eventn==EVENT_OBJECTDESELECTED0)
 {
  if(lxobject && file==lxfile && (lxobject==object ||
                  objectinobject(lxobject,object,file)))
  {
   ipchangepane(toolbox,IP_PANE2,NULL);
   lxobject=0;
   lxfile=NULL;
  }
 }
 else
 if(eventn==EVENT_OBJECTSELECTED1 || eventn==EVENT_OBJECTDESELECTED1)
 {
  if(toolcurrent(file)==TL_SELECT)
  {
   n=nselected(&object,file);
   if(n==1)
   {
    sob=(sobjectstr*)fob_find(object,file);
    if(sob->type==OLINE)
    {
     lxobject=object;
     lxfile=file;
     ipchangepane(toolbox,IP_PANE2,&lipstr);
    }
   }
  }
 }

 return(NULL);

 USE(eventn);
 USE(user);
}



static os_error * lxpref(int eventn,int user,viewstr * view,prefdatastr * old)
{
 filestr     * file;
 prefdatastr * xnew;

 file=view->file;

 if(lxfile==file)
 {
  xnew=prefp(file);
  if(xnew->units!=old->units) iprefreshpane(file,0x1,IP_PANE2);
 }

 return(NULL);
 USE(eventn);
 USE(user);
}



static os_error * lxschange1(int eventn,int user,filestr * file,int object)
{
 if(lxfile==file)
 {
  iprefreshpane(lxfile,0x1,IP_PANE2);
 }

 return(NULL);

 USE(eventn);
 USE(user);
 USE(object);
}






os_error * linetoolinit(void)
{
 os_error * err;

 err=subtoolregister(&lxtool);
 if(!err) err=addevent(EVENT_OBJECTSELECTED0,(eventfn)lxselection,0);
 if(!err) err=addevent(EVENT_OBJECTDESELECTED0,(eventfn)lxselection,0);
 if(!err) err=addevent(EVENT_OBJECTSELECTED1,(eventfn)lxselection,0);
 if(!err) err=addevent(EVENT_OBJECTDESELECTED1,(eventfn)lxselection,0);

 if(!err) err=addevent(EVENT_MODIFYSELECTION1,(eventfn)lxschange1,0);
 if(!err) err=addevent(EVENT_PREFERENCES,(eventfn)lxpref,0);

 return(err);
}


