/*->h.macros */


extern int    codechar(char * string);
extern char * uncode(char * string,int byte);

typedef os_error * (*macrokeyhandler)(int *);
                                      /* function to handle key presses */
typedef os_error * (*expandfn)(int);  /* expansion function */


extern  os_error * keymacro(macrokeyhandler,int * key,int macenv,int macview);
extern  os_error * expandmacro(expandfn exfn,char * string);
extern  os_error * expandmacro2(expandfn exfn,char * string,
                                int macenv,int macview);
extern  os_error * expandamacro(expandfn exfn,int n,int macenv,int macview);

extern os_error * expandmacrostring(char * source,char ** result,int flags);
extern os_error * expandmacrostringfinit(char ** result);

extern os_error * expandmacrostring2(char * source,unsigned short ** result,int flags);
extern os_error * expandmacrostringfinit2(unsigned short ** result);


extern os_error * macrotostring(char * in,char * out,int maxlen);
extern os_error * stringtomacro(char * in,char * out,int maxlen);

extern os_error * macrotostring2(char * in,unsigned short * out,int maxlen);
extern os_error * stringtomacro2(unsigned short * in,char * out,int maxlen);


extern os_error * expandcode(int c,char ** outp,char * lt);


extern os_error * macrohelp(char ** p,int n);

extern os_error * macrotip(char ** p,int n);

extern  int  convert(char * string,char * result,int * length,int maxlen);


extern int macroextbits(int i);


#define MACENVINT 0x0
#define MACENVBUT 0x1
#define MACENVKEY 0x2



#define MNLEN  16
#define MDLEN  16
#define MACLEN 256


#define TYPEMASK             0x3
#define TYPEBUTTON             0
#define TYPEKEY                1
#define TYPETEXT               2
#define TYPEBUTTONA            4
#define TYPEBUTTONG            8
#define TYPEBUTTONL           16
#define TYPEBUTTONX           32
#define TYPEBUTTONEXTEND      64
#define TYPEBUTTONEXTEXT     128
#define TYPEBUTTONTXWIDTH    0x1FF00

#define TYPEBUTTONTXSHIFT      8


#define MACINUSE   0x1
#define MACACTIVE  0x2
#define MACGAP     0x4
#define MACNL      0x8
#define MACEXTERN  0x10
#define MACEXTEND  0x20
#define MACEXTEXT  0x40
#define MACTXWIDTH 0xFF80
#define MACTXSHIFT 7



typedef struct
{
 char name[MNLEN];
 int  type;
 int  defn;
 int  flags;

 union
 {
  char data[MDLEN];
  int  value;
 } data;

} macro;



extern macro * macros;        /* holds header for each macro */
extern char  * mstrings;      /* holds macro strings */

extern int     macrostot; 
extern int     mstringsize;

extern os_error * savemacros(void);
extern os_error * loadmacros(void);
extern os_error * clearmacros(void);


extern os_error * macrosboot(void);
extern int        findmacro(char * name,int type);
extern int        macrofindtoken(char * string);
extern int        macrofindglyph(char * string);
extern int        macrofindnearestglyph(char * string);
extern char     * macrofindglyphname(int unicode);
extern char     * macrofindtokenname(int unicode);

extern int        nextbuttonmacro(int n);
extern int        prevbuttonmacro(int n);


extern int        macrorecorder(int ch);
extern int        macrorecordermacro(void);

extern void delmacron(int n);
extern void delallmacros(int fp);
extern void delmacro(int fp);
extern void defmacro(int fp);
extern void defmacro2(int fp);
extern void defmacro3(int fp);
extern void defmacro4(int fp);
extern int  isdefmacro(int fp);
extern int  evalmacro(int fp);

extern int xmacrofindglyph(int fp);
extern int xmacrofindglyphname(int fp);


extern os_error * macrossave(char * filename,int delall);
extern os_error * savedefaultmacros(void);

extern os_error * updatemacro(int mn,char * definition,char * help,char * aname,char * ttip);
extern os_error * addmacro(int type,char * name,char * definition,int value,
                                         char * data,char * help,char * aname,char * ttip,int * n);



extern void macrorename(int fp);
extern int macrostring(int fp);




typedef os_error * (*fixedmacrofn)(expandfn exp);


typedef struct fixedmacrostr
{
 int            parent;
 int            sibls[2];
 int            balance;
 char         * name;
 fixedmacrofn   fn;

} fixedmacrostr;


extern os_error * registermacroblock(fixedmacrostr * mb,int n);




