/*->c.scripts */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <ctype.h>


#include "os.h"
#include "flex.h"
#include "wimp.h"
#include "werr.h"
#include "transform.h"

#include "err.h"
#include "alloc.h"
#include "xext.h"
#include "wos.h"
#include "poll.h"
#include "key.h"
#include "etc.h"
#include "scrap.h"
#include "fsx.h"
#include "bits.h"
#include "avl.h"
#include "deb.h"


#include "constants.h"
#include "str.h"


#include "scripts.h"



static os_error *eventhandler(int eventn,int userhandle,void * data,int data1);


/* void addeventhandler(int eventno,int user,string & function) */
/* void remeventhandler(int eventno,int user,string & function) */


/* need to associate a handle with each block, and to be able to access */
/* each block by the function name                                      */



typedef struct scripteventfnstr
{
 struct scripteventfnstr * next;
 struct scripteventfnstr * prev;
 int    user;
 int    eventno;
 char   name[1];
} scripteventfnstr;



static scripteventfnstr * firstsfp;



static os_error * remscripteventfn(scripteventfnstr ** sfp)
{
 scripteventfnstr * sf;
 scripteventfnstr * next;
 scripteventfnstr * prev;

 sf=*sfp;

 if(sf==firstsfp) firstsfp=sf->next;

 next=sf->next;
 prev=sf->prev;

 if(next) next->prev=prev;
 if(prev) prev->next=next;

 return(sfree((flex_ptr)sfp));
}



static os_error * findscripteventfn(int eventno,int user,char * name,
                                               scripteventfnstr ** sfp)
{
 scripteventfnstr * sf;

 *sfp=NULL;

 sf=firstsfp;
 while(sf)
 {
  if(sf->eventno==eventno &&
     sf->user==user &&
     !strcmp(name,sf->name))
  {
   *sfp=sf;
   break;
  }
  sf=sf->next;
 }

 return(NULL);
}



static os_error * addscripteventfn(int eventno,int user,char * name,
                                                 scripteventfnstr ** sfp)
{
 os_error         * err;
 scripteventfnstr * sf;

 err=findscripteventfn(eventno,user,name,sfp);

 if(*sfp) *sfp=NULL;
 else
 {

  err=salloc((flex_ptr)sfp,sizeof(scripteventfnstr)+strlen(name));
  if(!err)
  {
   sf=*sfp;
   sf->eventno=eventno;
   sf->user=user;
   strcpy(sf->name,name);
   if(firstsfp)
   {
    firstsfp->prev=sf;
    sf->next=firstsfp;
   }
   firstsfp=sf;
  }
 }

 return(err);
}



void addeventhandler(int fp)
{
 os_error         * err;
 TCHAR              name[256];
 int                eventno;
 int                user;
 scripteventfnstr * sfp;


 eventno=stack[fp];
 user=stack[fp+1];

          err=xzstrncpye(name,stringptr(stack[fp+2]),sizeof(name)/sizeof(TCHAR));
	if(!err) err=addscripteventfn(eventno,user,name,&sfp);

 if(!err && sfp)
 {
  addevent(eventno,eventhandler,(int)sfp);
 }

 zreport(err);
}



void remeventhandler(int fp)
{
	os_error         * err;
 TCHAR              name[256];
 int                eventno;
 int                user;
 scripteventfnstr * sfp;

 eventno=stack[fp];
 user=stack[fp+1];
 err=xzstrncpye(name,stringptr(stack[fp+2]),sizeof(name)/sizeof(TCHAR));

 findscripteventfn(eventno,user,name,&sfp);
 if(sfp)
 {
  remevent(eventno,eventhandler,(int)sfp);
  remscripteventfn(&sfp);
 }

	zreport(err);
}



/****************************************************************************/


static scripteventstr * sbroot=(scripteventstr*)(-1);


static int sbcmpcs(void * key1,void * key2)
{
 return(*((int*)key1)-*((int*)key2));
}



/* look up the event in the event blocks                */
/* based on what you find, construct the parameter list */
/* exec the function with the parameter list            */
/* back to the event block and fill in the values       */


/* I == parameter is integer  */
/* S == parameter is string   */
/* i == parameter is integer* */
/* s == parameter is string*  */
/* n == parameter is string max len */
/* v == skip parameter pointer one value */

static os_error * eventhandler(int eventno,int userhandle,void * data,int data1)
{
 os_error         * err;
 scripteventfnstr * sfp;
 int              * px[2];
 int                temp[32];
 char               args[128];
 int                result;
 char             * p;
 int                n;
 int                nx[2];
 char             * v;
 int                c;
 int                rx;
 int                i;
 scripteventstr  *  se;


 err=NULL;


 rx=0;
 sfp=(scripteventfnstr *)userhandle;
 temp[0]=sfp->user;
 strcpy(args,"KI");
 p=args+strlen(args);
 n=1;

 px[0]=(int*)data;
 px[1]=(int*)data1;
 nx[0]=nx[1]=0;

 /* look up eventno */

 se=(scripteventstr*)avlfind(&sfp->eventno,(int)sbroot,0,sbcmpcs);
 if((int)se!=-1)
 {
  v=se->arglist;

  if(v)
  {
   while((c=*v++)!=0)
   {
    if(c=='/')
    {
     nx[0]=nx[1]=0;
     *p++=(char)c;
     rx=1;
    }
    else
    if(c=='1' || c=='2')
    {
     i=c-'1';
     c=*v++;

     if(rx)
     {
      if(c=='i')
      {
       *p++='R';
       temp[n++]=(int)(px[i]+nx[i]++);
      }
      else
      if(c=='n')
      {
       *p++='N';
       temp[n++]=*(px[i]+nx[i]++);
      }
      else
      if(c=='N')
      {
       *p++=(char)c;
       temp[n++]=(int)px[i];
      }
      else
      if(c=='s' || c=='S')
      {
       *p++='S';
       temp[n++]=(int)(px[i]+nx[i]++);
      }
      else
      if(c=='V')
      {
       *p++=(char)c;
       nx[i]++;
      }
     }
     else
     {
      if(c=='I' || c=='S')
      {
       *p++=(char)c;
       temp[n++]=(int)px[i];
      }
      else
      if(c=='i' || c=='s')
      {
       *p++=(char)toupper(c);
       temp[n++]=*(px[i]+nx[i]++);
      }
      else
      if(c=='v')
      {
       nx[i]++;
      }
     }
    }
    else
    if(c=='V')
    {
     *p++=(char)c;
    }
   }
  }
 }

 *p=0;


 err=xexec(sfp->name,&result,args,temp);

 return(err);

 USE(eventno);
}





static scripteventstr scriptevents[]=
{
 0,0,0,0, EVENT_FOPEN,         "1I",
 0,0,0,0, EVENT_FCLOSE,        "1I",
 0,0,0,0, EVENT_RUNPROGRAM,    NULL,
 0,0,0,0, EVENT_ENDPROGRAM,    NULL,
 0,0,0,0, EVENT_VOPEN,         "1I",
 0,0,0,0, EVENT_VCLOSE,        "1I",
 0,0,0,0, EVENT_FPRESAVE,      "1I2S/VV2S",
 0,0,0,0, EVENT_FONTSCHANGED,  NULL,
 0,0,0,0, EVENT_RUNPROGRAM2,   NULL,
 0,0,0,0, EVENT_ZOOM,          "1I2I",
 0,0,0,0, EVENT_PREFERENCES,   "1I",
 0,0,0,0, EVENT_CHOICES,       NULL,

 0,0,0,0, EVENT_FILEMODIFIED,  "1I",

 0,0,0,0, EVENT_KEYPRESS,      "1I2i/2i",

 0,0,0,0, EVENT_INSTEXT0,      "2v1S2i/V2n1S2i",
 0,0,0,0, EVENT_INSTEXT1,      "2v1S2i/V2n1S2i",

 0,0,0,0, EVENT_FILESAVED,     "1I",
 0,0,0,0, EVENT_CARET,         "1I2I",

 0,0,0,0, EVENT_NEWDOC0,       "1I",
 0,0,0,0, EVENT_NEWDOCF,       "1I",
 0,0,0,0, EVENT_BAREDOC0,      "1I",
 0,0,0,0, EVENT_BAREDOCF,      "1I",
 0,0,0,0, EVENT_LOADSTYLE0,    "1I",
 0,0,0,0, EVENT_LOADSTYLEF,    "1I",

 0,0,0,0, EVENT_CHOICESSAVE,    NULL,
 0,0,0,0, EVENT_PREFERENCESSAVE,"1I",

 0,0,0,0, EVENT_VIEWCLICK,     "1I2i2i2i/V2V2V2i",
 0,0,0,0, EVENT_VOPENPOST,     "1I",

 0,0,0,0, EVENT_FONTMISSING,   "1I2s2i/V1V2V2i",

 0,0,0,0, EVENT_TEXTUPDATE,     "1I",
 0,0,0,0, EVENT_ACTIVEVIEW,     "1I2I",
 0,0,0,0, EVENT_USERSTYLECHANGE,"1I",
 0,0,0,0, EVENT_COLOURCHANGE,   "1I",


 0,0,0,0, EVENT_OBJECTSELECTED0, "1I2I",
 0,0,0,0, EVENT_OBJECTSELECTED1, "1I2I",
 0,0,0,0, EVENT_OBJECTDESELECTED0, "1I2I",
 0,0,0,0, EVENT_OBJECTDESELECTED1, "1I2I",

 0,0,0,0, EVENT_TRANSFORMSELECTION, "1I", 
 0,0,0,0, EVENT_TRANSFORMSELECTION1, "1I",
 0,0,0,0, EVENT_TRANSFORMSELECTION0, "1I",

 0,0,0,0, EVENT_TRANSFORMSELECTIONR0,"1I",
 0,0,0,0, EVENT_TRANSFORMSELECTIONR1,"1I",

 0,0,0,0, EVENT_TEXTFLOWSELECTION,   "1I",
 0,0,0,0, EVENT_TEXTFLOWSELECTION0,  "1I",
 0,0,0,0, EVENT_TEXTFLOWSELECTION1,  "1I",

 0,0,0,0, EVENT_MODIFYSELECTION,     "1I",
 0,0,0,0, EVENT_MODIFYSELECTION0,    "1I",
 0,0,0,0, EVENT_MODIFYSELECTION1,    "1I",

 0,0,0,0, EVENT_SELECTIONDELETED,    "1I",

 0,0,0,0, EVENT_SHAPESELECTION0,     "1I",
 0,0,0,0, EVENT_SHAPESELECTION1,     "1I",

 0,0,0,0, EVENT_MOVESELECTION0,      "1I",
 0,0,0,0, EVENT_MOVESELECTION1,      "1I",

 0,0,0,0, EVENT_LOCALSELECTION,      "1I",
 0,0,0,0, EVENT_MASTERSELECTION,     "1I",
 0,0,0,0, EVENT_BEEP,                "1i2I/1i",

 0,0,0,0, EVENT_FILENOREAD,          "1I2i/V1V2i",
 0,0,0,0, EVENT_FILEWRITEFAIL,       "1I2i/V1V2i",
 0,0,0,0, EVENT_FILESCRAP,           "1I2i/V1V2i",


 0,0,0,0, EVENT_PRSTARTJOB,          "1I",
 0,0,0,0, EVENT_PRENDJOB,            "1I",
 0,0,0,0, EVENT_PRCACHE0,            "1I",
 0,0,0,0, EVENT_PRCACHE1,            "1I",

 0,0,0,0, EVENT_PRSTARTPAGE,         "1I",
 0,0,0,0, EVENT_PRENDPAGE,           "1I",
 0,0,0,0, EVENT_PRSTARTRECORD,       "1I",
 0,0,0,0, EVENT_PRENDRECORD,         "1I",
 0,0,0,0, EVENT_PRSTART,             "1I",
 0,0,0,0, EVENT_PREND,               "1I",

 0,0,0,0, EVENT_PRGOPRINTER0,        "1I",
 0,0,0,0, EVENT_PRGOPRINTER1,        "1I",
 0,0,0,0, EVENT_PRGONORMAL0,         "1I",
 0,0,0,0, EVENT_PRGONORMAL1,         "1I",
 0,0,0,0, EVENT_PRCOPIES,            "1I",
 0,0,0,0, EVENT_PRSTARTCOPY,         "1I",
 0,0,0,0, EVENT_PRENDCOPY,           "1I",

 0,0,0,0, EVENT_PRCHANGE,            NULL,
 0,0,0,0, EVENT_PRPAGECHANGE,        NULL,

 0,0,0,0, EVENT_NONRECTCLIP,         "2i/2i",
 0,0,0,0, EVENT_DOCLIP,              NULL,
 0,0,0,0, EVENT_CURRPAGE,            "1I",

 0,0,0,0, EVENT_PRPXSTART,           "1I",
 0,0,0,0, EVENT_PRPXEND,             "1I",

 0,0,0,0, EVENT_SPELLCHECK,          "1I2i2i2s/2i",

 0,0,0,0, EVENT_MERGESTART,          "1I2S",
 0,0,0,0, EVENT_MERGEFINISH,         "1I",
 0,0,0,0, EVENT_MERGEDATA,           "1I2I",
 0,0,0,0, EVENT_MERGESTRIP,          "1I",
 0,0,0,0, EVENT_MERGECLEAR,          "1I",

 0,0,0,0, EVENT_SETCLIPBOARD,        "1I2I",
 0,0,0,0, EVENT_SETNOCLIPBOARD,      "1I2I",

 0,0,0,0, EVENT_CLEARSELECTION0,     "1I2I",
 0,0,0,0, EVENT_CLEARSELECTION1,     "1I2I",
 0,0,0,0, EVENT_DELETESELECTION0,    "1I2I",
 0,0,0,0, EVENT_DELETESELECTION1,    "1I2I",
 0,0,0,0, EVENT_COPYSELECTION0,      "1I2I",
 0,0,0,0, EVENT_COPYSELECTION1,      "1I2I",
 0,0,0,0, EVENT_PASTESELECTION0,     "1I2I",
 0,0,0,0, EVENT_PASTESELECTION1,     "1I2I",
 0,0,0,0, EVENT_PASTECLICK0,         "1I2I",
 0,0,0,0, EVENT_PASTECLICK1,         "1I2I",
 0,0,0,0, EVENT_CUTSELECTION0,       "1I2I",
 0,0,0,0, EVENT_CUTSELECTION1,       "1I2I",

 0,0,0,0, EVENT_PICTOBJECTCHANGE,    "1I2I",
 0,0,0,0, EVENT_SUBTOOL,             "1I2I",
 0,0,0,0, EVENT_NEWDEFAULT,										NULL,

 0,0,0,0, EVENT_PSHEADER0,           "1I",
 0,0,0,0, EVENT_PSHEADER1,           "1I",
 0,0,0,0, EVENT_PSPROLOG0,           "1I",
 0,0,0,0, EVENT_PSPROLOG1,           "1I",
 0,0,0,0, EVENT_PSSETUP0,            "1I",
 0,0,0,0, EVENT_PSSETUP1,            "1I",
 0,0,0,0, EVENT_PSTRAILER0,          "1I",
 0,0,0,0, EVENT_PSTRAILER1,          "1I",
 0,0,0,0, EVENT_PSPAGE0,             "1I",
 0,0,0,0, EVENT_PSPAGE1,             "1I",
 0,0,0,0, EVENT_PSPAGETRAILER0,      "1I",
 0,0,0,0, EVENT_PSPAGESETUP0,        "1I",
 0,0,0,0, EVENT_PSPAGESETUP1,        "1I",
 0,0,0,0, EVENT_PSSTARTPICT ,        "1I",
 0,0,0,0, EVENT_PSENDPICT,           "1I",


};




os_error * registerscripteventblock(scripteventstr * sb,int n)
{

 while(n--)
 {
  avlsearch((int)sb,(int*)&sbroot,0,sbcmpcs);
  sb++;
 }

 return(NULL);
}




os_error * scriptsinit(void)
{


 return(registerscripteventblock(scriptevents,
                                 sizeof(scriptevents)/sizeof(scripteventstr)));
}


