/*->c.dbpixref */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <ctype.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "flex.h"
#include "transform.h"
#include "xprocess.h"
#include "etc.h"

#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "xmath.h"
#include "dbhi.h"
#include "mhi.h"
#include "fsx.h"
#include "bf.h"
#include "bits.h"
#include "trans.h"
#include "save.h"
#include "load.h"
#include "avl.h"
#include "deb.h"
#include "osshell.h"


#include "str.h"
#include "constants.h"
#include "reslink.h"
#include "units.h"
#include "posn.h"
#include "object.h"
#include "undo.h"



#include "view.h"
#include "viewr.h"
#include "file.h"
#include "chain.h"
#include "select.h"
#include "dbscale.h"

#include "pxstr.h"
#include "pxconstant.h"
#include "pict.h"
#include "dbpict.h"
#include "pixtool.h"
#include "pxtags.h"

#include "impex.h"


#include "pxref.h"
#include "pxcache.h"

#include "dbpixref.h"





/*****************************************************************************/




static viewstr    * cview;
static filestr    * cfile;
static int          cpictbox;
static int          cpicture;





static pxproxystr cproxy;

pxproxystr pxdefproxy=
{
 1,
 (0x10000/4),
 8,

};




static pxproxyfn proxyfn;


static os_error * proxychoiceclose(int code)
{
 os_error * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  if(proxyfn) err=proxyfn(&cproxy);
 }

 return(err);
}




static dbiconstr proxychoiceicondefs[]=
{
   13, &cproxy.dither,DBTOGGLE, 1,   0,      1,   F1,     0,0,    NULL, 0,

   15, &cproxy.scale, DBRADIO,  1,   0,(0x10000/8),F2,  1, 0,    NULL, 0,
    5, &cproxy.scale, DBRADIO,  1,   0,(0x10000/1), F3,  1, 0,    NULL, 0,
    3, &cproxy.scale, DBRADIO,  1,   0,(0x10000/4),F4,  1, 0,    NULL, 0,
    4, &cproxy.scale, DBRADIO,  1,   0,(0x10000/2), F5,  1, 0,    NULL, 0,
    6, &cproxy.scale, DBRADIO,  1,   0,(0x10000*2), F6,  1, 0,    NULL, 0,
    7, &cproxy.scale, DBRADIO,  1,   0,(0x10000*4),F7,  1, 0,    NULL, 0,

//    8, &cproxy.bpp,   DBRADIO,  1,   0,2,           F8,  2, 0,    NULL, 0,
    9, &cproxy.bpp,   DBRADIO,  1,   0,4,           F9,  2, 0,    NULL, 0,
   10, &cproxy.bpp,   DBRADIO,  1,   0,8,           F10, 2, 0,    NULL, 0,
   11, &cproxy.bpp,   DBRADIO,  1,   0,16,          F11, 2, 0,    NULL, 0,
   12, &cproxy.bpp,   DBRADIO,  1,   0,32,          PRINTK,2,0,   NULL, 0,

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

   1,  NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
   2,  NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0

};



static dboxstr proxychoicebox=
{
 0,
 TPROXYCHOICE,
 DBFIX,
 DBGRAB,
 proxychoiceclose, /* close */
 NULL, /* icon  */
 NULL,
 NULL,
 proxychoiceicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};




os_error * openproxychoice(pxproxystr * pproxy,pxproxyfn xproxyfn,
                            dboxstr * parent,dbstackstr * dsp)
{
 os_error * err;

 proxyfn=xproxyfn;

 cproxy=*pproxy;
 if(cproxy.bpp==2) cproxy.bpp=4;

 err=dodboxsp(&proxychoicebox,1,parent,dsp);

 return(err);
}



os_error * wrproxyinfo(pxproxystr * proxy,char * string)
{
 int  scale;
 char temp[8];

 scale=proxy->scale/0x10000;
 if(scale>1) sprintf(temp,"*%d",scale);
 else
 {
  scale=0x10000/proxy->scale;
  if(scale>1)  sprintf(temp,"/%d",scale);
  else         *temp=0;
 }

 return(tsprintf(256,string,"{PX05}%s %d{PX06}",temp,proxy->bpp));
}


/*****************************************************************************/

extern dboxstr proxybox;

static int tpicture;
static int proxypictsize;
static int proxycurrsize;


static os_error * pfn(sobjectstr * sob,filestr * file,int * message)
{
 pictboxstr * pictp;
 int          pict;
 int          page;
 int          section;

 if(sob->type==OPICTBOX)
 {
  pictp=(pictboxstr*)sob;
  pict=pictp->key;
  if(pictp->picture==tpicture)
  {
   pagesectionof((chainobject*)sob,file,&page,&section);
   pxrefresh(pict,section,page,file);
  }
 }

 return(NULL);
 USE(message);
}



static os_error * pxrefreshpicture(int cpicture,filestr * cfile)
{
 os_error * err;
 int        message;

 message=OM_FUNCTION2;
 tpicture=cpicture;
 err=broadcastmessage(cfile,&message,(void*)pfn);

 return(err);
}



static os_error * pxundowriteproxy(int picture,filestr * file)
{
 os_error      * err;
 pxproxytagstr   proxytag;

          err=pxreadtag((pxtagstr*)&proxytag,PXPROXYTAG,picture,file);
 if(!err) err=undowritefn(file,UPXPROXY,&picture,sizeof(int));
 if(!err) err=undowrite(file,&proxytag.len,sizeof(int));
 if(!err)
 {
  if(proxytag.len)err=undowrite(file,&proxytag.proxy,sizeof(pxproxystr));
 }

 return(err);
}






os_error * pxundoproxy(filestr * file)
{
 os_error     * err;
 int            picture;
 pxproxytagstr  proxytag;
 picturestr   * picturep;


                  undoread(file,&picture,sizeof(int));
                  undoread(file,&proxytag.len,sizeof(int));
 if(proxytag.len) undoread(file,&proxytag.proxy,sizeof(pxproxystr));

 err=pxundowriteproxy(picture,file);

 picturep=(picturestr*)fob_find(picture,file);
 if(proxytag.len)
 {
  err=importmakeproxy(picturep->ftype,picture,file,&proxytag.proxy);
 }
 else
 {
  err=importremoveproxy(picturep->ftype,picture,file);
 }

 err=pxrefreshpicture(picture,file);

 return(err);
}





static os_error * proxyclose(int code)
{
 os_error    * err;
 picturestr  * picturep;
 pictboxstr  * pictp;
 int           page;
 int           section;


 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  pictp=(pictboxstr*)fob_find(cpictbox,cfile);
  pagesectionof((chainobject*)pictp,cfile,&page,&section);

  err=modfile(cfile,section);
  if(!err)
  {
   err=undostart(cfile);
   if(!err)
   {
    err=pxundowriteproxy(cpicture,cfile);

    if(!err)
    {
     picturep=(picturestr*)fob_find(cpicture,cfile);

     err=importmakeproxy(picturep->ftype,cpicture,cfile,&cproxy);
     if(!err)
     {
      picturep=(picturestr*)fob_find(cpicture,cfile);
      proxycurrsize=picturep->proxylen;
      dbchangevalue(&proxycurrsize,&proxybox);
      err=pxrefreshpicture(cpicture,cfile);
     }
    }
    undoend(cfile);
   }
  }
 }

 return(err);
}




static os_error * remfn(int handle,int userhandle,wimp_mousestr * m)
{                                                                                os_error    * err;
 picturestr  * picturep;
 pictboxstr  * pictp;
 int           page;
 int           section;


 err=NULL;

 picturep=(picturestr*)fob_find(cpicture,cfile);
 if(picturep->proxylen)
 {
  pictp=(pictboxstr*)fob_find(cpictbox,cfile);
  pagesectionof((chainobject*)pictp,cfile,&page,&section);

  err=modfile(cfile,section);
  if(!err)
  {
   err=undostart(cfile);
   if(!err)
   {
    err=pxundowriteproxy(cpicture,cfile);

    picturep=(picturestr*)fob_find(cpicture,cfile);
    err=importremoveproxy(picturep->ftype,cpicture,cfile);
    if(!err)
    {
     err=pxrefreshpicture(cpicture,cfile);
     picturep=(picturestr*)fob_find(cpicture,cfile);
     proxycurrsize=picturep->proxylen;
     dbchangevalue(&proxycurrsize,&proxybox);
    }

    undoend(cfile);
   }
  }
 }

 return(err);

 USE(handle);
 USE(userhandle);
 USE(m);
}



static int rmchange;


static os_error * rmfn(sobjectstr * sob,filestr * file,int * message)
{
 os_error   * err;
 pictboxstr * pictp;
 picturestr * picturep;
 int          pict;
 int          picture;
 int          page;
 int          section;


 err=NULL;

 if(sob->type==OPICTBOX)
 {
  pictp=(pictboxstr*)sob;
  pict=pictp->key;
  picture=pictp->picture;

  if(picture)
  {
   picturep=(picturestr*)fob_find(picture,file);
   if(picturep->proxylen)
   {
    pictp=(pictboxstr*)fob_find(pict,file);
    pagesectionof((chainobject*)pictp,file,&page,&section);

    err=modfile(file,section);
    if(!err)
    {
     if(!rmchange) err=undostart(file);
     if(!err)
     {
      rmchange=1;

      err=pxundowriteproxy(picture,file);

      picturep=(picturestr*)fob_find(picture,file);
      err=importremoveproxy(picturep->ftype,picture,file);
      if(!err)
      {
       err=pxrefreshpicture(picture,file);
      }
     }
    }
   }
  }
 }

 return(err);

 USE(message);
}






static os_error * remallfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error   * err;
 int          message;
 picturestr * picturep;

 rmchange=0;
 message=OM_FUNCTION2;
 err=broadcastmessage(cfile,&message,(void*)rmfn);
/* viewrefreshall(cfile,-1,VRBACK); */

 if(rmchange) undoend(cfile);

 picturep=(picturestr*)fob_find(cpicture,cfile);
 proxycurrsize=picturep->proxylen;
 dbchangevalue(&proxycurrsize,&proxybox);

 return(err);

 USE(handle);
 USE(userhandle);
 USE(m);
}




static os_error * outm(int value,char * string)
{
 strcpy(string,memstring(value));
 return(NULL);
}




static dbiconstr proxyicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

   13, &cproxy.dither,DBTOGGLE, 1,   0,      1,   F1,     0,0,    NULL, 0,

   15, &cproxy.scale, DBRADIO,  1,   0,(0x10000/8),F2,  1, 0,    NULL, 0,
    5, &cproxy.scale, DBRADIO,  1,   0,(0x10000/1), F3,  1, 0,    NULL, 0,
    3, &cproxy.scale, DBRADIO,  1,   0,(0x10000/4),F4,  1, 0,    NULL, 0,
    4, &cproxy.scale, DBRADIO,  1,   0,(0x10000/2), F5,  1, 0,    NULL, 0,
    6, &cproxy.scale, DBRADIO,  1,   0,(0x10000*2), F6,  1, 0,    NULL, 0,
    7, &cproxy.scale, DBRADIO,  1,   0,(0x10000*4),F7,  1, 0,    NULL, 0,

//    8, &cproxy.bpp,   DBRADIO,  1,   0,2,           F8,  2, 0,    NULL, 0,
    9, &cproxy.bpp,   DBRADIO,  1,   0,4,           F9,  2, 0,    NULL, 0,
   10, &cproxy.bpp,   DBRADIO,  1,   0,8,           F10, 2, 0,    NULL, 0,
   11, &cproxy.bpp,   DBRADIO,  1,   0,16,          F11, 2, 0,    NULL, 0,
   12, &cproxy.bpp,   DBRADIO,  1,   0,32,          PRINTK,2,0,   NULL, 0,

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,
   21, NULL,         DBACTION, 0,   0,      0,0, 1,0, (dbreadfn)remfn,0,
   16, NULL,         DBACTION, 0,   0,      0,0, 1,0, (dbreadfn)remallfn,0,

   18, &proxycurrsize,DBTEXT,  0,   0,        -1, -1, -1, -1, NULL, outm,
   20, &proxypictsize,DBTEXT,  0,   0,        -1, -1, -1, -1, NULL, outm,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0

};



static dboxstr proxybox=
{
 0,
 TPROXY,
 DBFIX,
 DBGRAB,
 proxyclose, /* close */
 NULL, /* icon  */
 NULL,
 NULL,
 proxyicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};






void openproxybox(int fp)
{
 os_error      * err;
 pictboxstr    * pictp;
 pxproxytagstr * proxytag;
 picturestr    * picturep;
 int             info[256];
 int           * p;


 dbclear(&proxybox);

 err=pixselected(&cpictbox,menufile);
 if(cpictbox)
 {
  cview=menuview;
  cfile=menufile;

  pictp=(pictboxstr*)fob_find(cpictbox,cfile);
  cpicture=pictp->picture;

  err=impexpxinfo(cpicture,pictp->ftype,cfile,info);
  if(!err)
  {
   proxypictsize=proxycurrsize=0;

   p=info;
   while(*p)
   {
    if(*p==PT_LENGTH)
    {
     proxypictsize=p[2];
     break;
    }
    p=(int*)(((char*)p)+p[1]);
   }
                                                                                   if(cpicture)
   {
    picturep=(picturestr*)fob_find(cpicture,cfile);
    proxycurrsize=picturep->proxylen;
    proxytag=(pxproxytagstr*)pxfindtag(picturep,PXPROXYTAG);
    if(proxytag) cproxy=proxytag->proxy;
    else         cproxy=pxdefproxy;

    if(cproxy.bpp==2) cproxy.bpp=4;

    err=dodboxspparent(&proxybox,1,&proxybox,&dbviewstack,cview->handle);
   }
  }
 }

 zreport(err);

 USE(fp);
}


/*****************************************************************************/


extern dboxstr   piximportbox;
static char      refpath[FILENAMELEN];
static posnstr   refposn;
static int       refftype;
static pxreffn   reffn;
static pxrefstr  cref;



static os_error * impokfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 if(reffn)
 {
  err=reffn(refpath,refftype,&refposn,&cref);
  dbclose(&piximportbox,DBOK);
  reffn=NULL;
 }

 return(err);

 USE(handle);
 USE(userhandle);
 USE(m);
}




static os_error * piximportclose(int code)
{
 os_error * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {

 }

 return(err);
}




static os_error * piximportfn(pxproxystr * proxy)
{

 cref.proxy=*proxy;

 cref.makeproxy=1;

 dbchangevalue(&cref.makeproxy,&piximportbox);
 dbchangevalue(&cref.proxy.scale,&piximportbox);

 return(NULL);
}


static os_error * piximporticon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 if(m->i==5) err=openproxychoice(&cref.proxy,piximportfn,
                                 &piximportbox,&dbviewstack);

 return(err);

 USE(handle);
 USE(userhandle);
}




static os_error * wrproxy(int value,char * string)
{
 return(wrproxyinfo(&cref.proxy,string));
 USE(value);
}



static os_error * wrname(int value,char * string)
{
 strcpy(string,refpath);
 return(NULL);
 USE(value);
}


/*
static os_error * rdname(int * value,char * string)
{

 strcpy(refpath,string);
 return(NULL);
 USE(value);
}
*/



static dbiconstr piximporticondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

    7, NULL,         DBTEXT,   0,   0,      0,  0,  0,  0,     NULL,wrname,

    4,&cref.proxy.scale,DBTEXT,0,   0,      0,  0,  0,  0,     NULL,wrproxy,

    3,&cref.makeproxy,DBTOGGLE, 0,   0,      1,  F1, 0,  0,     NULL, NULL,
    0,&cref.reference,DBTOGGLE, 0,   0,      1,  F2, 0,  0,     NULL, NULL,

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

   1,  NULL,         DBACTION, 0,   0,      0,RETURN,0,0, (dbreadfn)impokfn,0,
   2,  NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,


   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0

};



static dboxstr piximportbox=
{
 0,
 TPIXIMPORT,
 DBFIX,
 DBGRAB,
 piximportclose, /* close */
 piximporticon, /* icon  */
 NULL,
 NULL,
 piximporticondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};




os_error * openpiximportbox(char * name,int ftype,posnstr * posn,pxreffn xreffn)
{
 os_error * err;

 cview=posn->view;
 cfile=posn->file;

 strcpy(refpath,name);
 refftype=ftype;
 refposn=*posn;
 reffn=xreffn;

 cref.proxy=pxdefproxy;

 err=dodboxspparent(&piximportbox,1,&piximportbox,&dbviewstack,cview->handle);

 return(err);
}



/**************************************************************************/


extern dboxstr pixrefbox;


static int refloadicon;

static os_error * refloadtype(char * name,int type,mousestr * m,int userhandle,
                                                      int * method)
{

 refloadicon=m->icon;
 if(!(*method)) 
 {
  *method=1;
 }

 return(NULL);
 USE(type);
 USE(m);
 USE(userhandle);
 USE(name);
}




static os_error * refload(char * name,int type,int userhandle,int xvolatile)
{
 if(!xvolatile)
 {
  if(refloadicon==3 || refloadicon==9) writeicon(pixrefbox.handle,refloadicon,name);
 }

 return(NULL);
 USE(userhandle);
 USE(type);
}






static os_error * refclose(int code)
{
 os_error           * err;
 picturestr         * picturep;
 pxpreftagstr       * tag;
 char                 name[FILENAMELEN];


 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  readicon(pixrefbox.handle,3,name,sizeof(name));

  picturep=(picturestr*)fob_find(cpicture,cfile);

  tag=(pxpreftagstr*)pxfindtag(picturep,PXPREF1TAG);
  if(tag)
  {
   if(cstrcmp(tag->name,name))
   {
    err=pxreferencechanged(cpictbox,cpicture,name,cfile);
   }
  }
 }


 if(!err && (code==DBOK || code==DBCANCEL))
 {
  remdataload(pixrefbox.handle,0,refload);
  remdataloadtype(pixrefbox.handle,0,refloadtype);
 }


 return(err);
}




static os_error * savepath(char * name,int type,int userhandle,int xvolatile)
{
 os_error * err;

 err=writeicon(pixrefbox.handle,3,name); 
 
 return(err);

 USE(type);
 USE(userhandle);
 USE(xvolatile);
}





// click on path arrow

static os_error * refpathfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 loadoptstr opts;
 int        xtype=-1;
 int        copt;
 char       name[FILENAMELEN];
 char       newpath[FILENAMELEN];

 opts.description="All files (*.*)";
 opts.ntypes=1;
 opts.types=&xtype;

 readicon(pixrefbox.handle,3,name,sizeof(name)); 

 pxexpandpath(newpath,NITEM(newpath),name,cview->file);

 err=openloadparent(newpath,&copt,&opts,1,savepath,0,cview->handle);

 return(err);

 USE(handle);
 USE(m);
 USE(userhandle);
}


// update picture reference

static os_error * refupdatefn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error           * err;
 pictboxstr         * pictp;
 picturestr         * picturep;
 pxpreftagstr       * tag;
 char                 name[FILENAMELEN];

 err=NULL;

 readicon(pixrefbox.handle,3,name,sizeof(name));

 picturep=(picturestr*)fob_find(cpicture,cfile);

 tag=(pxpreftagstr*)pxfindtag(picturep,PXPREF1TAG);
 if(tag)
 {
  if(cstrcmp(tag->name,name))
  {
   err=pxreferencechanged(cpictbox,cpicture,name,cfile);
  }
 }
	else
	{
		err=pxnewreference(cpictbox,cpicture,name,cview,cfile);
	}

 if(!err)
 {
  pictp=(pictboxstr*)fob_find(cpictbox,cfile);
  cpicture=pictp->picture;
 }

 return(err);

 USE(handle);
 USE(m);
 USE(userhandle);
}






#define MAXDIR 60


static char * expdir;
static char * expdirend;
static char * namdir;
static char * namdirend;
static int    cdirn;    /* entries in current dir */




static os_error * csetnextdir(void)
{
 os_error * err;
 fxstat     fx;
 int        n;
 int        eof;


 err=fs_cdir(expdir);

 if(!err)
 {
  fs_startscan();

  n=0;
  while(1)
  {
   err=fs_nextitem(expdir,&fx,"*.*",&eof);
   if(err || eof) break;
   n++;
  }

  cdirn=n;
 }


 return(err);
}



static os_error * cgetnextdir(void)
{
 os_error * err;

 err=NULL;

 cdirn++;

 while(cdirn>MAXDIR)
 {
  fs_strcat(expdir,FILENAMELEN,"More");
  fs_strcat(namdir,FILENAMELEN,"More");
  err=csetnextdir();
  if(err) break;
 }

 return(err);
}




static int subpath(char * path,char * pathend,char * filepath)
{
 int    c1=0;
 int    c2=0;

 while(1)
 {
  c2=toupper(*path++);
  if(!c2) 
  {
   return(0);
  }

  c1=toupper(*filepath++);
  if(c1!=c2) break;
 }

 if(path>pathend) return(0);

 return(c1-c2);
}




#define SMAPCHUNK 0x1000


static char * smap;
static int    smaplen;
static int    srootp;




typedef struct smapstr
{
 int          parent;
 int          sibls[2];
 int          balance;
 int          picture;
 char         name[1];

} smapstr;




static int smcmp1(void * key1,void * key2)
{
 return(cstrcmp((char*)key1,(char*)(((int*)key2)+1)));
}



static int smcmp2(void * key1,void * key2)
{
 return(cstrcmp((char*)(((int*)key1)+1),(char*)(((int*)key2)+1)));
}







static int ssearchmap(char * name)
{
 int offset;

 offset=avlfind(name,srootp,smap,smcmp1);

 if(offset>=0)
 {
 /* dprintf(0,"hit %s %d",name,((smapstr*)(smap+offset))->picture); */

  return(((smapstr*)(smap+offset))->picture);
 }
 else
 {
/* dprintf(0,"mis %s",name); */
  return(0);
 }
}




static os_error * saddtomap(char * name,int picture)
{
 os_error * err;
 int        len;
 smapstr  * s;


/* dprintf(0,"add %s %d",name,picture); */

 len=(strlen(name)+1+3) & (~0x3);
 len+=sizeof(smapstr);

 err=flex_chunk((flex_ptr)&smap,smaplen+len,SMAPCHUNK);
 if(!err)
 {
  s=(smapstr*)(smap+smaplen);
  strcpy(s->name,name);
  s->picture=picture;
  avlsearch(smaplen,&srootp,smap,smcmp2);
  smaplen+=len;
 }

 return(err);
}


static os_error * smapinit(void)
{
 os_error * err;

 err=flex_alloc((flex_ptr)&smap,SMAPCHUNK);
 if(!err)
 {
  smaplen=0;
  srootp=-1;

 }

 return(err);
}



static os_error * smapfinit(void)
{

 return(flex_free((flex_ptr)&smap));
}





static os_error * pxundowritecol(int picture,filestr * file)
{
 os_error           * err;
 pxpreftagstaticstr   reftag;
 int                  len;


 err=pxreadtag((pxtagstr*)&reftag,PXPREF1TAG,picture,file);
 if(reftag.len)
 {
  undowritefn(file,UPXCOL,&picture,sizeof(int));
  len=strlen(reftag.name)+1;
  undowrite(file,&len,sizeof(int));
  undowrite(file,reftag.name,len);
 }

 return(err);
}



os_error * pxundocollect(filestr * file)
{
 os_error           * err;
 char                 name[FILENAMELEN];
 pxpreftagstaticstr   reftag;
 int                  picture;
 int                  len;


 err=undoread(file,&picture,sizeof(int));
 undoread(file,&len,sizeof(int));
 undoread(file,name,len);

 pxundowritecol(picture,file);

 reftag.tag=PXPREF1TAG;
 strcpy(reftag.name,name);
 reftag.len=sizeof(pxtagstr)+((strlen(reftag.name)+1+3)&(~0x3));
 err=pxwritetag((pxtagstr*)&reftag,picture,file);


 reftag.tag=PXPREF2TAG;
 pxexpandpath(reftag.name,NITEM(reftag.name),name,file);
 reftag.len=sizeof(pxtagstr)+((strlen(reftag.name)+1+3)&(~0x3));
 err=pxwritetag((pxtagstr*)&reftag,picture,file);


 return(err);
}










static os_error * cfn(sobjectstr * sob,filestr * file,int * message)
{
 os_error           * err;
 pictboxstr         * pictp;
 picturestr         * picturep;
 int                  pict;
 int                  picture;
 pxpreftagstaticstr   reftag;
 char                 sourcename[FILENAMELEN];
 TCHAR                string[FILENAMELEN];
 int                  page;
 int                  section;
 int                  xpicture;


 err=NULL;

 if(sob->type==OPICTBOX)
 {
  pictp=(pictboxstr*)sob;
  pict=pictp->key;
  picture=pictp->picture;
  if(picture)
  {
   picturep=(picturestr*)fob_find(picture,file);
   if(picturep->imagelen==0)
   {
    pxreadtag((pxtagstr*)&reftag,PXPREF1TAG,picture,file);
    if(reftag.len)
    {
     err=pxexpandpath(sourcename,NITEM(sourcename),reftag.name,file);
     
     if(!err)
     {
      /* find out if we already mapped this name, and if so just copy */
      
      xpicture=ssearchmap(sourcename);
      if(xpicture)
      {


       pxundowritecol(picture,file);

       pxreadtag((pxtagstr*)&reftag,PXPREF1TAG,xpicture,file);
       err=pxwritetag((pxtagstr*)&reftag,picture,file);

       if(picture==cpicture)
       {
        writeicon(pixrefbox.handle,3,reftag.name);        
       }
       
       pxreadtag((pxtagstr*)&reftag,PXPREF2TAG,xpicture,file);
       err=pxwritetag((pxtagstr*)&reftag,picture,file);
      }
      else 
      if(subpath(expdir,expdirend,sourcename))
      {
       /* ignore files already in the destination path */
       /* get the next directory name ... */



       err=cgetnextdir();
       if(!err)
       {
        pictp=(pictboxstr*)fob_find(pict,file);
        pagesectionof((chainobject*)pictp,file,&page,&section);

        err=modfile(file,section);

        if(!err)
        {
         if(!rmchange) err=undostart(file);
         if(!err) rmchange=1;
        }

        if(!err) err=makefilename(fs_leaf(sourcename),reftag.name,expdir,0);


        if(!err)
        {
// sprintf(string,"copy %s %s a~cf~l~n~q r~s~T~v",sourcename,reftag.name);
//         err=os_cli(string);
         err=fs_copyobject(sourcename,reftag.name,0,NULL,NULL);
         
         if(!err)
         {
          pxundowritecol(picture,file);

          reftag.tag=PXPREF2TAG;
          reftag.len=sizeof(pxtagstr)+((strlen(reftag.name)+1+3)&(~0x3));
          err=pxwritetag((pxtagstr*)&reftag,picture,file);

          xzstrncpyu(string,reftag.name,NITEM(string));

//          sprintf(reftag.name,"%s\\%s",namdir,fs_leaf(string));
          fs_join(reftag.name,NITEM(reftag.name),namdir,fs_leaf(string));

          reftag.tag=PXPREF1TAG;
          reftag.len=sizeof(pxtagstr)+((strlen(reftag.name)+1+3)&(~0x3));
          err=pxwritetag((pxtagstr*)&reftag,picture,file);

          if(picture==cpicture)
          {
           writeicon(pixrefbox.handle,3,reftag.name);
          }

          err=saddtomap(sourcename,picture);
         }
        }
       }
      }
     }
    }
   }
  }
 }

 return(err);
 USE(message);
}








static os_error * savecollection(char * name,int type)
{
 os_error * err;
 char       expandedpath[FILENAMELEN];
 int        message;

 err=NULL;

 if(strlen(name))
 {
  err=pxexpandpath(expandedpath,NITEM(expandedpath),name,cfile);

  if(!err)
  {
   err=fs_cdir(expandedpath);
   if(!err)
   {
    expdir=expandedpath;
    expdirend=expdir+strlen(expdir);
    namdir=name;
    namdirend=namdir+strlen(namdir);

    err=csetnextdir();
    if(!err) err=smapinit();
    if(!err)
    {
     rmchange=0;
     message=OM_FUNCTION2;
     err=broadcastmessage(cfile,&message,(void*)cfn);
     
     if(rmchange) undoend(cfile);
     smapfinit();
    }
   }
  }
 }

 return(err);

 USE(type);
}






static os_error * collectpathfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 char       name[FILENAMELEN];
 char       expanded[FILENAMELEN];

 readicon(handle,9,name,sizeof(name));

 err=pxexpandpath(expanded,NITEM(expanded),name,cfile);
 if(!err)
 {
  strcpy(name,expanded);

  err=osshellbrowseforfolder(expanded,"",handle,0);
  if(!err)
  {
   if(cstrcmp(name,expanded))
   {
    writeicon(handle,9,expanded);
   }
  }
 }

 return(err);

 USE(handle);
 USE(userhandle);
 USE(m);
}




static os_error * collectfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 char       name[FILENAMELEN];

          err=readicon(handle,9,name,sizeof(name));
 if(!err) err=savecollection(name,0);

 return(err);

 USE(handle);
 USE(userhandle);
 USE(m);
}




/*****************************************************************************/



static os_error * pxundowriteembed(int picture,filestr * file)
{
 os_error           * err;
 pxpreftagstaticstr   reftag;
 int                  ftype;
 int                  len;
 picturestr         * picturep;


 err=pxreadtag((pxtagstr*)&reftag,PXPREF1TAG,picture,file);
 if(reftag.len)
 {
  picturep=(picturestr*)fob_find(picture,file);
  ftype=picturep->ftype;

  undowritefn(file,UPXRELOAD,&picture,sizeof(int));
  undowrite(file,&ftype,sizeof(int));
  len=strlen(reftag.name)+1;
  undowrite(file,&len,sizeof(int));
  undowrite(file,reftag.name,len);
 }

 return(err);
}




os_error * pxundoembed(filestr * file)
{
 os_error   * err;
 picturestr * picturep;
 int          picture;

          err=undoread(file,&picture,sizeof(int));
 if(!err) err=pxundowriteembed(picture,file);
 if(!err)
 {
  picturep=(picturestr*)fob_find(picture,file);
  err=importembed(picturep->ftype,picture,file);
 }

 return(err);
}




os_error * pxundoreload(filestr * file)
{
 os_error * err;
 char       expname[FILENAMELEN];
 char       name[FILENAMELEN];
 int        picture;
 int        ftype;
 int        len;

 err=undoread(file,&picture,sizeof(int));
 undoread(file,&ftype,sizeof(int));
 undoread(file,&len,sizeof(int));
 undoread(file,name,len);

 undowritefn(file,UPXEMBED,&picture,sizeof(int));

 pxexpandpath(expname,NITEM(expname),name,file);

 err=importreferencereload(name,expname,ftype,picture,file);

 return(err);
}



/* possibly this should check the current refpath before embedding */


static os_error * embedfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error   * err;
 picturestr * picturep;
 pictboxstr * pictp;
 int          page;
 int          section;

 err=NULL;

 picturep=(picturestr*)fob_find(cpicture,cfile);

 cprintf("imagelen %d",picturep->imagelen);

 if(picturep->imagelen==0)
 {
  pictp=(pictboxstr*)fob_find(cpictbox,cfile);
  pagesectionof((chainobject*)pictp,cfile,&page,&section);

  err=modfile(cfile,section);
  if(!err)
  {
   err=undostart(cfile);
   if(!err)
   {
    err=pxundowriteembed(cpicture,cfile);
    if(!err)
    {
					picturep=(picturestr*)fob_find(cpicture,cfile);
     err=importembed(picturep->ftype,cpicture,cfile);
     if(!err)
     {
      writeicon(pixrefbox.handle,3,"");
     }
				}
    undoend(cfile);
   }
  }
 }

 return(err);

 USE(handle);
 USE(userhandle);
 USE(m);
}





static os_error * emfn(sobjectstr * sob,filestr * file,int * message)
{
 os_error   * err;
 pictboxstr * pictp;
 picturestr * picturep;
 int          pict;
 int          picture;
 int          page;
 int          section;
 int          ftype;


 err=NULL;

 if(sob->type==OPICTBOX)
 {
  pictp=(pictboxstr*)sob;
  pict=pictp->key;
  picture=pictp->picture;
  if(picture)
  {
   picturep=(picturestr*)fob_find(picture,file);
   if(picturep->imagelen==0)
   {
    ftype=picturep->ftype;

    pagesectionof((chainobject*)pictp,file,&page,&section);

    err=modfile(file,section);
    if(!err)
    {
     if(rmchange==0) err=undostart(file);
     if(!err) rmchange=1;
    }

    if(!err) err=pxundowriteembed(picture,file);
    if(!err) err=importembed(ftype,picture,file);

    if(!err)
    {
     if(picture==cpicture)
     {
      writeicon(pixrefbox.handle,3,"");
     }
    }
   }
  }
 }

 return(err);
 USE(message);
}





static os_error * embedallfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        message;

 rmchange=0;
 message=OM_FUNCTION2;
 err=broadcastmessage(cfile,&message,(void*)emfn);
 if(rmchange) undoend(cfile);

 return(err);

 USE(handle);
 USE(userhandle);
 USE(m);
}











static dbiconstr pixreficondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,

    8, NULL,         DBACTION, 0,   0,      0,0, 1,0, (dbreadfn)refpathfn,0,
    5, NULL,         DBACTION, 0,   0,      0,0, 1,0, (dbreadfn)collectpathfn,0,
   11, NULL,         DBACTION, 0,   0,      0,0, 1,0, (dbreadfn)collectfn,0,
   10, NULL,         DBACTION, 0,   0,      0,0, 1,0, (dbreadfn)refupdatefn,0,
   
    0, NULL,         DBACTION, 0,   0,      0,0, 1,0, (dbreadfn)embedfn,0,
    6, NULL,         DBACTION, 0,   0,      0,0, 1,0, (dbreadfn)embedallfn,0,


   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0

};



static dboxstr pixrefbox=
{
 0,
 TPIXREF,
 DBFIX,
 DBGRAB,
 refclose, /* close */
 NULL, /* icon  */
 NULL,
 NULL,
 pixreficondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};






void openpicturereferencebox(int fp)
{
 os_error      * err;
 pictboxstr    * pictp;
 picturestr    * picturep;
 pxpreftagstr  * tag;


 dbclear(&pixrefbox);


 err=pixselected(&cpictbox,menufile);
 if(cpictbox)
 {
  cview=menuview;
  cfile=menufile;

  err=dodboxspparent(&pixrefbox,1,&pixrefbox,&dbviewstack,cview->handle);

  if(!err)
  {
   adddataload(pixrefbox.handle,0,refload);
   adddataloadtype(pixrefbox.handle,0,refloadtype);
   writeicon(pixrefbox.handle,9,"{filedir}\\Pictures");

   pictp=(pictboxstr*)fob_find(cpictbox,cfile);
   cpicture=pictp->picture;
   picturep=(picturestr*)fob_find(cpicture,cfile);

   tag=(pxpreftagstr*)pxfindtag(picturep,PXPREF1TAG);

//   if(tag) cprintf("ref name %s",tag->name);

   if(tag) writeicon(pixrefbox.handle,3,tag->name);
   else    writeicon(pixrefbox.handle,3,"");
  }
 }

 zreport(err);

 USE(fp);
}


