/*->c.fit */



#include "stdafx.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


#include "os.h"
#include "wimp.h"
#include "sprite.h"
#include "wimpt.h"
#include "bbc.h"
#include "akbd.h"
#include "werr.h"
#include "flex.h"


#include "wos.h"
#include "xmath.h"
#include "transform.h"
#include "deb.h"


#include "constants.h"
#include "str.h"
#include "etc.h"


#include "geometry.h"
#include "curvelo.h"

#include "pxchoices.h"

#include "simplex.h"
#include "fit.h"


#define STACKSIZE 0x4000



extern coordstr * xgencurv(bezier * p,coordstr * vector,
                                          coordstr * veclim,int * stack);

extern int xresid(int point,int npoint,coordstr * vec,coordstr * vector);
extern int xsetscale(int x,int y);


static coordstr * vector;
static int       point;
static int       maxvpoint;

#define   VPSIZE 8192 


/* static double    pixerror=0.8; acceptable error in fraction of pixel */
static int          pixlimit;



/* given initial bezier curve, and somewhere to put the points */


#ifdef NEVER

static os_error * gencurv(bezier * p)
{
 bezier   stack[100];
 bezier   a;
 register int    temp;
 int      sp;
 os_error * err;

 sp=1;
 a=*p;
 err=NULL;

 while(sp)
 {

  if(
(abs(a.left.x-a.right.x)<(spddx)) && (abs(a.left.y-a.right.y)<(spddy)) &&
(abs(a.leftc.x-a.rightc.x)<(spddx)) && (abs(a.leftc.y-a.rightc.y)<(spddy))
   )
 {
  /* points close enough */
  /* output points       */

  if(point<maxvpoint)
  {
   vector[point++]=a.left;
   vector[point++]=a.right;
  }
  else
  {
   err=flex_extend((flex_ptr)&vector,maxvpoint*sizeof(coordstr)+VPSIZE);
   if(err) break;
   maxvpoint+=VPSIZE/sizeof(coordstr);
   if(point<maxvpoint)
   {
    vector[point++]=a.left;
    vector[point++]=a.right;
   }
  }
  a=stack[sp-1];
  sp--;
 }
 else
 {
  /* both */

  p=&stack[sp];

  p->right.x=a.right.x;
  p->right.y=a.right.y;

  /* x coords */

  temp=(a.leftc.x+a.rightc.x)>>1;

  p->rightc.x=(a.rightc.x+a.right.x)>>1;
  p->leftc.x =(temp+p->rightc.x)>>1;

  a.leftc.x =(a.left.x+a.leftc.x)>>1;
  a.rightc.x=(temp+a.leftc.x)>>1;

  p->left.x=a.right.x=(a.rightc.x+p->leftc.x)>>1;

  /* y coords */

  temp=(a.leftc.y+a.rightc.y)>>1;

  p->rightc.y=(a.rightc.y+a.right.y)>>1;
  p->leftc.y =(temp+p->rightc.y)>>1;

  a.leftc.y =(a.left.y+a.leftc.y)>>1;
  a.rightc.y=(temp+a.leftc.y)>>1;

  p->left.y=a.right.y=(a.rightc.y+p->leftc.y)>>1;

  sp++;
  }
 }

 return(err);
}

#endif



int xresid(int point,int npoint,coordstr * vec,coordstr * vector)
{
 int i;
 int jbig;
 int sum;
 int dx;
 int dy;


 jbig=0;
 sum=0;

 for(i=0;i<npoint;i++)
 {
  jbig+=point;
  while(jbig>npoint)
  {
   jbig-=npoint;
   vector++;
  }

  dx=(vec->x-vector->x)/64;
  dy=(vec->y-vector->y)/64;

  sum+=dx*dx+dy*dy;

  vec++;
 }

 return(sum);
}


static int spddx;
static int spddy;

int xsetscale(int ddx,int ddy)
{
 spddx=ddx;
 spddy=ddy;
 return(0);
}


static os_error * gencurv(bezier * p)
{
 bezier   stack[200];
 bezier   a;
 register int    temp;
 int      sp;
 os_error * err;

 sp=1;
 a=*p;
 err=NULL;

// cprintf("spddx %d spddy %d",spddx,spddy);
// cprintf("plx %d ply %d prx %d pry %d",p->left.x,p->left.y,p->right.x,p->right.y);

 while(sp)
 {

  if(
(abs(a.left.x-a.right.x)<(spddx)) && (abs(a.left.y-a.right.y)<(spddy)) &&
(abs(a.leftc.x-a.rightc.x)<(spddx)) && (abs(a.leftc.y-a.rightc.y)<(spddy))
   )
 {
  /* points close enough */
  /* output points       */

  if(point<maxvpoint)
  {
   vector[point++]=a.left;
   vector[point++]=a.right;
  }
  else
  {
   err=flex_extend((flex_ptr)&vector,maxvpoint*sizeof(coordstr)+VPSIZE);
   if(err) break;
   maxvpoint+=VPSIZE/sizeof(coordstr);
   if(point<maxvpoint)
   {
    vector[point++]=a.left;
    vector[point++]=a.right;
   }
  }
  a=stack[sp-1];
  sp--;
 }
 else
 {
  /* both */

  p=&stack[sp];

  p->right.x=a.right.x;
  p->right.y=a.right.y;

  /* x coords */

  temp=(a.leftc.x+a.rightc.x)>>1;

  p->rightc.x=(a.rightc.x+a.right.x)>>1;
  p->leftc.x =(temp+p->rightc.x)>>1;

  a.leftc.x =(a.left.x+a.leftc.x)>>1;
  a.rightc.x=(temp+a.leftc.x)>>1;

  p->left.x=a.right.x=(a.rightc.x+p->leftc.x)>>1;

  /* y coords */

  temp=(a.leftc.y+a.rightc.y)>>1;

  p->rightc.y=(a.rightc.y+a.right.y)>>1;
  p->leftc.y =(temp+p->rightc.y)>>1;

  a.leftc.y =(a.left.y+a.leftc.y)>>1;
  a.rightc.y=(temp+a.leftc.y)>>1;

  p->left.y=a.right.y=(a.rightc.y+p->leftc.y)>>1;

  sp++;
  }
 }

 return(err);
}










/*
static int rescount;
static int restime;
*/

/* input is vector of points, bezier curve         */
/* output error measure, plus point with max error */

                                                            
static os_error *residuals(coordstr * vec,int npoints,
                           bezier * b,int * maxr,int * sumr)
{
 os_error   * err;
 int          i;
 int          j;
 int          sum;
 register int temp;
 int          diff1;
 int          maxi;
 int          max;
 int          jbig;
 int        * stack;

 maxi=sum=0;  /* compiler */

/* rescount++; */
 err=flex_alloc((flex_ptr)&stack,STACKSIZE);
 if(!err)
 {
#ifdef NEVER
  while(1)
  {
   point=xgencurv(b,vector,vector+maxvpoint,stack)-vector;
   if(point>=maxvpoint)
   {
    err=flex_extend((flex_ptr)&vector,maxvpoint*sizeof(coordstr)+VPSIZE);
    if(err) break;
    maxvpoint+=VPSIZE/sizeof(coordstr);
   }
   else break;
  }
#else
 point=0;
 gencurv(b);
#endif
  flex_free((flex_ptr)&stack);
 }

 if(!err)
 {
  sum=0;
  max=0;
  j=jbig=0;


  for(i=0;i<npoints;i++)
  {
   jbig+=point;
   while(jbig>npoints)
   {
    j++;
    jbig-=npoints;
   }

   temp=(vec[i].x-vector[j].x)/64; 
   diff1=temp*temp;

   temp=(vec[i].y-vector[j].y)/64; 
   diff1+=temp*temp;

   if(diff1>max)
   {
    maxi=i;
    max=diff1;
   }

   sum+=diff1;
   if(sum<0) break;
  }
 }

 *maxr=maxi;
 *sumr=sum;
 return(err);
}



                                                            
static os_error * fastresiduals(coordstr * vec,int npoints,
                                               bezier * b,int * sumr)
{
 int        sum;
 os_error * err;
 int      * stack;

/* rescount++; */

 err=flex_alloc((flex_ptr)&stack,STACKSIZE);
 if(!err)
 {
#ifdef NEVER
  while(1)
  {
   point=xgencurv(b,vector,vector+maxvpoint,stack)-vector;
   if(point>=maxvpoint)
   {
    err=flex_extend((flex_ptr)&vector,maxvpoint*sizeof(coordstr)+VPSIZE);
    if(err) break;
    maxvpoint+=VPSIZE/sizeof(coordstr);
   }
   else break;
  }
#else
 point=0;
 gencurv(b);
#endif

  flex_free((flex_ptr)&stack);
 }


 if(!err)
 {
  sum=xresid(point,npoints,vec,vector);
  *sumr=sum;
 }

 return(err);
}







static coordstr * svector;  /* the data vector        */
static int        spoints;  /* number of points in it */
static bezier     sb;       /* bezier curve           */





os_error * sresiduals(int p1,int p2,int p3,int p4,int * sumr)
{
 bezier     b;
 int        sum;
 os_error * err;

 b=sb;
 b.leftc.x =p1;
 b.leftc.y =p2;
 b.rightc.x=p3;
 b.rightc.y=p4;

 err=fastresiduals(svector,spoints,&b,&sum);
 *sumr=sum;
 return(err);
}




static os_error * mresiduals(int p1,int p2,int p3,int p4,int * max,int * sumr)
{
 bezier     b;
 int        sum;
 os_error * err;

 b=sb;
 b.leftc.x =p1;
 b.leftc.y =p2;
 b.rightc.x=p3;
 b.rightc.y=p4;

 err=residuals(svector,spoints,&b,max,&sum);
 *sumr=sum;
 return(err);
}


/*****************************************************************************/

#define PATHCHUNK 0x200

static os_error * vecextend(int n,fitstr * fit)
{
 os_error * err;

 err=NULL;

 if((fit->pathsize+n)>=fit->maxpathsize)
 {
  if(fit->path) 
  {
   err=flex_extend((flex_ptr)&fit->path,fit->maxpathsize+PATHCHUNK);
  }
  else
  {
   err=flex_alloc((flex_ptr)&fit->path,PATHCHUNK);
  }

  if(!err) fit->maxpathsize+=PATHCHUNK;
 }

 return(err);
}



static os_error * veccurve(int x1,int y1,int x2,int y2,
                                         int x3,int y3,fitstr * fit)
{
 os_error * err;
 int      * p;

 err=vecextend(7*sizeof(int),fit);
 if(!err)
 {
  p=fit->path+fit->pathsize/sizeof(int);

  *p++=DRAWCURVE;
  *p++=x1;
  *p++=y1;
  *p++=x2;
  *p++=y2;
  *p++=x3;
  *p++=y3;

  fit->pathsize+=7*sizeof(int);
 }

 return(err);
}



static os_error * vecmove(int x,int y,fitstr * fit)
{
 os_error * err;
 int      * p;

 err=vecextend(3*sizeof(int),fit);
 if(!err)
 {
  p=fit->path+fit->pathsize/sizeof(int);

  *p++=DRAWMOVE;
  *p++=x;
  *p++=y;

  fit->pathsize+=3*sizeof(int);
 }

 return(err);
}



static os_error * vecdraw(int x,int y,fitstr * fit)
{
 os_error * err;
 int      * p;

 err=vecextend(3*sizeof(int),fit);
 if(!err)
 {
  p=fit->path+fit->pathsize/sizeof(int);

  *p++=DRAWDRAW;
  *p++=x;
  *p++=y;

  fit->pathsize+=3*sizeof(int);
 }

 return(err);
}

os_error * vecclose(fitstr * fit)
{
 os_error * err;
 int      * p;

 err=vecextend(sizeof(int),fit);
 if(!err)
 {
  p=fit->path+fit->pathsize/sizeof(int);

  *p++=DRAWCLOSE;

  fit->pathsize+=sizeof(int);
 }

 return(err);
}


os_error * vecend(fitstr * fit)
{
 os_error * err;
 int      * p;

 err=vecextend(sizeof(int),fit);
 if(!err)
 {
  p=fit->path+fit->pathsize/sizeof(int);

  *p++=DRAWEND;

  fit->pathsize+=sizeof(int);
 }

 return(err);
}




os_error * vecopen(fitstr * fit)
{
 fit->path=NULL;
 fit->pathsize=0;
 fit->maxpathsize=0;
 return(NULL);
}



os_error * vecclear(fitstr * fit)
{
 flex_free((flex_ptr)&fit->path);
 return(NULL);
}



/* the entry point, passed a vector of npoints 2D points */
/* output a series of Beziers                            */


/* we call simplex                                                           */
/* we pass the values of the two variables                                   */
/* we set up global structures that residuals will use when simplex calls it */



#define MINAREASIZE ((30000*16)/25)



static os_error * fitcurvesub2(fitstr * fit,int vec,int npoints)
{
 os_error * err;
 int        sum;
 int        max;
 int        code1;
 simplxstr  sim;
 int        i;
 int        xlo;
 int        xhi;
 int        ylo;
 int        yhi;

 err=NULL;

 svector=fit->pointstore+vec;
 spoints=npoints;

 xlo=xhi=svector[0].x;
 ylo=yhi=svector[0].y;

 for(i=1;i<spoints;i++)
 {
  if(svector[i].x<xlo) xlo=svector[i].x;
  else
  if(svector[i].x>xhi) xhi=svector[i].x;

  if(svector[i].y<ylo) ylo=svector[i].y;
  else
  if(svector[i].y>ylo) yhi=svector[i].y;
 }

 xhi=ABS(xhi-xlo);
 yhi=ABS(yhi-ylo);

 max=MAX(xhi,yhi);

 if(max<MINAREASIZE)
 {
  err=vecdraw(svector[spoints-1].x,svector[spoints-1].y,fit);
 }
 else
 {
  sb.left =svector[0];
  sb.right=svector[npoints-1];

  sim.p1=svector[npoints/3].x;
  sim.p2=svector[npoints/3].y;
  sim.p3=svector[(2*npoints)/3].x;
  sim.p4=svector[(2*npoints)/3].y;
 
  err=simplex(&sim,fit->spddx,fit->spddy,&code1); 
  /* if(code1) */ if(!err) err=simplex(&sim,fit->spddx,fit->spddy,&sum);

  if(!err) err=mresiduals(sim.p1,sim.p2,sim.p3,sim.p4,&max,&sum);

  /* assume mresiduals called first        */
  /* sets up max and min x and y for curve */
  if(!err)
  {
   if((sum>=0 && sum<(npoints*pixlimit)) || npoints<=4) 
   {
    err=veccurve(sim.p1,sim.p2,sim.p3,sim.p4,sb.right.x,sb.right.y,fit);
   }
   else
   {
    if(max<4 || ((npoints-max)<4) || sum<0) max=npoints/2;

             err=fitcurvesub2(fit,vec,max);
    if(!err) err=fitcurvesub2(fit,vec+max,npoints-max);
   }
  }
 }

 return(err);
}



#define ATDIM 9


static int atab[ATDIM][ATDIM];

static void initatab(void)
{
 int x;
 int y;

 for(x=0;x<ATDIM;x++)
 {
  for(y=0;y<ATDIM;y++) 
  {
   if(x==y) atab[x][y]=45;
   else
   if(x==0) atab[x][y]=90;
   else     atab[x][y]=(int)((atan(((double)y)/((double)x))*45)/atan((double)1));
  }
 }
}





static int arctan(int dx,int dy)
{
 int a;

 a=atab[abs(dx)/256][abs(dy)/256];

 if(dx<0)
 {
  if(dy>0) a=180-a;
  else     a=180+a;
 }
 else
 {
  if(dy<0) a=360-a;
 }

 return(a);
}




static os_error * fitcurvesub(fitstr * fit,int vec,int npoints,int * angle)
{
 os_error * err;
 int        i;

 err=NULL;

 for(i=1;i<(npoints-1);i++) if(angle[i]) break;

 if(i>=(npoints-1))
 {
  err=vecdraw(fit->pointstore[vec+npoints-1].x,
              fit->pointstore[vec+npoints-1].y,fit);
 }
 else
 {
  err=fitcurvesub2(fit,vec,npoints);
 }

 return(err);
}




os_error * fitcurve(fitstr * fit,int vec,int npoints)
{
 os_error * err;
 int      * angle1;
 int      * angle2;
 int        i;
 int        j;
 int        next;
 int        prev;
 int        dx;
 int        dy;
 int        a;
 int        start;
 int        temp;


/* rescount=0;
 restime=clock(); */

// xsetscale(fit->spddx/256,fit->spddy/256); 

 xsetscale(fit->spddx,fit->spddy);

 pixlimit=ttmul(defpixerror,defpixerror);
 temp=(fit->spddx*fit->spddx+fit->spddy*fit->spddy)/(64*64);
 pixlimit=scale(temp,pixlimit,0x10000);

 err=flex_alloc((flex_ptr)&vector,VPSIZE);
 if(!err)
 {
  maxvpoint=VPSIZE/sizeof(coordstr)-2;

  err=flex_alloc((flex_ptr)&angle1,npoints*sizeof(int));
  if(!err)
  {
   err=flex_alloc((flex_ptr)&angle2,npoints*sizeof(int));
   if(!err)
   {
    err=vecmove(fit->pointstore[0].x,fit->pointstore[0].y,fit);
    if(!err)
    {
     /* calculate angle turned at each point */
 
     for(i=0,next=1,prev=npoints-2;i<(npoints-1);i++)
     {
      dx=fit->pointstore[prev].x-fit->pointstore[i].x;
      dy=fit->pointstore[prev].y-fit->pointstore[i].y;
  
      angle1[i]=arctan(dx,dy);

      dx=fit->pointstore[next].x-fit->pointstore[i].x;
      dy=fit->pointstore[next].y-fit->pointstore[i].y;
  
      a=arctan(dx,dy);

      a=angle1[i]-a-180;
      if(a>180)  a=360-a;
      if(a<-180) a=a+360;
      angle1[i]=a;

      next++;
      if(next>=(npoints-1)) next=0;
      prev++;
      if(prev>=(npoints-1)) prev=0;
     }


 
     for(i=0,next=2,prev=npoints-3;i<(npoints-1);i++)
     {
      dx=fit->pointstore[prev].x-fit->pointstore[i].x;
      dy=fit->pointstore[prev].y-fit->pointstore[i].y;
  
      angle2[i]=arctan(dx,dy);
    
      dx=fit->pointstore[next].x-fit->pointstore[i].x;
      dy=fit->pointstore[next].y-fit->pointstore[i].y;
  
      a=arctan(dx,dy);

      a=angle2[i]-a-180;
      if(a>180)  a=360-a;
      if(a<-180) a=a+360;
      angle2[i]=a;

      next++;
      if(next>=(npoints-1)) next=0;
      prev++;
      if(prev>=(npoints-1)) prev=0;
     }



     for(i=0,start=0;i<npoints;i++)
     {
      if(angle2[i]>=90 || angle2[i]<=-90)
      {
       if((npoints-i)<4) i=npoints-1;
       if((i-start)>=4)
       {
        err=fitcurvesub(fit,vec+start,i-start+1,angle1+start);
        if(err) break;
        start=i;
       }
      } 
     } 

     if(!err)
     {
      if((i-start)>=4) err=fitcurvesub(fit,vec+start,i-start,angle1+start);
      else             
      {
       for(j=1;j<(i-start);j++)
       {
        err=vecdraw(fit->pointstore[start+j].x,
                                fit->pointstore[start+j].y,fit);
        if(err) break;
       }
      }
     }
    }
    flex_free((flex_ptr)&angle2);
   }
   flex_free((flex_ptr)&angle1);
  }
  flex_free((flex_ptr)&vector);
 }

 return(err);
}




os_error * fitinit(void)
{
 initatab();

 return(NULL);
}



