/*->c.psfont */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "bbc.h"
#include "font.h"
#include "flex.h"
#include "transform.h"
#include "xprocess.h"


#include "osgraphics.h"


#include "xext.h"
#include "wos.h"
#include "err.h"
#include "poll.h"
#include "colour.h"
#include "xmath.h"
#include "etc.h"
#include "bits.h"
#include "dbhi.h"
#include "fsx.h"
#include "bf.h"
#include "osprint.h"
#include "drawmod.h"
#include "deb.h"
#include "imlib.h"
#include "timex.h"
#include "truetype.h"


#include "str.h"
#include "constants.h"
#include "object.h"
#include "reslink.h"

#include "geometry.h"
#include "xredraw.h"

#include "view.h"
#include "viewr.h"
#include "file.h"
#include "page.h"
#include "main.h"
#include "macros.h"


#include "xxcolour.h"
#include "xcolour.h"
#include "cconv.h"
#include "colsep.h"
#include "splink.h"

#include "curve.h"


#include "prstr.h"
#include "xprint.h"
#include "prstat.h"
#include "pract.h"
#include "preg.h"

#include "txstr.h"
#include "codes.h"
#include "fx.h"
#include "fox.h"
#include "fcache.h"
#include "txchoices.h"

#include "psinternal.h"

#include "postscript.h"


#define FIXFLOAT1K(fix)	((int)((1000*fix.value)/designsize))

#define FIXFLOAT(fix)	((int)((fix.value)))




#define PS_ENCSYMBOLCOUNT	(224+1)
#define PS_ENCLATIN1COUNT	(224+1-1-1-1)

// take off one for space, hyphen, delete


static char * psencoding[]=
{
	NULL, //"g0",
	NULL, //	"g1",
	NULL, //	"g2",
	NULL, //	"g3",
	NULL, //	"g4",
	NULL, //	"g5",
	NULL, //	"g6",
	NULL, //	"g7",
	NULL, //	"g8",
	NULL, //	"g9",
	NULL, //	"g10",
	NULL, //	"g11",
	NULL, //	"g12",
	NULL, //	"g13",
	NULL, //	"g14",
	NULL, //	"g15",
	NULL, //	"g16",
	NULL, //	"g17",
	NULL, //	"g18",
	NULL, //	"g19",
	NULL, //	"g20",
	NULL, //	"g21",
	NULL, //	"g22",
	NULL, //	"g23",
	NULL, //	"g24",
	NULL, //	"g25",
	NULL, //	"g26",
	NULL, //	"g27",
	NULL, //	"g28",
	NULL, //	"g29",
	NULL, //	"g30",
	NULL, //	"g31",

 "space",																						// 32
 "exclam",
 "quotedbl",
 "numbersign",
 "dollar",
 "percent",
 "ampersand",
 "quotesingle",
 "parenleft",
 "parenright",
 "asterisk",
 "plus",
 "comma",
 "hyphen",
 "period",
 "slash",
 "zero",
 "one",
 "two",
 "three",
 "four",
 "five",
 "six",
 "seven",
 "eight",
 "nine",
 "colon",
 "semicolon",
 "less",
 "equal",
 "greater",
 "question",

 "at",																					// 64
 "A",
 "B",
 "C",
 "D",
 "E",
 "F",
 "G",
 "H",
 "I",
 "J",
 "K",
 "L",
 "M",
 "N",
 "O",
 "P",
 "Q",
 "R",
 "S",
 "T",
 "U",
 "V",
 "W",
 "X",
 "Y",
 "Z",
 "bracketleft",
 "backslash",
 "bracketright",
 "asciicircum",
 "underscore",

 "grave",
 "a",
 "b",
 "c",
 "d",
 "e",
 "f",
 "g",
 "h",
 "i",
 "j",
 "k",
 "l",
 "m",
 "n",
 "o",
 "p",
 "q",
 "r",
 "s",
 "t",
 "u",
 "v",
 "w",
 "x",
 "y",
 "z",
 "braceleft",
 "bar",
 "braceright",
 "asciitilde",
	NULL, // "g127",																	// 127

 "Euro",																	// 128
 "Wcircumflex",										// 129
 "wcircumflex",										// 130
 "g131",
 "g132",
 "Ycircumflex",
 "ycircumflex",
 "orn.001",
 "orn.002",
 "orn.003",
 "orn.004",
 "orn.005",
 "ellipsis",
 "trademark",
 "perthousand",
 "bullet",
 "quoteleft",
 "quoteright",
 "guilsinglleft",
 "guilsinglright",
 "quotedblleft",
 "quotedblright",
 "quotedblbase",
 "endash",
 "emdash",
 "minus",
 "OE",
 "oe",
 "dagger",
 "daggerdbl",
 "fi",
 "fl",

 NULL, //"space",																			// 160
 "exclamdown",																								// 161
 "cent",																														// 162
 "sterling",																										// 163
 "currency",																										// 164
 "yen",																															// 165
 "brokenbar",																									// 166
 "section",																											// 167
 "dieresis",																										// 168
 "copyright",																									// 169
 "ordfeminine",																							// 170
 "guillemotleft",																					// 170
 "logicalnot",																								// 171
 NULL, // "hyphen",																				172
 "registered",
 "macron",
 "degree",
 "plusminus",
 "twosuperior",
 "threesuperior",
 "acute",
 "mu",
 "paragraph",
 "periodcentered",
 "cedilla",
 "onesuperior",
 "ordmasculine",
 "guillemotright",
 "onequarter",
 "onehalf",
 "threequarters",
 "questiondown",

 "Agrave",
 "Aacute",
 "Acircumflex",
 "Atilde",
 "Adieresis",
 "Aring",
 "AE",
 "Ccedilla",
 "Egrave",
 "Eacute",
 "Ecircumflex",
 "Edieresis",
 "Igrave",
 "Iacute",
 "Icircumflex",
 "Idieresis",
 "Eth",
 "Ntilde",
 "Ograve",
 "Oacute",
 "Ocircumflex",
 "Otilde",
 "Odieresis",
 "multiply",
 "Oslash",
 "Ugrave",
 "Uacute",
 "Ucircumflex",
 "Udieresis",
 "Yacute",
 "Thorn",
 "germandbls",

 "agrave",
 "aacute",
 "acircumflex",
 "atilde",
 "adieresis",
 "aring",
 "ae",
 "ccedilla",
 "egrave",
 "eacute",
 "ecircumflex",
 "edieresis",
 "igrave",
 "iacute",
 "icircumflex",
 "idieresis",
 "eth",
 "ntilde",
 "ograve",
 "oacute",
 "ocircumflex",
 "otilde",
 "odieresis",
 "divide",
 "oslash",
 "ugrave",
 "uacute",
 "ucircumflex",
 "udieresis",
 "yacute",
 "thorn",
 "ydieresis"
};




static char *	psencglypname(int unicode)
{
	char      * p;
	static char temp[16];

 p=macrofindglyphname(unicode);
	if(*p==0)
	{
		sprintf(temp,"uni%04X",unicode);
		p=temp;
	}

	return(p);
}






static os_error * getglyphdata(int osfont,int code,char ** gdata,int * gsize)
{
	os_error    * err;
	int           glyph;
 int           size;
	char        * glyphdata;
 GLYPHMETRICS  gm;
	MAT2          mat;

	err=NULL;

	mat.eM11.fract=0;
	mat.eM11.value=1;
	mat.eM22.fract=0;
	mat.eM22.value=1;
	mat.eM12.fract=0;
	mat.eM12.value=0;
	mat.eM21.fract=0;
	mat.eM21.value=0;


	size=0;
	glyphdata=NULL;

	if(txunicode)
	{
 	if(ISW9X)
 	{
/*
   if(fontsos[osfont].charset==SYMBOL_CHARSET)
   {
    code=code16index(code);
   }
*/
   if(code>255)
   {
    glyph=GetTTUnicodeGlyphIndex(((hdcstr*)fonthdcptr)->hdc,(unsigned short)code);
				if(glyph)
				{
     size=GetGlyphOutlineA(((hdcstr*)fonthdcptr)->hdc,glyph,GGO_NATIVE|GGO_GLYPH_INDEX,&gm,0,NULL,&mat);
   	 glyphdata=(char*)malloc(size);
     GetGlyphOutlineA(((hdcstr*)fonthdcptr)->hdc,glyph,GGO_NATIVE|GGO_GLYPH_INDEX,&gm,size,glyphdata,&mat);
				}
 		}
			else
			{
    size=GetGlyphOutlineA(((hdcstr*)fonthdcptr)->hdc,code,GGO_NATIVE,&gm,0,NULL,&mat);
  	 glyphdata=(char*)malloc(size);
    GetGlyphOutlineA(((hdcstr*)fonthdcptr)->hdc,code,GGO_NATIVE,&gm,size,glyphdata,&mat);
			}
 	}
		else
		{
   size=GetGlyphOutlineW(((hdcstr*)fonthdcptr)->hdc,code,GGO_NATIVE,&gm,0,NULL,&mat);
 	 glyphdata=(char*)malloc(size);
   GetGlyphOutlineW(((hdcstr*)fonthdcptr)->hdc,code,GGO_NATIVE,&gm,size,glyphdata,&mat);
		}
	}
	else
	{
  size=GetGlyphOutlineA(((hdcstr*)fonthdcptr)->hdc,code,GGO_NATIVE,&gm,0,NULL,&mat);
	 glyphdata=(char*)malloc(size);
  GetGlyphOutlineA(((hdcstr*)fonthdcptr)->hdc,code,GGO_NATIVE,&gm,size,glyphdata,&mat);
	}

	*gsize=size;
	*gdata=glyphdata;

	return(err);

	USE(osfont);
}








os_error * ps_uploadfont3(char * name,int userfont)
{
	os_error        * err;
	int               osfont;
	MAT2              mat;
	int               c;
	int               fh;
	int               size;
	char            * buffer;
	char            * p;
	char            * lt;
	int               i;
	int               k;
	int															k1;
 TTPOLYGONHEADER	* hdr;
	TTPOLYCURVE     *	crvlt;
	TTPOLYCURVE     *	crv;
	int               lx;
	int               ly;
	int               mx;
	int               my;
	int               designsize;
 font_info         fi1;
 font_info         fi2;
 font_info         fi;
	int               metricw;
	int               metrich;
	int               code;
 char            * encoding;
 char              temp[16];
 char              sa[16];
	int               fontplanes;
	int               fp;
	int               encodingtype;
	int               entries;
	char              fontname[MAXFONTNAMELEN];


	mat.eM11.fract=0;
	mat.eM11.value=1;
	mat.eM22.fract=0;
	mat.eM22.value=1;
	mat.eM12.fract=0;
	mat.eM12.value=0;
	mat.eM21.fract=0;
	mat.eM21.value=0;


	osfont=fontosfromuser(userfont);
	designsize=fontdesignsize(osfont);
	pscharmapinfo(userfont,&fontplanes);


 err=validfont(osfont,0,designsize,0,&fh,NULL);
 if(!err)
 {
  font_setfont2(fh,fonthdcptr);
	
//  fontbbox(osfont,designsize,designsize,&fi1,&fi2);
  fontbbox(osfont,1000,1000,&fi1,&fi2);

		for(fp=0;fp<fontplanes;fp++)
		{
	  pscharmapfontinfo(userfont,fp,&encodingtype);

 		if(encodingtype==PS_ENCSYMBOL)
   {
				entries=PS_ENCSYMBOLCOUNT;
			}
			else
			if(encodingtype==PS_ENCLATIN1)
			{
				entries=PS_ENCLATIN1COUNT;
			}
			else						// custom encoding
			{
				entries=1;		// allow for .notdef

				oswriteprinterf("%%%%BeginResource: procset DPL_Encoding_%x 1.00 0\r\n",encodingtype);
    oswriteprinterf("%%%%Title: OvationPro font encoding\r\n");
    oswriteprinterf("%%%%CreationDate: 22/04/2004\r\n");
    oswriteprinterf("%%%%Copyright: (C) 2004 David Pilling Ltd All Rights Reserved\r\n");

    oswriteprinterf("/DPL_Encoding_%x [\r\n",encodingtype);

 			for(i=0;i<256;i++)
				{
 			 code=pscharmapunicode(userfont,fp,i);
					if(code<0) oswriteprinterf("/.notdef\r\n"); 
					else
     {
      oswriteprinterf("/%s\r\n",psencglypname(code));
						entries++;
					}
				}

			 oswriteprinterf("] def\r\n");
    oswriteprinterf("%%%%EndResource\r\n\r\n");
			}

   pscodefontname(fontname,name,fp,sizeof(fontname));


   oswriteprinterf("%%%%BeginResource: Font %s\r\n",fontname);

   oswriteprinter("12 dict begin\r\n");
   oswriteprinter("/FontType 3 def\r\n");

//  xftoa(1.0/(double)designsize,sa,sizeof(sa),6);

//  oswriteprinterf("/FontMatrix [%s 0 0 %s 0 0] def\r\n",sa,sa);
   oswriteprinterf("/FontMatrix [0.001 0 0 0.001 0 0] def\r\n",sa,sa);
   oswriteprinterf("/FontBBox [%d %d %d %d] def\r\n",fi2.minx,fi2.miny,fi2.maxx,fi2.maxy);

 		if(encodingtype==PS_ENCSYMBOL) oswriteprinterf("/Encoding DPL_SymbolEncoding def\r\n");
 		else
   if(encodingtype==PS_ENCLATIN1) oswriteprinterf("/Encoding DPL_Latin1Encoding def\r\n");
			else																										 oswriteprinterf("/Encoding DPL_Encoding_%x def\r\n",encodingtype);

   ps_kerndata(osfont,userfont,fp);

 	 oswriteprinterf("/CharProcs %d dict def\r\n",entries);
 	 oswriteprinter("CharProcs begin\r\n");
 	 oswriteprinter("/.notdef {} def\r\n");

 		for(c=0;c<256;c++)
 		{
 			code=pscharmapunicode(userfont,fp,c);

 			if(encodingtype==PS_ENCSYMBOL)
 			{
 				sprintf(temp,"g%d",c);
 				encoding=temp;
 			}
 			else
 			if(encodingtype==PS_ENCLATIN1)
  		{
 	 		encoding=psencoding[c];
 		 }
 			else
 			{
 				encoding=psencglypname(code);
 			}


 			if(encoding && code>=0)
 			{
//    fontcharwidth(osfont,designsize,designsize,code,&metricw,&metrich);
//    fontcharbbox(osfont,designsize,designsize,code,&fi);

     fontcharwidth(osfont,1000,1000,code,&metricw,&metrich);
     fontcharbbox(osfont,1000,1000,code,&fi);

  	  oswriteprinterf("/%s\r\n",encoding);
  	  oswriteprinter("{\r\n");

   	 oswriteprinterf("%d %d\r\n",metricw,metrich);				  // width
 	   oswriteprinterf("%d %d %d %d\r\n",fi.minx,fi.miny,fi.maxx,fi.maxy); 	// bounding box
     oswriteprinter("setcachedevice\r\n");


     getglyphdata(osfont,code,&buffer,&size);			// glyphdata may be NULL if size is zero
 

// 			cprintf("c %d size %d",c,size);

  			p=buffer;
  			lt=(buffer+size);
  			while(p<lt)
  			{
  				hdr=(TTPOLYGONHEADER*)p;

 					if(hdr->cb==0)		cprintf("hdr cb %d c %d",hdr->cb,c);

  				crvlt=(TTPOLYCURVE*)(p+hdr->cb);
  				crv=(TTPOLYCURVE*)(p+sizeof(TTPOLYGONHEADER));

  				oswriteprinterf("%d %d moveto\r\n",lx=FIXFLOAT1K(hdr->pfxStart.x),ly=FIXFLOAT1K(hdr->pfxStart.y));

  				while(crv<crvlt)
  				{
 					// cprintf("type %d cpfx %d",crv->wType,crv->cpfx);

  					if(crv->wType==TT_PRIM_LINE)
  					{
  						for(i=0;i<crv->cpfx;i++)
  						{
  						 oswriteprinterf("%d %d lineto\r\n",lx=FIXFLOAT1K(crv->apfx[i].x),ly=FIXFLOAT1K(crv->apfx[i].y));
  						}
  					}
  					else
  					if(crv->wType==TT_PRIM_QSPLINE)
  					{
        switch(crv->cpfx)
        {
         case 1:
	  													oswriteprinterf("%d %d lineto\r\n",mx=FIXFLOAT1K(crv->apfx[0].x),my=FIXFLOAT1K(crv->apfx[0].y));
                break;

         case 2:
                oswriteprinterf("%d %d %d %d %d %d curveto\r\n",
                                 (lx+2*FIXFLOAT1K(crv->apfx[0].x))/3,
                                 (ly+2*FIXFLOAT1K(crv->apfx[0].y))/3,
                                 (2*FIXFLOAT1K(crv->apfx[0].x)+FIXFLOAT1K(crv->apfx[1].x))/3,
                                 (2*FIXFLOAT1K(crv->apfx[0].y)+FIXFLOAT1K(crv->apfx[1].y))/3,
                                  mx=FIXFLOAT1K(crv->apfx[1].x),my=FIXFLOAT1K(crv->apfx[1].y));
                    
                break;

         case 3:
                oswriteprinterf("%d %d %d %d %d %d curveto\r\n",
                                 (-lx+4*FIXFLOAT1K(crv->apfx[0].x))/3,
                                 (-ly+4*FIXFLOAT1K(crv->apfx[0].y))/3,
                                 (4*FIXFLOAT1K(crv->apfx[1].x)-FIXFLOAT1K(crv->apfx[2].x))/3,
                                 (4*FIXFLOAT1K(crv->apfx[1].y)-FIXFLOAT1K(crv->apfx[2].y))/3,
                                 mx=FIXFLOAT1K(crv->apfx[2].x),my=FIXFLOAT1K(crv->apfx[2].y));

                break;

         case 4:
                oswriteprinterf("%d %d %d %d %d %d curveto\r\n",
                                 (lx+2*FIXFLOAT1K(crv->apfx[0].x))/3,
                                 (ly+2*FIXFLOAT1K(crv->apfx[0].y))/3,
                                 (5*FIXFLOAT1K(crv->apfx[0].x)+FIXFLOAT1K(crv->apfx[1].x))/6,
                                 (5*FIXFLOAT1K(crv->apfx[0].y)+FIXFLOAT1K(crv->apfx[1].y))/6,
                                 (FIXFLOAT1K(crv->apfx[0].x)+FIXFLOAT1K(crv->apfx[1].x))/2,
                                 (FIXFLOAT1K(crv->apfx[0].y)+FIXFLOAT1K(crv->apfx[1].y))/2);

                oswriteprinterf("%d %d %d %d %d %d curveto\r\n",
                                 (FIXFLOAT1K(crv->apfx[0].x)+5*FIXFLOAT1K(crv->apfx[1].x))/6,
                                 (FIXFLOAT1K(crv->apfx[0].y)+5*FIXFLOAT1K(crv->apfx[1].y))/6,
                                 (5*FIXFLOAT1K(crv->apfx[1].x)+FIXFLOAT1K(crv->apfx[2].x))/6,
                                 (5*FIXFLOAT1K(crv->apfx[1].y)+FIXFLOAT1K(crv->apfx[2].y))/6,
                                 (FIXFLOAT1K(crv->apfx[2].x)+FIXFLOAT1K(crv->apfx[1].x))/2,
                                 (FIXFLOAT1K(crv->apfx[2].y)+FIXFLOAT1K(crv->apfx[1].y))/2);


                oswriteprinterf("%d %d %d %d %d %d curveto\r\n",
                                 (FIXFLOAT1K(crv->apfx[1].x)+5*FIXFLOAT1K(crv->apfx[2].x))/6,
                                 (FIXFLOAT1K(crv->apfx[1].y)+5*FIXFLOAT1K(crv->apfx[2].y))/6,
                                 (2*FIXFLOAT1K(crv->apfx[2].x)+FIXFLOAT1K(crv->apfx[3].x))/3,
                                 (2*FIXFLOAT1K(crv->apfx[2].y)+FIXFLOAT1K(crv->apfx[3].y))/3,
                                 mx=FIXFLOAT1K(crv->apfx[3].x),my=FIXFLOAT1K(crv->apfx[3].y));
			 
               break;

        default:

                k1=crv->cpfx-1;

                oswriteprinterf("%d %d %d %d %d %d curveto\r\n",
                                 (lx+2*FIXFLOAT1K(crv->apfx[0].x))/3,
                                 (ly+2*FIXFLOAT1K(crv->apfx[0].y))/3,
                                 (5*FIXFLOAT1K(crv->apfx[0].x)+FIXFLOAT1K(crv->apfx[1].x))/6,
                                 (5*FIXFLOAT1K(crv->apfx[0].y)+FIXFLOAT1K(crv->apfx[1].y))/6,
                                 (FIXFLOAT1K(crv->apfx[0].x)+FIXFLOAT1K(crv->apfx[1].x))/2,
                                 (FIXFLOAT1K(crv->apfx[0].y)+FIXFLOAT1K(crv->apfx[1].y))/2);


                for(k=1;k<k1;k++)
                {
                 oswriteprinterf("%d %d %d %d %d %d curveto\r\n",
                                 (FIXFLOAT1K(crv->apfx[k-1].x)+5*FIXFLOAT1K(crv->apfx[k].x))/6,
                                 (FIXFLOAT1K(crv->apfx[k-1].y)+5*FIXFLOAT1K(crv->apfx[k].y))/6,
                                 (5*FIXFLOAT1K(crv->apfx[k].x)+FIXFLOAT1K(crv->apfx[k+1].x))/6,
                                 (5*FIXFLOAT1K(crv->apfx[k].y)+FIXFLOAT1K(crv->apfx[k+1].y))/6,
                                 (FIXFLOAT1K(crv->apfx[k].x)+FIXFLOAT1K(crv->apfx[k+1].x))/2,
                                 (FIXFLOAT1K(crv->apfx[k].y)+FIXFLOAT1K(crv->apfx[k+1].y))/2);
                }
							 
                oswriteprinterf("%d %d %d %d %d %d curveto\r\n",
                                 (FIXFLOAT1K(crv->apfx[k1-2].x)+5*FIXFLOAT1K(crv->apfx[k1-1].x))/6,
                                 (FIXFLOAT1K(crv->apfx[k1-2].y)+5*FIXFLOAT1K(crv->apfx[k1-1].y))/6,
                                 (2*FIXFLOAT1K(crv->apfx[k1-1].x)+FIXFLOAT1K(crv->apfx[k1].x))/3,
                                 (2*FIXFLOAT1K(crv->apfx[k1-1].y)+FIXFLOAT1K(crv->apfx[k1].y))/3,
                                 mx=FIXFLOAT1K(crv->apfx[k1].x),my=FIXFLOAT1K(crv->apfx[k1].y));

               break;
        }

				 			lx=mx;
				 			ly=my;
 			 		}
 			 		else
 			 		if(crv->wType==TT_PRIM_CSPLINE)
 		 			{



 			 		}
				 		else
				 		{
//							*(int*)0=0;
					 		cprintf("odd opcode");
	 						break;
	 					}

 	 				crv=(TTPOLYCURVE*)(((char*)crv)+2*sizeof(WORD)+crv->cpfx*sizeof(POINTFX));
 	 			}

		 			oswriteprinter("closepath\r\n");

 	 			p+=hdr->cb;
 	 		}
 		 	if(buffer) free(buffer);

 	 		oswriteprinter("fill } bind def\r\n");
		  }
		 }

 	 oswriteprinter("end\r\n");		// of char procs


	  oswriteprinter("/BuildGlyph {\r\n");
//	 oswriteprinter("1000 0\r\n");				  // width
//	 oswriteprinter("0 0 750 750\r\n"); 	// bounding box
//	 oswriteprinter("setcachedevice\r\n");
 	 oswriteprinter("exch /CharProcs get exch\r\n");
 	 oswriteprinter("2 copy known not {pop /.notdef} if\r\n");
 	 oswriteprinter("get exec\r\n");
 	 oswriteprinter("}bind def\r\n");

	  oswriteprinter("/BuildChar {\r\n");
	  oswriteprinter("1 index /Encoding get exch get\r\n");
	  oswriteprinter("1 index /BuildGlyph get exec\r\n");
	  oswriteprinter("}bind def\r\n");

 	 oswriteprinter("currentdict\r\n");
 	 oswriteprinter("end\r\n");												// end of font dict
 	 oswriteprinterf("/%s exch definefont pop\r\n",fontname);


	 	oswriteprinterf("%%%%EndResource\r\n\r\n");
		}
	}
	return(err);
}



/*******************************************************************************/

static ps_t1x;
static ps_t1y;



static os_error * ps_t1codenumber(buffer * bf,int n)
{
 os_error * err;
 
 if(n>=(-107) && n<=(107)) err=bf_putc(bf,n+139);
 else
 if(n>=108 && n<=1131) 
 {
           err=bf_putc(bf,(n-108)/256+247);
  if(!err) err=bf_putc(bf,(n-108)&0xFF);
 }
 else
 if(n<=(-108) && n>=(-1131))
 {
           err=bf_putc(bf,((-n)-108)/256+251);
  if(!err) err=bf_putc(bf,((-n)-108)&0xFF);
 }
 else
 {
           err=bf_putc(bf,255);
  if(!err) err=bf_putc(bf,(n>>24)&0xFF);
  if(!err) err=bf_putc(bf,(n>>16)&0xFF);
  if(!err) err=bf_putc(bf,(n>>8)&0xFF);
  if(!err) err=bf_putc(bf,n&0xFF);
 }

 return(err);
}


static os_error * ps_t1codecommand(buffer * bf,int n)
{
 os_error * err;

 err=NULL;

 if(n>=256) err=bf_putc(bf,(n>>8)&0xFF);
 if(!err)   err=bf_putc(bf,n&0xFF);

 return(err);
}



#define T1CLOSEPATH 9
#define T1ENDCHAR   14
#define T1RMOVETO   21
#define T1HMOVETO   22
#define T1VMOVETO   4

#define T1RLINETO   5
#define T1HLINETO   6
#define T1VLINETO   7

#define T1SBW       (12*256+7)
#define T1HSBW      13

#define T1HCURVETO    31
#define T1RRCURVETO   8
#define T1VCURVETO    30



static os_error * ps_t1start(buffer * bf,int x,int y,int metricw,int metrich)
{

 ps_t1x=x;
 ps_t1y=y;

 if(y==0 && metrich==0)
 {
  ps_t1codenumber(bf,x);
  ps_t1codenumber(bf,metricw);
  ps_t1codecommand(bf,T1HSBW);
 }
 else
 {
  ps_t1codenumber(bf,x);
  ps_t1codenumber(bf,y);
  ps_t1codenumber(bf,metricw);
  ps_t1codenumber(bf,metrich);
  ps_t1codecommand(bf,T1SBW);
 }

 ps_t1codenumber(bf,0);
 ps_t1codenumber(bf,0);
 ps_t1codecommand(bf,T1RMOVETO);

 return(NULL);
}


static os_error * ps_t1move(buffer * bf,int x,int y)
{
 int dx;
 int dy;

 dx=x-ps_t1x;
 dy=y-ps_t1y;

 if(dx==0)
 {
  ps_t1codenumber(bf,dy);
  ps_t1codecommand(bf,T1VMOVETO);
 }
 else
 if(dy==0)
 {
  ps_t1codenumber(bf,dx);
  ps_t1codecommand(bf,T1HMOVETO);
 }
 else
 {
  ps_t1codenumber(bf,dx);
  ps_t1codenumber(bf,dy);
  ps_t1codecommand(bf,T1RMOVETO);
 }

 ps_t1x=x;
 ps_t1y=y;

 return(NULL);
}


static os_error * ps_t1line(buffer * bf,int x,int y)
{
 int dx;
 int dy;

 dx=x-ps_t1x;
 dy=y-ps_t1y;

 if(dx==0)
 {
  ps_t1codenumber(bf,dy);
  ps_t1codecommand(bf,T1VLINETO);
 }
 else
 if(dy==0)
 {
  ps_t1codenumber(bf,dx);
  ps_t1codecommand(bf,T1HLINETO);
 }
 else
 {
  ps_t1codenumber(bf,dx);
  ps_t1codenumber(bf,dy);
  ps_t1codecommand(bf,T1RLINETO);
 }

 ps_t1x=x;
 ps_t1y=y;

 return(NULL);
}


static os_error * ps_t1curve(buffer * bf,int x0,int y0,int x1,int y1,int x2,int y2)
{

 int dx;
 int dy;

 dx=x0-ps_t1x;
 dy=y0-ps_t1y;

 ps_t1codenumber(bf,dx);
 ps_t1codenumber(bf,dy);

 ps_t1x=x0;
 ps_t1y=y0;


 dx=x1-ps_t1x;
 dy=y1-ps_t1y;

 ps_t1codenumber(bf,dx);
 ps_t1codenumber(bf,dy);

 ps_t1x=x1;
 ps_t1y=y1;

 
 dx=x2-ps_t1x;
 dy=y2-ps_t1y;

 ps_t1codenumber(bf,dx);
 ps_t1codenumber(bf,dy);

 ps_t1x=x2;
 ps_t1y=y2;

 ps_t1codecommand(bf,T1RRCURVETO);

 return(NULL);
}


static os_error * ps_t1closepath(buffer * bf)
{

 return(ps_t1codecommand(bf,T1CLOSEPATH));
}


static os_error * ps_t1end(buffer * bf)
{

 return(ps_t1codecommand(bf,T1ENDCHAR));
}





static char ps_encrypt(char plain,unsigned short int & r)
{
 const unsigned short int c1 = 52845;
 const unsigned short int c2 = 22719;
 char cipher;

 cipher =(char) (plain ^ (r>>8));
 r=(unsigned short)((cipher + r) * c1 + c2);
 return(cipher);
}






// nb raw font name

os_error * ps_uploadfont1(char * name,int userfont)
{
	os_error         * err;
	int                osfont;
	int                c;
 int                ch;
	int                fh;
	int                size;
	char             * glyphdata;
	char             * p;
	char             * lt;
	int                i;
	int                k;
	int												 			k1;
 TTPOLYGONHEADER 	* hdr;
	TTPOLYCURVE      *	crvlt;
	TTPOLYCURVE      *	crv;
	int                lx;
	int                ly;
	int                mx;
	int                my;
	int                designsize;
 font_info          fi1;
 font_info          fi2;
 font_info          fi;
	int                metricw;
	int                metrich;
	int                code;
 buffer             bf1;
 buffer             bf2;
 int                posn;
 unsigned short int r;
	char            *  encoding;
	int                encodingtype;       // use symbol encoding
	int                fontplanes;
	int                entries;
	int                fp;
	char               temp[128];
	char               buffer[MAXFONTNAMELEN];


	osfont=fontosfromuser(userfont);
	designsize=fontdesignsize(osfont);
	pscharmapinfo(userfont,&fontplanes);

	cprintf("designsize %d",designsize);

 err=validfont(osfont,0,designsize,0,&fh,NULL);			// doesn't matter which	of these two
// err=validfont(osfont,0,1000,0,&fh,NULL);
 if(!err)
 {
  font_setfont2(fh,fonthdcptr);
	
//  fontbbox(osfont,designsize,designsize,&fi1,&fi2);
  fontbbox(osfont,1000,1000,&fi1,&fi2);

		for(fp=0;fp<fontplanes;fp++)
		{
	  pscharmapfontinfo(userfont,fp,&encodingtype);

 		if(encodingtype==PS_ENCSYMBOL)
   {
				entries=PS_ENCSYMBOLCOUNT;
			}
			else
			if(encodingtype==PS_ENCLATIN1)
			{
				entries=PS_ENCLATIN1COUNT;
			}
			else						// custom encoding
			{
				entries=1;		// allow for .notdef

				oswriteprinterf("%%%%BeginResource: procset DPL_Encoding_%x 1.00 0\r\n",encodingtype);
    oswriteprinterf("%%%%Title: OvationPro font encoding\r\n");
    oswriteprinterf("%%%%CreationDate: 22/04/2004\r\n");
    oswriteprinterf("%%%%Copyright: (C) 2004 David Pilling Ltd All Rights Reserved\r\n");

    oswriteprinterf("/DPL_Encoding_%x [\r\n",encodingtype);

 			for(i=0;i<256;i++)
				{
 			 code=pscharmapunicode(userfont,fp,i);
					if(code<0) oswriteprinterf("/.notdef\r\n"); 
					else
     {
      oswriteprinterf("/%s\r\n",psencglypname(code));
						entries++;
					}
				}

			 oswriteprinterf("] def\r\n");
    oswriteprinterf("%%%%EndResource\r\n\r\n");
			}

   pscodefontname(buffer,name,fp,sizeof(buffer));

   oswriteprinterf("%%%%BeginResource: Font %s\r\n",buffer);
   oswriteprinterf("%%!FontType1-1.0: %s\r\n",buffer);

   oswriteprinter("%%Creator: Ovation Pro\r\n");
   oswriteprinter("12 dict begin\r\n");
   oswriteprinter("/FontType 1 def\r\n");

   oswriteprinterf("/FontName /%s def\r\n",buffer);

//  oswriteprinterf("/FontMatrix [%f 0 0 %f 0 0] def\r\n",1.0/(double)designsize,1.0/(double)designsize);
   oswriteprinterf("/FontMatrix [0.001 0 0 0.001 0 0] def\r\n");
   oswriteprinterf("/FontBBox [%d %d %d %d] def\r\n",fi2.minx,fi2.miny,fi2.maxx,fi2.maxy);

 		if(encodingtype==PS_ENCSYMBOL) oswriteprinterf("/Encoding DPL_SymbolEncoding def\r\n");
 		else
   if(encodingtype==PS_ENCLATIN1) oswriteprinterf("/Encoding DPL_Latin1Encoding def\r\n");
			else																										 oswriteprinterf("/Encoding DPL_Encoding_%x def\r\n",encodingtype);


   oswriteprinter("/PaintType 0 def\r\n");
   oswriteprinter("/StrokeWidth 0 def\r\n");
   ps_kerndata(osfont,userfont,fp);
 //  oswriteprinter("/UniqueID 4754774 def\r\n");
   oswriteprinter("currentdict end\r\n");
   oswriteprinter("currentfile eexec\r\n");


   ps_hexinit();

   bf_open(NULL,'u',8192,&bf1);
   bf_open(NULL,'u',2048,&bf2);

   bf_printf(&bf1,"dup /Private 8 dict dup begin\r\n");
   bf_printf(&bf1,"/RD {string currentfile exch readstring pop} executeonly def\r\n");
   bf_printf(&bf1,"/ND {noaccess def} executeonly def\r\n");
   bf_printf(&bf1,"/NP {noaccess put} executeonly def\r\n");
   bf_printf(&bf1,"/BlueValues [] def\r\n");
   bf_printf(&bf1,"/MinFeature {16 16} def\r\n");
   bf_printf(&bf1,"/password 5839 def\r\n");
// bf_printf("/UniqueID 6859 def\r\n");
 
   bf_printf(&bf1,"2 index /CharStrings %d dict dup begin\r\n",entries);

/*

  /Alpha 186 RD ~186~binary~bytes~ ND
  % . . .
  % . . . 188 character definitions omitted
  % . . .
  /.notdef 9 RD ~9~binary~bytes~ ND
	 
*/  

 		for(c=-1;c<256;c++)
 		{
 			if(c<0)
 			{
 				encoding=".notdef";
 				code=32;
 			}
 			else
 			{
	 			code=pscharmapunicode(userfont,fp,c);

  			if(encodingtype==PS_ENCSYMBOL)
  			{
 					sprintf(temp,"g%d",c);
 					encoding=temp;
 				}
  			else
					if(encodingtype==PS_ENCLATIN1)
 	 		{
 		 		encoding=psencoding[c];
 			 }
					else
					{
						encoding=psencglypname(code);
					}
	 		}

 			if(encoding && code>=0)
 			{

//					cprintf("encoding %s code %d index %d",encoding,code,c);

//    fontcharwidth(osfont,designsize,designsize,code,&metricw,&metrich);
//    fontcharbbox(osfont,designsize,designsize,code,&fi);
     fontcharwidth(osfont,1000,1000,code,&metricw,&metrich);
     fontcharbbox(osfont,1000,1000,code,&fi);


     getglyphdata(osfont,code,&glyphdata,&size);			// glyphdata may be NULL if size is zero
// 			cprintf("c %d size %d",c,size);

  			p=glyphdata;
  			lt=(glyphdata+size);
     bf_seek(&bf2,0);

  			if(size==0)
     {
      ps_t1start(&bf2,0,0,metricw,metrich);
     }

     while(p<lt)
  			{
  				hdr=(TTPOLYGONHEADER*)p;

 	 			crvlt=(TTPOLYCURVE*)(p+hdr->cb);
 	 			crv=(TTPOLYCURVE*)(p+sizeof(TTPOLYGONHEADER));

      lx=FIXFLOAT1K(hdr->pfxStart.x);
      ly=FIXFLOAT1K(hdr->pfxStart.y);

      if(p==glyphdata)
      {
       ps_t1start(&bf2,lx,ly,metricw,metrich);
      }
      else
      {
       ps_t1move(&bf2,lx,ly);
      }

 		 		while(crv<crvlt)
 		 		{
 					// cprintf("type %d cpfx %d",crv->wType,crv->cpfx);

 		 			if(crv->wType==TT_PRIM_LINE)
 		 			{
 		 				for(i=0;i<crv->cpfx;i++)
 		 				{
 		 				 ps_t1line(&bf2,lx=FIXFLOAT1K(crv->apfx[i].x),ly=FIXFLOAT1K(crv->apfx[i].y));
 		 				}
 		 			}
 	 				else
 	 				if(crv->wType==TT_PRIM_QSPLINE)
 	 				{
        switch(crv->cpfx)
        {
         case 1:
	  													ps_t1line(&bf2,mx=FIXFLOAT1K(crv->apfx[0].x),my=FIXFLOAT1K(crv->apfx[0].y));
                break;

         case 2:
                ps_t1curve(&bf2,(lx+2*FIXFLOAT1K(crv->apfx[0].x))/3,
                           (ly+2*FIXFLOAT1K(crv->apfx[0].y))/3,
                           (2*FIXFLOAT1K(crv->apfx[0].x)+FIXFLOAT1K(crv->apfx[1].x))/3,
                           (2*FIXFLOAT1K(crv->apfx[0].y)+FIXFLOAT1K(crv->apfx[1].y))/3,
                           mx=FIXFLOAT1K(crv->apfx[1].x),my=FIXFLOAT1K(crv->apfx[1].y));
                    
                break;

         case 3:
                ps_t1curve(&bf2,(-lx+4*FIXFLOAT1K(crv->apfx[0].x))/3,
                           (-ly+4*FIXFLOAT1K(crv->apfx[0].y))/3,
                           (4*FIXFLOAT1K(crv->apfx[1].x)-FIXFLOAT1K(crv->apfx[2].x))/3,
                           (4*FIXFLOAT1K(crv->apfx[1].y)-FIXFLOAT1K(crv->apfx[2].y))/3,
                           mx=FIXFLOAT1K(crv->apfx[2].x),my=FIXFLOAT1K(crv->apfx[2].y));

                break;

         case 4:
                ps_t1curve(&bf2,(lx+2*FIXFLOAT1K(crv->apfx[0].x))/3,
                           (ly+2*FIXFLOAT1K(crv->apfx[0].y))/3,
                           (5*FIXFLOAT1K(crv->apfx[0].x)+FIXFLOAT1K(crv->apfx[1].x))/6,
                           (5*FIXFLOAT1K(crv->apfx[0].y)+FIXFLOAT1K(crv->apfx[1].y))/6,
                           (FIXFLOAT1K(crv->apfx[0].x)+FIXFLOAT1K(crv->apfx[1].x))/2,
                           (FIXFLOAT1K(crv->apfx[0].y)+FIXFLOAT1K(crv->apfx[1].y))/2);

                ps_t1curve(&bf2,(FIXFLOAT1K(crv->apfx[0].x)+5*FIXFLOAT1K(crv->apfx[1].x))/6,
                           (FIXFLOAT1K(crv->apfx[0].y)+5*FIXFLOAT1K(crv->apfx[1].y))/6,
                           (5*FIXFLOAT1K(crv->apfx[1].x)+FIXFLOAT1K(crv->apfx[2].x))/6,
                           (5*FIXFLOAT1K(crv->apfx[1].y)+FIXFLOAT1K(crv->apfx[2].y))/6,
                           (FIXFLOAT1K(crv->apfx[2].x)+FIXFLOAT1K(crv->apfx[1].x))/2,
                           (FIXFLOAT1K(crv->apfx[2].y)+FIXFLOAT1K(crv->apfx[1].y))/2);


                ps_t1curve(&bf2,(FIXFLOAT1K(crv->apfx[1].x)+5*FIXFLOAT1K(crv->apfx[2].x))/6,
                           (FIXFLOAT1K(crv->apfx[1].y)+5*FIXFLOAT1K(crv->apfx[2].y))/6,
                           (2*FIXFLOAT1K(crv->apfx[2].x)+FIXFLOAT1K(crv->apfx[3].x))/3,
                           (2*FIXFLOAT1K(crv->apfx[2].y)+FIXFLOAT1K(crv->apfx[3].y))/3,
                           mx=FIXFLOAT1K(crv->apfx[3].x),my=FIXFLOAT1K(crv->apfx[3].y));
			 
               break;

        default:

                k1=crv->cpfx-1;

                ps_t1curve(&bf2,(lx+2*FIXFLOAT1K(crv->apfx[0].x))/3,
                           (ly+2*FIXFLOAT1K(crv->apfx[0].y))/3,
                           (5*FIXFLOAT1K(crv->apfx[0].x)+FIXFLOAT1K(crv->apfx[1].x))/6,
                           (5*FIXFLOAT1K(crv->apfx[0].y)+FIXFLOAT1K(crv->apfx[1].y))/6,
                           (FIXFLOAT1K(crv->apfx[0].x)+FIXFLOAT1K(crv->apfx[1].x))/2,
                           (FIXFLOAT1K(crv->apfx[0].y)+FIXFLOAT1K(crv->apfx[1].y))/2);


                for(k=1;k<k1;k++)
                {
                 ps_t1curve(&bf2,(FIXFLOAT1K(crv->apfx[k-1].x)+5*FIXFLOAT1K(crv->apfx[k].x))/6,
                            (FIXFLOAT1K(crv->apfx[k-1].y)+5*FIXFLOAT1K(crv->apfx[k].y))/6,
                            (5*FIXFLOAT1K(crv->apfx[k].x)+FIXFLOAT1K(crv->apfx[k+1].x))/6,
                            (5*FIXFLOAT1K(crv->apfx[k].y)+FIXFLOAT1K(crv->apfx[k+1].y))/6,
                            (FIXFLOAT1K(crv->apfx[k].x)+FIXFLOAT1K(crv->apfx[k+1].x))/2,
                            (FIXFLOAT1K(crv->apfx[k].y)+FIXFLOAT1K(crv->apfx[k+1].y))/2);
                }
							 
                ps_t1curve(&bf2,(FIXFLOAT1K(crv->apfx[k1-2].x)+5*FIXFLOAT1K(crv->apfx[k1-1].x))/6,
                           (FIXFLOAT1K(crv->apfx[k1-2].y)+5*FIXFLOAT1K(crv->apfx[k1-1].y))/6,
                           (2*FIXFLOAT1K(crv->apfx[k1-1].x)+FIXFLOAT1K(crv->apfx[k1].x))/3,
                           (2*FIXFLOAT1K(crv->apfx[k1-1].y)+FIXFLOAT1K(crv->apfx[k1].y))/3,
                           mx=FIXFLOAT1K(crv->apfx[k1].x),my=FIXFLOAT1K(crv->apfx[k1].y));

               break;
        }

 							lx=mx;
	 						ly=my;
  					}
  					else
  					if(crv->wType==TT_PRIM_CSPLINE)
  					{



 	 				}
		 				else
		 				{
//							*(int*)0=0;
			 				cprintf("odd opcode");
			 				break;
			 			}

 			 		crv=(TTPOLYCURVE*)(((char*)crv)+2*sizeof(WORD)+crv->cpfx*sizeof(POINTFX));
 			 	}

	 				ps_t1closepath(&bf2);

  				p+=hdr->cb;
  			}

 	 		if(glyphdata) free(glyphdata);

 		 	ps_t1end(&bf2);

//  186 RD ~186~binary~bytes~ ND


     bf_tell(&bf2,&posn);
     bf_seek(&bf2,0);
     bf_printf(&bf1,"/%s %d RD ",encoding,posn+4);

     r=4330;

     for(i=0;i<4;i++)
     {
      bf_putc(&bf1,ps_encrypt(0,r));
     }

     for(i=0;i<posn;i++)
     {
      bf_getc(&bf2,&ch);
      bf_putc(&bf1,ps_encrypt((char)ch,r));
     }

	 	  bf_printf(&bf1,"ND\r\n");
   
    }
	 	}


   bf_printf(&bf1,"end\r\n");
   bf_printf(&bf1,"end\r\n");
   bf_printf(&bf1,"readonly put\r\n");
   bf_printf(&bf1,"noaccess put\r\n");
   bf_printf(&bf1,"dup /FontName get exch definefont pop\r\n");
   bf_printf(&bf1,"mark currentfile closefile ");

  // eecode

   bf_tell(&bf1,&posn);
   bf_seek(&bf1,0);
   r=55665;

//  cprintf("bf1 posn %d",posn);

   for(i=0;i<4;i++)
   {
    ps_hexwrite(ps_encrypt(0,r));
   }

   for(i=0;i<posn;i++)
   {
    bf_getc(&bf1,&ch);
//     oswriteprinterf("%c",ch);
    ps_hexwrite(ps_encrypt((char)ch,r));
   }

   ps_hexfinit();

   bf_close(&bf2,NULL);
   bf_close(&bf1,NULL);

  // 512 0's

   for(i=0;i<16;i++)
   {
    oswriteprinter("00000000000000000000000000000000\r\n");
   }

	  oswriteprinter("cleartomark\r\n");


	 	oswriteprinterf("%%%%EndResource\r\n\r\n");
	 }
	}

	return(err);
}





os_error * ps_uploadfont(char * name,int userfont)
{
 if(ps_fonttype==1) return(ps_uploadfont1(name,userfont));
 else               return(ps_uploadfont3(name,userfont));
}




/*******************************************************************************/


// we're outputing the kern data in the fonts own space and making the
// assumption that is in 0.001, design size of 1000
// OK for fonts output above, but an assumption for built in fonts


os_error * ps_kerndata(int osfont,int userfont,int fontplane)
{
 os_error   * err;
 int          first;
 int          second;
 int          npairs;
	int          maxpairs;
 int          j;
 int          shift;
	int          fp1;
	int          fp2;

 err=NULL;


 npairs=0;
 maxpairs=fontnpairs(osfont);

 for(j=0;j<maxpairs;j++)
 {
  first=((font_kerningdatastr*)fontkdata(osfont))[j].first;			// Unicode or Acorn values?
  second=((font_kerningdatastr*)fontkdata(osfont))[j].second;

//		cprintf("first %x second %x",first,second);

  first=pscharmapindex(userfont,&fp1,first);
  second=pscharmapindex(userfont,&fp2,second);

  if((first>=0) && (second>=0) && (fp1==fp2) && (fp1==fontplane)) npairs++;
 }


//	cprintf("kerndata pairs %d A %d W %d",npairs,pscharmapindex(userfont,&fp2,'A'),pscharmapindex(userfont,&fp2,'W'));


 if(npairs)
 {
  err=oswriteprinterf("/KernData %d dict dup begin\r\n",npairs);

  if(!err)
  {
   for(j=0;j<maxpairs;j++)
   {
    first=((font_kerningdatastr*)fontkdata(osfont))[j].first;
    first=pscharmapindex(userfont,&fp1,first);
      
    second=((font_kerningdatastr*)fontkdata(osfont))[j].second;
    second=pscharmapindex(userfont,&fp2,second);

    if((first>=0) && (second>=0) && (fp1==fp2) && (fp1==fontplane))
    {
     shift=((font_kerningdatastr*)fontkdata(osfont))[j].shift;
     shift=(shift*1000)/fontdesignsize(osfont);
     err=oswriteprinterf("%d %d def\r\n",second+(first<<8),shift);
    }
   }
  }

  if(!err) err=oswriteprinter("end def\r\n");
 }

 return(err);
}

