/*->c.blank */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "font.h"
#include "transform.h"
#include "xprocess.h"


#include "err.h"
#include "xmath.h"
#include "fsx.h"
#include "bf.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "colour.h"
#include "etc.h"
#include "osunits.h"
#include "osgraphics.h"
#include "deb.h"


#include "constants.h"
#include "str.h"

#include "object.h"

#include "geometry.h"

#include "viewr.h"
#include "view.h"
#include "file.h"
#include "chain.h"
#include "posn.h"


#include "xcolour.h"
#include "xredraw.h"
#include "curve.h"
#include "chain.h"




#include "txstr.h"
#include "tx.h"
#include "fox.h"

#include "blank.h"


static int   bsize;
static int   bshift;

static int * bstart;
static int * bend;
static int * bstartz;
static int * bendz;


static        int    blankcol;
static textboxstr  * blanktext;
static transformstr  blanktran;


static int   octant;

static int   blx;    /* OS unit base of arrays */
static int   bly;

static int   blankcorner;  // is the pixel base set up

static int   blxpx;  /* pixel unit base of arrays */
static int   blypx;

static int   bmaxx;
static int   bmaxy;
static int   blankmode;


static int   cl;
static int   cr;
static int   ct;
static int   cb;

static int       bsboxn;
static sboxstr * bsbox;




static void setoctant(int oct)
{
 octant=oct;

cprintf("octant=%d",octant);

 switch(octant)
 {
  case 0:
         ct=1;
         cb=3;
         cl=0;
         cr=2;
         break;

  case 1:
         ct=0;
         cb=2;
         cl=1;
         cr=3;
         break;

  case 2:
         ct=1;
         cb=3;
         cl=0;
         cr=2;
         break;

  case 3:
         ct=0;
         cb=2;
         cl=1;
         cr=3;
         break;

  case 4:
         ct=1;
         cb=3;
         cl=0;
         cr=2;
         break;

  case 5:
         ct=0;
         cb=2;
         cl=1;
         cr=3;
         break;

  case 6:
         ct=1;
         cb=3;
         cl=0;
         cr=2;
         break;

  case 7:
         ct=0;
         cb=2;
         cl=1;
         cr=3;
         break;

 }
}



os_error * blankstart(viewredrawstr * v,int s,textboxstr * text,int col,
                                                                int mode)
{
 os_error   * err;
 transformstr trx;
 transformstr trw;
 transformstr trz;
 int          dx;
 int          dy;
 int          bsizec;
 int          sboxn;
 sboxstr  **  sboxp;
 int          i;
 int          bmx1;
 int          bmy1;


 err=NULL;

 blankcol=col;
 blanktext=text;
 blankmode=mode;
 blankcorner=0;

 trx=text->data.transform;
 tr_setshift(&trw,text->fcurve.box.x,text->fcurve.box.y);
 tr_multiply(&blanktran,&trw,&trx);

 dx=text->fcurve.box.w;
 dy=0;

 trz=blanktran;
 trz.e=trz.f=0;
 tr_delta(&trz,&dx,&dy);

 if(ABS(dy)>ABS(dx))
 {
  if(dy>0 && dx>=0)
  {
   setoctant(2);
  }
  else
  if(dy>0 && dx<0)
  {
   setoctant(3);
  }
  else
  if(dy<0 && dx<0)
  {
   setoctant(6);
  }
  else
  if(dy<0 && dx>=0)
  {
   setoctant(7);
  }
 }
 else
 {
  if(dy<=0 && dx>=0)
  {
   setoctant(0);
  }
  else
  if(dy>0 && dx>0)
  {
   setoctant(1);
  }
  else
  if(dy>=0 && dx<0)
  {
   setoctant(4);
  }
  else
  if(dy<0 && dx<0)
  {
   setoctant(5);
  }

 }


 blx=v->ox+osunits(v->xpo+text->box.x,v->view);
 bmx1=bmaxx=v->ox+osunits(v->xpo+text->box.x+text->box.w,v->view);

 bmaxx-=blx;
// bmaxx/=cvdu.deltax;
 bmaxx=xos2pix(bmaxx);
 bmaxx++;

 bly=v->oy-osunits(v->ypo+text->box.y+text->box.h,v->view);
 bmy1=bmaxy=v->oy-osunits(v->ypo+text->box.y,v->view);

 bmaxy-=bly;
// bmaxy/=cvdu.deltay;
 bmaxy=yos2pix(bmaxy);
 bmaxy++;


 if(octant==0 || octant==1 || octant==4 || octant==5)
 {
//  cprintf("bly %d bmy1 %d",bly,bmy1);
//  cprintf("y0 %d y1%d",v->redrawstr.g.y0-cvdu.deltay,v->redrawstr.g.y1+cvdu.deltay);

// crash here because although y0<y1 and bly<bmy1
// bmy1 can be less than bshift
// so added cut on bsize

  bshift=MAX(bly,v->redrawstr.g.y0-cvdu.extray);
  bmy1=MIN(bmy1,v->redrawstr.g.y1+cvdu.extray);

//  cprintf("bly %d bmy1 %d",bshift,bmy1);  

//  bsize=(bmy1-bshift)/cvdu.deltay;
  bsize=yos2pix(bmy1-bshift);
  if(bsize<0) bsize=0;

//  bshift=(bshift-bly)/cvdu.deltay;
  bshift=yos2pix(bshift-bly);
  bsize++;
  if(octant==4 || octant==5) 
  {
   bshift=bmaxy-(bshift+bsize);
   if(bshift<0) bshift=0;
  }
 }
 else
 {
  bshift=MAX(blx,v->redrawstr.g.x0-cvdu.extrax);
  bmx1=MIN(bmx1,v->redrawstr.g.x1+cvdu.extrax);
//  bsize=(bmx1-bshift)/cvdu.deltax;
  bsize=xos2pix(bmx1-bshift);
  if(bsize<0) bsize=0;
//  bshift=(bshift-blx)/cvdu.deltax;
  bshift=xos2pix(bshift-blx);
  bsize++;
  if(octant==6 || octant==7) 
  {
   bshift=bmaxx-(bshift+bsize);
   if(bshift<0) bshift=0;
  }
 }


 // seen crash with bsize<0 here

 bsizec=bsize*sizeof(int);

 if(mode & BLANKZONE)
 {
  if(!err) err=flex_alloc((flex_ptr)&bstartz,bsizec);
  if(!err) err=flex_alloc((flex_ptr)&bendz,bsizec);
  if(!err)
  {
   memset(bstartz,0,bsizec);
   memset(bendz,0,bsizec);
  }
 }

 if(mode & BLANKTEXT)
 {
  if(!err) err=flex_alloc((flex_ptr)&bstart,bsizec);
  if(!err) err=flex_alloc((flex_ptr)&bend,bsizec);
  if(!err)
  {
   memset(bstart,0,bsizec);
   memset(bend,0,bsizec);
  }
 }

 bsboxn=0;

 if(!err)
 {
  vxgetareas(v,&sboxn,&sboxp);

  if(sboxn)
  {
   err=flex_alloc((flex_ptr)&bsbox,sboxn*sizeof(sboxstr));
   if(!err)
   {
    XMEMCPYX(bsbox,*sboxp,sboxn*sizeof(sboxstr));
    bsboxn=sboxn;

    for(i=0;i<sboxn;i++)
    {
     bsbox[i].box.x0=v->ox+osunits(v->xpo+bsbox[i].box.x0,v->view)-cvdu.extrax;
     bsbox[i].box.x1=v->ox+osunits(v->xpo+bsbox[i].box.x1,v->view)+cvdu.extrax;
     bsbox[i].box.y0=v->oy-osunits(v->ypo+bsbox[i].box.y0,v->view)+cvdu.extray;
     bsbox[i].box.y1=v->oy-osunits(v->ypo+bsbox[i].box.y1,v->view)-cvdu.extray;

     bsbox[i].box.x0=xos2pix(bsbox[i].box.x0-blx);
     bsbox[i].box.x1=xos2pix(bsbox[i].box.x1-blx);
     bsbox[i].box.y0=yos2pix(bsbox[i].box.y0-bly);
     bsbox[i].box.y1=yos2pix(bsbox[i].box.y1-bly);
    }
   }
  }
 }

 return(err);

 USE(s);
}




/* end points are max values       */
/* start points are min values     */
/* end points can be made smaller  */
/* start points can be made bigger */



static void outputline(int minx,int maxx,int y,int * ab,int * ae,int mode)
{
 y-=bshift;

 if(y>=bsize || y<0) return;

/* if(minx>maxx) dprintf(2,"maxx=%d minx=%d",maxx,minx); */

 if(minx>ab[y])
 {
  if(mode==0) ae[y]=minx;
  else
  if(mode==1) ae[y]=maxx;
  else
  if(mode==2) 
  {
   if(minx<=ae[y]) ab[y]=minx;
   else
   if(ae[y]>ab[y]) ab[y]=ae[y];

  /* ab[y]=MIN(minx,ae[y]); */
  }
  else
  {
   if(maxx<ae[y])
   {
    if(mode==3)
    {
     ae[y]=maxx;
    }
   }
  }
 }
 else
 if(maxx<ae[y])
 {
  if(mode==3)
  {
   ae[y]=MAX(maxx,ab[y]);
  }
 }
}




static void outputliney(coordstr * s,coordstr * e,int * ab,int * ae,int mode)
{
 int dx;
 int dy;
 int x1;
 int x2;
 int y1;
 int y2;
 int ix;
 int iy;
 int error;
 int x;
 int y;
 int minx;


 dx=e->x-s->x;
 dy=e->y-s->y;

 if(ABS(dx)>ABS(dy))
 {
  if(dx<0)
  {
   x1=e->x;
   x2=s->x;
   y1=e->y;
   y2=s->y;
  }
  else
  {
   x1=s->x;
   x2=e->x;
   y1=s->y;
   y2=e->y;
  }

  dy=y2-y1;
  dx=x2-x1;

  if(dy>0) iy=1;
  else     {iy=-1;dy=-dy;}

  x=x1;
  y=y1;

  error=-dx/2;

  minx=x;

  while(x<x2)
  {
   error+=dy;
   if(error>=0)
   {
    outputline(minx,x,y,ab,ae,mode);
    minx=x+1;
    y+=iy;
    error-=dx;
   }
   x++;
  }


  if(iy>0)
  {
   while(y<=y2)
   {
    outputline(x,x,y,ab,ae,mode);
    y+=iy;
   }
  }
  else
  {
   while(y>=y2)
   {
    outputline(x,x,y,ab,ae,mode);
    y+=iy;
   }
  }
 }
 else
 {
  if(dy<0)
  {
   x1=e->x;
   x2=s->x;
   y1=e->y;
   y2=s->y;
  }
  else
  {
   x1=s->x;
   x2=e->x;
   y1=s->y;
   y2=e->y;
  }

  dx=x2-x1;
  dy=y2-y1;

  if(dx>0) ix=1;
  else     {ix=-1;dx=-dx;}

  x=x1;
  y=y1;

  error=-dy/2;

  while(y<=y2)
  {
   outputline(x,x,y,ab,ae,mode);
   error+=dx;
   if(error>=0)
   {
    x+=ix;
    error-=dy;
   }
   y++;
  }
 }
}





static void blanktrset(coordstr * c,int n,viewredrawstr * v)
{

 switch(octant)
 {
  case 0:
         while(n--)
         {
          c->x=xos2pix(v->ox+osunits(v->xpo+c->x,v->view)-blx);// /cvdu.deltax;
          c->y=yos2pix(v->oy-osunits(v->ypo+c->y,v->view)-bly);// /cvdu.deltay;

          c->x=CUT(c->x,0,bmaxx);
          c->y=CUT(c->y,0,bmaxy);

          c++;
         }
         break;


  case 1:
         while(n--)
         {
          c->x=xos2pix(v->ox+osunits(v->xpo+c->x,v->view)-blx);// /cvdu.deltax;
          c->y=yos2pix(v->oy-osunits(v->ypo+c->y,v->view)-bly);// /cvdu.deltay;

          c->x=CUT(c->x,0,bmaxx);
          c->y=CUT(c->y,0,bmaxy);

          c->x=-c->x+bmaxx;

          c++;
         }
         break;


  case 2:
         while(n--)
         {
          c->x=xos2pix(v->ox+osunits(v->xpo+c->x,v->view)-blx);// /cvdu.deltax;
          c->y=yos2pix(v->oy-osunits(v->ypo+c->y,v->view)-bly);// /cvdu.deltay;

          c->x=CUT(c->x,0,bmaxx);
          c->y=CUT(c->y,0,bmaxy);

          SWOP(c->x,c->y);
          c->x=-c->x+bmaxy;

          c++;
         }
         break;

  case 3:
         while(n--)
         {
          c->x=xos2pix(v->ox+osunits(v->xpo+c->x,v->view)-blx);// /cvdu.deltax;
          c->y=yos2pix(v->oy-osunits(v->ypo+c->y,v->view)-bly);// /cvdu.deltay;

          c->x=CUT(c->x,0,bmaxx);
          c->y=CUT(c->y,0,bmaxy);

          SWOP(c->x,c->y);

          c++;
         }
         break;

  case 4:
         while(n--)
         {
          c->x=xos2pix(v->ox+osunits(v->xpo+c->x,v->view)-blx);// /cvdu.deltax;
          c->y=yos2pix(v->oy-osunits(v->ypo+c->y,v->view)-bly);// /cvdu.deltay;

          c->x=CUT(c->x,0,bmaxx);
          c->y=CUT(c->y,0,bmaxy);

          c->y=-c->y+bmaxy;
          c->x=-c->x+bmaxx;

          c++;
         }
         break;

  case 5:
         while(n--)
         {
          c->x=xos2pix(v->ox+osunits(v->xpo+c->x,v->view)-blx);// /cvdu.deltax;
          c->y=yos2pix(v->oy-osunits(v->ypo+c->y,v->view)-bly);// /cvdu.deltay;

          c->x=CUT(c->x,0,bmaxx);
          c->y=CUT(c->y,0,bmaxy);

          c->y=-c->y+bmaxy;

          c++;
         }
         break;

  case 6:
         while(n--)
         {
          c->x=xos2pix(v->ox+osunits(v->xpo+c->x,v->view)-blx);// /cvdu.deltax;
          c->y=yos2pix(v->oy-osunits(v->ypo+c->y,v->view)-bly);// /cvdu.deltay;

          c->x=CUT(c->x,0,bmaxx);
          c->y=CUT(c->y,0,bmaxy);

          c->x=-c->x+bmaxx;
          SWOP(c->x,c->y);

          c++;
         }
         break;

  case 7:
         while(n--)
         {
          c->x=xos2pix(v->ox+osunits(v->xpo+c->x,v->view)-blx);// /cvdu.deltax;
          c->y=yos2pix(v->oy-osunits(v->ypo+c->y,v->view)-bly);// /cvdu.deltay;

          c->x=CUT(c->x,0,bmaxx);
          c->y=CUT(c->y,0,bmaxy);

          c->x=-c->x+bmaxx;
          SWOP(c->x,c->y);
          c->x=-c->x+bmaxy;

          c++;
         }
         break;
 }
}


static int scached;
static int cx0;
static int cx1;
static int cy0;
static int cy1;


// at this point we know the area we want to blank in pixels
// relative to the corner of the frame (blx,bly)
// in RISC OS version here we had exact OS units to draw not relative
// we opt to draw in pixels and convert the corner to a pixel location
// could alternatively have done drawing in OS units whose pixel
// equivalents we know - cf grid drawing.


static void sxcacheflush(void)
{
 if(scached)
 {
/*
  for(int y=cy0;y<=cy1;y++)
  {
   bbc_move(cx0+blxpx,y+blypx);
   bbc_draw(cx1+blxpx,y+blypx);


  }
*/
  if(cy0==cy1)
  {
   bbc_move(cx0+blxpx,cy0+blypx);
   bbc_draw(cx1+blxpx,cy0+blypx);
  }
  else
  {
   bbc_rectanglefill(cx0+blxpx,cy0+blypx,(cx1-cx0),(cy1-cy0));
  }
 }
 scached=0;
}


static void scanlinex(int x0,int x1,int y)
{
 if(scached)
 {
  if(x0!=cx0 || x1!=cx1) sxcacheflush();
  else                   cy1=y;
 }

 if(!scached) 
 {
  cx0=x0;
  cx1=x1;
  cy0=cy1=y;
  scached++;
 }
}



static void sycacheflush(void)
{
 if(scached)
 {
  if(cx0==cx1)
  {
   bbc_move(cx0+blxpx,cy0+blypx);
   bbc_draw(cx0+blxpx,cy1+blypx);
  }
  else
  {
   bbc_rectanglefill(cx0+blxpx,cy0+blypx,(cx1-cx0),(cy1-cy0));
  }
 }
 scached=0;
}


static void scanliney(int x,int y0,int y1)
{
 if(scached)
 {
  if(y0!=cy0 || y1!=cy1) sycacheflush();
  else                   cx1=x;
 }

 if(!scached) 
 {
  cy0=y0;
  cy1=y1;
  cx0=cx1=x;
  scached++;
 }
}




static void bxliner(int x0,int x1,int y,int n)
{
 int i;

 if(bsboxn)
 {
  for(i=n;i<bsboxn;i++)
  {
   if(y<bsbox[i].box.y0 && y>bsbox[i].box.y1)
   {
    if((x0<bsbox[i].box.x0 && x1<bsbox[i].box.x0) ||
       (x0>bsbox[i].box.x1 && x1>bsbox[i].box.x1))
    {
     /* this line is outside clip box */


    }
    else
    if(x0<bsbox[i].box.x0 && x1>bsbox[i].box.x1)
    {
     bxliner(x0,bsbox[i].box.x0,y,i+1);
     bxliner(bsbox[i].box.x1,x1,y,i+1);
     break;
    }
    else
    if(x0<bsbox[i].box.x0)
    {
     bxliner(x0,bsbox[i].box.x0,y,i+1);
     break;
    }
    else
    if(x1>bsbox[i].box.x1)
    {
     bxliner(bsbox[i].box.x1,x1,y,i+1);
     break;
    }
    else 
    {
     /* line is completely inside clip box */

     break;
    }
   }
  }

  if(i>=bsboxn)
  {
   scanlinex(x0,x1,y);
  }
 }
 else
 {
  scanlinex(x0,x1,y);
 }
}



static void byliner(int x,int y0,int y1,int n)
{
 int i;

 if(bsboxn)
 {
  for(i=n;i<bsboxn;i++)
  {
   if(x>bsbox[i].box.x0 && x<bsbox[i].box.x1)
   {
    if((y0>bsbox[i].box.y0 && y1>bsbox[i].box.y0) ||
       (y0<bsbox[i].box.y1 && y1<bsbox[i].box.y1))
    {
     /* this line is outside clip box */


    }
    else
    if(y0>bsbox[i].box.y0 && y1<bsbox[i].box.y1)
    {
     byliner(x,y0,bsbox[i].box.y0,i+1);
     byliner(x,bsbox[i].box.y1,y1,i+1);
     break;
    }
    else
    if(y0>bsbox[i].box.y0)
    {
     byliner(x,y0,bsbox[i].box.y0,i+1);
     break;
    }
    else
    if(y1<bsbox[i].box.y1)
    {
     byliner(x,bsbox[i].box.y1,y1,i+1);
     break;
    }
    else 
    {
     /* line is completely inside clip box */

     break;
    }
   }
  }

  if(i>=bsboxn)
  {
   scanliney(x,y0,y1);
  }
 }
 else
 {
  scanliney(x,y0,y1);
 }
}





static void outputlines(int starty,int endy,int * bstartz,int * bendz)
{
 int y;

 switch(octant)
 {
  case 0:
         for(y=starty;y<endy;y++) 
         {
          if(bstartz[y]<bendz[y])
          {
// bxliner(bstartz[y]*cvdu.deltax+blx,(bendz[y]-1)*cvdu.deltax+blx,(y+bshift)*cvdu.deltay+bly,0);
           bxliner(bstartz[y],(bendz[y]-1),(y+bshift),0);
           bstartz[y]=bendz[y];
          }
          else sxcacheflush();
         }

         sxcacheflush();
         break;


  case 1:
         for(y=starty;y<endy;y++) 
         {
          if(bstartz[y]<bendz[y])
          {
// bxliner(-(bstartz[y]-bmaxx)*cvdu.deltax+blx,-(bendz[y]-1-bmaxx)*cvdu.deltax+blx,(y+bshift)*cvdu.deltay+bly,0);
           bxliner(-(bstartz[y]-bmaxx),-(bendz[y]-1-bmaxx),(y+bshift),0);
           bstartz[y]=bendz[y];
          }
          else sxcacheflush();
         }

         sxcacheflush();
         break;


  case 2:
         for(y=starty;y<endy;y++) 
         {
          if(bstartz[y]<bendz[y])
          {
 // byliner((y+bshift)*cvdu.deltax+blx,-(bstartz[y]-bmaxy)*cvdu.deltay+bly,-(bendz[y]-1-bmaxy)*cvdu.deltay+bly,0);
           byliner((y+bshift),-(bstartz[y]-bmaxy),-(bendz[y]-1-bmaxy),0);
           bstartz[y]=bendz[y];
          }
          else sycacheflush();
         }

         sycacheflush();
         break;

  case 3:
         for(y=starty;y<endy;y++) 
         {
          if(bstartz[y]<bendz[y])
          {
// byliner((y+bshift)*cvdu.deltax+blx,bstartz[y]*cvdu.deltay+bly,(bendz[y]-1)*cvdu.deltay+bly,0);
           byliner((y+bshift),bstartz[y],(bendz[y]-1),0);
           bstartz[y]=bendz[y];
          }
          else sycacheflush();
         }

         sycacheflush();
         break;

  case 4:
         for(y=starty;y<endy;y++) 
         {
          if(bstartz[y]<bendz[y])
          {
// bxliner(-(bstartz[y]-bmaxx)*cvdu.deltax+blx,-(bendz[y]-1-bmaxx)*cvdu.deltax+blx,(-(y-bmaxy)-bshift)*cvdu.deltay+bly,0);
           bxliner(-(bstartz[y]-bmaxx),-(bendz[y]-1-bmaxx),(-(y-bmaxy)-bshift),0);
           bstartz[y]=bendz[y];
          }
          else sxcacheflush();
         }

         sxcacheflush();
         break;


   case 5:
         for(y=starty;y<endy;y++) 
         {
          if(bstartz[y]<bendz[y])
          {
// bxliner(bstartz[y]*cvdu.deltax+blx,(bendz[y]-1)*cvdu.deltax+blx,(-(y-bmaxy)-bshift)*cvdu.deltay+bly,0);
           bxliner(bstartz[y],(bendz[y]-1),(-(y-bmaxy)-bshift),0);
           bstartz[y]=bendz[y];
          }
          else sxcacheflush();
         }

         sxcacheflush();
         break;

  case 6:
         for(y=starty;y<endy;y++) 
         {
          if(bstartz[y]<bendz[y])
          {
// byliner((-(y-bmaxx)-bshift)*cvdu.deltax+blx,bstartz[y]*cvdu.deltay+bly,(bendz[y]-1)*cvdu.deltay+bly,0);
           byliner((-(y-bmaxx)-bshift),bstartz[y],(bendz[y]-1),0);
           bstartz[y]=bendz[y];
          }
          else sycacheflush();
         }

         sycacheflush();
         break;

  case 7:
         for(y=starty;y<endy;y++) 
         {
          if(bstartz[y]<bendz[y])
          {
// byliner((-(y-bmaxx)-bshift)*cvdu.deltax+blx,-(bstartz[y]-bmaxy)*cvdu.deltay+bly,-(bendz[y]-1-bmaxy)*cvdu.deltay+bly,0);
           byliner((-(y-bmaxx)-bshift),-(bstartz[y]-bmaxy),-(bendz[y]-1-bmaxy),0);
           bstartz[y]=bendz[y];
          }
          else sycacheflush();
         }

         sycacheflush();
         break;
 }
}





/* set the start point, which must be greater than the current one */
/* set the blank lengths                                          */
/* blank out lines                                                */


static coordstr c[4];
static int blankdata;

os_error * blankline(viewredrawstr * v,aboxstr * box) 
{
 abox2coord(c,box);

 tr_transformset(c,4,&blanktran);
 blanktrset(c,4,v);

 outputliney(&c[cb],&c[cl],bstart,bstart,0);
 outputliney(&c[cl],&c[ct],bstart,bstart,0);

 outputliney(&c[cr],&c[ct],bstart,bend,0);
 outputliney(&c[cr],&c[cb],bstart,bend,0);

 blankdata=1;

 return(NULL);
}



static graphicssavestr saves;


static os_error * setcorner(void)
{
 if(!blankcorner)
 {
//  fontdefscale();				// go os units

  blxpx=blx;
  blypx=bly;

  gros2pix(&blxpx,&blypx);

//  fontpixelscale();

  grossave(&saves);
		grospixel();

  grpix2os(&blxpx,&blypx);

  blankcorner=1;
 }
 else
 {
  grossave(&saves);
		grospixel();

//  fontpixelscale();
 }

 return(NULL);
}


static os_error * unsetcorner(void)
{
	if(blankcorner)
	{
		grosload(&saves);
	}

	return(NULL);
}



os_error * doblank(void)
{
 int starty;
 int endy;


 if(blankdata)
 {
  setcorner();

  rsetgcol(blankcol,0); 

  starty=CUT((c[cb].y-bshift),0,bsize);
  endy  =CUT((c[ct].y-bshift),0,bsize);

  outputlines(starty,endy,bstart,bend);
  blankdata=0;

  unsetcorner();
 }

 return(NULL);
}



/* in abox y0=smallest y coord==top */
/* abox2coord 0+1==y0 2+3==y1       */
// here we have a line (abox) and sub area in it (sbox)

os_error * blanklinez(viewredrawstr * v,aboxstr * box,
                                        aboxstr * sbox,int paint) 
{
 int      i;
 coordstr c[4];
 coordstr d[4];
 int      sub0;
 int      sub1;
 int      starty;
 int      endy;
 int      size;


 abox2coord(c,box);

 tr_transformset(c,4,&blanktran);
 blanktrset(c,4,v);

 sub0=(box->x0!=sbox->x0);
 sub1=(box->x1!=sbox->x1);

 if(cl!=0 && cl!=3) SWOP(sub0,sub1);

 if(sub0 || sub1)
 {
  abox2coord(d,sbox);
  d[0].y-=30000;
  d[1].y-=30000;
  d[2].y+=30000;
  d[3].y+=30000;

  tr_transformset(d,4,&blanktran);
  blanktrset(d,4,v);
 }
 else
 {
  for(i=0;i<4;i++) d[i]=c[i];
 }


 outputliney(&c[cl],&c[ct],bstartz,bstartz,0);
 outputliney(&c[cb],&c[cl],bstartz,bstartz,0);

 outputliney(&c[cr],&c[cb],bstartz,bendz,1);
 outputliney(&c[ct],&c[cr],bstartz,bendz,1);


 if(sub0) {outputliney(&d[cb],&d[cl],bstartz,bendz,2);/*dprintf(8,"mode=2");*/}
 if(sub1) {outputliney(&d[ct],&d[cr],bstartz,bendz,3);/*dprintf(8,"mode=3");*/}


 if(paint)
 {
  setcorner();

  rseteorcol(WIMPWHITE,WIMPBLACK);

  if(c[cb].y<d[cb].y)
  {
   starty=CUT((c[cb].y-bshift),0,bsize);
   endy  =CUT((d[cb].y-bshift),0,bsize);
   size=endy-starty;
   if(size>0) XMEMCPYX(&bstartz[starty],&bendz[starty],size*sizeof(int));
  }

  starty=CUT((d[cb].y-bshift),0,bsize);
  endy  =CUT((d[ct].y-bshift),0,bsize);

  outputlines(starty,endy,bstartz,bendz);

  if(d[ct].y<=c[ct].y)
  {
   starty=CUT((d[ct].y-bshift),0,bsize);
   endy  =CUT((c[ct].y-bshift),0,bsize);
   size=endy-starty;
   if(size>0) XMEMCPYX(&bstartz[starty],&bendz[starty],size*sizeof(int));
  }

  unsetcorner();
 }
 else
 {
  starty=CUT((c[cb].y-bshift),0,bsize);
  endy  =CUT((c[ct].y-bshift),0,bsize);
  size=endy-starty;
  if(size>0) XMEMCPYX(&bstartz[starty],&bendz[starty],size*sizeof(int));
 }


 return(NULL);
}


os_error * blankend(void)
{
 os_error * err;

 err=NULL;

 if(bsboxn)
 {
  err=flex_free((flex_ptr)&bsbox);
  bsboxn=0;
 }

 if(blankmode & BLANKTEXT)
 {
  if(!err) err=flex_free((flex_ptr)&bstart);
  if(!err) err=flex_free((flex_ptr)&bend);
 }

 if(blankmode & BLANKZONE)
 {
  if(!err) err=flex_free((flex_ptr)&bstartz);
  if(!err) err=flex_free((flex_ptr)&bendz);
 }

 return(err);
}

