/*->c.dbsp */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "flex.h"
#include "transform.h"
#include "xprocess.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "bf.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "wimptext.h"
#include "dbhi.h"
#include "deb.h"


#include "obj.h"

#include "mhi.h"

#include "str.h"
#include "reslink.h"

#include "view.h"
#include "file.h"
#include "dbscale.h"

#include "spell.h"
#include "dbsped.h"

#include "dbsp.h"


typedef struct xdlinestr
{
 spdictstr spd;
 unsigned int       current:1;

} xdlinestr;


static xdlinestr * xdtable;
static int         xnames;
static int         xonames;

extern dboxstr dictionary[2];

static os_error * setpaneextent(int handle);


static int     selectedn;
static int     focusn;

static filestr * dfile;


/*****************************************************************************/


static os_error * dcmap2xdtable(filestr * file)
{
 os_error  * err;
 int         i;
 int         j;
 int         spellk;
 spellstr  * spellp;
 int         embedded;

 err=NULL;

 spellk=file->hdr.spell;

 spellp=(spellstr*)fob_find(spellk,file);

 embedded=0;

 for(i=0;i<spellp->nodc;i++)
 {
  if(spellp->spdict[i].embedded) embedded++;
 }

 xnames=xonames=totnames+embedded;

 err=flex_alloc((flex_ptr)&xdtable,sizeof(xdlinestr)*xnames);
 if(!err)
 {
  memset(xdtable,0,sizeof(xdlinestr)*xnames);

  for(j=0;j<totnames;j++)
  {
   strcpy(xdtable[j].spd.name,dtable[j].name);
   xdtable[j].spd.index=j;
  }

  spellp=(spellstr*)fob_find(spellk,file);

  for(i=0;i<spellp->nodc;i++)
  {
   if(spellp->spdict[i].embedded)
   {
    xdtable[j++].spd=spellp->spdict[i];
   }
   else
   {
    xdtable[spellp->spdict[i].index].current=1;
   }
  }

  /* take out duplicates/sort */

 }
 return(err);
}


static os_error * xdtable2dcmap(filestr * file)
{
 os_error * err;
 int        i;
 int        n;
 int        spellk;
 spellstr * spellp;

 err=NULL;

 n=0;

 for(i=0;i<xnames;i++)
 {
  if(xdtable[i].spd.embedded || xdtable[i].current) n++;
 }

 spellk=file->hdr.spell;

 err=fob_change(spellk,file,sizeof(spellstr)+n*sizeof(spdictstr),
                                                       (fobjptr)&spellp);
 if(!err)
 {
  spellp->nodc=n;

  n=0;

  for(i=0;i<xnames;i++)
  {
   if(xdtable[i].current || xdtable[i].spd.embedded)
   {
    spellp->spdict[n]=xdtable[i].spd;
    n++;
   }
  }
 }
 return(err);
}



os_error * dcaddload(int xnew,int addto,int browse,filestr * file)
{
 os_error * err;
 int        spellk;
 spellstr * spellp;
 int        n;

 err=NULL;

 spellk=file->hdr.spell;

 spellp=(spellstr*)fob_find(spellk,file);

 n=spellp->nodc;

 err=fob_change(spellk,file,sizeof(spellstr)+n*sizeof(spdictstr),
                                                    (fobjptr)&spellp);
 if(!err)
 {
  spellp->nodc=n+1;

  memset(&spellp->spdict[n],0,sizeof(spdictstr));
  strcpy(spellp->spdict[n].name,dtable[xnew].name);
  spellp->spdict[n].addto=addto;
  spellp->spdict[n].browse=browse;
  spellp->spdict[n].index=xnew;

  dtable[xnew].uses++;

/*  dprintf(5,"inc uses %d",new); */

  if(!dtable[xnew].loaded) err=loaddcn(xnew);
 }

 return(err);
}



/****************************************************************************/

static char tempname[DCNAMELEN+1];


/* create a new dictionary */

static os_error * newnameclose(int code)
{
 os_error * err;
 int        n;
 int        xnew;
 int        i;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  n=strlen(tempname)+1;
  if(n<=1 || n>=DCNAMELEN) err=geterror(ESP00);
  else
  {
   n=finddc(tempname);              /* also check embedded */
   if(n!=-1) err=geterror(ESP01);
   else
   {
    err=createdict(tempname,&xnew);
    if(!err)
    {
     for(i=0;i<xonames;i++)
     {
      if(!xdtable[i].spd.embedded && xdtable[i].spd.index>=xnew)
                                                      xdtable[i].spd.index++;
     }

     for(n=0;n<xnames;n++)
     {
      if(strcmp(xdtable[n].spd.name,tempname)>0) break;
     }

     err=flex_extend((flex_ptr)&xdtable,(xonames+1)*sizeof(xdlinestr));
     if(!err)
     {
      xnames++;
      xonames++;
      for(i=xonames-1;i>n;i--) 
      {
       xdtable[i]=xdtable[i-1];
      }

      memset(&xdtable[n],0,sizeof(xdlinestr));
      strcpy(xdtable[n].spd.name,dtable[xnew].name);
      xdtable[n].spd.index=xnew;

      selectedn=xnew;
      setpaneextent(dictionary[1].handle);
      reopenw(dictionary[1].handle);
      refreshwindow(dictionary[1].handle);
     }
    }
   }
  }
 }
 return(err);
}


static os_error * wrnewname(int value,char * string)
{
 strcpy(string,"");
 return(NULL);
 value=value;
}


/*

static os_error * wroldname(int value,char * string)
{
 strcpy(string,xdtable[selectedn].spd.name);
 return(NULL);
 value=value;
}

*/


static os_error * rdrenname(int * value,char * string)
{
 xzstrncpy(tempname,string,sizeof(tempname));
 return(NULL);
 value=value;
}



static dbiconstr newdicticondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0, NULL ,0,

    3, NULL,         DBWRITE,  0,   0,     -1, -1, -1,  -1,rdrenname,wrnewname,

   -1, NULL,         0,        0,   0,      0,  0,  0,  0,  0,      0
};



static dboxstr newdict=
{
 0,
 TCREATEDICT,
 DBFIX,
 0,
 newnameclose,
 NULL,
 NULL,
 NULL,
 newdicticondefs,
 0,
 0
};



static os_error * deldictionary(void)
{
 os_error * err;
 int        result;
 int        i;
 xdlinestr  temp;

 err=NULL;

 if(xnames>0 && selectedn>=0 && selectedn<xnames)
 {
  err=confirmparent(dictionary[0].handle,CONDC,&result,"{SP00}");
  if(!err)
  {
   if(result==1)
   {
    temp=xdtable[selectedn];

    xnames--;
   
    for(i=selectedn;i<xnames;i++)
    {
     xdtable[i]=xdtable[i+1];
    }

    xdtable[xnames]=temp;

    if(selectedn>0) selectedn--;
    setpaneextent(dictionary[1].handle);
    reopenw(dictionary[1].handle);
    refreshwindow(dictionary[1].handle);
   }
  }
 }

 return(err);
}




static os_error * scrapdcs(void)
{
 os_error * err;
 int        i;

 err=NULL;

 for(i=xnames;i<xonames;i++)
 {
  if(xdtable[i].spd.embedded)
  {
   err=fob_delete(xdtable[i].spd.index,dfile);
  }
  else
  {
   err=deletedict(xdtable[i].spd.index);
  }
  if(err) break;
 }

 return(err);
}


/***************************************************************************/
/* dictionary selector pane */

#define PANETOPMARGIN  8
#define PANESTEP       32
#define PANEHEIGHT     28
#define PANETEXTSHIFT  0
#define PANEBLOCKX     24
#define PANEBLOCKY     24
#define PANELEFTMARGIN 4
#define PANETEXT       10*16
#define PANEBLOCKSHIFT 8


static os_error * setpaneextent(int handle)
{
 os_error * err;
 windowstr  window;
 int        height;
 int        width;

 err=getw(handle,&window);
 if(!err)
 {
  width=window.x1-window.x0;
  height=MAX(window.y1-window.y0,PANETOPMARGIN+xnames*PANESTEP);
  err=extent(handle,0,-height,width,0);
 }
 return(err);
}


static os_error * paneredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error    * err;
 int           ox;
 int           oy;
 int           ylo;
 int           yhi;
 int           n;
 int           y;

 err=NULL;

	if(more)
	{
  wimpfontstart(0);

  while(more)
  {
   ox=redrawstr->box.x0-redrawstr->scx;
   oy=redrawstr->box.y1-redrawstr->scy;

   ylo=-(redrawstr->g.y1-oy);            /* small number, top of window */
   yhi=-(redrawstr->g.y0-oy);            /* bigger, bottom of window */

   n=(ylo-PANETOPMARGIN)/PANESTEP;
   if(n<0) n=0;
   y=n*PANESTEP+PANETOPMARGIN;

   while(y<=yhi && n<xnames)
   {
    wimp_setcolour(n==selectedn?WIMPBLACK:WIMPWHITE);
    bbc_rectanglefilli(ox+PANELEFTMARGIN,oy-y,
                         PANEBLOCKX+PANEBLOCKSHIFT+PANETEXT,-PANEHEIGHT);

    if(n==focusn)
    {
     wimp_setcolour(WIMPWHITE);
     wimp_setcolour(0xF0+WIMPBLACK);
     bbc_setstyle(1);
     bbc_rectanglei(ox+PANELEFTMARGIN,oy-y,PANEBLOCKX+PANEBLOCKSHIFT+PANETEXT,-PANEHEIGHT);
    }


    if(xdtable[n].current || 
       xdtable[n].spd.embedded || xdtable[n].spd.index==hpdcno)
    {
/*    stringat(ox+PANELEFTMARGIN+PANEBLOCKSHIFT,oy-y-PANETEXTSHIFT,
      tickstring,
      n==selectedn?(WIMPWHITE|(WIMPBLACK<<8)):(WIMPBLACK|(WIMPWHITE<<8)),
      PANEHEIGHT);  */
     tickat(ox+PANELEFTMARGIN+PANEBLOCKSHIFT,oy-y-PANETEXTSHIFT-wimpfontgetlead(),
       n==selectedn?(WIMPWHITE|(WIMPBLACK<<8)):(WIMPBLACK|(WIMPWHITE<<8)));
    }

    stringat(ox+PANELEFTMARGIN+PANEBLOCKX+PANEBLOCKSHIFT,oy-y-PANETEXTSHIFT,
             xdtable[n].spd.name,
             n==selectedn?(WIMPWHITE|(WIMPTRANS<<8)):(WIMPBLACK|(WIMPTRANS<<8)),
             PANEHEIGHT);

    y+=PANESTEP;
    n++;
   }

   wimp_get_rectangle(redrawstr,&more);
  }

  wimpfontend();
	}

 return(err);

 USE(handle);
}


static os_error * paneredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) paneredrawsub(handle,&redrawstr,more);
 return(err);
 userhandle=userhandle;
}


static void panerefreshline(int handle,int n)
{
 wimp_redrawstr r;
 int more;

 r.box.x0=PANELEFTMARGIN-cvdu.extrax;
 r.box.x1=r.box.x0+PANEBLOCKX+PANEBLOCKSHIFT+PANETEXT+2*cvdu.extrax;
 r.box.y1=-(n*PANESTEP+PANETOPMARGIN)+cvdu.extray;
 r.box.y0=r.box.y1-PANEHEIGHT-2*cvdu.extray;
 r.w=handle;

 wimp_update_wind(&r,&more);
 paneredrawsub(handle,&r,more);
}



static os_error * speditn(int n)
{
 if(xnames>0 && n>=0 && n<xnames)
 {
  if(xdtable[n].spd.embedded)
   return(editdictionary(xdtable[n].spd.name,-1,dictionary,
                                    xdtable[n].spd.index,dfile->domain));
  else
  return(editdictionary(xdtable[n].spd.name,xdtable[n].spd.index,dictionary,
                         dtable[xdtable[n].spd.index].dict,ddomain));
 }

 return(NULL);
}




static void paneopenline(int handle,int n)
{
 wimp_wstate wblock;
 int         top;
 int         bot;

 wimp_get_wind_state(handle,&wblock);

 top=-((n)*PANESTEP+PANETOPMARGIN);
 bot=-((n+1)*PANESTEP+PANETOPMARGIN);

 if(top>wblock.o.y) wblock.o.y=top;

 if(bot<(wblock.o.y-(wblock.o.box.y1-wblock.o.box.y0))) wblock.o.y=bot+(wblock.o.box.y1-wblock.o.box.y0);

// wblock.o.y=-(n+1)*(PANESTEP)+(PANESTEP>>1)+((wblock.o.box.y1-wblock.o.box.y0)>>1);


 wimp_open_wind(&wblock.o);
}





static void paneselectn(int handle,int n)
{
 int oldn;

 oldn=selectedn;
 selectedn=n;
 if(focusn>=0) focusn=selectedn;
 panerefreshline(handle,oldn);
 panerefreshline(handle,selectedn);
}



static os_error * panecaret(int handle,int userhandle,int gain)
{
 os_error * err;
 int        oldfocusn;

 err=NULL;

 if(gain)
 {
  focusn=selectedn;
  panerefreshline(handle,focusn);
 }
 else
 {
  oldfocusn=focusn;
  focusn=-1;
  panerefreshline(handle,oldfocusn);
 }

 return(err);

 USE(userhandle);
}

static os_error * panekey(int panehandle,int userhandle,int icon,int * key)
{
 int ch;
 int mainhandle;
 int n;
 int next;


 mainhandle=dictionary[0].handle;

 ch=*key;

 if(ch==CUP || ch==CDOWN)
 {
  n=focusn;
  n+=((*key==CDOWN)?1:-1);
  if(n<0) n=0;
  if(n>=xnames) n=xnames-1;

  if(n!=selectedn)
  {
   paneselectn(panehandle,n);
   paneopenline(panehandle,n);
  }
  *key=-1;
 }
 else
 if(ch==TAB || ch==SHFT_TAB)
 {
  findnexttabw(mainhandle,panehandle,ch==SHFT_TAB,&next);
  setfocusicon(mainhandle,next);
  *key=-1;
 }


 return(NULL);

 USE(userhandle);
 USE(icon);
}







static os_error * paneicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        n;
 windowstr  window;

 err=getw(handle,&window);
 if(!err)
 {
  n=((window.by-m->y)-PANETOPMARGIN)/PANESTEP;

  if(m->bbits==wimp_BLEFT)
  {
   paneselectn(handle,n);
   setfocus(handle);
  }
  else
  if(m->bbits==wimp_DOUBLELEFT)
  {
   err=speditn(n);
  }
 }
 return(err);

 USE(userhandle);
}



/***************************************************************************/

#define LOADIC 20
#define REMIC  4


static os_error * dictionaryicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
  case  LOADIC:  /* load */
  case  REMIC:   /* remove */
          if(xnames>0 && selectedn>=0 && selectedn<xnames)
          {
           if(!xdtable[selectedn].spd.embedded &&
               xdtable[selectedn].spd.index!=hpdcno)
           {
            xdtable[selectedn].current=(m->i==LOADIC);
            panerefreshline(dictionary[1].handle,selectedn);
           }
          }
          break;  

  case  5:  /* create */
          err=dodboxsp(&newdict,1,dictionary,&dbviewstack);
          break;

  case  3:  /* delete */
          err=deldictionary();
          break;

  case  6:  /* edit */
          err=speditn(selectedn);
          break;
 }

 return(err);

 USE(handle);
 USE(userhandle);
}




/* idea is that OK will now delete any deleted dictionaries */

static os_error * dictionaryclose(int code)
{
 os_error * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  remfiledc(dfile);
  err=xdtable2dcmap(dfile);
  addfiledc(dfile);
  scrapdcs();
  dccleanup();
  xonames=xnames;
 }
 else
 {
  dccleanup();
 }

 if(!err && code!=DBAPPLY)
 {
  flex_free((flex_ptr)&xdtable);
  remcaretevent(panecaret,dictionary[1].handle,0);
 }

 return(err);
}



static dbiconstr dictionaryicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};





static dboxstr dictionary[2]=
{
 0,
 TLOADDICT,
 DBFIX,
 0,
 dictionaryclose,
 dictionaryicon,
 NULL,
 NULL,
 dictionaryicondefs,
 0,
 0,
 0,NULL,
 0,
 0,

 0,
 TDICTPANE,
 DBPANE,
 0, //DBFITICON,
 NULL,
 paneicon,
 panekey,
 paneredraw,
 NULL,
 0,
 0,
 0,NULL,
 0,
 0, // 8               // icon to fit pane to

};



void dictionarybox(int fp)
{
 os_error * err;

 if(dfile==menufile && dictionary[0].handle)
 {
  err=dboxforward(dictionary);
 }
 else
 {
  if(dictionary[0].handle) dbclose(dictionary,DBCANCEL);

  dfile=menufile;

  selectedn=0;

  err=dcmap2xdtable(dfile);
  if(!err)
  {
   err=dodboxspparent(dictionary,2,dictionary,&dbviewstack,menuview->handle);
   wimp_setwindowbackground(dictionary[1].handle,CCRGB|PALWHITE);
   if(!err) err=setpaneextent(dictionary[1].handle);
   if(!err) err=setfocus(dictionary[1].handle);
   if(!err) err=addcaretevent(panecaret,dictionary[1].handle,0);
   if(!err) err=wimp_setwindowflags(dictionary[1].handle,WINDOWNOTDIALOGUE,0);
  }
 }

 zreport(err);

 USE(fp);
}

