/*->c.dbstyle */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <ctype.h>

#include "os.h"
#include "bbc.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "font.h"
#include "transform.h"
#include "etc.h"
#include "osunits.h"


#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "keylegacy.h"
#include "temp.h"
#include "redraw.h"
#include "colour.h"
#include "conf.h"
#include "bits.h"
#include "trans.h"
#include "xmath.h"
#include "wimptext.h"
#include "fsx.h"
#include "filetype.h"
#include "bf.h"
#include "timex.h"
#include "drag.h"
#include "deb.h"
#include "dbhi.h"





#include "dbdec.h"
#include "save.h"


#include "str.h"
#include "constants.h"

#include "object.h"

#include "mhi.h"
#include "reslink.h"
#include "units.h"
#include "xcolour.h"
#include "file.h"
#include "posn.h"
#include "xredraw.h"

#include "view.h"
#include "viewr.h"

#include "dbcolour.h"
#include "dbscale.h"


#include "txstr.h"
#include "tx.h"
#include "text.h"
#include "style.h"
#include "ustyle.h"
#include "tabs.h"
#include "fox.h"
#include "fx.h"
#include "act.h"
#include "styleif.h"
#include "fmap.h"
#include "codes.h"
#include "vl.h"
#include "vec.h"
#include "txds.h"
#include "txchoices.h"
#include "fontmenu.h"
#include "textunicode.h"

#include "dbtabs.h"
#include "dbul.h"

#include "dbstyle.h"



/*****************************************************************************/

static os_error * writeselected(void);
static os_error * updateselected(void);
static os_error * stylesetfont(int sfont);
static os_error * stylesetfont2(int font,int sub);
static os_error * stylegetfont(int * sfont);
static os_error * stylegetfont2(int * sfont);
static os_error * openstylesave(void);
static void setuserstylemenu(setuserstylemenuhandler xssmh,getuserstylemenuhandler xgsmh);


extern dboxstr        stylebox[2];
extern dboxstr        textfxbox;
extern dboxstr        formatbox;
extern dboxstr        formatfxbox;


static userstylebasestr * stylebase;

static userstylestr       cstyle;


#define CSNONE     0
#define CSUSERDBOX 1


static int            cstylemode;

static int selectedstylerank;
static int selectedstyleindex;
static int focusn;
static int selectedbody;


static viewstr * cview;
static filestr * cfile;

static int         rank;
static int         scope;
static int         menu;
static int         keypress;

static int         bold;       /* bit 0 value, bit 1 action, bit 2 chaged */
static int         italic;
static int         reverse;
static int         strikeout;
static int         smlcaps;

static int         xcase;
static int         actcase;
static int         changedcase;
static char   *    casestring[4]={"{FO06}","{FO07}","{FO08}","{FO08b}"};


static colourvalue fcolour;
static int         actfcolour;
static int         changedfcolour;

static colourvalue bcolour;
static int         actbcolour;
static int         changedbcolour;

static int         cfont;
static int         actfont;
static int         changedfont;


static int         size;
static int         actsize;
static int         changedsize;


static int         hscale;
static int         acthscale;
static int         changedhscale;

static int         kern;
static int         actkern;
static int         changedkern;

static int         baseshift;
static int         actbaseshift;
static int         changedbaseshift;



static int         actsuper;
static int         actsub;

static int         supersub;    /* 0==normal 1==super 2==sub */
static int         actsupersub; /* unique! in having change bit at 0x2 */

static int         hyphenation;

static int         underline;

static int         index;

static int         actcontents;              /* 3 state */

static int         layer;
static int         changedlayer;
static int         actlayer;


static int         rotate;
static int         actrotate;
static int         changedrotate;

static int         skew;
static int         actskew;
static int         changedskew;

static int         justification;

static int         changedtabs;


static colourvalue vrulecolour;
static colourvalue hrulecolour;

static int         rulevert;                 /* action buttons */
static int         rulehoriz;                /*                */

static int         ruleabove;
static int         ruleaboveshift;
static int         rulebelow;
static int         rulebelowshift;
static int         ruleleft;
static int         ruleleftshift;
static int         ruleright;
static int         rulerightshift;


static int         vrulethickness;
static int         hrulethickness;


static int         align;
static int         actalign;
static char   *    alignstring[4]={"{FO10}","{FO11}","{FO12}","{FO13}"};
static int         changedalign;


static int         leading;
static int         leadingtype;
static int         actleading;
static int         changedleading;

static int         before;
static int         actbefore;
static int         changedbefore;

static int         after;
static int         actafter;
static int         changedafter;

static int         leftshift;
static int         actleft;
static int         changedleft;
static int         lefttype;

static int         rightshift;
static int         actright;
static int         changedright;
static int         righttype;

static int         firstshift;
static int         actfirst;
static int         changedfirst;


static int         actbullet;              /* 3 state */

static int         dropno;
static int         actdrop;                /* 3 state */

static int         keeplines;
static int         actkeeplines;           /* 3 state */
static int         actkeeppara;            /* 3 state */
static int         actkeepnext;            /* 3 state */

static int         actautokern;            /* 3 state */

static int         actbaselock;            /* 3 state */




static void setchangebits(xstylestr * style)
{
 memset(&style->action,0,sizeof(actionbits));

 style->action.bold=bold>>2;
 style->action.italic=italic>>2;
 style->action.underline=underline>>2;
 style->action.reverse=reverse>>2;

 style->action.supersub=actsupersub>>1;

 style->action.strikeout=strikeout>>2;

 /* rules */

 style->action.font=changedfont;
 style->action.fcolour=changedfcolour;
 style->action.bcolour=changedbcolour;
 style->action.size=changedsize;
 style->action.hscale=changedhscale;
 style->action.track=changedkern;
 style->action.baseshift=changedbaseshift;
 style->action.align=changedalign;
 style->action.before=changedbefore;
 style->action.after=changedafter;
 style->action.leading=changedleading;
 style->action.left=changedleft;
 style->action.right=changedright;
 style->action.first=changedfirst;
 style->action.xcase=changedcase;
 style->action.drop=actdrop>>2;
 style->action.bullet=actbullet>>2;
 style->action.hyphenation=hyphenation>>2;
 style->action.akern=actautokern>>2;

 /* word wrap */

 style->action.index=index>>2;
 style->action.contents=actcontents>>2;
 style->action.layer=changedlayer;
 style->action.baselinelock=actbaselock>>2;
 style->action.smlcaps=smlcaps>>2;


 style->action.keeplines=actkeeplines>>2;
 style->action.keeppara=actkeeppara>>2;
 style->action.keepnext=actkeepnext>>2;

 /* language */

 style->action.tab=changedtabs;

 style->action.rotate=changedrotate;
 style->action.skew=changedskew;

 style->action.justification=justification>>2;
}


static void clrchangebits(void)
{
 bold&=~0x4;
 italic&=~0x4;
 underline&=~0x4;
 reverse&=~0x4;

 /* super sub */

 actsupersub&=~0x2;
 strikeout&=~0x4;

 /* rules */

 changedfont=0;
 changedfcolour=0;
 changedbcolour=0;
 changedsize=0;
 changedhscale=0;
 changedkern=0;
 changedbaseshift=0;
 changedalign=0;
 changedbefore=0;
 changedafter=0;
 changedleading=0;
 changedleft=0;
 changedright=0;
 changedfirst=0;
 changedcase=0;
 actdrop&=~0x4;
 actbullet&=~0x4;
 hyphenation&=~0x4;
 actautokern&=~0x4;

 /* word wrap */

 index&=~0x4;
 actcontents&=~0x4;
 changedlayer=0;
 actbaselock&=~0x4;
 smlcaps&=~0x4;

 actkeeplines&=~0x4;
 actkeeppara&=~0x4;
 actkeepnext&=~0x4;

 /* language */

 changedtabs=0;

 changedrotate=0;
 changedskew=0;

 justification&=~0x4;
}



static void format2style(xstylestr * style)
{
 style->data.align=align;
 style->action.align=actalign;
 style->data.leading=leading;
 style->data.leadingtype=leadingtype;
 style->action.leading=actleading;
 style->data.before=before;
 style->action.before=actbefore;
 style->data.after=after;
 style->action.after=actafter;

 style->data.firstshift=firstshift;
 style->action.first=actfirst;

 style->data.leftshift=leftshift;
 style->action.left=actleft;
 style->data.lefttype=lefttype;

 style->data.rightshift=rightshift;
 style->action.right=actright;
 style->data.righttype=righttype;

 style->data.bullet=actbullet;
 style->action.bullet=actbullet>>1;

 style->data.dropno=dropno;
 style->action.drop=actdrop>>1;
 style->data.drop=actdrop;

 style->data.hyphenation=hyphenation;
 style->action.hyphenation=hyphenation>>1;

 style->data.akern=actautokern;
 style->action.akern=actautokern>>1;

 style->data.baselinelock=actbaselock;
 style->action.baselinelock=actbaselock>>1;

 style->data.contents=actcontents;
 style->action.contents=actcontents>>1;

 style->data.layer=layer;
 style->action.layer=actlayer;

 style->data.keeplinesno=keeplines;
 style->data.keeplines=actkeeplines;
 style->action.keeplines=actkeeplines>>1;

 style->data.keeppara=actkeeppara;
 style->action.keeppara=actkeeppara>>1;

 style->data.keepnext=actkeepnext;
 style->action.keepnext=actkeepnext>>1;

 style->data.justification=justification;
 style->action.justification=justification>>1;
}


static void rule2style(xstylestr * style)
{
 style->data.vrulecolour=vrulecolour;
 style->data.hrulecolour=hrulecolour;

 style->action.rulevert=rulevert;
 style->action.rulehoriz=rulehoriz;

 style->data.ruleabove=ruleabove;
 style->data.ruleaboveshift=ruleaboveshift;
 style->data.rulebelow=rulebelow;
 style->data.rulebelowshift=rulebelowshift;
 style->data.ruleleft=ruleleft;
 style->data.ruleleftshift=(char)ruleleftshift;
 style->data.ruleright=ruleright;
 style->data.rulerightshift=rulerightshift;
}




static void text2style(xstylestr * style)
{
 style->data.bold=bold;
 style->action.bold=bold>>1;

 style->data.italic=italic;
 style->action.italic=italic>>1;

 style->data.reverse=reverse;
 style->action.reverse=reverse>>1;

 style->data.strikeout=strikeout;
 style->action.strikeout=strikeout>>1;

 style->data.underline=underline;
 style->action.underline=underline>>1;

 style->data.smlcaps=smlcaps;
 style->action.smlcaps=smlcaps>>1;


 style->data.font=fontuserfromstyle2(cfont,style->data.bold,style->data.italic);
 style->action.font=actfont;

 style->data.xcase=xcase;
 style->action.xcase=actcase;

 style->data.fcolour=fcolour;
 style->action.fcolour=actfcolour;

 style->data.bcolour=bcolour;
 style->action.bcolour=actbcolour;

 style->data.ypts=size;
 style->action.size=actsize;

 style->data.xpts=scale(size,hscale,0x10000);
 style->action.hscale=acthscale;

 style->data.track=writetrack(kern,style);
 style->action.track=actkern;

 style->data.baseshift=writetrackpc(baseshift,style);
 style->action.baseshift=actbaseshift;

 style->data.supersub=supersub;
 style->action.supersub=actsupersub;

 style->data.index=index;
 style->action.index=index>>1;



 style->data.rotate=(short int)rotate;
 style->action.rotate=actrotate;
 style->data.skew=(short int)skew;
 style->action.skew=actskew;
}


static void local2style(userstylestr * style)
{
 style->rank=rank;
 style->scope=scope;
 style->key=keylegacyfromcode(keypress);
 style->menu=!menu;
}



static void style2format(xstylestr * style)
{
 align=style->data.align;
 actalign=style->action.align;

 leading=style->data.leading;
 leadingtype=style->data.leadingtype;
 actleading=style->action.leading;

 before=style->data.before;
 actbefore=style->action.before;

 after=style->data.after;
 actafter=style->action.after;
 
 leftshift=style->data.leftshift;
 actleft=style->action.left;
 lefttype=style->data.lefttype;

 rightshift=style->data.rightshift;
 actright=style->action.right;
 righttype=style->data.righttype;

 firstshift=style->data.firstshift;
 actfirst=style->action.first;

 actbullet=style->data.bullet|(style->action.bullet<<1);

 dropno=style->data.dropno;
 actdrop=style->data.drop|(style->action.drop<<1);

 hyphenation=style->data.hyphenation|(style->action.hyphenation<<1);

 actautokern=style->data.akern|(style->action.akern<<1);

 actbaselock=style->data.baselinelock|(style->action.baselinelock<<1);

 actcontents=style->data.contents|(style->action.contents<<1);

 actlayer=style->action.layer;
 layer=style->data.layer;

 actkeeplines=style->data.keeplines|(style->action.keeplines<<1);
 keeplines=style->data.keeplinesno;

 actkeeppara=style->data.keeppara|(style->action.keeppara<<1);

 actkeepnext=style->data.keepnext|(style->action.keepnext<<1);

 justification=style->data.justification|(style->action.justification<<1);
}


static void style2rule(xstylestr * style) 
{
 vrulecolour=style->data.vrulecolour;
 hrulecolour=style->data.hrulecolour;

 rulevert=style->action.rulevert;
 rulehoriz=style->action.rulehoriz;

 ruleabove=style->data.ruleabove;
 ruleaboveshift=style->data.ruleaboveshift;
 rulebelow=style->data.rulebelow;
 rulebelowshift=style->data.rulebelowshift;
 ruleleft=style->data.ruleleft;
 ruleleftshift=style->data.ruleleftshift;
 ruleright=style->data.ruleright;
 rulerightshift=style->data.rulerightshift;

}



static void style2text(xstylestr * style)
{
 bold=style->data.bold|(style->action.bold<<1);
 italic=style->data.italic|(style->action.italic<<1);
 underline=style->data.underline|(style->action.underline<<1);
 reverse=style->data.reverse|(style->action.reverse<<1);
 strikeout=style->data.strikeout|(style->action.strikeout<<1);
 smlcaps=style->data.smlcaps|(style->action.smlcaps<<1);

 cfont=style->data.font;
 actfont=style->action.font;

 xcase=style->data.xcase;
 actcase=style->action.xcase;

 fcolour=style->data.fcolour;
 bcolour=style->data.bcolour;

 actfcolour=style->action.fcolour;
 actbcolour=style->action.bcolour;

 size=style->data.ypts;
 actsize=style->action.size;

 hscale=scale(0x10000,style->data.xpts,style->data.ypts);
 acthscale=style->action.hscale;

 actkern=style->action.track;
 kern=readtrack(style->data.track,style);

 actbaseshift=style->action.baseshift;
 baseshift=readtrackpc(style->data.baseshift,style);

 supersub=style->data.supersub;
 actsupersub=style->action.supersub;

 index=style->data.index|(style->action.index<<1);

 actrotate=style->action.rotate;
 rotate=style->data.rotate;
 actskew=style->action.skew;
 skew=style->data.skew;
}


static void style2local(userstylestr * style)
{
 rank=style->rank;
 scope=style->scope;
 keypress=keycodefromlegacy(style->key);
// cprintf("keypress =%d %d",keypress,style->key);
 menu=!style->menu;
}



static os_error * wrpts(int value,char * string)
{
 strcpy(string,unitstostring(value,POINTS));
 return(NULL);
}

static os_error * rdpts(int * value,char * string)
{
 return(stringtounits(string,value,POINTS));
}

static os_error * wrunits(int value,char * string)
{
 strcpy(string,unitstostring(value,cview->data.units));
 return(NULL);
}

static os_error * rdunits(int * value,char * string)
{
 return(stringtounits(string,value,cview->data.units));
}

/****************************************************************************/

/* text attributes/style dbox is closed */
#define TSNONE 0

/* text attributes/style dbox is open for a user style */
#define TSUSER 1

/* text attributes/style dbox is open from the main menu */
#define TSPEND 2

static int  textstylemode;





/****************************************************************************/
/* format */


#define SYMICON  16

#define CXFRONT  PALBLACK


static os_error * formatclose(int code)
{
 os_error * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  format2style(&cstyle.style);

  if(textstylemode==TSUSER)
  {
   updateselected();
   scope=SCOPEPARA;
   dbchangevalue(&scope,stylebox);
  }
  else
  if(textstylemode==TSPEND)
  {
   setchangebits(&cstyle.style);
   err=settextstyle(cfile,&cstyle.style,SCOPEPARA);
  }
 }

 if(code!=DBAPPLY && !err)
 {
  textstylemode=TSNONE;
 }

 return(err);
}



static void hpclose(xstylestr * style)
{
 style->data.hyphenation=cstyle.style.data.hyphenation;
 styleassignhyph(&cstyle.style,style);
 hyphenation|=0x4;
}


static void bulletclose(xstylestr * style)
{
 int handle;

 style->data.bullet=cstyle.style.data.bullet;
 styleassignbullet(&cstyle.style,style);

 actbullet|=0x4;

 if(textstylemode==TSUSER) handle=formatbox.handle;
 else                      handle=formatfxbox.handle;

 if(handle) wimp_set_icon_state(handle,SYMICON,
                                        (wimp_iconflags)0,(wimp_iconflags)0);
}


static void justclose(xstylestr * style)
{
 style->data.justification=cstyle.style.data.justification;
 styleassignjust(&cstyle.style,style);
 justification|=0x4;
}



static os_error * formatredrawsub(int handle,wimp_redrawstr * redrawstr,
                                                       int more,int paint)
{
 os_error    * err;
 userstylestr  s;
 int           fh;
 iconstr       icon;
 char          string[32];
 font_info     fi;
 int           ox;
 int           oy;
 int           xshift;
 int           yshift;
 int           n;
 int           bulletstyle;
 int           uni;
	int           code;
	int           osfont;


 err=NULL;

	if(more)
	{
  uni=txunicode;

  geti(handle,SYMICON,&icon);

		code=cstyle.style.data.bulletdata1+(cstyle.style.data.bulletdata2<<8);

  if(cstyle.style.data.bulletornumber)
  {
   memset(string,0,sizeof(string));

//   cprintf("bulletdata %d",code);

   if(uni)
   {
				if(code<256)
    {
     fontgetcode16(code,-1,(wchar_t*)string,NULL);
				}
				else
				{
					*((wchar_t*)string)=(wchar_t)code;
					*(((wchar_t*)string)+1)=0;
				}
   }
   else
   {
				if(code<256) fontgetcode8(code,-1,string,NULL);
   }
  }
  else
  {
   uni=0;
   wrbulletformat(code,string);
  }

  bulletstyle=cstyle.style.data.bulletstyle;
  if(bulletstyle==BULLETNOSTYLE) bulletstyle=BODYTEXT;

  while(more)
  {
   if(iconinredraw(redrawstr,&icon)) 
   {
    ox=redrawstr->box.x0-redrawstr->scx;
    oy=redrawstr->box.y1-redrawstr->scy;

    wimp_setoscolour(CCSYSBASE+COLOR_BTNFACE);
    bbc_rectanglefilli(ox+icon.ix0,oy+icon.iy0,icon.ix1-icon.ix0,icon.iy1-icon.iy0);

    if(paint)
    {
     if(textstylemode==TSUSER)
     {
      n=finduserstylebase(stylebase,bulletstyle);
      s=stylebase->userstyle[n];
     }
     else
     {
      finduserstyle(&s,bulletstyle,cfile);
     }

     osfont=fontosfromuser(s.style.data.font);

     err=font_find4(fontosname(osfont),fontcharset(osfont),0,fontitalic(osfont),
                      fontfamily(osfont),fontpitch(osfont),0,(12*cvdu.ydpi)/72,0,&fh);
					if(!err)
					{
      font_setcolour(fh,PALTRANSPARENT,CXFRONT,0);

      font_align(FA_BASELINE|FA_LEFT);

      if(uni) font_stringbbox16((wchar_t*)string,&fi);
      else    font_stringbbox(string,&fi);

      xshift=((icon.ix1-icon.ix0)-xpix2os(fi.maxx-fi.minx))/2;
      yshift=((icon.iy1-icon.iy0)-ypix2os(fi.maxy-fi.miny))/2;
      yshift+=ypix2os(fi.maxy);


      if(uni) font_paint16((wchar_t*)string,font_OSCOORDS,(ox+icon.ix0+xshift),(oy+icon.iy1-yshift));
      else    font_paint(string,font_OSCOORDS,(ox+icon.ix0+xshift),(oy+icon.iy1-yshift));
					}
    }
   }

   wimp_get_rectangle(redrawstr,&more);
  }
	}

 return(err);
}



static os_error * formatredrawsub1(int handle,int paint)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) formatredrawsub(handle,&redrawstr,more,paint);
 return(err);
}



static os_error * formatredraw(int handle,int userhandle)
{
 return(formatredrawsub1(handle,1));
 USE(userhandle);
}



static os_error * formatfxredraw(int handle,int userhandle)
{
 return(formatredrawsub1(handle,actbullet & 0x6));
 USE(userhandle);
}



static os_error * formaticon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
  case  8:
          err=openmenuparent("align_menu",handle);
          break;

  case 17:
          err=openbullet(cfile,&cstyle.style,bulletclose,
                (dboxstr*)userhandle,(textstylemode==TSUSER)?&stylebase:NULL);
          break;

  case 21:
          err=openhyphenation(cfile,&cstyle.style,
                                           hpclose,(dboxstr*)userhandle);
          break;

  case  9:
          err=openjustification(cview,&cstyle.style,
                                           justclose,(dboxstr*)userhandle);
          break;

 }

 return(err);

 USE(handle);
}



static os_error * rdleft(int * value,char * string)
{
 os_error * err;
 char     * p;
 int        c;

 p=string;

 lefttype=INDENTDELTA;

 while((c=*p++)!=0)
 {
  if(c=='+') 
  {
   lefttype=INDENTABS;
   break;
  }
  else
  if(isdigit(c)) break;
 }

 err=rdunits(&c,string);

 if(c<0) *value=0;
 else    *value=c;

 return(err);
}



static os_error * wrleft(int value,char * string)
{
 if(lefttype==INDENTABS) *string++='+';
 return(wrunits(value,string));
}



static os_error * rdfirst(int * value,char * string)
{
 return(rdunits(value,string));
}



static os_error * wrfirst(int value,char * string)
{
 return(wrunits(value,string));
}



static os_error * rdright(int * value,char * string)
{
 os_error * err;
 char     * p;
 int        c;

 p=string;

 righttype=INDENTDELTA;

 while((c=*p++)!=0)
 {
  if(c=='+') 
  {
   righttype=INDENTABS;
   break;
  }
  else
  if(c=='-')
  {
   righttype=INDENTOFFSET;
   break;
  }
  else
  if(isdigit(c)) break;
 }

 err=rdunits(&c,string);
 *value=ABS(c);
 return(err);
}



static os_error * wrright(int value,char * string)
{
 if(righttype==INDENTABS) *string++='+';
 else
 if(righttype==INDENTOFFSET) *string++='-';
 return(wrunits(value,string));
}



static os_error * rdbefore(int * value,char * string)
{
 return(rdunits(value,string));
}



static os_error * wrbefore(int value,char * string)
{
 return(wrpts(value,string));
}



static os_error * rdafter(int * value,char * string)
{
 return(rdunits(value,string));
}



static os_error * wrafter(int value,char * string)
{
 return(wrpts(value,string));
}



static os_error * wrlayer(int value,char * string)
{
 strcpy(string,numbertostring(value));
 return(NULL);
}



static os_error * rdlayer(int * value,char * string)
{
 os_error * err;

 err=stringtonumber(string,value);

 if(!err)
 {
  if((*value)<0 || (*value)>=MAXBLEVEL) err=geterror(ES03);
 }

 return(err);
}



static os_error * rddrop(int * value,char * string)
{
 os_error * err;
 int        n;

 err=stringtonumber(string,&n);
 if(!err)
 {
  *value=CUT(n,MINDROP,MAXDROP);
 }

 return(err);
}



static os_error * wrdrop(int value,char * string)
{
 strcpy(string,numbertostring(value));
 return(NULL);
}



static os_error * rdkeep(int * value,char * string)
{
 os_error * err;
 int        n;

 err=stringtonumber(string,&n);
 if(!err)
 {
  *value=CUT(n,MINKEEP,MAXKEEP);
 }

 return(err);
}


static os_error * wrkeep(int value,char * string)
{
 strcpy(string,numbertostring(value));
 return(NULL);
}






static os_error * wralign(int value,char * string)
{
 return(tsprintf(12,string,"%s",alignstring[value]));
}



static os_error * xwrleading(int value,int leadingtype,char * string)
{
 *string=0;

 switch(leadingtype)
 {
  case LEADABS:
               wrpts(value,string);
               break;

  case  LEADPC:
               strcpy(string,numbertostring(scale(value,100,0x10000)));
               string+=strlen(string);
               *string++='%';
               *string=0;
               break;

   case LEADDL:
               if(value>=0) *string++='+';
             /*  else         *string++='-'; */
               wrpts(value,string);
               break;
 }

 return(NULL);
}



static os_error * wrleading(int value,char * string)
{
 return(xwrleading(value,leadingtype,string));
}


static os_error * rdleading(int * value,char * string)
{
 os_error * err;
 int type;
 int i;
 int c;

 i=0;
 type=-1;


 while((c=string[i])!=0)
 {
  if(c=='+' || c=='-') type=LEADDL;
  else
  if(c=='%') type=LEADPC;
  i++;
 }
 if(type==-1) type=LEADABS;

 leadingtype=type;

 switch(type)
 {
   case LEADPC:
               err=readpc(value,string);
               if(*value<0) *value=0;
               return(err);
               break;

  case  LEADDL:
  case LEADABS:
               return(rdpts(value,string));
               break;
 }


 return(NULL);
}



static dbiconstr formaticondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

   28,  &leftshift,  DBWRITE,  0,   0,      9, -1,  3,  -1,  rdleft,wrleft,
    5,  &firstshift, DBWRITE,  0,   0,     -1, -1,  5,   1,  rdfirst,wrfirst,
   10,  &before,     DBWRITE,  0,   0,     -1, -1,  7,   3,  rdbefore,wrbefore,
   12,  &after,      DBWRITE,  0,   0,     -1, -1, 20,   5,  rdafter,wrafter,
   25,  &dropno,     DBWRITE,  0,   0,     -1, -1,  9,   7,  rddrop,wrdrop,

    3,  &rightshift, DBWRITE,  0,   0,     -1,  1, -1,  20,  rdright,wrright,

 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

    7,  &align,      DBTEXT,   0,   0,      0,  0,  0,   0,  NULL,wralign,
   14,  &leading,    DBTEXT,   0,   0,      0,  0,  0,   0,rdleading,wrleading,

   39,  &keeplines, DBWRITE,  0,   0,      -1, -1,  9,   7,  rdkeep,wrkeep,


 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,
   47, NULL,         DBACTION, 0,   0,      DBAPPLY,-1,0,0 ,NULL ,0,

 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */


 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   30,  &actleft,    DBTOGGLE, 2,    0,      1,  -1, 0, 0,   NULL,   0,
   31,  &actfirst,   DBTOGGLE, 2,    0,      1,  -1, 0, 0,   NULL,   0,
   34,  &actright,   DBTOGGLE, 2,    0,      1,  -1, 0, 0,   NULL,   0,

   32,  &actbefore,  DBTOGGLE, 2,    0,      1,  -1, 0, 0,   NULL,   0,
   36,  &actafter,   DBTOGGLE, 2,    0,      1,  -1, 0, 0,   NULL,   0,
   18,  &actdrop,    DBTRI,    1,    0,      1,  -1, 0, 0,   NULL,   0,

   35,  &actalign,   DBTOGGLE, 2,    0,      1,  -1, 0, 0,   NULL,   0,
   33,  &actleading, DBTOGGLE, 2,    0,      1,  -1, 0, 0,   NULL,   0,
   37,  &actbullet,  DBTRI,    1,    0,      1,  -1, 0, 0,   NULL,   0,

   20,  &hyphenation,DBTRI,    1,    0,      1,  F3, 0, 0,   NULL,   0,

   24,  &actkeeplines,DBTRI,   1,    0,      1,  F3, 0, 0,   NULL,   0,
   26,  &actkeeppara,DBTRI,    1,    0,      1,  F3, 0, 0,   NULL,   0,
   27,  &actkeepnext,DBTRI,    1,    0,      1,  F3, 0, 0,   NULL,   0,

   22,  &actautokern,DBTRI,    1,    0,      1,  F3, 0, 0,   NULL,   0,
   23,  &actbaselock,DBTRI,    1,    0,      1,  F3, 0, 0,   NULL,   0,

   38,  &actcontents,DBTRI,    1,    0,      1,  F2, 0, 0,   NULL,   0,

   19,  &layer,      DBWRITE,  0,    0,     -1, -1, -1, 18,  rdlayer,wrlayer,
   42,  &actlayer,   DBTOGGLE, 2,    0,      1, -1, 0, 0,    NULL,   0,

   40,  &justification,DBTRI,  1,    0,      1,  F3, 0, 0,   NULL,   0,

   -1, NULL,         0,        0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr formatbox=
{
 0,
 TFORMATSTYLE,
 DBFIX,
 0,
 formatclose,
 formaticon,
 NULL,
 formatredraw,
 formaticondefs,
 0,
 0,
 0,NULL,
 0,0,
};


static os_error * openformat(dboxstr * parent)
{
 os_error * err;

 /* watch out for recursive calls */

 style2format(&cstyle.style);

 err=dodboxsp(&formatbox,1,parent,&dbviewstack);

 dbshade(2,selectedbody?DBNOOFFG:0,&formatbox);
 dbshade(1,selectedbody?DBNONOG:0,&formatbox);

 textstylemode=TSUSER;


 return(err);
}


/****************************************************************************/
/* rules */

extern dboxstr rulebox;
static int     hrulemode;

static os_error * rulecolredrawsub(int handle,wimp_redrawstr * redrawstr,
                                                                     int more)
{
 os_error * err;

 err=NULL;

 while(more)
 {
  redrawblock(redrawstr,handle,11,vfindcolour2(NULL,cfile,&hrulecolour));
  redrawblock(redrawstr,handle,24,vfindcolour2(NULL,cfile,&vrulecolour));

  wimp_get_rectangle(redrawstr,&more);
 }
 return(err);

 USE(handle);
}

static os_error * ruleredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) rulecolredrawsub(handle,&redrawstr,more);
 return(err);
 USE(userhandle);
}


void setrulewidth(int fp)
{
 if(hrulemode)
 {
  hrulethickness=stack[fp];
  dbchangevalue(&hrulethickness,&rulebox);
 }
 else
 {
  vrulethickness=stack[fp];
  dbchangevalue(&vrulethickness,&rulebox);
 }
}


int getrulewidth(int fp)
{
 if(hrulemode)
 {
  return(hrulethickness);
 }
 else
 {
  return(vrulethickness);
 }
 USE(fp);
}


static os_error * openrulewidth(int mode,int handle)
{
 hrulemode=mode;
 return(openmenuparent("rulewidth_menu",handle));
}


static void hrulepickclose(colourvalue * colour)
{
 hrulecolour=*colour;
 wimp_set_icon_state(rulebox.handle,11,(wimp_iconflags)0,(wimp_iconflags)0);
}


static void vrulepickclose(colourvalue * colour)
{
 vrulecolour=*colour;
 wimp_set_icon_state(rulebox.handle,24,(wimp_iconflags)0,(wimp_iconflags)0);
}


static os_error * ruleclose(int code)
{
 os_error * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  rule2style(&cstyle.style);

  if(textstylemode==TSNONE) /* hence called from menu */
  {
   setchangebits(&cstyle.style);
   err=settextstyle(cfile,&cstyle.style,SCOPEPARA);
  }
 }

 return(err);
}


static os_error * ruleicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
  case 12:
          err=pickcolour(cfile,&hrulecolour,hrulepickclose,&rulebox);
          break;

  case 25:
          err=pickcolour(cfile,&vrulecolour,vrulepickclose,&rulebox);
          break;

  case  9:
          err=openrulewidth(1,handle);
          break;

  case 22:
          err=openrulewidth(0,handle);
          break;
 }

 return(err);

 USE(handle);
 USE(userhandle);
}


static os_error * wrvrt(int value,char * string)
{
 if(value) strcpy(string,unitstostring(value,POINTS));
 else      tsprintf(32,string,"{THIN}");
 return(NULL);
}

static os_error * wrhrt(int value,char * string)
{
 if(value) strcpy(string,unitstostring(value,POINTS));
 else      tsprintf(32,string,"{THIN}");
 return(NULL);
}

static os_error * wrrule(int value,char * string)
{
 strcpy(string,unitstostring(value,POINTS));
 return(NULL);
}

static os_error * rdrule(int * value,char * string)
{
 return(stringtounits(string,value,POINTS));
}


static dbiconstr ruleicondefs[15]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,

 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */


    0,&rulehoriz,    DBTOGGLE, 1,    0,      1,  -1, 0, 0,   NULL,   0,
   13,&rulevert,     DBTOGGLE, 1,    0,      1,  -1, 0, 0,   NULL,   0,

   26,&ruleabove,    DBTOGGLE, 0,    0,      1,  -1, 0, 0,   NULL,   0,
    4,&rulebelow,    DBTOGGLE, 0,    0,      1,  -1, 0, 0,   NULL,   0,
   14,&ruleleft,     DBTOGGLE, 0,    0,      1,  -1, 0, 0,   NULL,   0,
   17,&ruleright,    DBTOGGLE, 0,    0,      1,  -1, 0, 0,   NULL,   0,

    3,&ruleaboveshift,DBWRITE, 0,    0,     -1,  -1,-1,-1, rdrule,wrrule,
    6,&rulebelowshift,DBWRITE, 0,    0,     -1,  -1,-1,-1, rdrule,wrrule,
   16,&ruleleftshift, DBWRITE, 0,    0,     -1,  -1,-1,-1, rdrule,wrrule,
   19,&rulerightshift,DBWRITE, 0,    0,     -1,  -1,-1,-1, rdrule,wrrule,

    8,&hrulethickness,DBTEXT,  0,    0,      0,   0, 0, 0,   NULL,wrhrt,
   21,&vrulethickness,DBTEXT,  0,    0,      0,   0, 0, 0,   NULL,wrvrt,


 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   -1, NULL,         0,        0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr rulebox=
{
 0,
 TRULES,
 DBFIX,
 0,
 ruleclose,
 ruleicon,
 NULL,
 ruleredraw,
 ruleicondefs,
 0,
 0,
 0,NULL,
 0,0,
};


static os_error * openrulebox(dboxstr * parent)
{
 os_error * err;

 style2rule(&cstyle.style);
 err=dodboxsp(&rulebox,1,parent,&dbviewstack);

 textstylemode=TSUSER;

 dbshade(1,selectedbody?DBNOOFFG:0,&rulebox);

 return(err);
}


/****************************************************************************/
/* text attributes box */

extern dboxstr textstylebox;



static os_error * colredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error * err;

 err=NULL;

 while(more)
 {
  redrawblock(redrawstr,handle,10,vfindcolour2(NULL,cfile,&fcolour));
  redrawblock(redrawstr,handle,13,vfindcolour2(NULL,cfile,&bcolour));
  wimp_get_rectangle(redrawstr,&more);
 }
 return(err);

 USE(handle);
}


static os_error * textstyleredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) colredrawsub(handle,&redrawstr,more);
 return(err);
 USE(userhandle);
}



static void pickclosef(colourvalue * colourv)
{
 fcolour=*colourv;
 changedfcolour=1;

 if(textstylemode==TSNONE) /* hence called from menu */
 {
  text2style(&cstyle.style);
  setchangebits(&cstyle.style);
  zreport(settextstyle(cfile,&cstyle.style,SCOPECURR));
 }
 else
 if(textstylemode==TSPEND)
 {
  wimp_set_icon_state(textfxbox.handle,10,
                                       (wimp_iconflags)0,(wimp_iconflags)0);
 }
 else
 if(textstylemode==TSUSER)
 {
  wimp_set_icon_state(textstylebox.handle,10,
                                         (wimp_iconflags)0,(wimp_iconflags)0);
  if(!actfcolour)
  {
   actfcolour=1;
   dbchangevalue(&actfcolour,&textstylebox);
  }
 }
}



static void pickcloseb(colourvalue * colourv)
{
 bcolour=*colourv;
 changedbcolour=1;

 if(textstylemode==TSNONE) /* hence called from menu */
 {
  text2style(&cstyle.style);
  setchangebits(&cstyle.style);
  zreport(settextstyle(cfile,&cstyle.style,SCOPECURR));
 }
 else
 if(textstylemode==TSPEND)
 {
  wimp_set_icon_state(textfxbox.handle,13,(wimp_iconflags)0,(wimp_iconflags)0);
 }
 else
 if(textstylemode==TSUSER)
 {
  wimp_set_icon_state(textstylebox.handle,13,
                                          (wimp_iconflags)0,(wimp_iconflags)0);
  if(!actbcolour)
  {
   actbcolour=1;
   dbchangevalue(&actbcolour,&textstylebox);
  }
 }
}


static void ulclose(xstylestr * style)
{
 style->data.underline=cstyle.style.data.underline;
 styleassignuline(&cstyle.style,style);
 underline|=0x4|0x3;
 dbchangevalue(&underline,(textstylemode==TSPEND)?&textfxbox:&textstylebox);
}


static void stclose(xstylestr * style)
{
 style->data.strikeout=cstyle.style.data.strikeout;
 styleassignstrike(&cstyle.style,style);
 strikeout|=0x4|0x3;
 dbchangevalue(&strikeout,(textstylemode==TSPEND)?&textfxbox:&textstylebox);
}


static os_error * textstyleclose(int code)
{
 os_error * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  text2style(&cstyle.style);

  if(textstylemode==TSUSER)
  {
   updateselected();
  }
  else
  if(textstylemode==TSPEND)
  {
   setchangebits(&cstyle.style);
   err=settextstyle(cfile,&cstyle.style,SCOPECURR);
  }
 }
 
 if(code!=DBAPPLY && !err)
 {
  textstylemode=TSNONE;
 }

 return(err);
}


os_error * txopenfontmenu(viewstr * view)
{
 menuview=view;
 menufile=view->file;
 return(openfontmenu(stylesetfont,stylesetfont2,stylegetfont,stylegetfont2,view->handle));
}



static os_error * textstyleicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
  case 37:
          err=openfontmenu(stylesetfont,stylesetfont2,
                           stylegetfont,stylegetfont2,handle);
          break;

  case  5:
          err=openmenuparent("size_menu",handle);
          break;

  case  8:
          err=openmenuparent("case_menu",handle);
          break;

  case 11:
          err=pickcolour(cfile,&fcolour,pickclosef,(dboxstr*)userhandle);
          break;

  case 14:
          err=pickcolour(cfile,&bcolour,pickcloseb,(dboxstr*)userhandle);
          break;


  case 27: /* open under line */
          err=openulattributes(cfile,&cstyle.style,ulclose,
                                                   (dboxstr*)userhandle);
          break;

  case 29:
          err=openstattributes(cfile,&cstyle.style,stclose,
                                                   (dboxstr*)userhandle);
          break;

 }

 return(err);

 USE(handle);
}


static os_error * wrfname(int value,char * string)
{
 strcpy(string,fontlocalnamei(value));
 return(NULL);
}


static os_error * wrcase(int value,char * string)
{
 return(tsprintf(12,string,"%s",casestring[value]));
}


static os_error * wrhscale(int value,char * string)
{
 return(writepc(value,string));
 return(NULL);
}

static os_error * rdhscale(int * value,char * string)
{
 os_error * err;
 int        n;

 err=readpc(&n,string);

 *value=CUT(n,MINHSCALE,MAXHSCALE);

 return(err);
}


static os_error * wrkern(int value,char * string)
{
 strcpy(string,numbertostring(value));
 return(NULL);
}

static os_error * rdkern(int * value,char * string)
{
 os_error * err;
 int        n;

 err=stringtonumber(string,&n);
 *value=CUT(n,MINTRACK,MAXTRACK);

 return(err);
}

static os_error * wrbase(int value,char * string)
{
 return(writepc(value,string));
}

static os_error * rdbase(int * value,char * string)
{
 os_error * err;
 int        n;

 err=readpc(&n,string);
 *value=CUT(n,MINBASESHIFT,MAXBASESHIFT);

 return(err);
}



static os_error * wrangle(int value,char * string)
{
 return(writeangle(-(value*360),string));
}


static os_error * rdangle(int * value,char * string)
{
 os_error * err;
 int        angle;

 err=readangle(&angle,string);

 if(!err)
 {
  while(angle>(180*0x10000))  angle-=(360*0x10000);
  while(angle<(-180*0x10000)) angle+=(360*0x10000);

  *value=(-angle)/360;
 }

 return(err);
}


static os_error * wrskew(int value,char * string)
{
 return(writeangle(-value*360,string));
}


static os_error * rdskew(int * value,char * string)
{
 os_error * err;
 int        skew;

 err=readangle(&skew,string);

 if(!err)
 {
  skew=-skew;

  while(skew>(180*0x10000))  skew-=(360*0x10000);
  while(skew<(-180*0x10000)) skew+=(360*0x10000);

  skew=CUT(skew,MINSKEW,MAXSKEW);

  *value=skew/360;
 }

 return(err);
}


/******************************************************************************/
static void clicksupers(void)
{
 if(actsuper & 0x1)
 {
  actsub&=~0x1;
 }

 actsub&=~0x6;
 actsub|=(actsuper & 0x6);

 actsupersub=actsuper>>1;
 supersub=(actsuper & 0x1)|((actsub & 0x1)<<1);
}

static void clicksubs(void)
{
 if(actsub & 0x1)
 {
  actsuper&=~0x1;
 }

 actsuper&=~0x6;
 actsuper|=(actsub & 0x6);

 actsupersub=actsub>>1;
 supersub=(actsuper & 0x1)|((actsub & 0x1)<<1);
}


static os_error * clicksuper(int handle,int userhandle,wimp_mousestr * m)
{
 clicksupers();
 return(dbchangevalue(&actsub,&textstylebox));
 USE(handle);
 USE(userhandle);
 USE(m);
}

static os_error * clicksub(int handle,int userhandle,wimp_mousestr * m)
{
 clicksubs();
 return(dbchangevalue(&actsuper,&textstylebox));
 USE(handle);
 USE(userhandle);
 USE(m);
}



static void setupactss(void)
{
 actsuper=(supersub & 0x1)|(actsupersub<<1);
   actsub=((supersub & 0x2)>>1)|(actsupersub<<1);
}


/****************************************************************************/

static dbiconstr textstyleicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,
   53, NULL,         DBACTION, 0,   0,      DBAPPLY,-1,0,0 ,NULL ,0,

 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */

   36, &cfont,       DBTEXT,   0,   0,      0,  0,  0,   0,     NULL,wrfname,
    4, &size,        DBWRITE,  0,   0,      0,  0,  0,   0,     rdpts,wrpts,
    7, &xcase,       DBTEXT,   0,   0,      0,  0,  0,   0,     NULL,wrcase,
   16, &hscale,      DBWRITE,  0,   0,     -1, -1, 18,  -1,  rdhscale,wrhscale,
   19, &kern,        DBWRITE,  0,   0,     -1, -1, 21,  13,     rdkern,wrkern,
   20, &baseshift,   DBWRITE,  0,   0,     -1, -1, -1,  18,     rdbase,wrbase,

   22, &rotate,      DBWRITE,  0,   0,     -1, -1, -1,  18,    rdangle,wrangle,
   23, &skew,        DBWRITE,  0,   0,     -1, -1, -1,  18,    rdskew,wrskew,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   24,  &bold,       DBTRI,    2,    0,      1,  F1, 0, 0,   NULL,   0,
   25,  &italic,     DBTRI,    2,    0,      1,  F2, 0, 0,   NULL,   0,
   26,  &underline,  DBTRI,    2,    0,      1,  F3, 0, 0,   NULL,   0,
   28,  &strikeout,  DBTRI,    2,    0,      1,  F5, 0, 0,   NULL,   0,
   30,  &smlcaps,    DBTRI,    2,    0,      1,  F6, 0, 0,   NULL,   0,
   46,  &reverse,    DBTRI,    2,    0,      1,  F6, 0, 0,   NULL,   0,


   38,  &actfont,    DBTOGGLE, 1,    0,      1,  -1, 0, 0,   NULL,   0,
   39,  &actsize,    DBTOGGLE, 1,    0,      1,  -1, 0, 0,   NULL,   0,
   40,  &actcase,    DBTOGGLE, 1,    0,      1,  -1, 0, 0,   NULL,   0,
   41,  &actfcolour, DBTOGGLE, 1,    0,      1,  -1, 0, 0,   NULL,   0,
   42,  &actbcolour, DBTOGGLE, 1,    0,      1,  -1, 0, 0,   NULL,   0,
   43,  &acthscale,  DBTOGGLE, 1,    0,      1,  -1, 0, 0,   NULL,   0,
   44,  &actkern,    DBTOGGLE, 1,    0,      1,  -1, 0, 0,   NULL,   0,
   45,  &actbaseshift,DBTOGGLE,1,    0,      1,  -1, 0, 0,   NULL,   0,

   31,  &actsuper,   DBTRI,    2,    0,      1,  -1, 0, 0,
                                                        (dbreadfn)clicksuper,0,
   32,  &actsub,     DBTRI,    2,    0,      1,  -1, 0, 0,
                                                        (dbreadfn)clicksub,0,

   33,  &index,      DBTRI,    2,    0,      1,  F2, 0, 0,   NULL,   0,

   47,  &actrotate,  DBTOGGLE, 1,    0,      1,  -1, 0, 0,   NULL,   0,
   48,  &actskew,    DBTOGGLE, 1,    0,      1,  -1, 0, 0,   NULL,   0,


   -1, NULL,         0,        0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr textstylebox=
{
 0,
 TTEXTSTYLE,
 DBFIX,
 0,
 textstyleclose,
 textstyleicon,
 NULL,
 textstyleredraw,
 textstyleicondefs,
 0,
 0,
 0,NULL,
 0,0,
};


static os_error * opentextattributes(dboxstr * parent)
{
 os_error * err;

 style2text(&cstyle.style);
 setupactss();

 err=dodboxsp(&textstylebox,1,parent,&dbviewstack);

 textstylemode=TSUSER;

 dbshade(1,selectedbody?DBNOOFFG:0,&textstylebox);
 dbshade(2,selectedbody?DBNONOG:0,&textstylebox);

 return(err);
}


/***************************************************************************/
/* style pane */

#define PANETOPMARGIN  8
#define PANESTEP       32
#define PANEHEIGHT     28
#define PANETEXTSHIFT  0
#define PANELEFTMARGIN 4
#define PANETEXT       16*16



/* input the nth style in the window */
/* output index in stylebase         */

/* assert either styles all have rank 0 or have ordered rank values */

int styleindex(userstylebasestr * stylebase,int rank)
{
 int i;

 if(stylebase->userstyle[0].rank!=0)
 {
  for(i=0;i<stylebase->n;i++)
  {
   if((int)stylebase->userstyle[i].rank==(rank+1)) return(i);
  }
 }

 return(rank);
}



static int stylerank(userstylebasestr * stylebase,int index)
{
 if(stylebase->userstyle[0].rank!=0)
 {
  return(stylebase->userstyle[index].rank-1);
 }
 return(index);
}



static void styleremoverank(userstylebasestr * stylebase,int rank)
{
 int i;

 if(stylebase->userstyle[0].rank!=0)
 {
  for(i=0;i<stylebase->n;i++)
  {
   if(((int)stylebase->userstyle[i].rank-1)>=rank)
   {
    stylebase->userstyle[i].rank--;
   }
  }
 }
}




static void stylesetupranks(userstylebasestr * stylebase)
{
 int i;

 if(stylebase->userstyle[0].rank==0)
 {
  for(i=0;i<stylebase->n;i++)
  {
   stylebase->userstyle[i].rank=i+1;
  }
 }
}


static void stylesetrank(userstylebasestr * stylebase,int oldrank,int newrank)
{
 int i;

 oldrank++;
 newrank++;


 if(oldrank<newrank)
 {
  for(i=0;i<stylebase->n;i++)
  {
   if((int)stylebase->userstyle[i].rank>oldrank &&
      (int)stylebase->userstyle[i].rank<=newrank)
   {
    stylebase->userstyle[i].rank--;
   }
   else
   if((int)stylebase->userstyle[i].rank==oldrank) 
   {
    stylebase->userstyle[i].rank=newrank;
   }
  }
 }
 else
 if(oldrank>newrank)
 {
  for(i=0;i<stylebase->n;i++)
  {
   if((int)stylebase->userstyle[i].rank>=newrank &&
      (int)stylebase->userstyle[i].rank<oldrank)
   {
    stylebase->userstyle[i].rank++;
   }
   else
   if((int)stylebase->userstyle[i].rank==oldrank) 
   {
    stylebase->userstyle[i].rank=newrank;
   }
  }
 }
}



static os_error * setpaneextent(int handle)
{
 os_error * err;
 windowstr  window;
 int        height;
 int        width;

 err=getw(handle,&window);
 if(!err)
 {
  width=window.x1-window.x0;
  height=MAX(window.y1-window.y0,PANETOPMARGIN+stylebase->n*PANESTEP);
  err=extent(handle,0,-height,width,0);
 }
 return(err);
}



/* n is a rank */

static os_error * paneopenat(int n,int handle)
{
 os_error * err;
 windowstr  window;

 err=getw(handle,&window);

 openatscroll(handle,0,-(PANETOPMARGIN+n*PANESTEP)+(window.y1-window.y0)/2);

 return(err);
}



static os_error * paneopenline(int handle,int n)
{
 wimp_wstate wblock;
 int         top;
 int         bot;

 wimp_get_wind_state(handle,&wblock);

 top=-((n)*PANESTEP+PANETOPMARGIN);
 bot=-((n+1)*PANESTEP+PANETOPMARGIN);

 if(top>wblock.o.y) wblock.o.y=top;

 if(bot<(wblock.o.y-(wblock.o.box.y1-wblock.o.box.y0))) wblock.o.y=bot+(wblock.o.box.y1-wblock.o.box.y0);

// wblock.o.y=-(n+1)*(PANESTEP)+(PANESTEP>>1)+((wblock.o.box.y1-wblock.o.box.y0)>>1);


 return(wimp_open_wind(&wblock.o));
}





static os_error * paneredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error * err;
 int        ox;
 int        oy;
 int        ylo;
 int        yhi;
 int        n;
 int        y;
 err=NULL;

	if(more)
	{

  wimpfontstart(0);

  while(more)
  {
   ox=redrawstr->box.x0-redrawstr->scx;
   oy=redrawstr->box.y1-redrawstr->scy;

   ylo=-(redrawstr->g.y1-oy);            /* small number, top of window */
   yhi=-(redrawstr->g.y0-oy);            /* bigger, bottom of window */


//  cprintf("height %d",redrawstr->g.y1-redrawstr->g.y0);

   n=(ylo-PANETOPMARGIN)/PANESTEP;
   if(n<0) n=0;
   y=n*PANESTEP+PANETOPMARGIN;

   while(y<=yhi && n<stylebase->n)
   {
    wimp_setcolour(n==selectedstylerank?WIMPBLACK:WIMPWHITE);
    bbc_rectanglefilli(ox+PANELEFTMARGIN,oy-y,PANETEXT,-PANEHEIGHT);

    if(n==focusn)
    {
     wimp_setcolour(WIMPWHITE);
     wimp_setcolour(0xF0+WIMPBLACK);
     bbc_setstyle(1);
     bbc_rectanglei(ox+PANELEFTMARGIN,oy-y,PANETEXT,-PANEHEIGHT);
    }

    stringat(ox+PANELEFTMARGIN,oy-y-PANETEXTSHIFT,
             stylebase->userstyle[styleindex(stylebase,n)].name,
             n==selectedstylerank?(WIMPWHITE|(WIMPTRANS<<8)):(WIMPBLACK|(WIMPTRANS<<8)),
             PANEHEIGHT);

    y+=PANESTEP;
    n++;
   }
   wimp_get_rectangle(redrawstr,&more);
  }

  wimpfontend();
	}

 return(err);

 USE(handle);
}


static os_error * paneredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) paneredrawsub(handle,&redrawstr,more);
 return(err);
 userhandle=userhandle;
}


static void panerefreshline(int handle,int n)
{
 wimp_redrawstr r;
 int more;

 r.box.x0=PANELEFTMARGIN-cvdu.extrax;
 r.box.x1=r.box.x0+PANETEXT+3*cvdu.extrax;
 r.box.y1=-(n*PANESTEP+PANETOPMARGIN)+cvdu.extray;
 r.box.y0=r.box.y1-PANEHEIGHT-2*cvdu.extray;
 r.w=handle;

 wimp_update_wind(&r,&more);
 paneredrawsub(handle,&r,more);
}


/* n is an index */

static void setpanevalues(int n)
{
 cstyle=stylebase->userstyle[n];
 style2local(&cstyle);
 duptabruler(cfile,cstyle.style.data.tab);
 selectedbody=(stylebase->userstyle[n].style.n==BODYTEXT);
}


static void readpanevalues(void)
{
 int oldtab;
 int oldfont;
 int mfont;

 local2style(&cstyle);
 oldtab=stylebase->userstyle[selectedstyleindex].style.data.tab;
 oldfont=stylebase->userstyle[selectedstyleindex].style.data.mfont;

 checkuserstyle(&cstyle,cfile);

 fmapadd(cfile,cstyle.style.data.font,1,&mfont);
 cstyle.style.data.mfont=mfont;

 fmaprem(cfile,oldfont,1);
 stylebase->userstyle[selectedstyleindex]=cstyle;

 duptabruler(cfile,cstyle.style.data.tab);
 remtabruler(cfile,oldtab);
}


static void clearpanevalues(void)
{
 local2style(&cstyle);
 remtabruler(cfile,cstyle.style.data.tab);
}



static os_error * setupmainstyle(void)
{
 return(shadeiconst(stylebox[0].handle,12,selectedbody));
// return(shadeiconst(stylebox[0].handle,3,selectedbody));
}



/* n is an index */

static os_error * newselectedn(int n)
{
 os_error * err;

 clearpanevalues();
 setpanevalues(n);
 writeselected();
 err=dbchangevalue(&keypress,stylebox);
 dbchangevalue(&menu,stylebox);
 dbchangevalue(&keypress,stylebox);
 dbchangevalue(&scope,stylebox);

 setupmainstyle();

 return(err);
}




static os_error * autoscrollwindow(int handle,int dx,int dy)
{
 os_error   * err;
 windowstr    window;
 mousestr     mouse;
 int          shiftx;
 int          shifty;

          err=getw(handle,&window);
 if(!err) err=getpointer(&mouse);

 if(!err)
 {
  shiftx=shifty=0;

  if(mouse.y>=(window.y1-dy)) shifty=MAX(dy,mouse.y-(window.y1-dy));
  if(mouse.y<=(window.y0+dy)) shifty=-MAX(dy,(window.y0+dy)-mouse.y);


  if(shiftx || shifty)
  {
   openatscroll(handle,window.scx+shiftx/2,window.scy+shifty/2);
  }
 }

 return(err);

 USE(dx);
}


#define MINTIME 8

static void panedragzero(int handle)
{
 autoscrollwindow(handle,0,PANESTEP);
 addscheduledevent(panedragzero,handle,MINTIME);
}



static os_error * panedragend(int handle,int userhandle,wimp_box * box)
{
 os_error   * err;
 windowstr    window;
 mousestr     mouse;
 int          n;

 remscheduledevent(panedragzero,handle);
 setfocus(stylebox[0].handle);

          err=getw(handle,&window);
 if(!err) err=getpointer(&mouse);
 if(!err)
 {
  n=((window.by-mouse.y)-PANETOPMARGIN)/PANESTEP;
  if(n>=0 && n<stylebase->n && n!=selectedstylerank)
  {
   stylesetupranks(stylebase);

   stylesetrank(stylebase,selectedstylerank,n);
   selectedstylerank=n;
   rank=n+1;

   refreshwindow(handle);
   paneopenat(selectedstylerank,handle);
  }
 }

 return(err);

 USE(handle);
 USE(userhandle);
 USE(box);
}




static os_error * panecaret(int handle,int userhandle,int gain)
{
 os_error * err;
 int        oldfocusn;

 err=NULL;


 if(gain)
 {
  focusn=selectedstylerank;
  panerefreshline(handle,focusn);
 }
 else
 {
  oldfocusn=focusn;
  focusn=-1;
  panerefreshline(handle,oldfocusn);
 }


 return(err);

 USE(userhandle);
}



static os_error * paneselectn(int panehandle,int n)
{
 os_error * err;
 int        oldn;
 int        oldfocusn;

 oldfocusn=focusn;
 focusn=-1;
 readpanevalues();
 oldn=selectedstylerank;
 selectedstylerank=n;
 selectedstyleindex=styleindex(stylebase,selectedstylerank);
 if(oldfocusn>=0) focusn=selectedstylerank;
 panerefreshline(panehandle,oldn);
 panerefreshline(panehandle,selectedstylerank);
 err=newselectedn(selectedstyleindex);
 setfocus(panehandle);

 return(err);
}



static os_error * stylepanekeypress(int panehandle,int userhandle,int icon,int * key)
{
 int ch;
 int n;
 int next;
 int mainhandle;


 ch=*key;
 mainhandle=stylebox[0].handle;

 if(ch==CLEFT || ch==CRIGHT || ch==CTRL_CLEFT || ch==CTRL_CRIGHT ||
                               ch==SHFT_CLEFT || ch==SHFT_CRIGHT)
 {
  *key=-1;  // feel likely to attach these keys by accident when pane has focus
 }
 else
 if(ch==HOME)
 {
  n=0;
  if(n!=selectedstylerank)
  {
   paneselectn(panehandle,n);
   paneopenline(panehandle,n);
  }
  *key=-1;
 }
 else
 if(ch==COPY)
 {
  n=stylebase->n-1;
  if(n!=selectedstylerank)
  {
   paneselectn(panehandle,n);
   paneopenline(panehandle,n);
  }
  *key=-1;
 }
 else
 if(ch==CUP || ch==CDOWN || ch==PAGEUP || ch==PAGEDOWN)
 {
  n=focusn;
  n+=((ch==CDOWN || ch==PAGEDOWN)?1:-1);
  if(n<0) n=0;
  if(n>=stylebase->n) n=stylebase->n-1;

  if(n!=selectedstylerank)
  {
   paneselectn(panehandle,n);
   paneopenline(panehandle,n);
  }
  *key=-1;
 }
 else
 if(ch==TAB || ch==SHFT_TAB)
 {
  findnexttabw(mainhandle,panehandle,ch==SHFT_TAB,&next);
  setfocusicon(mainhandle,next);
  *key=-1;
 }
 else
 if(ch==ESCPRESS)
 {
  if(getdraghandle()==panehandle)
  {
   dragstop();
   remscheduledevent(panedragzero,panehandle);
   *key=-1;
  }
		else
		{


		}
 }
 else
 if(ch>=' ' && ch<256) // move to next entry that starts with ch
 {
  n=focusn;
  do
  {
   n++;
   if(n>=stylebase->n) n=0;
   if(toupper(*stylebase->userstyle[styleindex(stylebase,n)].name)==toupper(ch)) break;
  } while(n!=focusn);

  if(n!=focusn)
  {
   paneselectn(panehandle,n);
   paneopenline(panehandle,n);
   *key=-1;
  }
 }


 return(NULL);

 USE(icon);
 USE(userhandle);
}





static os_error * stylepaneicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error   * err;
 int          n;
 windowstr    window;
 wimp_dragstr dblock;
 int          dlshift;
 int          dhshift;


 err=getw(handle,&window);
 if(!err)
 {
  if(m->bbits==0x2)
  {
   err=openstylesave();
  }
  else
  {
   n=((window.by-m->y)-PANETOPMARGIN)/PANESTEP;

   if(m->bbits==0x4)
   {
    if((n!=selectedstylerank || n!=focusn) && n<stylebase->n && n>=0)
    {
     paneselectn(handle,n);
    }
   }
   else
   if(m->bbits==0x40)
   {
    dblock.window=handle;
    dblock.type=wimp_USER_FIXED;

    dblock.box.x0=window.bx+PANELEFTMARGIN;
    dblock.box.x1=dblock.box.x0+PANETEXT;

    dblock.box.y1=window.by-PANETOPMARGIN-PANESTEP*selectedstylerank;
    dblock.box.y0=dblock.box.y1-PANEHEIGHT;

    dlshift=m->x-dblock.box.x0;
    dhshift=dblock.box.x1-m->x;

    dblock.parent.x0=window.bx+PANELEFTMARGIN;
    dblock.parent.y1=window.y1;
    dblock.parent.x1=dblock.parent.x0+PANETEXT;
    dblock.parent.y0=window.y0;

    startdrag(handle,0,panedragend);
    wimp_drag_box(&dblock);
    addscheduledevent(panedragzero,handle,MINTIME);
//    setfocus(handle);
   }
  }
 }

 return(err);

 USE(userhandle);
}













/****************************************************************************/

static char tempstylename[STYLENAMELEN+1];

static int findstylename(char * name)
{
 int i;

 for(i=0;i<stylebase->n;i++)
  if(!cstrcmp(name,stylebase->userstyle[i].name)) break;

 if(i>=stylebase->n) return(-1);
 else                return(i);
}


static os_error * rdrenname(int * value,char * string)
{
 xzstrncpy(tempstylename,string,sizeof(tempstylename));
 return(NULL);
 value=value;
}

static os_error * renameclose(int code)
{
 os_error * err;
 int        n;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  n=strlen(tempstylename)+1;
  if(n==1 || n>=STYLENAMELEN) err=geterror(ES00);
  else
  {
   n=findstylename(tempstylename);
   if(n!=-1 && n!=selectedstyleindex) err=geterror(ES01);
   else
   {
    xzstrncpy(stylebase->userstyle[selectedstyleindex].name,tempstylename,NITEM(stylebase->userstyle[selectedstyleindex].name));
    xzstrncpy(cstyle.name,tempstylename,NITEM(cstyle.name));

    panerefreshline(stylebox[1].handle,selectedstylerank);
   }
  }
 }
 return(err);
}

/* create a new style */

extern dboxstr newstyle;

static int newbasestyle;
static int newapply;


static os_error * newnameclose(int code)
{
 os_error * err;
 int        n;
 int        seq;
 int        newbasestylen;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  n=strlen(tempstylename)+1;
  if(n==1 || n>=STYLENAMELEN) err=geterror(ES00);
  else
  {
   n=findstylename(tempstylename);
   if(n!=-1) err=geterror(ES01);
   else
   {
    err=createstyle(&stylebase);
    if(!err)
    {
     readpanevalues();
     n=stylebase->n-1;
     seq=stylebase->userstyle[n].style.n;

     /* nb overwriting the new style number here */

     if(!newapply) newbasestyle=BODYTEXT;

     newbasestylen=finduserstylebase(stylebase,newbasestyle);
     stylebase->userstyle[n]=stylebase->userstyle[newbasestylen];

     if(newbasestyle==BODYTEXT)
     {
      stylebase->userstyle[n].nodelete=0;
   /*   styleclrall(&stylebase->userstyle[n].style); */
     }

     if(!newapply) styleclrall(&stylebase->userstyle[n].style);
 
     stylebase->userstyle[n].key=-1;  /* don't copy key press */

     /* so restore it now */
     stylebase->userstyle[n].style.n=seq;

     if(stylebase->userstyle[0].rank!=0)
     {
      stylebase->userstyle[n].rank=n+1;
     }

     xzstrncpy(stylebase->userstyle[n].name,tempstylename,NITEM(stylebase->userstyle[n].name));
     duptabruler(cfile,stylebase->userstyle[n].style.data.tab);
     fmapdup(cfile,stylebase->userstyle[n].style.data.mfont);
     selectedstyleindex=selectedstylerank=n;
     newselectedn(selectedstyleindex);
     setpaneextent(stylebox[1].handle);
     refreshwindow(stylebox[1].handle);
     paneopenat(n,stylebox[1].handle);
    }
   }
  }
 }

 if(code!=DBAPPLY)
 {
  textstylemode=TSNONE;
 }

 return(err);
}



static os_error * wrnewname(int value,char * string)
{
 strcpy(string,"");
 return(NULL);
 value=value;
}


static os_error * wroldname(int value,char * string)
{
 int newbasestylen;
 newbasestylen=finduserstylebase(stylebase,value);
 strcpy(string,stylebase->userstyle[newbasestylen].name);

 return(NULL);
}



static os_error * setbasestyle(int style)
{
 newbasestyle=style;
// dbchangevalue(&newbasestyle,&newstyle);
 return(NULL);
}


static os_error * getbasestyle(int * style)
{
 *style=newbasestyle;
 return(NULL);
}


static os_error * newstyleicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

// if(m->i==4) err=openuserstylemenu(setbasestyle,getbasestyle,handle);

 return(err);

 USE(handle);
 USE(userhandle);
	USE(m);
}


static os_error * newcombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

	setuserstylemenu(setbasestyle,getbasestyle);

 err=menucombo(&newstyle,3,"userstyle_menu",event,data,hit,userp);
																																																																																					 
	return(err);

	USE(datap);

	return(NULL);
}


static os_error * newmode(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

	err=dbshade(1,!newapply,&newstyle);

 return(err);
 USE(handle);
 USE(userhandle);
 USE(m);
}



static dbiconstr newstyleicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0, NULL ,0,

//    3, &newbasestyle,DBTEXT,   0,   0,      0,  0,  0,   0,     NULL,wroldname,
    3, &newbasestyle,DBCOMBO,   1,   DBCOMBOSTATIC,0,  0,  0,   0,     NULL,(dbwritefn)newcombo,
    5, NULL,         DBWRITE,  0,   0,     -1, -1, -1,  -1,rdrenname,wrnewname,

    7, &newapply,    DBTOGGLE, 0,    0,     1,  -1, 0, 0,        (dbreadfn)newmode, 0,

   -1, NULL,         0,        0,   0,      0,  0,  0,  0,  0,      0
};



static dboxstr newstyle=
{
 0,
 TNEWSTYLE,
 DBFIX,
 0,
 newnameclose,
 newstyleicon,
 NULL,
 NULL,
 newstyleicondefs,
 0,
 0,
 0,NULL,
 0,0,
};



static dbiconstr renstyleicondefs[5]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0, NULL ,0,

    3, NULL,         DBWRITE,  0,   0,     -1, -1, -1,  -1,rdrenname,wrnewname,
    4, &newbasestyle,DBTEXT,   0,   0,      0,  0,  0,   0,    NULL,wroldname,

   -1, NULL,         0,        0,   0,      0,  0,  0,  0,  0,      0
};



static dboxstr renstyle=
{
 0,
 TRENAMESTYLE,
 DBFIX,
 0,
 renameclose,
 NULL,
 NULL,
 NULL,
 renstyleicondefs,
 0,
 0,
 0,NULL,
 0,0,
};



static os_error * delstyle(void)
{
 os_error * err;
 int        result=0;


 if(stylebase->userstyle[selectedstyleindex].nodelete) err=geterror(ES02);
 else err=confirmparent(stylebox[0].handle,CONDC,&result,"{STYLE00}");

 if(!err)
 {
  if(result==1)
  {
   err=deletestyle(cfile,&stylebase,selectedstyleindex);
   if(!err)
   {
    styleremoverank(stylebase,selectedstylerank);
    if(selectedstylerank>0) selectedstylerank--;
    selectedstyleindex=styleindex(stylebase,selectedstylerank);
    newselectedn(selectedstyleindex);
    setpaneextent(stylebox[1].handle);
    refreshwindow(stylebox[1].handle);
    paneopenat(selectedstylerank,stylebox[1].handle);
   }
  }
 }

 return(err);
}


/****************************************************************************/

static int local2string(char * string);




static int xlen;

static void xprintf(char *string,char * format, ...)
{
 va_list args;
 char    tformat[128];

 if(xlen) 
 {
  string+=xlen;
  *string++=' ';
  *string++='+';
  *string++=NBSPACE;
  xlen+=3;
 }

 xzstrncpy(tformat,format,sizeof(tformat));
 trans(tformat,sizeof(tformat));

 va_start(args,format);
 xlen+=vsprintf(string,tformat,args);
 va_end(args);
}






/* save styles as text */
                  
static os_error * savestyletext(char * name,int type)
{
 os_error    * err;
 buffer        bf;
 char          string[1024];
 userstylestr  tstyle;
 int           i;
 int           units;

 err=bf_open(name,'w',DEFBUFFSIZE,&bf);
 if(!err)
 {
  readpanevalues();

  tstyle=cstyle;

  for(i=0;i<stylebase->n;i++)
  {
   cstyle=stylebase->userstyle[styleindex(stylebase,i)];

   tsprintf(sizeof(string),string,"{FO38} %s\r\n",cstyle.name);
   bf_printf(&bf,string);

   local2string(string);

   units=cview->data.units;

   if(cstyle.style.action.first) xprintf(string,"{FO41} %s",
                          unitstostring(cstyle.style.data.firstshift,units));
   if(cstyle.style.action.left)  xprintf(string,"{FO39} %s",
                          unitstostring(cstyle.style.data.leftshift,units));
   if(cstyle.style.action.right) xprintf(string,"{FO40} %s",
                          unitstostring(cstyle.style.data.rightshift,units));

   bf_write(&bf,string,xlen);

   if(cstyle.style.action.tab)
   {
    tsprintf(sizeof(string),string,"\r\n{FO37}\r\n");		// FO37 == Tabruler is also output further back
    bf_printf(&bf,string);
    tabsavetext(&bf,&cstyle.style.data,cview);
   }

   bf_printf(&bf,"\r\n\r\n");
  }

  cstyle=tstyle;

  bf_closec(&bf,err,name,type);
 }

 return(err);
}


#ifdef NEVER
static os_error * savestyleint(mousestr * m,char * name,int type)
{
 return(NULL);
 USE(m);
 USE(name);
 USE(type);
}

#endif


static os_error * openstylesave(void)
{
 os_error * err;
 TCHAR      name[FILENAMELEN];

 xzstrncpyu(name,TEXT("TextFile"),NITEM(name));
 err=opensaveparent(name,NITEM(name),TEXTFILE,savestyletext,stylebox[0].handle);

 return(err);
}




/****************************************************************************/






typedef struct xsourcestr
{
 int  key;
 int  type;
 int  len;
 int  maxlen;
 int  goffset;
 int  spare;
 char stuff[32];
} xsourcestr;


static xsourcestr sample=
{
 0,       /* key     */
 OSOURCE, /* type    */
 20,      /* len     */
 20,      /* maxlen  */
 0,       /* goffset */
 0,       /* spare   */
 "{QTX}"
};



static int rulerfonthandle;

static os_error * rulerfontstart(void)
{
 os_error * err;

          err=font_find("Arial",0,6*16,0,0,&rulerfonthandle);
 if(!err) err=font_setcolour(rulerfonthandle,PALTRANSPARENT,PALBLACK,0);
 if(!err) err=font_align(FA_LEFT|FA_BASELINE);

 return(err);
}


static void rulerfontend(void)
{
 if(rulerfonthandle)
 {
  font_lose(rulerfonthandle);
  rulerfonthandle=0;
 }
}



static void summaryformat(char * string,char * q[],int * kp,int width)
{
 char        * p;
 int           k;
 int           len;
 font_string   fs;


 len=local2string(string);
 p=string;
 k=0;

// width*=400;

 while(len>0 && k<5) 
 {
  fs.s=p;
  fs.x=xos2pix(width);
  fs.y=0x7FFFFFFF;
  fs.term=len;
  fs.split=NBSPACE;

  font_strwidth(&fs);

  p[fs.term]=0;
  q[k++]=p;
  p+=fs.term+1;
  len-=fs.term+1;
 }

 *kp=k;
}


#define SUMBORDER 8

static void summaryprint(char * q[],int k,int ox,int oy,iconstr * icon)
{
 int          i;
 int          h;
 int          x;
 int          y;
 font_metric  fm;

 font_getmetric(&fm);

// h=icon->iy1-icon->iy0-2*SUMBORDER;
// h/=5;

 x=icon->ix0+ox;
 y=icon->iy1+oy-ypix2os(fm.descent+fm.extleading);
 h=ypix2os(fm.height+fm.extleading);

 for(i=0;i<k;i++)
 {
  font_paint(q[i],font_ABS|font_OSCOORDS,x,y);
  y-=h;
 }
}



#define SAMPLEICON 20
#define SUMMARYICON 4


static os_error *styleredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error * err;
 int        ox;
 int        oy;
 iconstr    icon0;
 iconstr    icon4;
 wimp_box   box;
 wimp_box   scrapbox;
 void     * cliphandle;
 fxrendstr  fxr;
 int        visible;
 char       string[1024];
 char     * q[5];
 int        k=0;
 int        first;
 int        bcol;
 int        temp;

	err=NULL;

	if(more)
	{
  first=1;

  err=geti(handle,SAMPLEICON,&icon0);
      geti(handle,SUMMARYICON,&icon4);

  memset(&fxr,0,sizeof(fxrendstr));

  fxr.vec.textsrc.sourcep=(sourcestr*)&sample;
  fxr.vec.textsrc.offset=0;
  fxr.len=sample.len;
  fxr.dobullet=0;

/*
 fxr.vec.astyle=0;
 fxr.width=0;
 fxr.hpend=0;
*/

  bcol=PALWHITE;

  if(cstyle.style.action.reverse && cstyle.style.data.reverse) 
  {
   if(cstyle.style.action.fcolour)
   {
    temp=vfindcolour2(NULL,cfile,&cstyle.style.data.fcolour);
    if(temp!=-1) bcol=temp;
   }
  }
  else
  {
   if(cstyle.style.action.bcolour)
   {
    temp=vfindcolour2(NULL,cfile,&cstyle.style.data.bcolour);
    if(temp!=-1) bcol=temp;
   }
  }

  fxr.backcol.data.tint.key=KEYTRANS;
  fxr.backcol.data.tint.tint=0x10000;
  fxr.backcol.data.tint.overprint=0;

  while(more)
  {
   startredraw();

   ox=redrawstr->box.x0-redrawstr->scx;
   oy=redrawstr->box.y1-redrawstr->scy;

   if(iconinredraw(redrawstr,&icon0))
   {
    box.x0=icon0.ix0+ox;
    box.x1=icon0.ix1+ox;
    box.y0=icon0.iy0+oy;
    box.y1=icon0.iy1+oy;

    setclipwindow(redrawstr,&box,&scrapbox,&cliphandle,&visible);
    if(visible)
    {
     rsetgcol(bcol,0);
     bbc_rectanglefilli(box.x0,box.y0,icon0.ix1-icon0.ix0,icon0.iy1-icon0.iy0);

     fxsample(cfile,&box,&fxr,&cstyle.style);

     resetclipwindow(redrawstr,&scrapbox,cliphandle);
    }
   }

   if(iconinredraw(redrawstr,&icon4))
   {
    rulerfontstart();


    if(first)
    {
     summaryformat(string,q,&k,icon4.ix1-icon4.ix0-2*SUMBORDER);
     first=0;
    }

    summaryprint(q,k,ox+SUMBORDER,oy-SUMBORDER,&icon4);

    rulerfontend();
   }

   wimp_get_rectangle(redrawstr,&more);
  }
	}

 return(err);
}


static os_error * styleredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;

 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) styleredrawsub(handle,&redrawstr,more);

 return(err);
 USE(userhandle);
}





static void style2tabs(dbtabstr * dtabs)
{
 strncpy(dtabs->leader,cstyle.style.data.leaderchar,LEADERLEN);

 dtabs->left=cstyle.style.data.leftshift;

 if(cstyle.style.data.righttype==INDENTOFFSET) 
             dtabs->right=/*dtabs->left+*/cstyle.style.data.rightshift;
 else        dtabs->right=dtabs->parawidth-cstyle.style.data.rightshift;

 dtabs->first=cstyle.style.data.firstshift+dtabs->left;

 if(cstyle.style.data.rulehoriz && cstyle.style.data.ruleleft) 
                       dtabs->lrule=cstyle.style.data.ruleleftshift;
 else                  dtabs->lrule=-1;

 if(cstyle.style.data.rulehoriz && cstyle.style.data.ruleright)
                       dtabs->rrule=cstyle.style.data.rulerightshift;
 else                  dtabs->rrule=-1;
}



static void tabs2style(dbtabstr * dtabs)
{
 int left;
 int right;
 int first;
 int chleader;

 left=dtabs->left;
 first=dtabs->first-dtabs->left;

 if(cstyle.style.data.righttype==INDENTOFFSET) right=dtabs->right/*-left*/;
 else                                    right=dtabs->parawidth-dtabs->right;

 changedleft=(cstyle.style.data.leftshift!=left);
 changedright=(cstyle.style.data.rightshift!=right);
 changedfirst=(cstyle.style.data.firstshift!=first);

 cstyle.style.data.leftshift=left;
 cstyle.style.data.firstshift=first;
 cstyle.style.data.rightshift=right;

 changedtabs=(cstyle.style.data.tab!=(unsigned int)dtabs->newtab);

 chleader=strncmp(cstyle.style.data.leaderchar,dtabs->leader,LEADERLEN);
 if(chleader)
 {
  strncpy(cstyle.style.data.leaderchar,dtabs->leader,LEADERLEN);
  /* nb leader width has not been updated */
  changedtabs=1;
 }

 cstyle.style.data.tab=dtabs->newtab;
}




static os_error * styleclosetabs(dbtabstr * dtabs,int code)
{
 tabs2style(dtabs);

 cstyle.style.action.left|=changedleft;
 cstyle.style.action.right|=changedright;
 cstyle.style.action.first|=changedfirst;
 cstyle.style.action.tab=dtabs->apply;
 remtabruler(cfile,dtabs->oldtab);
 writeselected();
 scope=SCOPEPARA;
 dbchangevalue(&scope,stylebox);
 return(NULL);

 USE(code);
}



static os_error * stylegetatabs(dbtabstr * ctabs)
{
 os_error      * err;
 vector          s;
 vlstr         * vline;
 int             xpo;
 int             ypo;
 coordstr        cx;
 int             gwidth;
 int             cwidth;


 if(zone) s=*lozon;
 else     s=act;

 err=txlock(&s.textsrc,s.file);
 if(!err)
 {
  settosopx(&s);

  vline=vlptr(s.textsrc.vsourcep,s.textsrc.voffset);

  ctabs->parawidth=cwidth=txcolwidth(s.textsrc.textp,s.textsrc.u,&gwidth);

  cx.x =s.textsrc.textp->fcurve.box.x;
  cx.y =s.textsrc.textp->fcurve.box.y+LY(vline->line.yy);

  tr_transformset(&cx,1,&s.textsrc.textp->data.transform);


  if(!s.textsrc.textp->data.changei)
  {
   if(s.textsrc.s==0) cx.x+=s.textsrc.textp->data.i;

   if(s.textsrc.textp->data.columns==1 || s.textsrc.u>0)
   {
    ctabs->parawidth-=2*s.textsrc.textp->data.i;
   }
   else
   {
    if(s.textsrc.s==0 || s.textsrc.s==((int)s.textsrc.textp->data.columns-1))
                             ctabs->parawidth-=s.textsrc.textp->data.i;
   }
  }

  if(s.textsrc.u==0 && s.textsrc.s>0)
  {
   cx.x+=(cwidth+gwidth)*s.textsrc.s;
  }


#ifdef NEVER

 absstylestr * astyle;
 int           shift;


  findabsstylep(s.file,vline->style,&astyle);

  if(astyle->style.data.lefttype==INDENTABS)
  {
   cx.x+=s.textsrc.s*(ctabs->parawidth+gwidth);
  }
  else
  {
   shift=vline->x-astyle->style.data.leftshift;
   if(!s.textsrc.voffset) shift-=astyle->style.data.firstshift;
   else
   {
    vline=vlptr(s.textsrc.vsourcep,s.textsrc.voffset-sizeof(vlstr));
    if(vline->eol==ISNL) shift-=astyle->style.data.firstshift;
   }
   cx.x+=shift;
   ctabs->parawidth-=shift;
  }

#endif


  getpagecoords(cview,s.page,s.section,&xpo,&ypo);

  ctabs->parax=cx.x+xpo;
  ctabs->paray=cx.y+ypo;

  txunlock(&s.textsrc,s.file);
 }

 return(err);
}


static os_error * styleopentabs(dboxstr * parent)
{
 os_error * err;
 dbtabstr   ctabs;

 memset(&ctabs,0,sizeof(dbtabstr));

 if(act.valid && act.file==cfile)
 {
  err=stylegetatabs(&ctabs);
 }
 else
 {
  ctabs.parax=0;
  ctabs.paray=0;
  ctabs.parawidth=MAX(cfile->hdr.maxpagewidth[DOC],cfile->hdr.maxpagewidth[MST]);
 }

 style2tabs(&ctabs);
 ctabs.oldtab=cstyle.style.data.tab;
 ctabs.apply=cstyle.style.action.tab;
 ctabs.lock=selectedbody;

 return(opentabs(&ctabs,styleclosetabs,parent,cview,cfile));
}



static os_error * styleicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        chandle;
 int        cicon;

 err=NULL;

 switch(m->i)
 {
//  case  3:
//          err=openmenuparent("scope_menu",handle);
//          break;

  case  6:
          err=opentextattributes(stylebox);
          break;

  case  7:
          err=openformat(stylebox);
          break;

  case  8:      /* tabs */
          err=styleopentabs(stylebox);
          break;

  case  9:
          err=openrulebox(stylebox);
          break;

  case 15:
          newbasestyle=stylebase->userstyle[selectedstyleindex].style.n;
          newapply=0;
          err=dodboxsp(&newstyle,1,stylebox,&dbviewstack);
										if(!err)	err=dbshade(1,!newapply,&newstyle);
          textstylemode=TSUSER;
          break;

  case 14:
          newbasestyle=stylebase->userstyle[selectedstyleindex].style.n;
          err=dodboxsp(&renstyle,1,stylebox,&dbviewstack);
          break;

  case 13:
          err=delstyle();
          break;


  case 21:
          err=openstylesave();
          break;

  default:
          findcaret(&chandle,&cicon);
          if(chandle!=stylebox[0].handle)
          {
           setfocus(stylebox[0].handle);
          }
          break;

 }

 return(err);

 USE(handle);
 USE(userhandle);
}


static os_error * wrkey(int value,char * string)
{
 if(value>=0)
  strcpy(string,keystringcanonical(keycode2canonical(keypress)));
 else
  *string=0;
 return(NULL);
}


static char * scopestring[]={
                             "{SC00}",
                             "{SC01}",
                             "{SC02}",
                             "{SC03}",
                             "{SC04}"
                            };


static os_error * wrscope(int value,char * string)
{
 if(value>sizeof(scopestring)/sizeof(char*)) 
                          value=sizeof(scopestring)/sizeof(char*);
 return(tsprintf(12,string,"%s",scopestring[value]));
}





static char * substring[3]={"","{FO03}","{FO04}"};


/* takes the menu vars and translates them to a string */
/* font translate menu vars to string */

static int local2string(char * string) 
{
 char temp[64];

 xlen=0;

 /* font name */
                                                                            
 if(cstyle.style.action.font) 
                  xprintf(string,fontusername(cstyle.style.data.font));

 /* font size */

 if(cstyle.style.action.size)
                 xprintf(string,unitstostring(cstyle.style.data.ypts,POINTS));

 /* case */

 if(cstyle.style.action.xcase && cstyle.style.data.xcase)
                        xprintf(string,casestring[cstyle.style.data.xcase]);


 /* foreground colour */

 if(cstyle.style.action.fcolour)
 {
  findcolourname(cfile,&cstyle.style.data.fcolour,temp);
  xprintf(string,"%s {FO35}",temp);
 }

 /* background colour */

 if(cstyle.style.action.bcolour)
 {
  findcolourname(cfile,&cstyle.style.data.bcolour,temp);
  xprintf(string,"%s {FO36}",temp);
 }

 /* H. scale */

 if(cstyle.style.action.hscale) xprintf(string,"{FO17} %d",
                        (100*cstyle.style.data.xpts)/cstyle.style.data.ypts);

 /* Kern */

 if(cstyle.style.action.track && cstyle.style.data.track)
 { 
  wrkern(readtrack(cstyle.style.data.track,&cstyle.style),temp);
  xprintf(string,"{FO18} %s",temp);
 }

 /* Base line */

 if(cstyle.style.action.baseshift && cstyle.style.data.baseshift)
 {
  wrbase(readtrackpc(cstyle.style.data.baseshift,&cstyle.style),temp);
  xprintf(string,"{FO19} %s",temp);
 }

 /* rotate */

 if(cstyle.style.action.rotate && cstyle.style.data.rotate)
 {
  wrangle(cstyle.style.data.rotate,temp);
  xprintf(string,"{FO30} %s",temp);
 }

 /* skew */

 if(cstyle.style.action.skew && cstyle.style.data.skew)
 {
  wrangle(-cstyle.style.data.skew,temp);
  xprintf(string,"{FO31} %s",temp);
 }



 /* font style bits */

 if(cstyle.style.action.bold && 
    cstyle.style.data.bold)       xprintf(string,"{FO00}");

 if(cstyle.style.action.italic && 
    cstyle.style.data.italic)   xprintf(string,"{FO01}");

 /* underline */

 if(cstyle.style.action.underline && 
    cstyle.style.data.underline) xprintf(string,"{FO02}");

 /* super/sub */

 if(cstyle.style.action.supersub && cstyle.style.data.supersub) 
                        xprintf(string,substring[cstyle.style.data.supersub]);

 /* strikeout */

 if(cstyle.style.action.strikeout && 
    cstyle.style.data.strikeout) xprintf(string,"{FO14}");

 /* small caps */

 if(cstyle.style.action.smlcaps && 
    cstyle.style.data.smlcaps) xprintf(string,"{FO09}");


 /* reverse */

 if(cstyle.style.action.reverse && 
    cstyle.style.data.reverse) xprintf(string,"{FO05}");


 /* align */
 if(cstyle.style.action.align && cstyle.style.data.align)
                         xprintf(string,alignstring[cstyle.style.data.align]);


 /* space before */

 if(cstyle.style.action.before) 
 {
  wrpts(cstyle.style.data.before,temp);
  xprintf(string,"{FO20} %s",temp);
 }

 /* space after */

 if(cstyle.style.action.after) 
 {
  wrpts(cstyle.style.data.after,temp);
  xprintf(string,"{FO21} %s",temp); 
 }

 /* leading */

 if(cstyle.style.action.leading) 
 {
  xwrleading(cstyle.style.data.leading,cstyle.style.data.leadingtype,temp);
  xprintf(string,"{FO22} %s",temp);
 }

 /* layer */

 if(cstyle.style.action.layer && cstyle.style.data.layer) 
                         xprintf(string,"{FO32} %d",cstyle.style.data.layer);

 /* drop cap */

 if(cstyle.style.action.drop && cstyle.style.data.drop) 
             xprintf(string,"{FO25} %d",cstyle.style.data.dropno);

 /* auto kern */

 if(cstyle.style.action.akern && cstyle.style.data.akern) 
                                                 xprintf(string,"{FO23}");

 /* lock to grid */

 if(cstyle.style.action.baselinelock && cstyle.style.data.baselinelock) 
                                                 xprintf(string,"{FO27}");


 /* bullet */

 if(cstyle.style.action.bullet && cstyle.style.data.bullet) 
                                            xprintf(string,"{FO34}");


 /* hyphenation */

 if(cstyle.style.action.hyphenation && cstyle.style.data.hyphenation) 
                                                 xprintf(string,"{FO24}");

 /* justification */

 if(cstyle.style.action.justification && cstyle.style.data.justification) 
                                            xprintf(string,"{FO33}");


 if(cstyle.style.action.tab) xprintf(string,"{FO37}");


 /* index */

 if(cstyle.style.action.index && 
    cstyle.style.data.index) xprintf(string,"{FO15}");

 /* contents */

 if(cstyle.style.action.contents && 
    cstyle.style.data.contents) xprintf(string,"{FO16}");
  

 /* keep with next */

 if(cstyle.style.action.keepnext && cstyle.style.data.keepnext) 
                                                 xprintf(string,"{FO26}");


 /* page break before */

 if(cstyle.style.action.keeppara && cstyle.style.data.keeppara) 
                                                 xprintf(string,"{FO28}");

 /* keep lines together */

 if(cstyle.style.action.keeplines && cstyle.style.data.keeplines) 
             xprintf(string,"{FO29} %d",cstyle.style.data.keeplinesno);


 return(xlen);
}



/* write the menu vars to the little panel in the style window */

static os_error * writeselected(void)
{
 wimp_set_icon_state(stylebox[0].handle,SUMMARYICON,
                 (wimp_iconflags)0,(wimp_iconflags)0);         /* summary */
 return(wimp_set_icon_state(stylebox[0].handle,SAMPLEICON,
                 (wimp_iconflags)0,(wimp_iconflags)0)); /* text sample */
}



static os_error * updateselected(void)
{
 checkuserstyle(&cstyle,cfile);
 return(writeselected());
}




static os_error * stylekeypress(int handle,int userhandle,int icon,int * key)
{
 int ch;
 int usn;

 ch=*key;

// cprintf("style keypress %x",*key);

	if(ch & KEYVIRT)
	{
  if((!isbadfunc(ch) && ch!=ENTER && ch!=ESCPRESS && !isasciitextkey(ch) && ch!=CUP && ch!=CDOWN) || ch==DEL)
  {
   usn=ustylekeys(stylebase,ch,NULL);

   if(ch==DEL || usn==0 ||usn==stylebase->userstyle[selectedstyleindex].style.n)
   {
    keypress=ch;
    if(keypress==DEL) keypress=-1;
    *key=-1;
    dbchangevalue(&keypress,stylebox);
			}
  }
 }

 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(icon);
}





static os_error * stylemode(wimp_msgstr * msg,int * ack)
{
 tempremapwindow(stylebox[0].handle);
 return(NULL);
 USE(msg);
 USE(ack);
}




/*****************************************************************************/


#define STYLEOVER   0
#define STYLERENAME 1
#define STYLESKIP   2

#define STYLEADD    3


/* icon value key */

static deciconstr decicons[]=
{
  2,         -1,      27,
  0,  STYLEOVER,      0,
  4,STYLERENAME,      0,
  1,  STYLESKIP,      13,

 -1,          0,      0,
};


static decstr decs=
{
 TMERGESTYLE,
 3,
 decicons,

};





static os_error * loadstyle(char * name,int type,int userhandle,int xvolatile)
{
 return(loaddoc(name,type,userhandle,xvolatile));
}


static os_error * loadstylepost(int userhandle)
{
 os_error         * err;
 int                load;
 int                ustyles;
 userstylebasestr * sbase;
 int                i;
 userstylestr       us;
 userstylestr       olds;
 int                n;
 int                result;
 int                changed;
 int                tab;
 int                mfont;


 cprintf("loadstylepost");

 err=loaddocpost1(&load,0);

 if(load)
 {
  ustyles=xloadfile->hdr.ustyles;
  i=0;
  n=0;    /* compiler */
  changed=0;

		// unicode compatability check

		if(xloadfile->compatability>=UNICOMPAT	&& cfile->compatability<UNICOMPAT)
 	{
   err=txcheckuserstyles(xloadfile);
		}

		if(!err)
		{
   while(1)
   {
    sbase=(userstylebasestr*)fob_find(ustyles,xloadfile);
    if(i>=sbase->n) break;

    us=sbase->userstyle[i];

    /* search for name */

    if((n=finduserstylebynameb(us.name,stylebase,&olds))>=0)
    {
    /* found, then overwrite, ignore, rename */

     decboxparent(&decs,stylebox[0].handle,&result,"{STYLE06}",us.name);

     if(result==-1) break;
     if(result==STYLERENAME)
     {
      newstylenameb(us.name,stylebase);
      result=STYLEADD;
     }
    }
    else
    {
     result=STYLEADD;
    }

    if(result==STYLEOVER)
    {
     err=remtabruler(cfile,olds.style.data.tab);
     err=fmaprem(cfile,olds.style.data.mfont,1);

     fmapadd(cfile,us.style.data.font,1,&mfont);
     us.style.data.mfont=mfont;

     gettabruler(xloadfile,us.style.data.tab);
     addtabruler(cfile,&tabruler,0,tabrulern,&tab);
     us.style.data.tab=tab;

     us.style.n=olds.style.n;
     us.rank=olds.rank;
     stylebase->userstyle[n]=us;

     if(olds.style.n==cstyle.style.n)
     {
      newselectedn(n);
     }
    }
    else
    if(result==STYLEADD)
    {
     fmapadd(cfile,us.style.data.font,1,&mfont);
     us.style.data.mfont=mfont;

     gettabruler(xloadfile,us.style.data.tab);
     addtabruler(cfile,&tabruler,0,tabrulern,&tab);
     us.style.data.tab=tab;

     createstyle(&stylebase);

     n=stylebase->n-1;
     us.style.n=stylebase->userstyle[n].style.n;

     if(stylebase->userstyle[0].rank!=0)
     {
      us.rank=n+1;
     }
     stylebase->userstyle[n]=us;

     changed=1;
    }

    i++;
   }

   if(changed)
   {
    setpaneextent(stylebox[1].handle);
    refreshwindow(stylebox[1].handle);
   }
		}

  closedoc(xloadfile);
 }

 return(err);

 USE(userhandle);
}



static os_error *loadstyletype(char * name,int type,mousestr * m,
                                        int userhandle,int *method)
{
 *method=(type==FTYPE2 || type==STYPE2);
 return(NULL);
 USE(userhandle);
 USE(m);
 USE(name);
}





static os_error * styleclose(int code)
{
 os_error      * err;
 int             i;


 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  readpanevalues();
  err=updatestylemap(cfile,&stylebase);
 }

 if(!err && code!=DBAPPLY)
 {
  clearpanevalues();
  losestylemap(cfile,&stylebase);
  cstylemode=CSNONE;
  if(stylebox[0].handle)
  {
   remmessage(stylemode,wimp_MMODECHANGE);
   remcaretevent(panecaret,stylebox[1].handle,0);

   for(i=0;i<2;i++)
   {
    remdataload(stylebox[i].handle,0,loadstyle);
    remdataloadpost(stylebox[i].handle,0,loadstylepost);
    remdataloadtype(stylebox[i].handle,0,loadstyletype);
   }
  }
 }

 return(err);
}







static os_error * scopecombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

 err=menucombo(stylebox,12,"scope_menu",event,data,hit,userp);
																																																																																					 
	return(err);

	USE(datap);

	return(NULL);
}




static dbiconstr styleicondefs[7]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1,  NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2,  NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,
    9,  NULL,         DBACTION, 0,   0,      DBAPPLY,-1,0,0 ,NULL ,0,


 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */


 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

 /* 1, &parastyle,   DBTOGGLE, 0,    0,      1,  F1,  0,  0,   NULL,   0,*/
 /* 2, &menu,        DBTOGGLE, 0,    0,      1,  F2,  0,  0,   NULL,   0,*/

    5, &keypress,    DBTEXT,   0,    0,      0,   0,  0,  0,   NULL, wrkey,
   12, &scope,       DBCOMBO,  0,    DBCOMBOSTATIC,  0,   0,  0,  0,   NULL, (dbwritefn)scopecombo,

   -1, NULL,         0,        0,    0,      0,  0,  0,  0,  0,      0
};


static dboxstr stylebox[2]=
{
 0,
 TSTYLE,
 DBFIX,
 DBGRAB,
 styleclose,
 styleicon,
 stylekeypress,
 styleredraw,
 styleicondefs,
 0,
 0,
 0,
 NULL,
 0,
 0,

 0,
 TSTYLEP,
 DBPANE,
 0,
 NULL,
 stylepaneicon,
 stylepanekeypress,
 paneredraw,
 NULL,
 0,
 0,
 0,
 NULL,
 0,
 0,
};










/* script function opens the user styles dialogue box */


/* void openstylebox(int stylekey); */

void openstylebox(int fp)
{
 os_error * err;
 int        i;
 int        n;

 dbstacksmash(&dbviewstack);

 cfile=menufile;
 cview=menuview;

 copystylemap(cfile,&stylebase);

 selectedstylerank=focusn=0;
 selectedstyleindex=styleindex(stylebase,selectedstylerank);

 n=stack[fp];

 if(n<=0 && act.valid && menufile==act.file)
 {
  n=getcurrentuserstyle(0);
 }

 if(n>0)
 {
  selectedstyleindex=finduserstylebase(stylebase,n);
  selectedstylerank=focusn=stylerank(stylebase,selectedstyleindex);
 }

 setpanevalues(selectedstyleindex);

 err=dodboxspparent(stylebox,2,stylebox,&dbviewstack,cview->handle);

 cstylemode=CSUSERDBOX;

 if(!err) err=setpaneextent(stylebox[1].handle);
 if(!err) err=writeselected();
 if(!err) err=setupmainstyle();

 if(!err && stylebox[0].handle)
 {
           err=addmessage(stylemode,wimp_MMODECHANGE);
  if(!err) err=setfocus(stylebox[1].handle);
  if(!err) err=addcaretevent(panecaret,stylebox[1].handle,0);
  if(!err) err=wimp_setwindowflags(stylebox[1].handle,WINDOWNOTDIALOGUE,0);


  for(i=0;i<2;i++)
  {
   if(!err) err=adddataload(stylebox[i].handle,0,loadstyle);
   if(!err) err=adddataloadpost(stylebox[i].handle,0,loadstylepost);
   if(!err) err=adddataloadtype(stylebox[i].handle,0,loadstyletype);
  }

  wimp_setwindowbackground(stylebox[1].handle,CCRGB|PALWHITE);
  paneopenat(selectedstylerank,stylebox[1].handle);
 }

 zreport(err);

 USE(fp);
}






/*************************************************************************/
/* Text effects dboxes                                                   */

static os_error * fxrdleft(int * value,char * string)
{
 os_error * err;
 int        oldvalue;
 int        oldtype;

 if(changedleft) return(rdleft(value,string));
 else
 if(*string)
 {
  oldvalue=*value;
  oldtype=lefttype;
  err=rdleft(value,string);
  if(oldvalue!=*value || oldtype!=lefttype) changedleft=1;
  return(err);
 }
 else
 return(NULL);
}


static os_error * fxwrleft(int value,char * string)
{
 if(actleft || changedleft) return(wrleft(value,string));
 else                       *string=0;
 return(NULL);
}


static os_error * fxrdfirst(int * value,char * string)
{
 os_error * err;
 int        oldvalue;

 if(changedfirst) return(rdfirst(value,string));
 else
 if(*string)
 {
  oldvalue=*value;
  err=rdfirst(value,string);
  if(oldvalue!=*value) changedfirst=1;
  return(err);
 }
 else
 return(NULL);
}


static os_error * fxwrfirst(int value,char * string)
{
 if(actfirst || changedfirst) return(wrfirst(value,string));
 else                         *string=0;
 return(NULL);
}



static os_error * fxrdright(int * value,char * string)
{
 os_error * err;
 int        oldvalue;
 int        oldtype;

 if(changedright) return(rdright(value,string));
 else
 if(*string)
 {
  oldvalue=*value;
  oldtype=righttype;
  err=rdright(value,string);
  if(oldvalue!=*value || oldtype!=righttype) changedright=1;
  return(err);
 }
 else
 return(NULL);
}


static os_error * fxwrright(int value,char * string)
{
 if(actright || changedright) return(wrright(value,string));
 else                         *string=0;
 return(NULL);
}


static os_error * fxrdbefore(int * value,char * string)
{
 os_error * err;
 int        oldvalue;

 if(changedbefore) return(rdbefore(value,string));
 else
 if(*string)
 {
  oldvalue=*value;
  err=rdbefore(value,string);
  if(oldvalue!=*value) changedbefore=1;
  return(err);
 }
 else
 return(NULL);
}


static os_error * fxwrbefore(int value,char * string)
{
 if(actbefore || changedbefore) return(wrbefore(value,string));
 else                           *string=0;
 return(NULL);
}


static os_error * fxrdafter(int * value,char * string)
{
 os_error * err;
 int        oldvalue;

 if(changedafter) return(rdafter(value,string));
 else
 if(*string)
 {
  oldvalue=*value;
  err=rdafter(value,string);
  if(oldvalue!=*value) changedafter=1;
  return(err);
 }
 else
 return(NULL);
}


static os_error * fxwrafter(int value,char * string)
{
 if(actafter || changedafter) return(wrafter(value,string));
 else                         *string=0;
 return(NULL);
}



static os_error * fxrdlayer(int * value,char * string)
{
 os_error * err;
 int        oldvalue;

 err=NULL;

 if(changedlayer) err=rdlayer(value,string);
 else
 if(*string)
 {
  oldvalue=*value;
  err=rdlayer(value,string);
  if(!err)
  {
   if(oldvalue!=*value) changedlayer=1;
  }
 }

 return(err);
}



static os_error * fxwrlayer(int value,char * string)
{
 if(actlayer || changedlayer) return(wrlayer(value,string));
 else                         *string=0;
 return(NULL);
}




static os_error * fxrddrop(int * value,char * string)
{
 os_error * err;
 int        oldvalue;

 if(actdrop & 0x4) return(rddrop(value,string));
 else
 if(*string)
 {
  oldvalue=*value;
  err=rddrop(value,string);
  if(oldvalue!=*value) actdrop|=0x4;

  return(err);
 }
 else
 return(NULL);
}


static os_error * fxwrdrop(int value,char * string)
{
 if(actdrop & 0x6) return(wrdrop(value,string));
 else              *string=0;
 return(NULL);
}




#ifdef NEVER

static os_error * fxrdkeep(int * value,char * string)
{
 os_error * err;
 int        oldvalue;

 if(actkeeplines & 0x4) return(rdkeep(value,string));
 else
 if(*string)
 {
  oldvalue=*value;
  err=rdkeep(value,string);
  if(oldvalue!=*value) actkeeplines|=0x4;

  return(err);
 }
 else
 return(NULL);
}


static os_error * fxwrkeep(int value,char * string)
{
 if(actkeeplines & 0x6) return(wrkeep(value,string));
 else                   *string=0;
 return(NULL);
}


#endif



static os_error * fxwralign(int value,char * string)
{
 if(actalign || changedalign) return(wralign(value,string));
 else                         *string=0;
 return(NULL);
}



static os_error * fxrdleading(int * value,char * string)
{
 os_error * err;
 int        oldvalue;
 int        oldtype;

 if(changedleading) return(rdleading(value,string));
 else
 if(*string)
 {
  oldvalue=*value;
  oldtype=leadingtype;
  err=rdleading(value,string);
  if(oldvalue!=*value || oldtype!=leadingtype) changedleading=1;
  return(err);
 }
 else
 return(NULL);
}


static os_error * fxwrleading(int value,char * string)
{
 if(actleading || changedleading) return(wrleading(value,string));
 else                             *string=0;
 return(NULL);
}



static dbiconstr formatfxicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

   28,  &leftshift,  DBWRITE,  0,   0,      9, -1,  3,  -1,fxrdleft,fxwrleft,
    5,  &firstshift, DBWRITE,  0,   0,     -1, -1,  5,   1,fxrdfirst,fxwrfirst,
   10,  &before,     DBWRITE,  0,   0,     -1, -1,  7, 3,fxrdbefore,fxwrbefore,
   12,  &after,      DBWRITE,  0,   0,     -1, -1, 20,   5,fxrdafter,fxwrafter,
   25,  &dropno,     DBWRITE,  0,   0,     -1, -1,  9,   7,fxrddrop,fxwrdrop,

    3,  &rightshift, DBWRITE,  0,   0,     -1,  1, -1,  20,fxrdright,fxwrright,

 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

    7,  &align,      DBTEXT,   0,   0,      0,  0,  0,   0,  NULL,fxwralign,
   14,  &leading,    DBTEXT,   0,   0,      0,  0, 0,0,fxrdleading,fxwrleading,

//   31,  &keeplines, DBWRITE,  0,   0,     -1, -1,  9,   7, fxrdkeep,fxwrkeep,


 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,
   37, NULL,         DBACTION, 0,   0,      DBAPPLY,-1,0,0 ,NULL ,0,

 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */


 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   18,  &actdrop,    DBTRI2,   0,    0,      1,  -1, 0, 0,   NULL,   0,
   20,  &hyphenation,DBTRI2,   0,    0,      1,  F3, 0, 0,   NULL,   0,

   15,  &actbullet,  DBTRI2,   0,    0,      1,  -1, 0, 0,   NULL,   0,

   24,  &actkeeplines,DBTRI2,  0,    0,      1,  F3, 0, 0,   NULL,   0,
   26,  &actkeeppara,DBTRI2,   0,    0,      1,  F3, 0, 0,   NULL,   0,
   27,  &actkeepnext,DBTRI2,   0,    0,      1,  F3, 0, 0,   NULL,   0,

   22,  &actautokern,DBTRI2,   0,    0,      1,  F3, 0, 0,   NULL,   0,
   23,  &actbaselock,DBTRI2,   0,    0,      1,  F3, 0, 0,   NULL,   0,

   30,  &actcontents,DBTRI2,   0,    0,      1,  F2, 0, 0,   NULL,   0,

   19,  &layer,      DBWRITE,  0,    0,     -1, -1, -1, 18,fxrdlayer,fxwrlayer,

   32,  &justification,DBTRI2, 0,    0,      1,  -1, 0, 0,   NULL,   0,


   -1, NULL,         0,        0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr formatfxbox=
{
 0,
 TFORMAT,
 DBFIX,
 0,
 formatclose,
 formaticon,
 NULL,
 formatfxredraw,
 formatfxicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};


void opentextformat(int fp)
{
 os_error     * err;

 dbstacksmash(&dbviewstack);

 cfile=menufile;
 cview=menuview;

 if(act.valid && act.file==menufile)
 {
  clrchangebits();
  gettextstyle(cfile,&cstyle.style);

  style2format(&cstyle.style);

  err=dodboxspparent(&formatfxbox,1,&formatfxbox,&dbviewstack,cview->handle);

  textstylemode=TSPEND;
 }

 USE(fp);
}


/*************************************************************************/

static os_error * fxwrfname(int value,char * string)
{
 if(actfont || changedfont) return(wrfname(value,string));
 else                       *string=0;
 return(NULL);
}

static os_error * fxsize(int value,char * string)
{
 if(actsize || changedsize) return(wrpts(value,string));
 else                       *string=0;
 return(NULL);
}



static os_error * fxrdsize(int * value,char * string)
{
 os_error * err;
 int        oldvalue;

 if(changedsize) return(rdpts(value,string));
 else
 if(*string)
 {
  oldvalue=*value;
  err=rdpts(value,string);
  if(oldvalue!=*value) changedsize=1;
  return(err);
 }
 else
 return(NULL);
}






static os_error * fxwrcase(int value,char * string)
{
 if(actcase || changedcase) return(wrcase(value,string));
 else                       *string=0;
 return(NULL);
}

static os_error * fxwrhscale(int value,char * string)
{
 if(acthscale || changedhscale) return(wrhscale(value,string));
 else                           *string=0;
 return(NULL);
}

static os_error * fxrdhscale(int * value,char * string)
{
 os_error * err;
 int        oldvalue;

 if(changedhscale) return(rdhscale(value,string));
 else
 if(*string)
 {
  oldvalue=*value;
  err=rdhscale(value,string);
  if(oldvalue!=*value) changedhscale=1;
  return(err);
 }
 else
 return(NULL);
}

static os_error * fxwrkern(int value,char * string)
{
 if(actkern || changedkern) return(wrkern(value,string));
 else                       *string=0;
 return(NULL);
}

static os_error * fxrdkern(int * value,char * string)
{
 os_error * err;
 int        oldvalue;

 if(changedkern) return(rdkern(value,string));
 else
 if(*string)
 {
  oldvalue=*value;
  err=rdkern(value,string);
  if(oldvalue!=*value) changedkern=1;
  return(err);
 }
 else
 return(NULL);
}

static os_error * fxwrbase(int value,char * string)
{
 if(actbaseshift || changedbaseshift) return(wrbase(value,string));
 else                                 *string=0;
 return(NULL);
}

static os_error * fxrdbase(int * value,char * string)
{
 os_error * err;
 int        oldvalue;

 if(changedbaseshift) return(rdbase(value,string));
 else
 if(*string)
 {
  oldvalue=*value;
  err=rdbase(value,string);
  if(oldvalue!=*value) changedbaseshift=1;
  return(err);
 }
 else
 return(NULL);
}




static os_error * fxwrrot(int value,char * string)
{
 if(actrotate || changedrotate) return(wrangle(value,string));
 else                           *string=0;
 return(NULL);
}

static os_error * fxrdrot(int * value,char * string)
{
 os_error * err;
 int        oldvalue;

 if(changedrotate) return(rdangle(value,string));
 else
 if(*string)
 {
  oldvalue=*value;
  err=rdangle(value,string);
  if(oldvalue!=*value) changedrotate=1;
  return(err);
 }
 else
 return(NULL);
}


static os_error * fxwrskew(int value,char * string)
{
 if(actskew || changedskew) return(wrskew(value,string));
 else                           *string=0;
 return(NULL);
}

static os_error * fxrdskew(int * value,char * string)
{
 os_error * err;
 int        oldvalue;

 if(changedskew) return(rdskew(value,string));
 else
 if(*string)
 {
  oldvalue=*value;
  err=rdskew(value,string);
  if(oldvalue!=*value) changedskew=1;
  return(err);
 }
 else
 return(NULL);
}



static os_error * clicksuper2(int handle,int userhandle,wimp_mousestr * m)
{
 clicksupers();
 return(dbchangevalue(&actsub,&textfxbox));
 USE(handle);
 USE(userhandle);
 USE(m);
}

static os_error * clicksub2(int handle,int userhandle,wimp_mousestr * m)
{
 clicksubs();
 return(dbchangevalue(&actsuper,&textfxbox));
 USE(handle);
 USE(userhandle);
 USE(m);
}



static dbiconstr textfxicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,
   43, NULL,         DBACTION, 0,   0,      DBAPPLY,-1,0,0 ,NULL ,0,

 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */

   36, &cfont,       DBTEXT,   0,   0,      0,  0,  0,   0,   NULL,fxwrfname,
    4, &size,        DBWRITE,  0,   0,      0,  0,  0,   0,   fxrdsize,fxsize,
    7, &xcase,       DBTEXT,   0,   0,      0,  0,  0,   0,   NULL,fxwrcase,
   16, &hscale,      DBWRITE,  0,   0,     -1, -1, 18,-1,fxrdhscale,fxwrhscale,
   19, &kern,        DBWRITE,  0,   0,     -1, -1, 21,  13,fxrdkern,fxwrkern,
   20, &baseshift,   DBWRITE,  0,   0,     -1, -1, -1,  18,fxrdbase,fxwrbase,
   22, &rotate,      DBWRITE,  0,   0,     -1, -1, -1,  18,fxrdrot,fxwrrot,
   23, &skew,        DBWRITE,  0,   0,     -1, -1, -1,  18,fxrdskew,fxwrskew,


 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   24,  &bold,       DBTRI2,   0,    0,      1,  F1, 0, 0,   NULL,   0,
   25,  &italic,     DBTRI2,   0,    0,      1,  F2, 0, 0,   NULL,   0,
   26,  &underline,  DBTRI2,   0,    0,      1,  F3, 0, 0,   NULL,   0,
   28,  &strikeout,  DBTRI2,   0,    0,      1,  F5, 0, 0,   NULL,   0,
   30,  &smlcaps,    DBTRI2,   0,    0,      1,  F6, 0, 0,   NULL,   0,
   38,  &reverse,    DBTRI2,   0,    0,      1,  F6, 0, 0,   NULL,   0,

   31,  &actsuper,   DBTRI2,   0,    0,      1,  -1, 0, 0,
                                                      (dbreadfn)clicksuper2,0,
   32,  &actsub,     DBTRI2,   0,    0,      1,  -1, 0, 0,
                                                      (dbreadfn)clicksub2,0,

   33,  &index,      DBTRI2,   0,    0,      1,  F2, 0, 0,   NULL,   0,

   -1, NULL,         0,        0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr textfxbox=
{
 0,
 TTEXT,
 DBFIX,
 0,
 textstyleclose,
 textstyleicon,
 NULL,
 textstyleredraw,
 textfxicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};




os_error * opentextstylebox(filestr * file,viewstr * view)
{
 os_error * err;

 err=dbstacksmash(&dbviewstack);

 cfile=file;
 cview=view;

 if(act.valid && act.file==menufile)
 {
  clrchangebits();
  gettextstyle(file,&cstyle.style);
  style2text(&cstyle.style);
  setupactss();

  err=dodboxspparent(&textfxbox,1,&textfxbox,&dbviewstack,cview->handle);

  textstylemode=TSPEND;
 }

 return(err);
}


/* called from menu, open dbox on immediate text style */

void opentextstyle(int fp)
{
 os_error * err;

 err=opentextstylebox(menufile,menuview);

 zreport(err);

 USE(fp);
}

/*************************************************************************/


/* function called when the main menu is popped up                 */
/* we know that this means we should read pending style to current */


static os_error * stylegetfont(int * sfont)
{

 if(textstylemode==TSNONE)
 {
  if(act.valid && act.file==menufile)
  {
   cfile=menufile;
   cview=menuview;

   clrchangebits();
   gettextstyle(cfile,&cstyle.style);

   style2text(&cstyle.style);
  }
 }

 *sfont=actfont?ufont(cfont):-1;

 return(NULL);
}


static os_error * stylegetfont2(int * sfont)
{
 *sfont=actfont?(fontuserfromstyle2(cfont,(bold & 0x1),(italic & 0x1))
                                                 -ifont(ufont(cfont))):-1;
 return(NULL);
}





static os_error * stylesetfont(int sfont) 
{
 os_error * err;

 err=NULL;

 sfont=fontuserfromstyle(sfont,(bold & 0x1),(italic & 0x1));

 actfont=(cfont!=sfont)||(!actfont);
 cfont=sfont;
 changedfont=1;

 if(textstylemode==TSUSER)
 {
  dbchangevalue(&actfont,&textstylebox);
  dbchangevalue(&cfont,&textstylebox);
 }
 else
 if(textstylemode==TSPEND)
 {
  dbchangevalue(&actfont,&textfxbox);
  dbchangevalue(&cfont,&textfxbox);
 }
 else
 {
  text2style(&cstyle.style);
  setchangebits(&cstyle.style);
  err=settextstyle(cfile,&cstyle.style,SCOPECURR);
 }

 return(err);
}



static os_error * stylesetfont2(int font,int sub) 
{
 os_error * err;
 int sbold;
 int sitalic;


 err=NULL;


 if(sub<0) return(stylesetfont(font));
 else
 {
  font=ifont(font)+sub;
  finduserfontstyle(font,&sbold,&sitalic);

  actfont=(cfont!=font)||(!actfont);
  cfont=font;
  changedfont=1;

  if(sbold) bold=4+2+1;
  else      bold=4+2;

  if(sitalic) italic=4+2+1;
  else        italic=4+2;

  if(textstylemode==TSUSER)
  {
   dbchangevalue(&actfont,&textstylebox);
   dbchangevalue(&cfont,&textstylebox);
   dbchangevalue(&bold,&textstylebox);
   dbchangevalue(&italic,&textstylebox);
  }
  else
  if(textstylemode==TSPEND)
  {
   dbchangevalue(&actfont,&textfxbox);
   dbchangevalue(&cfont,&textfxbox);
   dbchangevalue(&bold,&textfxbox);
   dbchangevalue(&italic,&textfxbox);
  }
  else
  {
   text2style(&cstyle.style);
   setchangebits(&cstyle.style);
   err=settextstyle(cfile,&cstyle.style,SCOPECURR);
  }
 }

 return(err);
}






void caretcontext(int fp)
{
 if(act.valid && act.file==menufile)
 {

  setfonthandlers(stylesetfont,stylesetfont2,stylegetfont,stylegetfont2);

  if(textstylemode==TSNONE)
  {
   if(act.valid && act.file==menufile)
   {
    cfile=menufile;
    cview=menuview;

    clrchangebits();
    gettextstyle(cfile,&cstyle.style);
    style2text(&cstyle.style);
   }
  }
 }

 USE(fp);
}


void opentextfont(int fp)
{
 caretcontext(fp);
 if(menuview) zreport(fontmenu(menuview->handle));
}



int getfontsize(int fp)
{

 if(textstylemode==TSNONE)
 {
  if(act.valid && act.file==menufile)
  {
   cfile=menufile;
   cview=menuview;

   clrchangebits();
   gettextstyle(cfile,&cstyle.style);
   style2text(&cstyle.style);
  }
 }

 return(actsize?size:-1);
 USE(fp);
}


static os_error * setfontsizes(int newsize)
{
 os_error * err;

 err=NULL;

 getfontsize(0);

 actsize=(size!=newsize)||(!actsize);
 size=newsize;

 size=CUT(size,MINPTSIZE*1000,MAXPTSIZE*1000);

 changedsize=1;

 if(textstylemode==TSUSER)
 {
  dbchangevalue(&actsize,&textstylebox);
  dbchangevalue(&size,&textstylebox);
 }
 else
 if(textstylemode==TSPEND)
 {
  dbchangevalue(&actsize,&textfxbox);
  dbchangevalue(&size,&textfxbox);
 }
 else
 {
  text2style(&cstyle.style);
  setchangebits(&cstyle.style);
  err=settextstyle(cfile,&cstyle.style,SCOPECURR);
 }

 return(err);
}


void setfontsize(int fp)
{
 zreport(setfontsizes(stack[fp]));
}


os_error * txsetfontsize(int newsize,viewstr * view)
{
 menuview=view;
 menufile=view->file;

 return(setfontsizes(newsize));
}








static os_error * txgetcolour(int eventn,int user,filestr * file,int * data)
{
 xstylestr style;

 if(act.valid && act.file==file && !*data) 
 {
  gettextstyle(file,&style);
  *((colourvalue*)data)=style.data.fcolour;
 }

 return(NULL);
 USE(eventn);
 USE(user);
}





static os_error * txsetcolour(int eventn,int user,filestr * file,int * data)
{
 xstylestr style;

 if(act.valid && act.file==file) 
 {
  style.data.fcolour=*((colourvalue*)data);
  styleclrall(&style);
  style.action.fcolour=1;
  settextstyle(file,&style,SCOPECURR);
 }

 return(NULL);
 USE(eventn);
 USE(user);
}




int getsmallcaps(int fp)
{
 if(act.valid && act.file==menufile)
 {
  cfile=menufile;
  cview=menuview;

  clrchangebits();
  gettextstyle(cfile,&cstyle.style);
  style2text(&cstyle.style);
 }

 return(smlcaps & 0x1);
 USE(fp);
}



void setsmallcaps(int fp)
{
 int smallcaps;

 smallcaps=stack[fp];

 if(act.valid && act.file==menufile)
 {
  getsmallcaps(0);

		smlcaps=smallcaps | (0x6);

  text2style(&cstyle.style);
  setchangebits(&cstyle.style);
  zreport(settextstyle(cfile,&cstyle.style,SCOPECURR));
 }
}






int getbaseshift(int fp)
{
 if(act.valid && act.file==menufile)
 {
  cfile=menufile;
  cview=menuview;

  clrchangebits();
  gettextstyle(cfile,&cstyle.style);
  style2text(&cstyle.style);
 }

 return(baseshift);
 USE(fp);
}



void setbaseshift(int fp)
{
 int shift;

 shift=stack[fp];

 if(act.valid && act.file==menufile)
 {
  getbaseshift(0);
  actbaseshift=(baseshift!=shift)||(!actbaseshift);
  changedbaseshift=1;
  baseshift=CUT(shift,MINBASESHIFT,MAXBASESHIFT);

  text2style(&cstyle.style);
  setchangebits(&cstyle.style);
  zreport(settextstyle(cfile,&cstyle.style,SCOPECURR));
 }
}





int getcase(int fp)
{

 if(textstylemode==TSNONE)
 {
  if(act.valid && act.file==menufile)
  {
   cfile=menufile;
   cview=menuview;

   clrchangebits();
   gettextstyle(cfile,&cstyle.style);
   style2text(&cstyle.style);
  }
 }

 return(actcase?xcase:-1);
 USE(fp);
}



void setcase(int fp)
{
 getcase(0);

 actcase=(xcase!=stack[fp])||(!actcase);
 xcase=stack[fp];
 changedcase=1;

 if(textstylemode==TSUSER)
 {
  dbchangevalue(&actcase,&textstylebox);
  dbchangevalue(&xcase,&textstylebox);
 }
 else
 if(textstylemode==TSPEND)
 {
  dbchangevalue(&actcase,&textfxbox);
  dbchangevalue(&xcase,&textfxbox);
 }
 else
 {
  text2style(&cstyle.style);
  setchangebits(&cstyle.style);
  zreport(settextstyle(cfile,&cstyle.style,SCOPECURR));
 }
}


int getscope(int fp)
{
 return(scope);
 USE(fp);
}


void setscope(int fp)
{
 scope=stack[fp];
// dbchangevalue(&scope,stylebox);
}



int getalign(int fp)
{

 if(textstylemode==TSNONE)
 {
  if(act.valid && act.file==menufile)
  {
   cfile=menufile;
   cview=menuview;

   clrchangebits();
   gettextstyle(cfile,&cstyle.style);
   style2format(&cstyle.style);
  }
 }

 return(actalign?align:-1);
 USE(fp);
}

static os_error * setaligns(int xalign)
{
 os_error * err;

 err=NULL;

 if(textstylemode==TSUSER)
 {
  actalign=(align!=xalign)||(!actalign);
 }
 else
 {
  actalign=1;
 }

 align=xalign;
 changedalign=1;

 if(textstylemode==TSUSER)
 {
  dbchangevalue(&actalign,&formatbox);
  dbchangevalue(&align,&formatbox);
 }
 else
 if(textstylemode==TSPEND)
 {
  dbchangevalue(&actalign,&formatfxbox);
  dbchangevalue(&align,&formatfxbox);
 }
 else
 {
  format2style(&cstyle.style);
  setchangebits(&cstyle.style);
  err=settextstyle(cfile,&cstyle.style,SCOPEPARA);
 }

 return(err);
}


void setalign(int fp)
{
 getalign(0);
 zreport(setaligns(stack[fp]));
}


os_error * txsetalign(int xalign,viewstr * view)
{
 menuview=view;
 menufile=view->file;

 getalign(0);
 return(setaligns(xalign));
}




int getparalevel(int fp)
{

 if(textstylemode==TSNONE)
 {
  if(act.valid && act.file==menufile)
  {
   cfile=menufile;
   cview=menuview;

   clrchangebits();
   gettextstyle(cfile,&cstyle.style);
   style2format(&cstyle.style);
  }
 }

 return(actlayer?layer:-1);
 USE(fp);
}



void setparalevel(int fp)
{
 os_error * err;
 int        xlayer;

 err=NULL;

 getparalevel(0);

 xlayer=stack[fp];

 if(textstylemode==TSUSER)
 {
  actlayer=(layer!=xlayer)||(!actlayer);
 }
 else
 {
  actlayer=1;
 }

 layer=xlayer;
 changedlayer=1;

 if(textstylemode==TSUSER)
 {
  dbchangevalue(&actlayer,&formatbox);
  dbchangevalue(&layer,&formatbox);
 }
 else
 if(textstylemode==TSPEND)
 {
  dbchangevalue(&actlayer,&formatfxbox);
  dbchangevalue(&layer,&formatfxbox);
 }
 else
 {
  format2style(&cstyle.style);
  setchangebits(&cstyle.style);
  err=settextstyle(cfile,&cstyle.style,SCOPEPARA);
 }

 zreport(err);
}





/* void getleading(string & s); */

static void writeleadings(void)
{
 if(act.valid && act.file==menufile)
 {
  cfile=menufile;
  cview=menuview;

  clrchangebits();
  gettextstyle(cfile,&cstyle.style);
  style2format(&cstyle.style);
 }
}


void writeleading(int fp)
{
 char        string[16];

 if(act.valid && act.file==menufile)
 {
  writeleadings();
  wrleading(leading,string);
  assignstring(stack[fp],string);
 }
}



/* void setleading(string & s); */

void readleading(int fp)
{

 if(act.valid && act.file==menufile)
 {
  writeleadings();

  changedleading=1;

  rdleading(&leading,stringptr(stack[fp]));

  format2style(&cstyle.style);
  setchangebits(&cstyle.style);

  zreport(settextstyle(cfile,&cstyle.style,SCOPEPARA));
 }
}





int islocaleffect(int fp)
{
 xstylestr   xstyle;
 int       * p;
 int         i;
 int         r;

 if(textstylemode==TSNONE && menufile && act.valid && act.file==menufile)
 {
  gettexteffects(menufile,&xstyle);

  p=(int*)&xstyle.action;
  r=0;

  for(i=0;i<sizeof(actionbits)/sizeof(int);i++)
  {
  /* dprintf(0+i,"i=%d r=%d v=%x",i,r,*p); */
   r+=*p++;
  }

  return(r!=0);
 }

 return(0);
 USE(fp);
}


// int getlocaleffect(int n)
// return effect id or <0 for no more effects




static actionbits geffxbits;



// int getnexteffect(int effect)

int getnexteffect(int fp)
{
 xstylestr   xstyle;
 int       * p;
 int         effect;
 int         mask;
 int         bits;

 if(menufile && act.valid && act.file==menufile)
 {
  effect=stack[fp];

  if(effect<0)
  {
   gettexteffects(menufile,&xstyle);
   geffxbits=xstyle.action;
   effect=0;
  }
  else
  {
   effect++;
  }

  p=(int*)&geffxbits;
  p+=effect/32;
  mask=(1<<(effect % 32));
  bits=*p++;

  while(1)
  {
   if(bits & mask) return(effect);
   effect++;
   if(effect>=MAXEFFECT) break;
   mask=mask<<1;
   if(mask==0)
   {
    mask=1;
    bits=*p++;    
   }
  }
 }

 return(-1);
}









static char * effxnames[MAXEFFECT]=
{
 "FO00", // bold
 "FO01", // italic
 "FO02", // underline
 "FO05", // reverse
 "FO42", // supersub
 "FO14", // strikeout
 "FO43", // rulevert
 "FO44", // rulehoriz
 "FO45", // font
 "FO46", // fcolour
 "FO47", // bcolour
 "FO48", // size
 "FO17", // hscale
 "FO50", // track
 "FO19", // baseshift
 "FO51", // align
 "FO20", // before
 "FO21", // after
 "FO22", // leading
 "FO39", // left
 "FO40", // right
 "FO41", // first
 "FO52", // xcase
 "FO25", // drop
 "FO34", // bullet
 "FO24", // hyphenation
 "FO23", // akern
 "FO53", // wordwrap
 "FO15", // index
 "FO16", // contents
 "FO32", // layer
 "FO19", // baselinelock
 "FO09", // smlcaps
 "FO29", // keeplines
 "FO28", // keeppara
 "FO26", // keepnext
 "FO54", // language
 "FO37", // tab ruler
 "FO30", // rotate
 "FO31", // skew
 "FO33", // justification
};

// geteffectname(int effect,string & s)

void geteffectname(int fp)
{
 int    effect;
 char * p;

 effect=stack[fp];

 if(effect>=0 && effect<MAXEFFECT)
 {
  p=transtoken(effxnames[effect]);
  zreport(assignstring(stack[fp+1],p));
 }
}


// void cleareffect(int effect,int scope)

void cleareffect(int fp)
{
 xstylestr   xstyle;
 int         effect;
 int       * p;

 if(act.valid && act.file==menufile)
 {
  styleclrall(&xstyle);

  effect=stack[fp];

   cprintf("clear effect effect %d scope %d",effect,stack[fp+1]);

  if(effect>=0 && effect<MAXEFFECT)
  {
   cprintf("clear effect effect %d scope %d",effect,stack[fp+1]);

   p=(int*)&xstyle.action;
   p+=effect/32;
   *p|=(1<<(effect % 32));

   zreport(styleop(&xstyle,STXSTRIP,stack[fp+1]));
  }
 }
}




/* Normal       1 */
/* Bold         2 */
/* Italic       4 */
/* Underline    8 */
/* Reverse     16 */
/* Superscript 32 */
/* Subscript   64 */


int geteffx(int fp)
{
 int enormal;
 int ebold;
 int eitalic;
 int eunderline;
 int ereverse;
 int esuper;
 int esub;

 if(textstylemode==TSNONE)
 {
  if(act.valid && act.file==menufile)
  {
   cfile=menufile;
   cview=menuview;

   clrchangebits();
   gettextstyle(cfile,&cstyle.style);
   style2text(&cstyle.style);
  }
 }

 enormal=((!(bold & 0x1)) && (bold & 0x2)) &&
         ((!(italic & 0x1)) && (italic & 0x2)) &&
         ((!(underline & 0x1)) && (underline & 0x2)) &&
         ((!(reverse & 0x1)) && (reverse & 0x2)) &&
         (!supersub && actsupersub);

 ebold=(bold==0x3);
 eitalic=(italic==0x3);
 eunderline=(underline==0x3);
 ereverse=(reverse==0x3);
 esuper=(supersub==1 && actsupersub);
 esub=(supersub==2 && actsupersub);

 return(enormal|(ebold<<1)|(eitalic<<2)|(eunderline<<3)|
                (ereverse<<4)|(esuper<<5)|(esub<<6));

 USE(fp);
}


static os_error * seteffxs(int bits)
{
 os_error * err;

 err=NULL;

 if(bits & 0x1)  /* normal */
 {
  bold=italic=underline=reverse=0x2|0x4;
  actsupersub=0x1|0x2;
  supersub=0;
 }

 if(bits & 0x2)  /* bold */
 {
  if(bold==0x3) bold=0;
  else          bold=0x3;
  bold|=0x4;
 }

 if(bits & 0x4)  /* italic */
 {
  if(italic==0x3) italic=0;
  else            italic=0x3;
  italic|=0x4;
 }

 if(bits&0x8)   /* underline */
 {
  if(underline==0x3) underline=0;
  else               underline=0x3;
  underline|=0x4;
 }

 if(bits&0x10)   /* reverse */
 {
  if(reverse==0x3) reverse=0;
  else             reverse=0x3;
  reverse|=0x4;
 }

 if(bits & 0x20)   /* super */
 {
  if((actsupersub & 0x1) && supersub==SUPS)
  {
   supersub=0;
   actsupersub=0x1;
  }
  else
  {
   supersub=SUPS;
   actsupersub=0x1;
  }
  actsupersub|=0x2;
 }
 else
 if(bits & 0x40)   /* subs  */
 {
  if((actsupersub & 0x1) && supersub==SUBS)
  {
   supersub=0;
   actsupersub=0x1;
  }
  else
  {
   supersub=SUBS;
   actsupersub=0x1;
  }
  actsupersub|=0x2;
 }


 if(textstylemode==TSUSER || textstylemode==TSPEND)
 {


 }
 else
 {
  text2style(&cstyle.style);
  setchangebits(&cstyle.style);
  err=settextstyle(cfile,&cstyle.style,SCOPECURR);
 }

 return(err);
}


void seteffx(int fp)
{
 int bits;

 geteffx(0);

 bits=stack[fp];

 zreport(seteffxs(bits));
}


/* called off info palette */

os_error * txseteffx(int bits,viewstr * view)
{
 menuview=view;
 menufile=view->file;

 geteffx(0);
 return(seteffxs(bits));
}




os_error * markindex(void)
{
 os_error  * err;
 xstylestr   style;
 int         index;

 err=NULL;

 if(act.valid && textstylemode==TSNONE)
 {
  gettextstyle(act.file,&style);
  index=style.action.index && style.data.index;
  styleclrall(&style);
  style.action.index=1;
  style.data.index=!index;
  err=settextstyle(act.file,&style,SCOPEWORD);
 }

 return(err);
}



os_error * markcontents(void)
{
 os_error  * err;
 xstylestr   style;
 int         contents;

 err=NULL;

 if(act.valid && textstylemode==TSNONE)
 {
  gettextstyle(act.file,&style);
  contents=style.action.contents && style.data.contents;
  styleclrall(&style);
  style.action.contents=1;
  style.data.contents=!contents;
  err=settextstyle(act.file,&style,SCOPEWORD);
 }

 return(err);
}



/* apply the para effects at s to the active point */

os_error * applypara(vector * s)
{
 os_error    * err;
 absstylestr   astyle;
 absstylestr   sstyle;

 err=NULL;

 if(act.valid && textstylemode==TSNONE)
 {
           err=getcaretstylex(s,&sstyle);
  if(!err) err=getcaretstylex(&act,&astyle);

  if(!err)
  {
   stylesetall(&sstyle.style);
   stylediffbits(&sstyle.style,&astyle.style);
   styleflipall(&sstyle.style);
   styleclrxformat(&sstyle.style);

   err=settextstyle(act.file,&sstyle.style,SCOPEPARA);
  }
 }

 return(err);
}


void opentextcolour(int fp)
{
 os_error * err;

 cfile=menufile;
 cview=menuview;


 if(act.valid && act.file==menufile)
 {
  textstylemode=TSNONE;

  clrchangebits();
  gettextstyle(cfile,&cstyle.style);
  style2text(&cstyle.style);

  err=pickcolourparent(cfile,&fcolour,pickclosef,NULL,cview->handle);
 }


 USE(fp);
}



static os_error * effxclosetabs(dbtabstr * dtabs,int code)
{
 os_error * err;

 tabs2style(dtabs);

 changedleft=1;          // added, ensure applying tabs across paras with more than one tab ruler
 changedright=1;         // where what you apply is the same as the first para
 changedfirst=1;         // does something
 changedtabs=1;          // another plan would be to combine action bits which show what is the same through selection and are already set up


 setchangebits(&cstyle.style);

 err=settextstyle(cfile,&cstyle.style,SCOPEPARA);

 remtabruler(cfile,dtabs->newtab);

 if(code==TBFAPPLY)  /* nead to update leaderwidth */
 {
  clrchangebits();
  gettextstyle(cfile,&cstyle.style);
 }

 return(err);
}


void opentexttabs(int fp)
{
 os_error * err;
 dbtabstr   ctabs;

 memset(&ctabs,0,sizeof(dbtabstr));

 cfile=menufile;
 cview=menuview;

 if(act.valid && act.file==menufile)
 {
  textstylemode=TSNONE;

  clrchangebits();
  gettextstyle(cfile,&cstyle.style);

  stylegetatabs(&ctabs);

  style2tabs(&ctabs);

  ctabs.oldtab=cstyle.style.data.tab;
                            /*copying this without actually duplicating it*/  
  ctabs.apply=-1;
  ctabs.lock=0;

  err=opentabs(&ctabs,effxclosetabs,NULL,cview,cfile);
 }

 USE(fp);
}



void opentextrules(int fp)
{
 os_error * err;

 dbstacksmash(&dbviewstack);

 cfile=menufile;
 cview=menuview;

 if(act.valid && act.file==menufile)
 {
  clrchangebits();
  gettextstyle(cfile,&cstyle.style);
  style2rule(&cstyle.style);

  err=dodboxspparent(&rulebox,1,&rulebox,&dbviewstack,cview->handle);

  textstylemode=TSNONE;

  dbshade(1,0,&rulebox);
 }

 USE(fp);
}



int timestring(int fp)
{
 char string[64];
 writesystime(string);
 return(createstring(string));
 USE(fp);
}


int xdatestring(int fp)
{
 char string[64];
 writesysdate(string);
 return(createstring(string));
 USE(fp);
}



/* return nth user style */

static int getnthstyle(int rank,filestr * file)
{

 if(textstylemode==TSUSER)
 {
  if(stylebase)
  {
   return(stylebase->userstyle[styleindex(stylebase,rank)].style.n);
  }
 }
 else
 {
  userstylebasestr  * stylebase;
  int                 styles;

  styles=file->hdr.ustyles;
  stylebase=(userstylebasestr*)fob_find(styles,file);
  if(stylebase)
  {
   return(stylebase->userstyle[styleindex(stylebase,rank)].style.n);
  }
 }

 return(0);
}




/* int getuserstyle(int i,string & s,int mode); */

int getuserstyle(int fp)
{
 userstylebasestr  * xstylebase;
 int                 styles;
 int                 i;
 char                temp[32];

 xstylebase=NULL;

 if(menufile)
 {
  if(textstylemode==TSUSER)
  {
   xstylebase=stylebase; 
  }
  else
  {
   styles=menufile->hdr.ustyles;
   xstylebase=(userstylebasestr*)fob_find(styles,menufile);
  }
 }

 if(xstylebase)
 {
  i=stack[fp];
  if(i>=0 && i<xstylebase->n)
  {
   i=styleindex(xstylebase,i);

   xzstrncpy(temp,xstylebase->userstyle[i].name,sizeof(temp));
   if((stack[fp+2]==1 || stack[fp+2]==2) && xstylebase->userstyle[i].key>0)
   {
    strcat(temp,stack[fp+2]==1?" ":"\t");
    strcat(temp,
         keystringcanonical(cckeyfromlegacy(xstylebase->userstyle[i].key)));
   }

   assignstring(stack[fp+1],temp);
   return(xstylebase->userstyle[i].style.n);
  }
 }

 return(0);
}





/* int getstylescope(int styleindex); */

int getstylescope(int fp)
{
 userstylebasestr  * xstylebase;
 int                 i;

 if(menufile)
 {
  xstylebase=(userstylebasestr*)fob_find(menufile->hdr.ustyles,menufile);

  if(xstylebase)
  {
   i=stack[fp];
   if(i>=0 && i<xstylebase->n)
   {
    i=styleindex(xstylebase,i);
    return(xstylebase->userstyle[i].scope);
   }
  }
 }

 return(0);
}








static setuserstylemenuhandler ssmh;
static getuserstylemenuhandler gsmh;

void setuserstyle(int fp)
{
 if(ssmh) ssmh(getnthstyle(stack[fp],menufile));
}

int isuserstyle(int fp)
{
 int style;
 style=-1;
 if(gsmh) gsmh(&style);
 return(style==getnthstyle(stack[fp],menufile));
}


static void setuserstylemenu(setuserstylemenuhandler xssmh,getuserstylemenuhandler xgsmh)
{
 ssmh=xssmh;
 gsmh=xgsmh;
}

os_error * openuserstylemenu(setuserstylemenuhandler xssmh,
                             getuserstylemenuhandler xgsmh,int handle)
{
	setuserstylemenu(xssmh,xgsmh);
 return(openmenuparent("userstyle_menu",handle));
}





/*****************************************************************************/


/* icon value key */

static deciconstr fmdecicons[]=
{
  2,         -1,      27,
  1,    FMAPSUB,      13,
  0,FMAPREPLACE,      0,

 -1,          0,      0,
};


static decstr fmdecs=
{
 TMISSINGFONT,
 4,
 fmdecicons,

};


os_error * fmapbox(filestr * file,int * result,int n,int first)
{
 *result=FMAPSUB; //return(NULL);

 if(n==1) return(decboxparent(&fmdecs,0,result,"{FOX00}",fmapname(first,file)));
 else     return(decboxparent(&fmdecs,0,result,"{FOX01}",n,fmapname(first,file)));
}


/***************************************************************************/


os_error * dbstyleinit(void)
{
 trans(sample.stuff,sizeof(sample.stuff));
 sample.len=sample.maxlen=strlen(sample.stuff);
 addevent(EVENT_GETCOLOUR,(eventfn)txgetcolour,0);
 addevent(EVENT_SETCOLOUR,(eventfn)txsetcolour,0);
 return(NULL);
}

