/*->h.dc     */


#define STRLEN 64
#define STRMAX 63
#define KEYLEN 8
#define MINTOK 31
#define ESCTOK 30


typedef struct
{
 char name[24];
 char  mark[8];
 char copy[64];
 int  capabilities;
 char stuff[156];

} dheader;




/* object of type ODICT2 */

typedef struct dictstr
{
 int             nowords;
 int             noindex;
 int             index;
 int             words;
 int             version;        // not in ODICT
 int             flags;          // not in ODICT
 int             capabilities;   // not in ODICT
 int             spare[8];       // not in ODICT
} dictstr;


typedef struct odictstr
{
 int       key;
 int       type;
 dictstr   dict;
} odictstr;



/* object of type OBUFFER */

typedef struct Ovnbuffer
{
  struct Ovnbuffer ** anchor;  /* this points at the anchor in the source   */
  int     len;                 /* amount of stuff in buffer */
  int     maxlen;              /* maximum length of buffer  */
  int     previous;            /* offset of previous buffer */
  int     goffset;             /* offset of gap in buffer   */
  char    buff[4];             /* character buffer          */
} Ovnbuffer;

typedef struct obufferstr
{
 int       key;
 int       type;
 Ovnbuffer buffer;
} obufferstr;




typedef struct word
{
 char string[STRLEN];    /* the word                */
 int  woffset;           /* offset of start of word */
 int  indexn;            /* number of index         */
 int  wordn;             /* word number             */
 int  len;               /* bytes in word woffset+len==next word */
} word;


typedef struct indexstr
{
 unsigned int woffset;  /* offset of first word indexed */
 unsigned int wordn;    /* number of first word indexed */
 char         key[8];   /* string of characters         */
} indexstr;



#define SETWOFF(indexp,woff) ((indexp)->woffset=(woff))

#define WOFF(indexp)   ((indexp)->woffset)


#define SETWORDN(indexp,wordnv) ((indexp)->wordn=(wordnv))

#define WORDN(indexp)   ((indexp)->wordn)


extern int        addword(char * word,int dict,domainstr * d);
extern int        remword(int dict,word * words,domainstr * d);
extern os_error * savedc(char * name,int dict,int user,domainstr * d);
extern os_error * loaddc(char * name,int * dict,int user,domainstr * d);
extern void       trashdc(int * dict,domainstr * d);
extern int        deleteword(char * word,int dict,domainstr * d);
extern int        nowords(int dict,domainstr * d);
extern char     * wordn(int n,int dict,domainstr * d);
extern int        locword(int seekn,int dict,word * words,domainstr * d);
extern int        nextword(int dict,word * words,domainstr * d);
extern os_error * createdc(int * dict,domainstr * d);


extern int        findword(char * string,int dict,word * words,
                                     int * flags,domainstr * d);

extern int        findwords(char * string,int dict,word * words,
                                     int * flags,domainstr * d);

extern int        findnextword(char * string,int dict,word * words,
                                     int * flags,domainstr * d);

extern int        findwordabs(char * string,int dict,word * words,
                                     int * flags,domainstr * d);



extern os_error * copydc(int * ddict,domainstr * d,int sdict,domainstr * s);


extern char * mfx[256];

extern char * dcpath[2];

extern os_error * dcpathinit(void);

extern int xstrncmp(char * s1,char * s2,int max,int * flags);

/* compares at most max chars of two strings  */
/* flags output 0x1    - mismatched case      */
/* flags input  0x1000 - ignore hyphens       */


extern int xscanword(char * string,int * flags,char * subs,char * dcspc);

extern int xgetscanstring(char * string);

extern char * spcharbuffer(int key,domainstr * d,int offset);



