
#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  
#include <ctype.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "bbc.h"
#include "font.h"
#include "colour.h"
#include "flex.h"


#include "transform.h"
#include "xprocess.h"

#include "Drawlevel0.h"


#include "poll.h"
#include "key.h"
#include "etc.h"
#include "err.h"
#include "deb.h"
#include "osunits.h"
#include "xmath.h"
#include "alloc.h"
#include "bf.h"


#include "str.h"
#include "constants.h"
#include "xcolour.h"

#include "txstr.h"
#include "fox.h"
#include "fcache.h"
#include "fx.h"
#include "codes.h"
#include "txchoices.h"
#include "xrender.h"

#include "fxdraw.h"





static viewredrawstr * fxviewredraw;



typedef struct fxdfontstr
{
 int ffont;
 int xsize;
 int ysize;
 int count;

} fxdfontstr;



static fxdfontstr * fxdfont;
static int          fxdfontn;

static int          fxdcfont;
static int          fxdcfcol;
static int          fxdcbcol;


#define FXDCHUNK    (16*sizeof(fxdfontstr))


static os_error * fxdaddfont(char* name,int xsize,int ysize,font * f)
{
 os_error * err;
 int        ffont;
 int        i;

 err=NULL;

// cprintf("add name %s",name);

 *f=0;
 ffont=findxuserfont(name);

 if(ffont<0) err=generror(0,"Draw file font not present");
 else
 {
  for(i=0;i<fxdfontn;i++)
  {
   if(fxdfont[i].ffont==ffont && fxdfont[i].xsize==xsize && fxdfont[i].ysize==ysize)
   {
    fxdfont[i].count++;
    *f=i+1;
    break;
   }
  }

  if(i>=fxdfontn)
  {
   if(fxdfont==NULL) err=salloc((flex_ptr)&fxdfont,FXDCHUNK);
   else              err=schunk((flex_ptr)&fxdfont,(fxdfontn+1)*sizeof(fxdfontstr),FXDCHUNK);

   if(!err)
   {
//    cprintf("fxaddfont %s %d %d %d",name,ffont,xsize,ysize);
    fxdfont[fxdfontn].count=1;
    fxdfont[fxdfontn].ffont=ffont;
    fxdfont[fxdfontn].xsize=xsize;
    fxdfont[fxdfontn].ysize=ysize;
    fxdfontn++;
    *f=fxdfontn;
   }
  }

//  cprintf("add font %d",*f);
 }
 return(err);
}





static os_error * fxdlose(font f)
{

// cprintf("lose font %d",f);
 if(f>0)
 {
  fxdfont[(int)f-1].count--;

  while(fxdfontn>0 && fxdfont[fxdfontn-1].count<=0) fxdfontn--;

//  if(fxdfontn==0) cprintf("no font handles left in use");
 }
 return(NULL);
}





static os_error * fxdfind(char* name,int xsize,int ysize,int xres,int yres,font * f)
{
//	cprintf("ysize %d",ysize);

 return(fxdaddfont(name,(xsize*125)/2,(ysize*125)/2,f));			// pts*16 -> 72000'ths

 USE(xres);
 USE(yres);
}




#define COMMENT    21
#define ULINECODE  25
#define FONTCODE   26
#define COLCODE    18
#define COLCODE2   19
#define FTRANSFORM 27

#define VM 11
#define HM 9


#define ULLEN   3
#define FCLEN   2
#define VMLEN   4
#define HMLEN   4
#define CCLEN   4
#define CC2LEN  8





static os_error * fxdexpand(char * s,int xscale,int yscale)
{
 os_error  * err;
 char      * r;
 char      * w;
 char      * wbrk;
 char      * fold;
 int         ch;
 int         c;
 int         f;
 int         fos;
 int         fx;
 int         fy;
 int         fc;
 int         fcol;
 int         bcol;
 colourvalue bcv;
 colourvalue fcv;
 int         n;


 err=NULL;

 fxuni=txunicode;

 w=fbuff;
 r=s;
 fxitem=0;
 wbrk=fbuff+fxmaxl;


 cvfrompal(&ffcol,fxdcfcol);     // first values in line
 cvfrompal(&fbcol,fxdcbcol);
 bcv=fbcol;
 ffont=fxdfont[fxdcfont].ffont;
 fos=ffontos=fontosfromuser(ffont);
 ffxpt=scale(fxdfont[fxdcfont].xsize,xscale,0x10000);
 ffypt=scale(fxdfont[fxdcfont].ysize,yscale,0x10000);


 do
 {
  ch=*r++;
  ffl[fxitem]=r;
  ffb[fxitem++]=w;

  if(w>wbrk)
  {
   fold=fbuff;
   err=fxchunkl();
   if(err) break;
   wbrk=fbuff+fxmaxl;
   w=w-fold+fbuff;
  }

  if(fxitem>fxmaxi)
  {
   err=fxchunki();
   if(err) break;
  }

  if(ch<32)
  {
   switch(ch)
   {

    case       VM:
                  *w++=FXVM;
                  *w++=0; // padding
                  *w++=*r++;
                  *w++=*r++;
                  c=(*w++=*r++);
                  *w++=(char)((c&0x80)?0xFF:0); 
                  break;


    case       HM:
                  *w++=FXHM;
                  *w++=0; // padding
                  *w++=*r++;
                  *w++=*r++;
                  c=(*w++=*r++);
                  *w++=(char)((c&0x80)?0xFF:0);
                  break;


    case FONTCODE:
                  f=*r++;
																		f=fxdfont[f-1].ffont;
                  fos=fontosfromuser(f);
					
                  fx=scale(fxdfont[f-1].xsize,xscale,0x10000);
                  fy=scale(fxdfont[f-1].ysize,yscale,0x10000);
//               cprintf("fontcode %d fxdc %d",fy,fxdcfont);
                  *w++=FXFONTCODE;
                  *w++=0;
                  *w++=(char)f;
                  *w++=(char)(f>>8);
                  *w++=(char)(f>>16);
                  *w++=(char)(f>>24);
                  *w++=(char)fx;
                  *w++=(char)(fx>>8);
                  *w++=(char)(fx>>16);
                  *w++=(char)(fx>>24);
                  *w++=(char)fy;
                  *w++=(char)(fy>>8);
                  *w++=(char)(fy>>16);
                  *w++=(char)(fy>>24);
                  break;

    case  COMMENT:
                  while((*r++)>=32);
                  break;

   case ULINECODE:
                  fx=*r++;
                  fy=*r++;
                  break;

    case  COLCODE:
                  fc=((*r++)<<8)|((*r++)<<16)|((*r++)<<24);
                  cvfrompal(&fcv,fc);
                  fcol=*((int*)&fcv);
                  bcol=*((int*)&bcv);

                  *w++=FXCOLCODE2;
                  *w++=0; // padding
                  *w++=(char)(bcol);
                  *w++=(char)(bcol>>8);
                  *w++=(char)(bcol>>16);
                  *w++=(char)(bcol>>24);
                  *w++=(char)(fcol);
                  *w++=(char)(fcol>>8);
                  *w++=(char)(fcol>>16);
                  *w++=(char)(fcol>>24);
                  break;

          default:
//                  cprintf("font ex code %d",ch);
                  *w++=(char)(ch=0);
                  *w=0;
                  break;
   }
  }
  else
  {
   if(fxuni)
   {
    fontgetcode16(ch,fos,(wchar_t*)w,&n);
    w+=2*n;
   }
   else
   {
    fontgetcode8(ch,fos,w,&n);
    w+=n;
   }
  }
 } while(ch);





// cprintf("ffypt %x",ffypt);

 return(err);
}









static os_error * fxdpaints(char * s,int options,int x,int y,transformstr * tr,int xscale,int yscale)
{
 os_error * err;


 fxlinejustify=0;
 fxlinedx=fxlinedy=fxlineddx=fxlineddy=0;

 err=fxdexpand(s,xscale,yscale);
 if(!err)
 {
		if(tr) fxtr=*tr;
		else			tr_setidentity(&fxtr);

  if((options & font_OSCOORDS))
  {
   x*=400;
   y*=400;
  } 

  fxpaintbase(fbuff,x,y,fxviewredraw);  // because Draw code does zooming itself, so want no effect.
 }

 return(err);
}



static os_error * fxdpaint(char * s,int options,int x,int y)
{
 return(fxdpaints(s,options,x,y,NULL,0x10000,0x10000));
}



static os_error * fxdpainttrans(char * string,int options,int x,int y,font_transform * trans)
{
 transformbitstr ftrbits;
	transformstr    tr;
 
 tr_getbits((transformstr*)trans,&ftrbits);
 tr_setbits(&tr,&ftrbits,TR_ROTATE | TR_SKEW);

// cprintf("xshift %d yshift %d",ftrbits.xshift,ftrbits.yshift);

// cprintf("y =%d yshift %d scale %x",y,ftrbits.yshift,ABS(ftrbits.yscale));

 return(fxdpaints(string,options,x+=ftrbits.xshift,y-=ftrbits.yshift,&tr,ABS(ftrbits.xscale),ABS(ftrbits.yscale)));
}




static os_error * fxdsetfont(font f)
{
 fxdcfont=(int)f-1;
// cprintf("set font %d",f);
 return(NULL);
}




static os_error * fxdstrwidth(font_string *fs)
{
 os_error * err;
 char     * s;
 int        i;

// cprintf("fxstringwidth %s",fs->s);

 s=fs->s;

 err=fxdexpand(s,0x10000,0x10000);
 if(!err)
 {
  fs->s=fbuff;

  err=fxstrwidth(fs,0,0,0);
  if(!err)
  {
   if(fs->term>0)
   {
    i=fchop(fs->term,ffb,fbuff);
//  cprintf("fs->term %d i %d",fs->term,i);
    fs->term=ffl[i]-s;
//  cprintf("fs->term %d i %d",fs->term,i);
//  cprintf("fs->x %d",fs->x);
   }
  }
  fs->s=s;                          
 }

 return(err);
}



#define YLIMIT 0x7FFFFFFF
#define XLIMIT 0x7FFFFFFF



static os_error * fxdstringbbox(char * s,font_info *fi)
{
 os_error    * err;
 font_string   fs;

// cprintf("fxstringbbox %s",s);

// font_stringbbox(s,fi);


// cprintf("fxstringwidth %s",fs->s);

 err=fxdexpand(s,0x10000,0x10000);
 if(!err)
 {
  fs.s=fbuff;
  fs.term;
  fs.x=XLIMIT;
  fs.y=YLIMIT;

  err=fxstrwidth(&fs,0,0,FXSBBOX);
  if(!err)
  {
   fi->maxx=fs.x;
   fi->minx=0;
   fi->maxy=fxsmaxy;
   fi->miny=fxsminy;
  }
//  cprintf("minx %d maxx %d miny %d maxy %d",fi->minx,fi->maxx,fi->miny,fi->maxy);
 }
 return(err);
}




static os_error * fxdsetcolour(font f,int background,int foreground,int offset)
{
//  cprintf("set font col %d %d %d",f,background,foreground);
 if(f>0) fxdcfont=(int)f-1;
 fxdcfcol=foreground;
 fxdcbcol=background;
 return(NULL);
 USE(offset);
}




os_error * fxdsetview(viewredrawstr * v)
{
 fxviewredraw=v;
 return(NULL);
}


viewredrawstr * fxdview(void)
{
 return(fxviewredraw);
}


static os_error * fxdrawsetcolour(int pal,int action)
{
 return(render_setgcol(pal,action,fxviewredraw));
}



static os_error * fxdrawstroke(int * path,int thickness,int flags,int * caps,transformstr * tr,int style,int flatness)
{
 return(render_draw_stroke(path,thickness,flags,caps,tr,style,flatness,fxviewredraw));
}



static os_error * fxdrawfill(int * path,transformstr * tr,int windingrule,int flatness,int flags)
{
 return(render_draw_fill(path,tr,windingrule,flatness,flags,fxviewredraw));
}



os_error * fxdrawinit(void)
{
 Draw_registerFontFunctions(fxdfind,
                            fxdlose,
                            fxdpaint,
                            fxdpainttrans,
                            fxdsetfont,
                            fxdstrwidth,
                            fxdstringbbox,
                            fxdsetcolour);

 Draw_registerDrawFunctions(fxdrawfill,
                            fxdrawstroke,
                            fxdrawsetcolour);


 return(NULL);
}

