/*->c.merge     */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  
#include <ctype.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "font.h"
#include "bbc.h"
#include "werr.h"
#include "flex.h"

#include "transform.h"

#include "etc.h"
#include "err.h"
#include "wos.h"
#include "poll.h"
#include "key.h"
#include "fsx.h"
#include "bf.h"
#include "csv.h"
#include "alloc.h"
#include "xext.h"


#include "str.h"
#include "constants.h"
#include "codes.h"

#include "object.h"

#include "file.h"
#include "view.h"
#include "viewr.h"
#include "viewo.h"


#include "txstr.h"
#include "tx.h"
#include "vec.h"
#include "sx.h"
#include "vl.h"
#include "fx.h"
#include "style.h"
#include "fl.h"
#include "act.h"
#include "fields.h"

#include "pxstr.h"
#include "pict.h"

#include "merge.h"


/****************************************************************************/

static buffer      csvbf;
static csvstr    * newcsv;
static int         mergecommand;

static os_error * csvtx(csvstr * csv)
{
	os_error * err;
	int        i;
	char     * p;
	int        c;

	err=NULL;

	for(i=0;i<csv->records;i++)
	{
		p=csv->record[i];
		while((c=*p)!=0)
		{
			*p++=(char)code8symbolinv(c);
		}
	}

	return(err);
}




static os_error * mergereflow(textboxstr * textp,filestr * file,int u)
{
 os_error * err;
 int        c;
 char     * p;
 int        bits;
 int        inslen;
 char     * insert;
 int        remlen;
 int        n;
 int        text;
 vector     v;
 int        changed;
 flowstr    fl;
 char     * string;


 err=NULL;

 text=textp->key;

 setvectorfrombox(&v,u,text,file);

 err=txlock(&v.textsrc,file);
 if(!err)
 {
  v.textsrc.offset=0;
  changed=0;

  while(1)
  {
   p=txptr(v.textsrc.sourcep,v.textsrc.offset);
   c=*p;
   bits=codex[c];

   if(c==MACSEQ)
   {
    n=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);

    remlen=0;

    if(mergecommand==MERGEDATA || mergecommand==MERGEOFF)
    {
     if(*(p+4)==EINTSEQ)
     {
      remlen=(*(p+5))+((*(p+6))<<8)+((*(p+7))<<16)+((*(p+8))<<24);
     }
    }
    else
    if(mergecommand==MERGESTRIP)
    {
     remlen=MSLEN;
     if(*(p+4)==EINTSEQ) remlen+=EINTLEN;
    }

    if(mergecommand==MERGEDATA) err=getfield(n,newcsv,file,&string);
    else                        string=NULL;

    if(!err)
    {
     if(!string) 
     {
      insert=NULL;
      inslen=0;
     }
     else
     {
      insert=string;
      inslen=(*(string+1))+((*(string+2))<<8)+((*(string+3))<<16)+
                                              ((*(string+4))<<24);
     }

     if(mergecommand==MERGEDATA || mergecommand==MERGEOFF)
                                              v.textsrc.offset+=MSLEN;

     if(inslen || remlen)
     {
      txsourcereplace(remlen,inslen,insert,&v.textsrc,file);
     }

     changed=1;
     v.textsrc.offset+=inslen;

     if(mergecommand==MERGEDATA) err=losefield(&string);
    }
   }
   else
   if(c==EOT) break;
   else       v.textsrc.offset+=bits & CODELEN;
  }

  txunlock(&v.textsrc,file);


  if(changed)
  {
   fl.opcode=FWAIT|FDATA;

   fl.data.type=FLDIRTY;
   fl.data.offset=0;
   fl.data.delta=0;
   fl.data.length=v.textsrc.offset;

   v.textsrc.offset=0;

   flow(&v,&fl);
  }
 }

 return(err);
}





static os_error * mergefn(textboxstr * textp,filestr * file,int * message)
{
 os_error   * err;
 int          text;

 err=NULL;

 text=textp->key;

 if(textp->type==OTEXTBOX)
 {
  if(!textp->fchain.prev)
  {
   mergereflow(textp,file,0);
  }

  textp=(textboxstr*)fob_find(text,file);

  if(textp->data.header)
  {
   mergereflow(textp,file,1);
  }

  textp=(textboxstr*)fob_find(text,file);

  if(textp->data.footer) 
  {
   mergereflow(textp,file,2);
  }
 }
 else
 if(textp->type==OPICTBOX)
 {
  pictmerge((pictboxstr*)textp,mergecommand,file);
 }

 return(err);

 USE(message);
}




static os_error * mergereflowall(filestr * file,int command)
{
 os_error * err;
 int        message;

 mergecommand=command;

 pictmergeall(command,0,file);

 message=OM_FUNCTION2;
 err=broadcastmessage(file,&message,(void*)mergefn);

 flowvalidfile(file);

 pictmergeall(command,1,file);

 return(NULL);
 USE(file);
}





os_error * mergeseek(int record,filestr * file,int * eof)
{
 os_error * err;

 err=NULL;

 newcsv=NULL;

 if(record==-1)
 {
  err=csvgetrecord(&csvbf,&newcsv);
 }
 else
 {
  err=csvgetrecordn(record,&csvbf,&newcsv);
 }


 if(newcsv)
 {
		csvtx(newcsv);

  event(EVENT_MERGEDATA,file,record);
  mergereflowall(file,MERGEDATA);
  file->mergedata=1;
  sfree((flex_ptr)&newcsv);
  *eof=0;
 }
 else
 {
  *eof=1;
 }

 return(NULL);
}



os_error * mergeclose(filestr * file)
{
 os_error * err;

 err=csvclose(&csvbf,NULL);

 if(file->merge)
 {
  file->merge=0;
  mergereflowall(file,MERGEOFF);
  event(EVENT_MERGECLEAR,file,NULL);
  file->mergedata=0;
 }

 event(EVENT_MERGEFINISH,file,NULL);

 return(err);
}




os_error * mergeopen(char * name,filestr * file)
{
 os_error * err;

 newcsv=NULL;

 event(EVENT_MERGESTART,file,(int)name);

 err=csvopen(name,&csvbf,'r');

 if(!err) file->merge=1;

 return(err);
}




int mergefield(int fp)
{
 int n;

 n=stack[fp];

 if(!newcsv || n>newcsv->records || n<1) 
 {
  return(createstring(""));
 }
 else
 {
  return(createstring(newcsv->record[n-1]));
 }
}


int mergemaxfield(int fp)
{
 return(newcsv?newcsv->records:0);
 USE(fp);
}


int mergenextrecord(int fp)
{
 os_error * err;
 int eof;

 sfree((flex_ptr)&newcsv);

 err=csvgetrecord(&csvbf,&newcsv);
 eof=(err==NULL && newcsv!=NULL)?0:1;
	if(!eof)
	{
		csvtx(newcsv);
	}


 return(eof);
 USE(fp);
}



/****************************************************************************/




os_error * mergefinish(filestr * file)
{

 if(file->merge)
 {
  event(EVENT_MERGECLEAR,file,NULL);
  file->merge=0;
  mergereflowall(file,MERGEOFF);
  file->mergedata=0;
 }

 event(EVENT_MERGEFINISH,file,NULL);

 return(NULL);
}




os_error * mergestart(filestr * file)
{
 newcsv=NULL;

 event(EVENT_MERGESTART,file,(int)"");

 file->merge=1;

 return(NULL);
}




os_error * mergeclear(filestr * file)
{
 if(file->merge)
 {
  event(EVENT_MERGESTRIP,file,NULL);
  file->merge=file->mergedata=0;
  mergereflowall(file,MERGESTRIP);
 }

 return(NULL);
}




os_error * mergeupdate(csvstr * newdata,filestr * file)
{
 os_error * err;

 err=NULL;

 newcsv=newdata;

 if(file->merge)
 {
  event(EVENT_MERGEDATA,file,-1);
  mergereflowall(file,MERGEDATA);
  file->mergedata=1;
 }

 return(NULL);
}




