/*->c.mx */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "font.h"
#include "transform.h"
#include "xprocess.h"


#include "err.h"
#include "xmath.h"
#include "fsx.h"
#include "bf.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "colour.h"
#include "etc.h"
#include "deb.h"


#include "constants.h"
#include "str.h"
#include "obj.h"
#include "object.h"
#include "reslink.h"

#include "geometry.h"

#include "viewr.h"
#include "view.h"
#include "file.h"
#include "chain.h"
#include "posn.h"

#include "select.h"

#include "splib.h"
#include "editpath.h"
#include "objectdb.h"
#include "undo.h"
#include "units.h"

#include "xcolour.h"
#include "border.h"
#include "xredraw.h"
#include "curve.h"
#include "chain.h"
#include "fillstub.h"

#include "pxstr.h"
#include "pict.h"
#include "impex.h"
#include "frameflow.h"

#include "section.h"

#include "txstr.h"
#include "tx.h"
#include "txprivate.h"
#include "fx.h"
#include "vl.h"
#include "vi.h"
#include "fl.h"
#include "style.h"
#include "caret.h"
#include "vec.h"
#include "act.h"
#include "texttool.h"
#include "codes.h"
#include "fmap.h"
#include "fox.h"
#include "text.h"
#include "stylemap.h"


#include "new.h"
#include "newx.h"
#include "mpage.h"


#include "mx.h"





/* file of functions concerned with manipulating text frames on master pages */



#define UTMXLOCAL   0x6100
#define UTMXMASTER  0x6101
#define UMAKEMASTER 0x6102
#define UPXTX       0x6103
#define UPXTXMK     0x6104
#define UUDM        0x6105
#define URDM        0x6106
#define ULOADDOC    0x6107
#define USAVEDOC    0x6108
#define ULOADMST    0x6109
#define USAVEMST    0x610A



int nullsource(int source,filestr * file)
{
 sourcestr * s;
 int         offset;
 int         len;
 int         c;

 s=(sourcestr*)fob_find(source,file);
 offset=0;
 len=s->len;

 while(offset<len)
 {
  c=*txptr(s,offset);

  switch(c)
  {
   case SNO:
   case EOT:
            break;

    default:
            return(0);
            break;

  }
  offset+=codex[c] & CODELEN;
 }
 return(1);
}




os_error * nullzone(vector * s1,vector * s2,int * zone)
{
 os_error * err;
 int        c;
 int        limit;
 int        offset;
 int        bits;

 err=NULL;

 *zone=0;

 if(s1->textsrc.offset!=s2->textsrc.offset)
 {
  err=txlock(&s1->textsrc,s1->file);
  if(!err)
  {
   if(s2->textsrc.offset>s1->textsrc.offset)
   {
    offset=s1->textsrc.offset;
    limit=s2->textsrc.offset;
   }
   else
   {
    offset=s2->textsrc.offset;
    limit=s1->textsrc.offset;
   }

   while(offset<limit)
   {
    c=*txptr(s1->textsrc.sourcep,offset);
    bits=codex[c];
    offset+=bits & CODELEN;

    if(c==EOT) break;
    else
    if(c!=SNO)
    {
     *zone=1;
     break;
    }
   }

   txunlock(&s1->textsrc,s1->file);
  }
 }
 return(err);
}











/* a null source on a master page, can only be edited if all frames */
/* based on it in the document are also null                        */

/* a source in the document can only be edited if its master        */
/* frame is also null                                               */

/* a repeating frame cannot have text in it on the master frame     */
/* a repeating frame cannot have a picture put in it                */



os_error * txeditable(int textk,int section,int u,filestr * file)
{
 os_error   * err;
 sectionstr * sectionp;
 pagestr    * pagep;
 textboxstr * textp;
 int          dsection;
 int          message;
 int          master;
 texsrc     * texsp;
 int          nextpage;


 err=NULL;

 sectionp=(sectionstr*)fob_find(section,file);
 if(sectionp->branch)                       /* master page section */
 {
  dsection=sectionp->dual;
  textp=(textboxstr*)fob_find(textk,file);

  if(textp->data.repeat && u==0) return(geterror(ETXE2));
  else
  {
   texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

   if(!nullsource(texsp[u].source,file)) return(err);
   else
   {
    sectionp=(sectionstr*)fob_find(dsection,file);

    nextpage=sectionp->chain.child;
    while(nextpage)    /* assert only one matching master object per page */
    {                  /* can optimise by only doing left/right pages     */
     pagep=(pagestr*)fob_find(nextpage,file);
     nextpage=pagep->chain.next;

     message=OM_FINDMASTER;
     master=textk;
     objectchainmessage(pagep->chain.child,file,&message,&master);

     if(!message)
     {
      textp=(textboxstr*)fob_find(master,file);
      if(!textp->flags.local)
      {
       if(textp->type==OPICTBOX) return(geterror(ETXE3));
       else
       {
        texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
								// ah yes but does the doc frame have a header/footer at all?
								if(u==0 || (u==1 && textp->data.header) || (u==2 && textp->data.footer))
								{
         if(!nullsource(texsp[u].source,file)) return(geterror(ETXE3));
								}
       }
      }
     }
    }
   }
  }
 }
 else
 {
  textp=(textboxstr*)fob_find(textk,file);
  if(textp->master && !textp->flags.local)
  {
   if(textp->data.repeat && u==0) return(err);
   else
   {
    textp=(textboxstr*)fob_find(textp->master,file);
    if(textp->type==OPICTBOX) return(geterror(ETXE0));
    else
    {
     texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
     if(!nullsource(texsp[u].source,file)) return(geterror(ETXE1));
    }
   }
  }
 }

 return(err);
}




os_error * txconvertable(int textk,int section,filestr * file)
{
 os_error   * err;
 textboxstr * textp;
 texsrc     * texsp; 

 err=txeditable(textk,section,0,file);
 if(!err)
 {
  textp=(textboxstr*)fob_find(textk,file);

//  cprintf("fprev %x fnext %x type %x",textp->fchain.prev,textp->fchain.next,textp->type);

  if(textp->fchain.prev || textp->fchain.next) err=geterror(ETXE4);
  else
  if(textp->data.repeat) err=geterror(ETXE5);
  else
  {
   texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
   if(!nullsource(texsp[0].source,file)) err=geterror(ETXE6);
  }
 }

 return(err);
}



/****************************************************************************/

/* this is the trivial operation */


/* tagged to UTMXLOCAL */

static os_error *  untxmakelocal(filestr * file)
{
 os_error   * err;
 int          object;
 textboxstr * textp=NULL;

          err=undoread(file,&object,sizeof(int));
 if(!err) err=undowritefn(file,UTMXMASTER,&object,sizeof(int));
 if(!err) err=fob_mod(object,file,(fobjptr)&textp);
 if(!err)
 {
  textp->flags.local=1;
  textp->flags.masterdata=0;
 }

 return(err);
}


/* tagged to UTMXMASTER */

static os_error *  untxmakemaster(filestr * file)
{
 os_error   * err;
 int          object;
 textboxstr * textp=NULL;

          err=undoread(file,&object,sizeof(int));
 if(!err) err=undowritefn(file,UTMXLOCAL,&object,sizeof(int));
 if(!err) err=fob_mod(object,file,(fobjptr)&textp);
 if(!err)
 {
  textp->flags.local=0;
  textp->flags.masterdata=1;
 }

 return(err);
}




static os_error * txmakelocal(textboxstr * textp,filestr * file)
{
 int master;

 master=textp->master;

 if(master)
 {
  if(!textp->flags.local && !textp->data.repeat)  
  {
   textp->flags.local=1;
   textp->flags.masterdata=0;
   undowritefn(file,UTMXMASTER,&textp->key,sizeof(int));
  }
 }

 return(NULL);
}


/****************************************************************************/


static int textsize(textboxstr * xnew)
{
 int newsize;

 newsize=sizeof(textboxstr);
 if(xnew->data.header || xnew->data.footer)
 {
  newsize+=sizeof(texhdr)+3*sizeof(texsrc)+
                                         (xnew->data.columns+2)*sizeof(texsub);
 }
 else
 {
  newsize+=sizeof(texsrc)+xnew->data.columns*sizeof(texsub);
 }

 return(newsize);
}



static void mxgethdr(textboxstr * textp,texhdr * texhp)
{
 if(textp->data.header || textp->data.footer)
 {
  *texhp=*((texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc)));
 }
 else
 {
  memset(texhp,0,sizeof(texhdr));
 }
}


static void mxgetexs(textboxstr * textp,texsrc * texsp)
{
 texsrc * xtexsp;

 xtexsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

 if(textp->data.header || textp->data.footer)
 {
  XMEMCPYX(texsp,xtexsp,3*sizeof(texsrc));
 }
 else
 {
  memset(texsp,0,3*sizeof(texsrc));
  *texsp=*xtexsp;
 }
}



static os_error * txscrapcontents(textboxstr * textp,filestr * file)
{
 os_error * err;
 textboxstr old;
 texsrc     texs[3];
 int        i;

 err=NULL;

 old=*textp;

 mxgetexs(textp,texs);

 for(i=0;i<3;i++)
 {
  txsourcedel(texs[i].source,file,1);
  vsourcedel(texs[i].vsource,file);
 }

 if(old.data.changei)     err=deletecurve(&old.icurve,file);
 if(old.textflow.changeo) err=deletecurve(&old.ocurve,file);

 return(err);
}


static os_error * txcopysources(int * osource,int * ovsource,
                                 int nsource,int nvsource,
                                 int text,int page,int section,filestr * file)
{
 os_error     * err;
 transformstr   tr;
 int            copymode;

 tr_setidentity(&tr);
 copymode=LOCFLOWDATA;

 err=txcopysourcedata(nsource,osource,
                      nvsource,ovsource,file,file,copymode);

 if(!err) err=txcopyeobs(file,file,&tr,
                               text,page,section,*osource,
                               0,-1,copymode);
 return(err);
}





static os_error * makemastersub(int textk,textboxstr * xnew,
                                texhdr * xtexhp,texsrc * xtexsp,filestr * file)
{
 os_error   * err;
 textboxstr * textp;
 int          changei;
 int          changeo;
 int          cbits;
 texhdr     * texhp;
 texsrc     * texsp;
 int          newsize;

 trashvboxes(textk,file);

 newsize=textsize(xnew);

 err=fob_change(textk,file,newsize,(fobjptr)&textp);

 vxadd((sobjectstr **)&textp,file);
 frameflow((sobjectstr **)&textp,file);

 frfladdb((sobjectstr **)&textp,file,1);

 changei=xnew->data.changei;
 changeo=xnew->textflow.changeo;

 textp->data=xnew->data;
 textp->transform=xnew->transform;
 textp->fcurve=xnew->fcurve;
 textp->frame=xnew->frame;

 texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

 if(xnew->data.header || xnew->data.footer)
 {
  texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
  *texhp=*xtexhp;
  XMEMCPYX(texsp,xtexsp,3*sizeof(texsrc));
 }
 else
 {
  *texsp=*xtexsp;
 }

 getmaxbox(&textp->box,&textp->fcurve.box,&textp->transform);
 setcurveradius(&textp->fcurve,textp->data.radius,&textp->transform);

 if(!changei || !changeo)
 {
  cbits=BCDEL;
  if(!changei) cbits|=BCINNER;
  if(!changeo) cbits|=BCOUTER;
  txboundingcurves(&textp,file,cbits);
 }

 if(changei) textp->icurve=xnew->icurve;
 if(changeo) textp->ocurve=xnew->ocurve;

 frameflow((sobjectstr **)&textp,file);
 vxadd((sobjectstr **)&textp,file);

 textp->flags.local=textp->flags.local^1;

 textp->flags.spread=xnew->flags.spread;
 textp->flags.locked=xnew->flags.locked;
 textp->flags.masterdata=xnew->flags.masterdata;

 zerocolumns(textp,-1,1);

 return(err);
}



static os_error * txmkmr(filestr * file,textboxstr * xnew,
                                        texhdr * texhp,texsrc * texsp)
{
 os_error * err;

          err=undoread(file,&xnew->transform,sizeof(transformstr));
 if(!err) err=undoread(file,&xnew->data,sizeof(textdatastr));
 if(!err) err=undoread(file,&xnew->textflow,sizeof(textflowstr));
 if(!err) err=undoread(file,&xnew->flags,sizeof(flagstr));
 if(!err) err=undoread(file,&xnew->frame,sizeof(int));
 if(!err) err=undoread(file,&xnew->fcurve,sizeof(curvestr));
 if(!err) err=undoread(file,texhp,sizeof(texhdr));
 if(!err) err=undoread(file,texsp,3*sizeof(texsrc));

 if(!err && xnew->data.changei)err=undoread(file,&xnew->icurve,sizeof(curvestr));
 else                             nullcurve(&xnew->icurve);

 if(!err && xnew->textflow.changeo)
                              err=undoread(file,&xnew->ocurve,sizeof(curvestr));
 else                             nullcurve(&xnew->ocurve);

 return(err);
}


static os_error * txmkmw(filestr * file,textboxstr * xnew,
                                            texhdr * texhp,texsrc * texsp)
{
 os_error * err;

          err=undowrite(file,&xnew->transform,sizeof(transformstr));
 if(!err) err=undowrite(file,&xnew->data,sizeof(textdatastr));
 if(!err) err=undowrite(file,&xnew->textflow,sizeof(textflowstr));
 if(!err) err=undowrite(file,&xnew->flags,sizeof(flagstr));
 if(!err) err=undowrite(file,&xnew->frame,sizeof(int));
 if(!err) err=undowrite(file,&xnew->fcurve,sizeof(curvestr));
 if(!err) err=undowrite(file,texhp,sizeof(texhdr));
 if(!err) err=undowrite(file,texsp,3*sizeof(texsrc));

 if(!err && xnew->data.changei) 
          err=undowrite(file,&xnew->icurve,sizeof(curvestr));
 if(!err && xnew->textflow.changeo)
          err=undowrite(file,&xnew->ocurve,sizeof(curvestr));

 return(err);
}


static os_error * txmkms(filestr * file)
{
 os_error   * err;
 textboxstr   xnew;
 texhdr       newtexh;
 texsrc       newtexs[3];
 int          i;

 err=txmkmr(file,&xnew,&newtexh,newtexs);

 if(!err)
 {
  for(i=0;i<3;i++)
  {
   txsourcedel(newtexs[i].source,file,1);
   vsourcedel(newtexs[i].vsource,file);
  }

  err=deletecurve(&xnew.fcurve,file);

  if(!err && xnew.data.changei)     err=deletecurve(&xnew.icurve,file);

  if(!err && xnew.textflow.changeo) err=deletecurve(&xnew.ocurve,file);

  if(!err) err=deleteborder(xnew.frame,file);
  /* if(!err) err=deletefill(&new.data.fill,file); */
 }

 return(err);
}




/* save text box stuff, about to be turned into pix */

os_error * txmxsave(int text,filestr * file)
{
 textboxstr * textp;
 textboxstr   old;
 texhdr       texh;
 texsrc       texs[3];

 textp=(textboxstr*)fob_find(text,file);
 old=*textp;
 mxgethdr(textp,&texh);
 mxgetexs(textp,texs);

 return(txmkmw(file,&old,&texh,texs));
}


/* reload text box stuff, turn pix into text */

os_error * txmxload(int text,filestr * file)
{
 os_error   * err;
 textboxstr * textp;
 textboxstr   xnew;
 texhdr       texh;
 texsrc       texs[3];


 textp=(textboxstr*)fob_find(text,file);

 textfrompictlo(textp,file);

 err=txmkmr(file,&xnew,&texh,texs);
 if(!err) err=makemastersub(text,&xnew,&texh,texs,file);

 return(err);
}


os_error * txmxscrap(int text,filestr * file)
{
 return(txmkms(file));
 USE(text);
}



/* given pict frame, text master */

os_error * txpxmakemaster(int text,int master,filestr * file)
{
 textboxstr    xnew;
 textboxstr  * textp;
 curvestr      fcurve;
 texhdr        texh;
 texsrc        texs[3];
 int           page;
 int           section;


 textp=(textboxstr*)fob_find(text,file);
 textfrompictlo(textp,file);

 textp=(textboxstr*)fob_find(text,file);
 pagesectionof((chainobject*)textp,file,&page,&section);

 textp=(textboxstr*)fob_find(master,file);

 xnew=*textp;
 mxgethdr(textp,&texh);
 mxgetexs(textp,texs);


 txcopysources(&texs[0].source,&texs[0].vsource,
                texs[0].source,texs[0].vsource,
                        text,page,section,file);


 if(xnew.data.header)
 {
  txcopysources(&texs[1].source,&texs[1].vsource,
                 texs[1].source,texs[1].vsource,
                         text,page,section,file);
 }


 if(xnew.data.footer)
 {
  txcopysources(&texs[2].source,&texs[2].vsource,
                 texs[2].source,texs[2].vsource,
                         text,page,section,file);
 }


 texh.footerdata=texh.headerdata=1;
 xnew.flags.masterdata=1;

 fcurve=xnew.fcurve;

 copycurve(&xnew.fcurve,file,&fcurve,file);

 if(xnew.data.changei) 
 {
  fcurve=xnew.icurve;
  copycurve(&xnew.icurve,file,&fcurve,file);
 }

 if(xnew.textflow.changeo)
 {
  fcurve=xnew.ocurve;
  copycurve(&xnew.ocurve,file,&fcurve,file);
 }

 copyborder(&xnew.frame,xnew.frame,file);
 copyfill(&xnew.data.fill,&xnew.data.fill,file);

 makemastersub(text,&xnew,&texh,texs,file);

 return(NULL);
}



/* does this master frame contain data */

int txmxdata(int master,filestr * file)
{
 textboxstr * textp;
 texsrc     * texsp;

 textp=(textboxstr*)fob_find(master,file);
 if(textp->type==OTEXTBOX)
 {
  texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
  return(!nullsource(texsp->source,file));
 }

 return(0);
}





/* tagged to UMAKEMASTER */

static os_error * unmakemasterscrap(filestr * file)
{
 os_error * err;
 int        text;
 err=undoread(file,&text,sizeof(int));
 if(!err) err=txmkms(file);
 return(err);
}




static os_error * unmakemaster(filestr * file)
{
 os_error   * err;
 textboxstr   old;
 textboxstr   xnew;
 int          textk;
 texhdr       newtexh;
 texhdr       oldtexh;
 texsrc       newtexs[3];
 texsrc       oldtexs[3];
 textboxstr * textp;


 err=undoread(file,&textk,sizeof(int));

 textp=(textboxstr*)fob_find(textk,file);
 old=*textp;
 mxgethdr(textp,&oldtexh);
 mxgetexs(textp,oldtexs);

 if(!err) err=undowritefn(file,UMAKEMASTER,&textk,sizeof(int));

 if(!err) err=txmkmr(file,&xnew,&newtexh,newtexs);

 if(!newtexs[0].source)
 {
  newtexs[0]=oldtexs[0];
  oldtexs[0].source=oldtexs[0].vsource=0;
 }

 if(!newtexs[1].source && xnew.data.header)
 {
  newtexs[1]=oldtexs[1];
  oldtexs[1].source=oldtexs[1].vsource=0;
 }

 if(!newtexs[2].source && xnew.data.footer)
 {
  newtexs[2]=oldtexs[2];
  oldtexs[2].source=oldtexs[2].vsource=0;
 }

 if(!err) err=txmkmw(file,&old,&oldtexh,oldtexs);

 if(!err) err=makemastersub(textk,&xnew,&newtexh,newtexs,file);

 return(err);
}



/**************************************************************************/
/* routines concerned with a doc text frame being made into a master pix  */

/* undo - pix goes back to text */

static os_error * upxtxscrap(filestr * file)
{
 int pict;
 undoread(file,&pict,sizeof(int));
 return(txmkms(file));
}


static os_error * upxtx(filestr * file)
{
 int          key;
 pictboxstr * pictp;
 texhdr       texh;
 texsrc       texs[3];
 textboxstr   xnew;

 undoread(file,&key,sizeof(int));
 undowritefn(file,UPXTXMK,&key,sizeof(int));

 pxmxsave(key,file);

 pictp=(pictboxstr*)fob_find(key,file);

 textfrompictlo((textboxstr*)pictp,file);

 txmkmr(file,&xnew,&texh,texs);

 makemastersub(key,&xnew,&texh,texs,file);

 return(NULL);
}


/* redo text goes back to pix */

static os_error * upxtxmkscrap(filestr * file)
{
 int text;
 undoread(file,&text,sizeof(int));
 return(pxmxscrap(text,file));
}


static os_error * upxtxmk(filestr * file)
{
 os_error   * err;
 int          text;
 textboxstr * textp;
 texhdr       texh;
 texsrc       texs[3];
 textboxstr   old;


 undoread(file,&text,sizeof(int));

 textp=(textboxstr*)fob_find(text,file);

 old=*textp;

 mxgethdr(textp,&texh);
 mxgetexs(textp,texs);

          err=undowritefn(file,UPXTX,&text,sizeof(int));
 if(!err) err=txmkmw(file,&old,&texh,texs);
 if(!err) err=pxmxload(text,file);

 return(NULL);
}



/* this is not trivial */

static os_error * txmakemaster(textboxstr * textp,filestr * file)
{
 os_error  * err;
 int         master;
 textboxstr  old;
 textboxstr  xnew;
 int         textk;
 int         page;
 int         section;
 curvestr    fcurve;
 texhdr      oldtexh;
 texhdr      newtexh;
 texsrc      oldtexs[3];
 texsrc      newtexs[3];



 err=NULL;
 master=textp->master;

 if(master)
 {
  if(textp->flags.local)
  {
   textk=textp->key;
   old=*textp;

   mxgethdr(textp,&oldtexh);
   mxgetexs(textp,oldtexs);

   clearactiveff(textk,file);

   pagesectionof((chainobject*)textp,file,&page,&section);

   textp=(textboxstr*)fob_find(master,file);
   if(textp->type==OPICTBOX)
   {
             err=undowritefn(file,UPXTX,&textk,sizeof(int));
    if(!err) err=txmkmw(file,&old,&oldtexh,oldtexs);
    if(!err) err=pxtxmakemaster(textk,master,file);
   }
   else
   {
    xnew=*textp;
    mxgethdr(textp,&newtexh);
    mxgetexs(textp,newtexs);

    if(old.flags.masterdata)
    {
     newtexs[0]=oldtexs[0];
     oldtexs[0].source=oldtexs[0].vsource=0;
    }
    else
    {
     txcopysources(&newtexs[0].source,&newtexs[0].vsource,
                    newtexs[0].source,newtexs[0].vsource,
                        textk,page,section,file);
    }


    if(old.data.header && oldtexh.headerdata && xnew.data.header)
    {
     newtexs[1]=oldtexs[1];
     oldtexs[1].source=oldtexs[1].vsource=0;
    }
    else
    if(xnew.data.header)
    {
     txcopysources(&newtexs[1].source,&newtexs[1].vsource,
                    newtexs[1].source,newtexs[1].vsource,
                        textk,page,section,file);
    }


    if(old.data.footer && oldtexh.footerdata && xnew.data.footer)
    {
     newtexs[2]=oldtexs[2];
     oldtexs[2].source=oldtexs[2].vsource=0;
    }
    else
    if(xnew.data.footer)
    {
     txcopysources(&newtexs[2].source,&newtexs[2].vsource,
                    newtexs[2].source,newtexs[2].vsource,
                        textk,page,section,file);
    }

             err=undowritefn(file,UMAKEMASTER,&textk,sizeof(int));
    if(!err) err=txmkmw(file,&old,&oldtexh,oldtexs);

    newtexh.footerdata=newtexh.headerdata=1;
    xnew.flags.masterdata=1;

    fcurve=xnew.fcurve;

    copycurve(&xnew.fcurve,file,&fcurve,file);

    if(xnew.data.changei) 
    {
     fcurve=xnew.icurve;
     copycurve(&xnew.icurve,file,&fcurve,file);
    }

    if(xnew.textflow.changeo)
    {
     fcurve=xnew.ocurve;
     copycurve(&xnew.ocurve,file,&fcurve,file);
    }
  
    copyborder(&xnew.frame,xnew.frame,file);
    copyfill(&xnew.data.fill,&xnew.data.fill,file);

    makemastersub(textk,&xnew,&newtexh,newtexs,file);
   }
  }
 }
 return(err);
}



/****************************************************************************/


static void txgetsources(textboxstr * textp,int * usizep,
                                            int * source,int * vsource)
{
 texsrc      * texsp;
 int           usize;
 int           i;

 if(textp->data.header || textp->data.footer) usize=3;
 else                                         usize=1;

 texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

 for(i=0;i<usize;i++)
 {
  source[i]=texsp->source;
  vsource[i]=texsp->vsource;
  texsp++;

 /* dprintf(0,"i=%d s=%d v=%d",i,source[i],vsource[i]); */
 }

 for(i=usize;i<3;i++)
 {
  source[i]=vsource[i]=0;
 }

 *usizep=usize;
}



static os_error * txforcesources(int * osource,int * ovsource,
                                 int nsource,int nvsource,
                                 int text,int page,int section,filestr * file)
{
 os_error     * err;
 transformstr   tr;
 int            copymode;

          err=txsourcedel(*osource,file,1);
 if(!err) err=vsourcedel(*ovsource,file);

 tr_setidentity(&tr);
 copymode=LOCFLOWDATA;

 if(!err) err=txcopysourcedata(nsource,osource,
                               nvsource,ovsource,file,file,copymode);

 if(!err) err=txcopyeobs(file,file,&tr,
                               text,page,section,*osource,
                               0,-1,copymode);
 return(err);
}




static os_error * txforcemaster(int mode,textboxstr * textp,filestr * file)
{
 os_error    * err;
 textboxstr    xnew;
 textboxstr    old;
 int           text;
 int           master;
 int           osource[3];
 int           ovsource[3];
 int           nsource[3];
 int           nvsource[3];
 texsrc      * texsp;
 int           newsize;
 int           ousize;
 int           nusize;
 int           i;
 int           page;
 int           section;
 texhdr      * texhp;
 int           headerdata;
 int           footerdata;
 int           header;
 int           footer;
 sectionmapstr map;
 sectionstr  * sectionp;


 err=NULL;


 cprintf("txforcemaster %d",mode);

 if(mode==FORCEMASTER || mode==FORCEMASTERU || mode==FORCEMASTERR)
 {
  master=textp->master;
  text=textp->key;

// cprintf("master=%d text=%d fill %d",master,text,textp->data.fill.fill); 

  if(mode==FORCEMASTERU) master=findoldmaster(master,file,0);

  if(master)
  {
   old=*textp;

   if(old.data.header || old.data.footer)
   {
    texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
    headerdata=texhp->headerdata;
    footerdata=texhp->footerdata;
   }
   else
   {
    headerdata=footerdata=0; /* compiler */
   }

   vxadd((sobjectstr **)&textp,file);
   frameflow((sobjectstr **)&textp,file);

   txgetsources(textp,&ousize,osource,ovsource);

   pagesectionof((chainobject*)textp,file,&page,&section);

   textp=(textboxstr*)fob_find(master,file);
   if(textp->type==OPICTBOX)
   {
    textp=(textboxstr*)fob_find(text,file);
    txscrapcontents(textp,file);
    textp=(textboxstr*)fob_find(text,file);
    pictfromtextlo((pictboxstr*)textp,file);
    objectlocal(text,file,mode);
   }
   else
   {
    deletecurve(&old.icurve,file);
    deletecurve(&old.ocurve,file);
    deletecurve(&old.fcurve,file);
    deleteborder(old.frame,file);
    deletefill(&old.data.fill,file);

    textp=(textboxstr*)fob_find(master,file);
    xnew=*textp;

    if(xnew.data.header || xnew.data.footer)
    {
     texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
     header=texhp->header;
     footer=texhp->footer;
    }
    else
    {
     header=footer=0;
    }


    txgetsources(textp,&nusize,nsource,nvsource);



    if(old.data.header && !xnew.data.header)
    {


    }
    else
    if(!old.data.header && xnew.data.header)
    {
     txforcesources(&osource[1],&ovsource[1],nsource[1],nvsource[1],
                                                    text,page,section,file);
     headerdata=1;
    }
    else
    if(old.data.header && xnew.data.header)
    {
     if(!nullsource(nsource[1],file) && nullsource(osource[1],file))
                                                              headerdata=1;

     if(headerdata)
     {
      txforcesources(&osource[1],&ovsource[1],nsource[1],nvsource[1],
                                                     text,page,section,file);
     }
    }


    if(old.data.footer && !xnew.data.footer)
    {


    }
    else
    if(!old.data.footer && xnew.data.footer)
    {
     txforcesources(&osource[2],&ovsource[2],nsource[2],nvsource[2],
                                                    text,page,section,file);
     footerdata=1;
    }
    else
    if(old.data.footer && xnew.data.footer)
    {
     if(!nullsource(nsource[2],file) && nullsource(osource[2],file))
                                                              footerdata=1;

     if(footerdata)
     {
      txforcesources(&osource[2],&ovsource[2],nsource[2],nvsource[2],
                                                      text,page,section,file);
     }
    }

     // xnew is the master, old is the document object

    if(!xnew.data.repeat && !old.data.repeat)
    {
     cprintf("!new repeat and !old repeat");


     if(!xnew.fchain.prev)
     {
      if(old.fchain.prev)
      {
       /* now chain header, but didn't used to be */

       osource[0]=ovsource[0]=0;
       old.flags.masterdata=1;
      }
      else
      {
       if(!nullsource(nsource[0],file) && nullsource(osource[0],file))
                                                     old.flags.masterdata=1;
      }

      if(old.flags.masterdata)
      {
       txforcesources(&osource[0],&ovsource[0],nsource[0],nvsource[0],
                                                      text,page,section,file);
      }
     }
    }
    else
    if(xnew.data.repeat && !old.data.repeat)
    {
     cprintf("new repeat and !old repeat");

     /* scrap old source */
     /* if this is the first frame of this chain in doc then */
     /* preserve its source and fill in map */

     sectionp=(sectionstr*)fob_find(section,file);
     sectionfindmap(nsource[0],&map,sectionp->dual,file);

     if(!xnew.fchain.prev && old.fchain.prev)
     {
      osource[0]=ovsource[0]=0;
      old.flags.masterdata=1;
      txforcesources(&osource[0],&ovsource[0],nsource[0],nvsource[0],
                                                     text,page,section,file);
     }

     if(!map.msource || !map.dsource)
     {
      map.dsource =osource[0];
      map.dvsource=ovsource[0];
      map.msource=nsource[0];
      map.mvsource=nvsource[0];

      sectionaddmap(&map,section,file,MST);
     }
    }
    else
    if(!xnew.data.repeat && old.data.repeat)
    {
     /* create source */

     cprintf("!new repeat and old repeat");

     if(!xnew.fchain.prev && old.fchain.prev)
     {
//      sectionfindmapds(osource[0],&map,section,file);
//      if(map.msource)
//      {
//       map.dsource=0;
//       map.dvsource=0;
//       sectionaddmap(&map,section,file,DOC);
//      }
//      else
//      {
       osource[0]=ovsource[0]=0;
       old.flags.masterdata=1;
  
       txforcesources(&osource[0],&ovsource[0],nsource[0],nvsource[0],
                                                     text,page,section,file);
//      }
     }
    }
    else
    if(xnew.data.repeat && old.data.repeat)
    {
     // bug here what if it is no longer part of the auto repeat chain it used to be?

     cprintf("new repeat and old repeat");

     cprintf("new,old repeat ns %d os %d",nsource[0],osource[0]);
     if(!xnew.fchain.prev)
     {
      sectionfindmapds(osource[0],&map,section,file);
      if(map.msource==nsource[0])
      {
       cprintf("no change in auto chains");

      }
      else
      {
       if(!old.fchain.prev)
       {
        cprintf("auto change 1");

       }
       else
       {
        cprintf("auto change 2");

        osource[0]=ovsource[0]=0;
        old.flags.masterdata=1;
  
        txforcesources(&osource[0],&ovsource[0],nsource[0],nvsource[0],
                                                      text,page,section,file);

        map.msource=nsource[0];
        map.mvsource=nvsource[0];
        map.dsource=osource[0];
        map.dvsource=ovsource[0];
        sectionaddmap(&map,section,file,MST);
       }
      }
     }
//     cprintf("new,old repeat ns %d os %d nusize %d",nsource[0],osource[0],nusize);
    }


    copycurve(&old.icurve,file,&xnew.icurve,file);
    copycurve(&old.ocurve,file,&xnew.ocurve,file);
    copycurve(&old.fcurve,file,&xnew.fcurve,file);
    copyborder(&old.frame,xnew.frame,file);
    copyfill(&xnew.data.fill,&xnew.data.fill,file); //     bug here was clobbering newly created fill object with the old one - dest (first) param was old.data
   
//    cprintf("xnew1 fill %d",xnew.data.fill.fill);

    trashvboxes(text,file);

    newsize=textsize(&xnew);

    fob_change(text,file,newsize,(fobjptr)&textp);

    texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
    for(i=0;i<nusize;i++)
    {
     texsp->source=osource[i];
     texsp->vsource=ovsource[i];
     texsp++;
    }

    if(xnew.data.header || xnew.data.footer)
    {
     texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
     texhp->header=header;
     texhp->footer=footer;
     texhp->headerdata=headerdata;
     texhp->footerdata=footerdata;
    }

    textp->data=xnew.data;

    textp->transform=xnew.transform;
    textp->box=xnew.box;
    textp->textflow=xnew.textflow;
    textp->icurve=old.icurve;
    textp->ocurve=old.ocurve;
    textp->fcurve=old.fcurve;
    textp->frame=old.frame;
    textp->flags.spread=xnew.flags.spread;
    textp->flags.locked=xnew.flags.locked;
    textp->flags.masterdata=old.flags.masterdata; /* was commented */

//    cprintf("xnew1 fill %d",xnew.data.fill.fill);

//     cprintf("text %d fill %d",textp->key,textp->data.fill.fill);


    zerocolumns(textp,-1,1);    /* get columns right */


    vxadd((sobjectstr **)&textp,file);
    frfladd((sobjectstr **)&textp,file);
    frameflow((sobjectstr **)&textp,file);
   }
  }
 }

 return(err);
}




static os_error * uudm(filestr * file)
{
 mrefstr      mref;
 objectloc    src;
 objectloc    dest;
 transformstr tr;

 undoread(file,&mref,sizeof(mrefstr));
 mpageundelete(&mref,0,&src,&dest,&tr,file);
 textcopyc(&src,&dest,&tr);
 return(undowritefn(file,URDM,&dest.object,sizeof(int)));
}


static os_error * deletemaster(textboxstr * textp,filestr * file)
{
 int     text;
 mrefstr mref;

 text=textp->key;

 mref.master=textp->master;
 mref.after=textp->chain.prev;

 textscrap(text,file,DELETEUNLINK);

 return(undowritefn(file,UUDM,&mref,sizeof(mrefstr)));
}


static os_error * urdm(filestr * file)
{
 int          text;
 textboxstr * textp;

 undoread(file,&text,sizeof(int));
 textp=(textboxstr*)fob_find(text,file);
 return(deletemaster(textp,file));
}





os_error * textlocalobject(textboxstr * textp,filestr * file,int makelocal)
{
 if(makelocal==MAKELOCAL)    return(txmakelocal(textp,file));
 else
 if(makelocal==MAKEMASTER)   return(txmakemaster(textp,file));
 else                       
 if(makelocal==DELETEMASTER) return(deletemaster(textp,file));
 else                        return(txforcemaster(makelocal,textp,file));
}



/****************************************************************************/

static int xmsection;
static int xdsection;

static os_error * searchfn(textboxstr * textp,filestr * file,int * message)
{
 sectionmapstr   map;
 sectionmapstr   xmap;
 texsrc        * texsp; 


/* dprintf(0,"search 1"); */


 if(textp->type==OTEXTBOX && textp->data.repeat)
 {
  texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

 /* dprintf(1,"search 2 %d",texsp->source); */

  map.msource=texsp->source;
  map.mvsource=texsp->vsource;
  map.dsource=0;
  map.dvsource=0;

  sectionfindmap(map.msource,&xmap,xdsection,file);
  if(xmap.msource==map.msource) sectionaddmap(&xmap,xmsection,file,MST);
  else                          sectionaddmap(&map,xmsection,file,MST);

 /* dprintf(2,"sectionaddmap"); */
 }

 return(NULL);

 USE(message);
}



static int addmap=0;
static int remmap=1;
static int endmap=2;



static os_error * scrapmap(int section,filestr * file)
{
 int           temp;
 sectionmapstr map;

 while(1)
 {
  undoread(file,&temp,sizeof(int));

  if(temp==addmap)
  {
   undoread(file,&map,sizeof(sectionmapstr));

 /* dprintf(0,"map scrap sources"); */

   txsourcedel(map.dsource,file,1);
   vsourcedel(map.dvsource,file);
  }
  else
  if(temp==remmap)
  {

  }
  else break;
 }

 return(NULL);

 USE(section);
}







static os_error * loadmap(int section,filestr * file)
{
 int           temp;
 sectionmapstr map;


/* dprintf(0,"load map %d",section); */

 while(1)
 {
  undoread(file,&temp,sizeof(int));

  if(temp==addmap)
  {
   undoread(file,&map,sizeof(sectionmapstr));
   sectionaddmap(&map,section,file,-1);
  }
  else
  if(temp==remmap)
  {
   undoread(file,&temp,sizeof(int));
   sectionremmap(temp,section,file,-1);
  }
  else break;
 }

 return(NULL);
}



static os_error * savemap(int old,int xnew,filestr * file)
{
 sectionstr     * oldp;
 sectionstr     * newp;
 sectionmapstr    mapentry;
 int              msource;
 int              m;
 int              d;


/* dprintf(0,"savemap old=%d new=%d",old,new); */

 fob_lock((fobjptr)&newp,xnew,file);

 fob_lock((fobjptr)&oldp,old,file);

 m=0;
 d=0;

 while(d<oldp->mapentries)
 {
  if(m>=newp->mapentries)
  {
   mapentry=oldp->map[d];
   undowrite(file,&addmap,sizeof(int));
   undowrite(file,&mapentry,sizeof(sectionmapstr));
   d++; /* scrap */

   /* dprintf(0,"scrap 2"); */
  } 
  else
  if(oldp->map[d].msource<newp->map[m].msource)
  {
   mapentry=oldp->map[d];
   undowrite(file,&addmap,sizeof(int));
   undowrite(file,&mapentry,sizeof(sectionmapstr));
   d++;   /* scrap */

   /* dprintf(0,"scrap 1"); */
  }
  else
  if(oldp->map[d].msource==newp->map[m].msource)
  {
   m++;
   d++;
  }
  else
  if(oldp->map[d].msource>newp->map[m].msource)
  {
   msource=newp->map[m].msource;
   undowrite(file,&remmap,sizeof(int));
   undowrite(file,&msource,sizeof(int));
   m++;
   /* dprintf(0,"add 1"); */
  }
 }

 while(m<newp->mapentries)
 {
  msource=newp->map[m].msource;
  undowrite(file,&remmap,sizeof(int));
  undowrite(file,&msource,sizeof(int));
  m++;

  /* dprintf(0,"add 2");  */
 }

 undowrite(file,&endmap,sizeof(int));

 fob_unlock((fobjptr)&oldp,file);

 fob_unlock((fobjptr)&newp,file);

 return(NULL);
}


static os_error * copymap(int dest,int src,filestr * file)
{
 sectionstr * destp;
 sectionstr * srcp;

 /* dprintf(0,"copymap dest=%d src=%d",dest,src); */

 fob_lock((fobjptr)&destp,dest,file);
 fob_lock((fobjptr)&srcp,src,file);

 fob_change(dest,file,
            sizeof(sectionstr)+srcp->mapentries*sizeof(sectionmapstr),
                                                   (fobjptr)&destp);

 XMEMCPYX(destp->map,srcp->map,srcp->mapentries*sizeof(sectionmapstr));

 destp->mapentries=srcp->mapentries;

 /* dprintf(0,"n=%d ms=%d ds=%d",destp->mapentries,
                                 destp->map[0].msource,
                                 destp->map[0].dsource);  */

 fob_unlock((fobjptr)&destp,file);
 fob_unlock((fobjptr)&srcp,file);

 return(NULL);
}



/* tagged to ULOADDOC */

static os_error * uscrapdoc(filestr * file)
{
/* dprintf(0,"scrap doc"); */

 undoread(file,&xdsection,sizeof(int));
 undoread(file,&xmsection,sizeof(int));

 return(scrapmap(xdsection,file));
}


static os_error * uloaddoc(filestr * file)
{
 undoread(file,&xdsection,sizeof(int));
 undoread(file,&xmsection,sizeof(int));

 undowritefn(file,USAVEDOC,&xdsection,sizeof(int));
 undowrite(file,&xmsection,sizeof(int));

 return(loadmap(xdsection,file));
}



/* tagged to USAVEDOC */

static os_error * usavedoc(filestr * file)
{
 undoread(file,&xdsection,sizeof(int));
 undoread(file,&xmsection,sizeof(int));

 undowritefn(file,ULOADDOC,&xdsection,sizeof(int));
 undowrite(file,&xmsection,sizeof(int));
 savemap(xdsection,xmsection,file);
 copymap(xdsection,xmsection,file);

 return(NULL);
}



/* tagged to ULOADMST */


static os_error * uscrapmst(filestr * file)
{
 /* dprintf(0,"scrap mst"); */

 undoread(file,&xdsection,sizeof(int));
 undoread(file,&xmsection,sizeof(int));

 return(scrapmap(xmsection,file));
}


static os_error * uloadmst(filestr * file)
{
 undoread(file,&xdsection,sizeof(int));
 undoread(file,&xmsection,sizeof(int));

 undowritefn(file,USAVEMST,&xdsection,sizeof(int));
 undowrite(file,&xmsection,sizeof(int));

 return(loadmap(xmsection,file));
}



/* tagged to USAVEMST */

static os_error * usavemst(filestr * file)
{
 undoread(file,&xdsection,sizeof(int));
 undoread(file,&xmsection,sizeof(int));

 undowritefn(file,ULOADMST,&xdsection,sizeof(int));
 undowrite(file,&xmsection,sizeof(int));
 savemap(xmsection,xdsection,file);
 copymap(xmsection,xdsection,file);

 return(NULL);
}






static os_error * mapchange(int eventn,int user,filestr * file,newmapstr * xnew)
{
 os_error   * err;
 sectionstr * msectionp;
 pagestr    * pagep;
 int          dble;
 int          message;
 int          next;


 xmsection=xnew->msection;
 xdsection=xnew->dsection;


 if(eventn==EVENT_CREATESECTIONMAP)
 {
  /* dprintf(1,"CREATESECTIONMAP m=%d d=%d",xmsection,xdsection); */

  sectionclearmap(xmsection,file);

  msectionp=(sectionstr*)fob_find(xmsection,file);
  dble=msectionp->data.dble;

  pagep=(pagestr*)fob_find(msectionp->chain.child,file);
  next=pagep->chain.next;

  message=OM_FUNCTION;
  err=objectchainmessage(pagep->chain.child,file,&message,(void *)searchfn);
  if(dble)
  {
   pagep=(pagestr*)fob_find(next,file);
   message=OM_FUNCTION;
   err=objectchainmessage(pagep->chain.child,file,&message,(void *)searchfn);
  }

  if(xnew->undo)
  {
   undowritefn(file,USAVEMST,&xdsection,sizeof(int));
   undowrite(file,&xmsection,sizeof(int));
  }
 }
 else
 if(eventn==EVENT_UPDATESECTIONMAP)
 {
  if(xnew->undo)
  {
   undowritefn(file,ULOADDOC,&xdsection,sizeof(int));
   undowrite(file,&xmsection,sizeof(int));
   savemap(xdsection,xmsection,file);
  }
  copymap(xdsection,xmsection,file);
 }

 return(NULL);
 USE(user);
}


/***************************************************************************/



/* this is only called on inserting or deleting pages */
/* there is a problem...                              */
/* document of next page codes, delete page one, crash on redraw page 2 */
/* the problem is that the lines flow forward and box contents are wrong */


static os_error * flowfn(textboxstr * textp,filestr * file,int * message)
{
 os_error      * err;
 flowstr         flop;
 vector          v;
 int             textk;
 sourcestr     * src;
 int             size;
 int             fnext;

 err=NULL;

 cprintf("flowfn");

 if(textp->type==OTEXTBOX && textp->data.repeat)
 {
  textk=textp->key;
  while(1)
  {
   fnext=textp->fchain.next;
   zerocolumns(textp,0,0);
   if(!fnext) break;
   textp=(textboxstr*)fob_find(fnext,file);
  }

  setvectorfrombox(&v,0,textk,file);

  src=(sourcestr*)fob_find(v.textsrc.source,file);
  size=src->len-v.boffset;

/*   dprintf(2,"flowfn size=%d offset=%d",size,v.boffset); */

  flop.opcode=FWAIT;
  flop.data.type=FLQUICK;
  flop.data.offset=v.boffset;
  flop.data.length=size;
  flop.data.delta=0;

  flow(&v,&flop);
 }

 return(err);

 USE(message);
}


static os_error * reflowpages(int eventn,int user,filestr * file,
                                                             newflowstr * xnew)
{
 os_error * err;
 pagestr  * pagep;
 int        message;

/* dprintf(0,"reflowpages");  */

 pagep=(pagestr*)fob_find(xnew->page,file);

 message=OM_FUNCTION;

 err=objectchainmessage(pagep->chain.child,file,&message,(void *)flowfn);

 return(err);

 USE(user);
 USE(eventn);
}


/****************************************************************************/


static os_error * delinkfn(textboxstr * textp,filestr * file,int * message)
{
 os_error      * err;

 err=NULL;

 if(textp->type==OTEXTBOX && textp->data.repeat)
 {
  zerocolumns(textp,0,0);
 }

 return(err);

 USE(file);
 USE(message);
}


static os_error * delinkpage(int eventn,int user,filestr * file,
                                                         newflowstr * xnew)
{
 os_error * err;
 pagestr  * pagep;
 int        message;

 pagep=(pagestr*)fob_find(xnew->page,file);

 message=OM_FUNCTION;

 err=objectchainmessage(pagep->chain.child,file,&message,(void *)delinkfn);

 return(err);

 USE(user);
 USE(eventn);
}


/****************************************************************************/


#define UNDOS 11

static undofnstr undos[UNDOS]=
{
 untxmakelocal,   NULL,              UTMXLOCAL,     NULL,
 untxmakemaster,  NULL,              UTMXMASTER,    NULL,
 unmakemaster,    unmakemasterscrap, UMAKEMASTER,   NULL,
 upxtx,           upxtxscrap,        UPXTX,         NULL,
 upxtxmk,         upxtxmkscrap,      UPXTXMK,       NULL,

 uudm,            NULL,              UUDM,          NULL,
 urdm,            NULL,              URDM,          NULL,

 uloaddoc,        uscrapdoc,         ULOADDOC,      NULL,
 usavedoc,        NULL,              USAVEDOC,      NULL,
 uloadmst,        uscrapmst,         ULOADMST,      NULL,
 usavemst,        NULL,              USAVEMST,      NULL,

};



os_error * txmxinit(void)
{
 os_error * err;

          err=undoaddblock(undos,UNDOS);
 if(!err) err=addevent(EVENT_CREATESECTIONMAP,(eventfn)mapchange,0);
 if(!err) err=addevent(EVENT_UPDATESECTIONMAP,(eventfn)mapchange,0);
 if(!err) err=addevent(EVENT_REFLOWPAGES,(eventfn)reflowpages,0);
 if(!err) err=addevent(EVENT_DELINKPAGE,(eventfn)delinkpage,0);

 return(err);
}


