/*->c.tabs */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "bbc.h"
#include "akbd.h"
#include "flex.h"
#include "transform.h"
#include "etc.h"
#include "deb.h"


#include "wos.h"
#include "err.h"
#include "task.h"
#include "bits.h"
#include "crc.h"
#include "poll.h"
#include "dbhi.h"

#include "str.h"
#include "file.h"
#include "view.h"
#include "reslink.h"

#include "txstr.h"
#include "tx.h"
#include "dbtabs.h"

#include "tabs.h"


/*****************************************************************************/
/* tab chains */

#define MAXTABINT  0x3FFFF
#define MINTABINT  0x1
#define PRTABINT   0x1FFFF
#define BADTAB     0x0


tabstr * tabruler;
int      tabrulern;
static   filestr * tabfile;
static   int       tabkey;


static int cmptabn(const void * s1,const void * s2)
{
 return(((tabhdrstr*)s1)->key-((tabhdrstr*)s2)->key);
}

static int cmptabs(tabstr * c1,int n1,tabstr * c2,int n2)
{
 if(n1==n2)
   return(memcmp(c1,c2,sizeof(tabstr)*n1));
 else
   return(n1-n2);
}



#define TABCHUNK 32



os_error * gettabruler(filestr * file,int key)
{
 os_error      * err;
 tabbasestr    * tbase;
 tabhdrstr     * r;
 int             tabs;
 static int      ecount;
 tabhdrstr       tabhdr;
 int             offset;

 err=NULL;

 if(file!=tabfile || key!=tabkey)
 {
  tabs=file->hdr.tabs;
  tbase=(tabbasestr*)fob_find(tabs,file);

  tabhdr.key=key;

  r=(tabhdrstr*)bsearch(&tabhdr,&tbase->tabhdr[0],tbase->n,
                                         sizeof(tabhdrstr),cmptabn);
  if(!r)
  {
   if(!ecount)
   {
    err=geterror(STYLE04);
    ecount++;
   }
   r=tbase->tabhdr;
   cprintf("Lost tab ruler");

  }
  else
  {
   tabrulern=r->n;
   offset=r->offset;


   if(!tabruler) err=flex_alloc((flex_ptr)&tabruler,
                                      MAX(tabrulern,TABCHUNK)*sizeof(tabstr));

   else          err=flex_chunk((flex_ptr)&tabruler,
                            tabrulern*sizeof(tabstr),TABCHUNK*sizeof(tabstr));


   if(!err)
   {
    tbase=(tabbasestr*)fob_find(tabs,file);
    memmove(tabruler,(char*)tbase->tabhdr+offset,tabrulern*sizeof(tabstr));
    tabfile=file;
    tabkey=key;
   }
  }
 }
 return(err);
}




int cmptabdataf(int tab1,filestr * file1,int tab2,filestr * file2)
{
 tabbasestr    * tbase1;
 tabbasestr    * tbase2;
 tabhdrstr     * r1;
 tabhdrstr     * r2;
 int             tabs1;
 int             tabs2;
 tabhdrstr       tabhdr;
 tabstr        * ruler1;
 tabstr        * ruler2;


 tabs1=file1->hdr.tabs;
 tbase1=(tabbasestr*)fob_find(tabs1,file1);

 tabhdr.key=tab1;

 r1=(tabhdrstr*)bsearch(&tabhdr,tbase1->tabhdr,tbase1->n,
                                         sizeof(tabhdrstr),cmptabn);

 tabs2=file2->hdr.tabs;
 tbase2=(tabbasestr*)fob_find(tabs2,file2);

 tabhdr.key=tab2;

 r2=(tabhdrstr*)bsearch(&tabhdr,tbase2->tabhdr,tbase2->n,
                                         sizeof(tabhdrstr),cmptabn);

 if(r1 && r2) 
 {
  ruler1=(tabstr*)(((char*)tbase1->tabhdr)+r1->offset);
  ruler2=(tabstr*)(((char*)tbase2->tabhdr)+r2->offset);

  return(cmptabs(ruler1,r1->n,ruler2,r2->n));
 }

 return(1);
}





os_error * duptabruler(filestr * file,int key)
{
 os_error      * err;
 tabbasestr    * tbase;
 tabhdrstr     * r;
 tabhdrstr       tabhdr;
 int             tabs;
 static int      ecount;


 cprintf("dup tab ruler %d",key);


 tabs=file->hdr.tabs;
 err=fob_mod(tabs,file,(fobjptr)&tbase);
 if(!err)
 {
  tabhdr.key=key;

  r=(tabhdrstr*)bsearch(&tabhdr,&tbase->tabhdr[0],
                                 tbase->n,sizeof(tabhdrstr),cmptabn);
  if(r)
  {
   r->count++;
  }
  else
  {
   if(!ecount)
   {
    err=geterror(STYLE04);
    ecount++;
   }
  }
 }
 return(err);
}




os_error * remtabruler(filestr * file,int key)
{
 os_error      * err;
 tabbasestr    * tbase;
 tabhdrstr     * r;
 tabhdrstr     * m;
 tabhdrstr       tabhdr;
 int             tabs;
 int             size;
 int             maxoffset;
 int             offset;
 int             n;
 int             i;
 static int      ecount;

 cprintf("remtabruler %d",key);


 tabs=file->hdr.tabs;
 err=fob_mod(tabs,file,(fobjptr)&tbase);
 if(!err)
 {
  tabhdr.key=key;

  r=(tabhdrstr*)bsearch(&tabhdr,&tbase->tabhdr[0],
                                 tbase->n,sizeof(tabhdrstr),cmptabn);
  if(r)
  {
   r->count--;

//   cprintf("count %d",r->count);

   if(!r->count)
   {
    size=r->n*sizeof(tabstr)+sizeof(tabhdrstr);
    offset=r->offset;
    m=&tbase->tabhdr[tbase->n-1];
    maxoffset=m->offset+m->n*sizeof(tabstr);
    n=r-tbase->tabhdr;

    for(i=n;i<(tbase->n-1);i++)
    {
     tbase->tabhdr[i]=tbase->tabhdr[i+1];
     tbase->tabhdr[i].offset-=size;
    }
    for(i=0;i<n;i++)
    {
     tbase->tabhdr[i].offset-=sizeof(tabhdrstr);
    }

    memmove((char*)tbase->tabhdr+(tbase->n-1)*sizeof(tabhdrstr),
            (char*)tbase->tabhdr+tbase->n*sizeof(tabhdrstr),
             offset-tbase->n*sizeof(tabhdrstr));

    offset-=sizeof(tabhdrstr);
    memmove((char*)tbase->tabhdr+offset,
            (char*)tbase->tabhdr+offset+size,maxoffset-offset-size);

    maxoffset-=size;
    size=(int)sizeof(tabbasestr)-(int)sizeof(tabhdrstr)+maxoffset;
    err=fob_change(tabs,file,size,(fobjptr)&tbase);
    tbase->n--;
   }
  }
  else
  {
   if(!ecount)
   {
    err=geterror(STYLE04);
    ecount++;
   }
  }
 }
 return(err);
}



static int tabcrc(tabstr * s,int n)
{
 int crc;
 crc=0;
 if(s)
 {
  crcblock32(&crc,(char*)s,n*sizeof(tabstr));
  crc&=MAXTABINT;
 }
 if(crc<MINTABINT) crc+=PRTABINT;
 return(crc);
}


os_error * addtabruler(filestr * file,tabstr **tabruler,int shift,
                                                        int xnew,int * nkey)
{
 os_error      * err;
 tabbasestr    * tbase;
 tabhdrstr       tabhdr;
 int             tabs;
 tabhdrstr     * s;
 tabhdrstr     * m;
 int             key;
 int             n;
 int             size;
 int             i;
 int             offset;
 int             maxoffset;
 int             minoffset;


 cprintf("add tab ruler");

 tabs=file->hdr.tabs;

 if(tabruler) key=tabcrc((tabstr*)(((char*)(*tabruler))+shift),xnew);
 else         key=PRTABINT;

 err=fob_mod(tabs,file,(fobjptr)&tbase);
 if(!err)
 {
  while(1)
  {
   tabhdr.key=key;
   s=(tabhdrstr*)bnearest(&tabhdr,&tbase->tabhdr[0],
                                 tbase->n,sizeof(tabhdrstr),cmptabn);
   n=s-tbase->tabhdr;

   if(n<tbase->n && !cmptabn(s,&tabhdr))
   {                              /* equal numbers */
    if(tabruler && cmptabs((tabstr*)((char*)tbase->tabhdr+s->offset),s->n,
                           (tabstr*)(((char*)(*tabruler))+shift),xnew))
    {                             /* but different chains - a collision */
     key+=PRTABINT;
     if(key>MAXTABINT) key-=MAXTABINT;
     if(key<MINTABINT) key+=PRTABINT;
    }
    else                            /* identical styles */
    {
     s->count++;
     break;
    }
   }
   else
   {
    if(tbase->n)
    {
     m=&tbase->tabhdr[tbase->n-1];
     maxoffset=m->offset+m->n*sizeof(tabstr);
     size=maxoffset+sizeof(tabbasestr)-sizeof(tabhdr);
     size+=sizeof(tabhdr)+xnew*sizeof(tabstr);
    }
    else
    {
     size=sizeof(tabbasestr)+xnew*sizeof(tabstr);
     maxoffset=0;
    }

    err=fob_change(tabs,file,size,(fobjptr)&tbase);
    size=xnew*sizeof(tabstr);

    if(n<tbase->n)
    {
     offset=tbase->tabhdr[n].offset;
     memmove(((char*)tbase->tabhdr)+offset+sizeof(tabhdr)+size,
            ((char*)tbase->tabhdr)+offset,maxoffset-offset);
    }
    else
    {
     offset=maxoffset;
    }


    if(tbase->n)
    {
     minoffset=tbase->tabhdr[0].offset;
     memmove(((char*)tbase->tabhdr)+minoffset+sizeof(tabhdr),
             ((char*)tbase->tabhdr)+minoffset,offset-minoffset);
     offset+=sizeof(tabhdr);

     for(i=tbase->n-1;i>=n;i--)
     {
      tbase->tabhdr[i+1]=tbase->tabhdr[i];
      tbase->tabhdr[i+1].offset+=size+sizeof(tabhdrstr);
     }
     for(i=0;i<n;i++)
     {
      tbase->tabhdr[i].offset+=sizeof(tabhdrstr);
     }
    }
    else
    {
     offset=sizeof(tabhdrstr);
    }

    tbase->tabhdr[n].offset=offset;
    tbase->tabhdr[n].key=key;
    tbase->tabhdr[n].count=1;
    tbase->tabhdr[n].n=xnew;
    if(tabruler)memmove(((char*)tbase->tabhdr)+offset,(tabstr*)(((char*)(*tabruler))+shift),size);
    tbase->n++;
    break;
   }
  }
 }

 *nkey=key;
 return(err);
}


os_error * deftabruler(int * key,filestr * file)
{
 return(addtabruler(file,NULL,0,0,key));
}




#ifndef PROD

os_error * tabcount(filestr * file)
{
 os_error      * err;
 tabbasestr    * tbase;
 int             tabs;
 int             i;
 int             sum;

 err=NULL;

 tabs=file->hdr.tabs;
 tbase=(tabbasestr*)fob_find(tabs,file);
 sum=0;


 for(i=0;i<tbase->n;i++)
 {
  sum+=tbase->tabhdr[i].count;
 }

 dprintf(2,"tab count n=%d sum=%d\n",tbase->n,sum);

 return(NULL);
}


#endif



#ifdef NEVER


static os_error * tabdebug(filestr * file)
{
 os_error      * err;
 tabbasestr    * tbase;
 int             tabs;
 int             i;

 err=NULL;

 tabs=file->hdr.tabs;
 tbase=fob_find(tabs,file);

 printf("tab debug n=%d\n",tbase->n);

 for(i=0;i<tbase->n;i++)
 {
  printf("key=%x count=%d offset=%d\n",tbase->tabhdr[i].key,
                    tbase->tabhdr[i].count,tbase->tabhdr[i].offset);
 }

 return(err);
}






void tabtest(void)
{
 filestr * file=firstfile;
 tabstr    tabs[4];
 tabstr  * t;
 int       key;
 int       key1;
 int       keyn[200];
 FILE    * fp;
 int       i;

  tabs[0].posn=101;
  tabs[1].posn=102;
  tabs[2].posn=103;
  tabs[3].posn=104;

  os_cli("sp.xx");
  t=tabs;

  for(i=0;i<100;i++)
  {
   tabs[2].posn=i;
   addtabruler(file,&t,1+i%4,&key);
   keyn[i]=key;
   printf("added chain key=%x\n",key);
  }

  tabdebug(file);

  for(i=0;i<100;i++)
  {
   printf("rem chain key=%x\n",keyn[i]);
   remtabruler(file,keyn[i]);
  }

  tabdebug(file);

 os_cli("sp.");
}


#endif


