/*->h.tx */


#define UACTPOSN    0x6000
#define UINSERTS    0x6001
#define UINSERTF    0x6002
#define UDELETES    0x6003
#define UDELETEF    0x6004
#define UDELETE     0x6005
#define UINSERT     0x6006
#define USWOPCASE   0x6007
#define USSBLOCK    0x6008
#define USTYLES     0x6009
#define USTYLEF     0x600A
#define UCARETLEFT  0x600B
#define UCARETRIGHT 0x600C
#define UCARETUP    0x600D
#define UCARETDOWN  0x600E
#define UTRANSPOSE  0x600F
#define UACTPOSN1   0x6010
#define UFINSERTS   0x6011
#define UFINSERTF   0x6012
#define UTXDES      0x6013
#define UTXDEF      0x6014
#define UTXMOVES    0x6015
#define UTXMOVEF    0x6016
#define UDELETEB    0x6017
#define UINSERTB    0x6018
#define UTXDESA     0x6019
#define UTXDEFA     0x601A
#define UTXMOVEM    0x601B
#define UTXMOVES1   0x601C
#define UTXMOVEF1   0x601D
#define UTXCOPYS    0x601E
#define UTXCOPYF    0x601F
#define UUNIHEXF				0x6020
#define UUNIHEXS				0x6021
#define UCHANGECASE 0x6022


extern os_error * txsourcenew(int * key,filestr * file);
extern os_error * txsourcecopy(int src,int * key,filestr * sfile,
                                                 filestr * dfile);
extern os_error * txsourcedel(int key,filestr * file,int contents);
extern int        txcodelen(int code,sourcestr * source);

extern os_error * txsourceinsert(char * data,int n,
                                        textsrcstr * textsrc,filestr * file);

extern os_error * txsourceclose(textsrcstr * textsrc,filestr * file);

extern os_error * txsourceremove(int n,textsrcstr * textsrc,filestr * file);

extern os_error * txsourcereplace(int xdelete,int insert,char * data,
                                          textsrcstr * textsrc,filestr * file);


extern os_error * txlock(textsrcstr * textsrc,filestr * file);
extern os_error * txunlock(textsrcstr * textsrc,filestr * file);

extern os_error * txcopyblock(textsrcstr * textsrc1,textsrcstr * textsrc2,
                       filestr * file1,filestr * file2,int n);

extern os_error * txmoveblock(textsrcstr * d,textsrcstr * s,
                                                     filestr * file,int n);


extern char     * txptr(sourcestr * source,int offset);
extern char     * txptrlt(sourcestr * source,int offset);

extern os_error * txclosesrc(textsrcstr * textsrc,filestr * file);


extern os_error * txundosourcereplace(int xdelete,int insert,char * data,
                                          textsrcstr * textsrc,filestr * file);
extern os_error * txundosourceinsert(char * data,int n,
                                          textsrcstr * textsrc,filestr * file);
extern os_error * txundosourceremovex(int n,textsrcstr *textsrc,filestr *file);
extern void       txundostart(textsrcstr * txsrc,filestr * file);

extern            void txundoend(int * loffset,int * hoffset,
                                               int * delta,filestr * file);


extern os_error * txsourceinsertsn(int sn,int dup,textsrcstr * textsrc,
                                                           filestr * file);
extern os_error * txundosourceinsertsn(int sn,textsrcstr * textsrc,
                                                           filestr * file);


extern os_error * uninsert(filestr * file);
extern os_error * undelete(filestr * file);
extern os_error * uninsertscrap(filestr * file);

extern os_error * uninsertb(filestr * file);
extern os_error * undeleteb(filestr * file);
extern os_error * uninsertscrapb(filestr * file);



#define USSMAX 256

typedef struct usmapstr
{
 int offset;
 int style;
} usmapstr;


typedef struct undostylestr
{
 int      ns;
 usmapstr usmap[USSMAX];
} undostylestr;



#define BSSPLIT 64      /* bigger than this and save by reference */

/* OTXSCRAP object */

typedef struct txscrapstr
{
 int       key;
 int       type;

 txmodstr  txmod;

 char      stuff[1];

} txscrapstr;





extern os_error * undostylemapstart(filestr * file,undostylestr * uss);
extern os_error * undostylemapadd(filestr * file,undostylestr * uss,
                                                    int offset,int sn);
extern os_error * undostylemapend(filestr * file,undostylestr * uss);
extern os_error * ussblock(filestr * file);
extern os_error * ussblockscrap(filestr * file);



extern os_error * txfindeobs(int object,int source,filestr * file,
                                                      int * offset);
extern os_error * txfindeob(int object,int text,filestr * file,
                                                      int * offset,int * u);


extern int sourcesize(int src,filestr * file);




/*->c.text */

extern os_error * settextoffset(filestr * file,textboxstr * text,
                                                   int * vloff,int * offset);

extern os_error * textboxupdate(unpackedtextdatastr * pd,textchangebits * bits,
                                                int text,filestr * file);

extern os_error * textchanges(int text,filestr * file,
                              unpackedtextdatastr * pd,textchangebits * bits);


extern void unpacktextdata(unpackedtextdatastr * pd,textboxstr * textp);

extern int guttersize(columnstr * ccol,int columns,int width);

extern os_error * newtextbuffer(int textk,filestr * file,int main);

extern void settexttransform(textboxstr * textp);

extern void zerocolumns(textboxstr * textp,int u,int vbox);

extern os_error * newtextbuffers(int * txsource,int * vlsource,filestr * file);

extern os_error * refreshfull(vector * v);
extern os_error * refreshfullbox(int text,filestr * file);

extern os_error * paintzone(viewredrawstr * v);



/* h.texttool */

extern void txfontschanged(void);





