/*->c.vi */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"
#include "deb.h"

#include "err.h"
#include "xmath.h"
#include "fsx.h"
#include "bf.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "colour.h"
#include "etc.h"


#include "constants.h"
#include "str.h"

#include "geometry.h"
#include "view.h"
#include "file.h"
#include "chain.h"
#include "obj.h"
#include "object.h"
#include "xredraw.h"
#include "curve.h"
#include "posn.h"



#include "txstr.h"
#include "tx.h"
#include "txprivate.h"

#include "vi.h"





/* #define DBUG 1 */

/*
static int xcount;

static void xcreate(int vbox,int del)
{
 if(del) {dprintf(0,"%d del %d",xcount,vbox);xcount--;}
 else    {dprintf(0,"%d cre %d",xcount,vbox);xcount++;} 
}
*/







os_error * vboxcopy(int s,int * dp,filestr * sfile,filestr * dfile)
{
 os_error * err;
 textvbox * svboxp;
 textvbox * dvboxp;
 int        size;
 int        nc;
 int        i;
 int        previous;
 int        current;
 textvbox * vboxp;

 err=NULL;

 svboxp=dvboxp=NULL;
 previous=0;

 *dp=0;

 while(s)
 {
  err=fob_static((fobjptr)&svboxp,s,sfile);
  if(err) break;
  err=fob_static((fobjptr)&dvboxp,s,sfile);
  if(err) break;

  nc=svboxp->nc;
  size=sizeof(textvbox)+(nc-1)*sizeof(curvestr);

  for(i=0;i<nc;i++)
  {
   err=copycurve(&dvboxp->curve[i],dfile,&svboxp->curve[i],sfile);
   if(err) break;
  }
  if(err) break;


  err=fob_create(size,dfile,OTEXTVBOX,(fobjptr)&vboxp);
  if(err) break;

  current=vboxp->key;
  vboxp->nc=nc;

  for(i=0;i<nc;i++)
  {
   vboxp->curve[i]=dvboxp->curve[i];
  }

  if(previous)
  {
   vboxp=(textvbox*)fob_find(previous,dfile);
   vboxp->down=current;
  }
  else 
  {
   *dp=current;
  }

  s=svboxp->down;
  previous=current;

  fob_free((fobjptr)&svboxp,sfile);
  fob_free((fobjptr)&dvboxp,sfile);
 }

 if(svboxp) fob_free((fobjptr)&svboxp,sfile);
 if(dvboxp) fob_free((fobjptr)&dvboxp,sfile);

 return(err);
}



static os_error * vboxdelete(int vboxk,filestr * file,int all)
{
 os_error * err;
 textvbox * vboxp;
 int        i;
 int        down;
 int        nc;

 err=NULL;
 i=0;

 while(!err && vboxk)
 {
  vboxp=(textvbox*)fob_find(vboxk,file);
  down=vboxp->down;

  nc=vboxp->nc;

  for(i=0;i<nc;i++)
  {
   if(vboxp->curve[i].type==CPATH)
   {
    err=deletecurve(&vboxp->curve[i],file);
    vboxp=(textvbox*)fob_find(vboxk,file);
   }
  }

  if(!err) err=fob_delete(vboxk,file);

  if(!all) break;
  vboxk=down;
 }
 return(err);
}




os_error * trashvboxes(int textk,filestr * file)
{
 os_error   * err;
 textboxstr * textp;
 int          columns;
 int          header;
 int          footer;
 int          n;
 texsub     * texup;
 int          usize;
 int          vbox;

 err=NULL;

 textp=(textboxstr*)fob_find(textk,file);
 if(textp)
 {
  columns=textp->data.columns;
  header=textp->data.header;
  footer=textp->data.footer;

  if(header || footer)
  {
   usize=sizeof(textboxstr)+3*sizeof(texsrc)+sizeof(texhdr);
   columns+=2;
  }
  else
  {
   usize=sizeof(textboxstr)+sizeof(texsrc);
  }

  for(n=0;n<columns;n++)
  {
   textp=(textboxstr*)fob_find(textk,file);
   texup=(texsub*)(((char*)textp)+usize);
   if(textp) 
   {
    vbox=texup[n].vbox;
    texup[n].vbox=0;
    vboxdelete(vbox,file,1);
   }
  }
 }
 return(err);
}




/* passed a buffer of curve interesction, and extremums */
/* start and end indexes in buffer                      */
/* and the two curves which produced the buffer         */

/* output a vbox strip                                  */

/* tcurve - what we are clipping */
/* tcurve is an array of nc non-overlaping curves */
/* ccurve - the clipping curve   */


#define OUTPATHCHUNK (128*sizeof(int))
#define OUTPATHMIN   (32*sizeof(int))


#define CVTRANS   0x1
#define CVLEFT    0x2
#define CVRIGHT   0x4
#define CVNEITHER 0x8
#define CVWIDEST  0x10


typedef struct vcutstr
{
 coordstr c;
 int      u1;
} vcutstr;


typedef struct vcurvestr
{
 curvestr c;
 int      toutside;
 int      boutside;
 int      bits;
} vcurvestr;


static vcurvestr * vcurves;
static int         nvcurves;


#define VCURVECHUNK (16*sizeof(vcurvestr))



static os_error * vistartcurves(void)
{
 os_error * err;

 nvcurves=0;

 err=salloc((flex_ptr)&vcurves,VCURVECHUNK);

 return(err);
}



static os_error * viaddcurve(curvestr * curve,int bits)
{
 os_error * err;

 err=schunk((flex_ptr)&vcurves,(nvcurves+1)*sizeof(vcurvestr),VCURVECHUNK);

 if(!err)
 {
  vcurves[nvcurves].c=*curve;
  vcurves[nvcurves].bits=bits;

  nvcurves++;
 }

 return(err);
}


static os_error * viclearcurves(filestr * file)
{
 int      i;

 for(i=0;i<nvcurves;i++)
 {
  deletecurve(&vcurves[i].c,file);
 }

 nvcurves=0;

 return(sfree((flex_ptr)&vcurves));
}





static os_error * createstripx(int * newvboxk,csbuffstr * cstop,
                     csbuffstr * csbot,curvestr * tcurve,filestr * file)
{
 os_error * err;
 int        toutsidec;
 int        toutsidet;
 int        boutsidec;
 int        boutsidet;
 int        it;
 int        ib;
 int        tops;
 int        tope;
 int        bots;
 int        bote;
 int        stripstart;
 int        stripend;
 int        nx;
 int        vboxk;
 curvestr   ocurve;
 textvbox * vboxp;
 int        topy;
 int        boty;
 curvestr * cleft;
 curvestr * cleftb;
 curvestr * cright;
 curvestr * crightb;
 curvestr * xcleft;
 curvestr * xcright;
 int        xleft;
 int        xright;
 int        sx;
 int        sy;
 int        cx;
 int        cy;
 int        xlo;
 int        xhi;
 int        ex;
 int        ey;
 int        tx;
 int        ty;
 pathstr *  pathp;
 int        index;
 int      * outputpath;
 int        leftbackwards;
 int        rightbackwards;
 segstr   * segp;
 int        ns;

 segstr     srighttop;
 segstr     slefttop;
 segstr     sleftbot;
 segstr     srightbot;

 vcutstr    crighttop;
 vcutstr    clefttop;
 vcutstr    cleftbot;
 vcutstr    crightbot;

 vcurvestr * vp;
 int         i;
 int         cxleft;
 int         cxright;
 int         ssize;


 err=NULL;

 toutsidec=boutsidec=0;

 for(i=0;i<nvcurves;i++)
 {
  if(vcurves[i].bits & CVTRANS)  vcurves[i].toutside=vcurves[i].boutside=0;
  else                           vcurves[i].toutside=vcurves[i].boutside=1;

  toutsidec+=vcurves[i].toutside;
  boutsidec+=vcurves[i].boutside;
 }

 toutsidet=boutsidet=1;


 it=0;
 ib=0;
 vboxk=0;
 nx=0;
 outputpath=NULL;

 topy=cstop->c[CSBOT][0].cx.y;
 boty=csbot->c[CSTOP][0].cx.y;


 cxleft=cxright=-1;

 for(i=0;i<cstop->n[CSBOT];i++)
 {
  if(cstop->c[CSBOT][i].c!=tcurve)
  {
   vp=(vcurvestr*)cstop->c[CSBOT][i].c;
   if((vp->bits & CVLEFT) && cxleft<0) cxleft=i;
   if(vp->bits & CVRIGHT) cxright=i;
   if(vp->bits & CVNEITHER)
   {
    *newvboxk=0;
    return(NULL);
   }
  }
 }


 /* get top span */
 /* get bot span */

 while(1)
 {
  stripstart=stripend=0;
  tops=tope=it;

  while(it<cstop->n[CSBOT])
  {
   if(cstop->c[CSBOT][it].c==tcurve) toutsidet^=1;
   else
   {
    vp=(vcurvestr*)cstop->c[CSBOT][it].c;
    toutsidec-=vp->toutside;
    vp->toutside^=1;
    toutsidec+=vp->toutside;
   }

   if(!toutsidet && (toutsidec==nvcurves) && !stripstart)
   {
    tops=it;
    stripstart=1;
   }

   if((toutsidet || (toutsidec!=nvcurves)) && stripstart)
   {
    tope=it;
    stripend=1;
   }

   it++;

   if(stripend) break;
  }

  if(!(stripstart && stripend)) 
  {

#ifdef DBUG
   dprintf(0,"break after top loop");
#endif
   break;
  }

#ifdef DBUG
  dprintf(0,"tops=%d x=%d y=%d tope=%d x=%d y=%d",
             tops,cstop->c[CSBOT][tops].cx.x,cstop->c[CSBOT][tops].cx.y,
             tope,cstop->c[CSBOT][tope].cx.x,cstop->c[CSBOT][tope].cx.y);
#endif

  stripstart=stripend=0;
  bots=bote=ib;


  while(ib<csbot->n[CSTOP])
  {
   if(csbot->c[CSTOP][ib].c==tcurve) boutsidet^=1;
   else
   {
    vp=(vcurvestr*)csbot->c[CSTOP][ib].c;
    boutsidec-=vp->boutside;
    vp->boutside^=1;
    boutsidec+=vp->boutside;
   }

   if(!boutsidet && (boutsidec==nvcurves) && !stripstart)
   {
    bots=ib;
    stripstart=1;
   }

   if((boutsidet || (boutsidec!=nvcurves)) && stripstart)
   {
    bote=ib;
    stripend=1;
   }

   ib++;

   if(stripend) break;
  }


  if(!(stripstart && stripend)) 
  {
#ifdef DBUG
   dprintf(0,"break after bot loop");
#endif
   break;
  }

  if(cxleft>=0  && tops>=cxleft)  break;
  if(cxright>=0 && tops<cxright) continue;   /* !!!! */


#ifdef DBUG
  dprintf(0,"bots=%d x=%d y=%d bote=%d x=%d y=%d",
      bots,csbot->c[CSTOP][bots].cx.x,csbot->c[CSTOP][bots].cx.y,
      bote,csbot->c[CSTOP][bote].cx.x,csbot->c[CSTOP][bote].cx.y);
#endif


  sx=sy=ex=ey=0;                     /* compiler */
  cleft=cright=NULL;                 /* compiler */
  xcleft=xcright=NULL;
  leftbackwards=rightbackwards=0;    /* compiler */

  /* now output the strip chunk */


  clefttop.c.x=cstop->c[CSBOT][tops].cx.x;
  clefttop.c.y=cstop->c[CSBOT][tops].cx.y;
  cleft=cstop->c[CSBOT][tops].c;
  slefttop=cstop->c[CSBOT][tops].s;
  clefttop.u1=cstop->c[CSBOT][tops].u;

  if(cstop->c[CSBOT][tops].dy) leftbackwards=(cstop->c[CSBOT][tops].dy>0);
  else 
  {
#ifdef DBUG
   dprintf(0,"left u=%x umin=%x umax=%x",cstop->c[CSBOT][tops].u,
                                         cstop->c[CSBOT][tops].umin,
                                         cstop->c[CSBOT][tops].umax);

#endif
   leftbackwards=cstop->c[CSBOT][tops].u==cstop->c[CSBOT][tops].umin;
  }

  crighttop.c.x=cstop->c[CSBOT][tope].cx.x;
  crighttop.c.y=cstop->c[CSBOT][tope].cx.y;
  cright=cstop->c[CSBOT][tope].c;
  srighttop=cstop->c[CSBOT][tope].s;
  crighttop.u1=cstop->c[CSBOT][tope].u;

  if(cstop->c[CSBOT][tope].dy) rightbackwards=cstop->c[CSBOT][tope].dy<0;
  else                          
  {
#ifdef DBUG
   dprintf(0,"right u=%x umin=%x umax=%x",cstop->c[CSBOT][tope].u,
                                          cstop->c[CSBOT][tope].umin,
                                          cstop->c[CSBOT][tope].umax);
#endif

   rightbackwards=cstop->c[CSBOT][tope].u==cstop->c[CSBOT][tope].umax;
  }

  cleftbot.c.x=csbot->c[CSTOP][bots].cx.x;
  cleftbot.c.y=csbot->c[CSTOP][bots].cx.y;
  sleftbot=csbot->c[CSTOP][bots].s;
  cleftbot.u1=csbot->c[CSTOP][bots].u;
  cleftb=csbot->c[CSTOP][bots].c;


  crightbot.c.x=csbot->c[CSTOP][bote].cx.x;
  crightbot.c.y=csbot->c[CSTOP][bote].cx.y;
  srightbot=csbot->c[CSTOP][bote].s;
  crightbot.u1=csbot->c[CSTOP][bote].u;
  crightb=csbot->c[CSTOP][bote].c;


  xleft=MIN(clefttop.c.x,cleftbot.c.x);
  xright=MAX(crighttop.c.x,crightbot.c.x);

#ifdef DBUG
  dprintf(0,"cleft=%x xcleft=%x type=%d",cleft,xcleft,cleft->type);

  dprintf(0,"cright=%x xcright=%x type=%d",cright,xcright,cright->type);
#endif



  if(cleft->type==CBOX && cright->type==CBOX)
  {
   ocurve.box.x=xleft;
   ocurve.box.w=xright-ocurve.box.x;
   ocurve.box.y=topy;
   ocurve.box.h=boty-ocurve.box.y;
   ocurve.type=CBOX;
  }
  else
  if(cleft==cright && (cleft->type==CELLIPSE || cleft->type==CBOXR) &&
       (topy==cleft->box.y && boty==(topy+cleft->box.h))
    )
  {
   ocurve=*cleft;
  }
  else  /* output a path  cleft!=cright */
  {
   index=0;
   if(!outputpath) err=flex_alloc((flex_ptr)&outputpath,OUTPATHCHUNK);

   if(cleft->type==CBOX)
   {
    outputpath[index++]=DRAWMOVE;
    outputpath[index++]=sx=xleft;
    outputpath[index++]=sy=boty;
    outputpath[index++]=DRAWDRAW;
    outputpath[index++]=ex=xleft;
    outputpath[index++]=ey=topy;
   }
   else
   if(cleft->type==CBOXR)
   {
    cx=cleft->box.x+cleft->box.w/2;
    cy=cleft->box.y+cleft->box.h/2;

    rboxwidth(cleft,topy,&xlo,&xhi);

    if(xleft>cx) ex=xhi;
    else         ex=xlo;
    ey=topy;

    rboxwidth(cleft,boty,&xlo,&xhi);

    if(xleft>cx) sx=xhi;
    else         sx=xlo;
    sy=boty;

    outputpath[index++]=DRAWMOVE;
    outputpath[index++]=sx;
    outputpath[index++]=sy;

    if(xleft>cx)    /* outside curve */
    index+=rboxarc(outputpath+index,cleft,sx,sy,ex,ey,0);
    else
    index+=rboxarc(outputpath+index,cleft,sx,sy,ex,ey,1);
   }
   else
   if(cleft->type==CELLIPSE)
   {
    outputpath[index++]=DRAWMOVE;
    outputpath[index++]=sx=cleftbot.c.x;
    outputpath[index++]=sy=cleftbot.c.y;
    ex=clefttop.c.x;
    ey=clefttop.c.y;


    if(leftbackwards)
    index+=ellipsearc(outputpath+index,cleft,sx,sy,ex,ey,0);
    else
    index+=ellipsearc(outputpath+index,cleft,ex,ey,sx,sy,1);

   }
   else
   if(cleft->type==CPATH)
   {
    /* if increasing index makes the curve go to the right and up */
    /* then output from lowest index to greatest                  */

    /* if increasing index makes the curve go to the left and down */
    /* then output from highest index to lowest                    */

    outputpath[index++]=DRAWMOVE;
    outputpath[index++]=sx=cleftbot.c.x;
    outputpath[index++]=sy=cleftbot.c.y;
    ex=clefttop.c.x;
    ey=clefttop.c.y;



#ifdef DBUG
    dprintf(0,"leftback=%d",leftbackwards);
#endif


    if(cleft!=cleftb) /* fix up, something is wrong */
    {
     outputpath[index++]=DRAWDRAW;
     outputpath[index++]=ex;
     outputpath[index++]=ey;
    }
    else
    {
     if(leftbackwards)
     {

#ifdef DBUG
     dprintf(0,"from u=%d x=%d y=%d index=%d",clefttop.u1,clefttop.c.x,
                                             clefttop.c.y,slefttop.index);

     dprintf(0,"to   u=%d x=%d y=%d index=%d",cleftbot.u1,cleftbot.c.x,
                                             cleftbot.c.y,sleftbot.index);

#endif

      outputsegments(cleft->data.path.path,clefttop.u1,&slefttop,
                                      clefttop.c.x,clefttop.c.y,
                                      cleftbot.u1,&sleftbot,
                                      cleftbot.c.x,cleftbot.c.y,
                                      &segp,&ns,&ssize,file);
     }
     else
     {

#ifdef DBUG
     dprintf(0,"to u=%d x=%d y=%d index=%d",clefttop.u1,clefttop.c.x,
                                             clefttop.c.y,slefttop.index);

     dprintf(0,"from   u=%d x=%d y=%d index=%d",cleftbot.u1,cleftbot.c.x,
                                             cleftbot.c.y,sleftbot.index);

#endif


      outputsegments(cleft->data.path.path,cleftbot.u1,&sleftbot,
                                      cleftbot.c.x,cleftbot.c.y,
                                      clefttop.u1,&slefttop,
                                      clefttop.c.x,clefttop.c.y,
                                      &segp,&ns,&ssize,file);
     }

     flex_chunk((flex_ptr)&outputpath,(index+ssize)*sizeof(int)+OUTPATHMIN,
                                                               OUTPATHCHUNK);

     index+=outputsegmentpath(outputpath+index,segp,ns,leftbackwards);

     clearsegments(&segp);
    }
   }



   if(cright->type==CBOX)
   {
    if(ex!=xright || ey!=topy)
    {
     outputpath[index++]=DRAWDRAW;
     outputpath[index++]=xright;
     outputpath[index++]=topy;
    }
    outputpath[index++]=DRAWDRAW;
    outputpath[index++]=ex=xright;
    outputpath[index++]=ey=boty;
   }
   else
   if(cright->type==CBOXR)
   {
    cx=cright->box.x+cright->box.w/2;
    cy=cright->box.y+cright->box.h/2;

    rboxwidth(cright,topy,&xlo,&xhi);

    if(xright>cx) tx=xhi;
    else          tx=xlo;
    ty=topy;

    rboxwidth(cright,boty,&xlo,&xhi);

    if(xright>cx) ex=xhi;
    else          ex=xlo;
    ey=boty;

    if(ex!=tx || ey!=ty)
    {
     outputpath[index++]=DRAWDRAW;
     outputpath[index++]=tx;
     outputpath[index++]=ty;
    }

    if(xright>cx)
    index+=rboxarc(outputpath+index,cright,tx,ty,ex,ey,1);
    else
    index+=rboxarc(outputpath+index,cright,tx,ty,ex,ey,0);
   }
   else
   if(cright->type==CELLIPSE)
   {
    tx=crighttop.c.x;
    ty=crighttop.c.y;

    if(ex!=tx || ey!=ty)
    {
     outputpath[index++]=DRAWDRAW;
     outputpath[index++]=tx;
     outputpath[index++]=ty;
    }

    ex=crightbot.c.x;
    ey=crightbot.c.y;

    if(!rightbackwards)
    index+=ellipsearc(outputpath+index,cright,ex,ey,tx,ty,1);
    else
    index+=ellipsearc(outputpath+index,cright,tx,ty,ex,ey,0);
   }
   else
   if(cright->type==CPATH)
   {
    if(ex!=crighttop.c.x || ey!=crighttop.c.y)
    {
     outputpath[index++]=DRAWDRAW;
     outputpath[index++]=crighttop.c.x;
     outputpath[index++]=crighttop.c.y;
    }

    ex=crightbot.c.x;
    ey=crightbot.c.y;

#ifdef DBUG
    dprintf(0,"rightback=%d",rightbackwards);
#endif

    if(cright!=crightb) /* fix up, something is wrong */
    {
     outputpath[index++]=DRAWDRAW;
     outputpath[index++]=ex;
     outputpath[index++]=ey;
    }
    else
    {
     if(rightbackwards)
     {

#ifdef DBUG     
     dprintf(0,"to   u=%d x=%d y=%d index=%d type=%d",
             crighttop.u1,crighttop.c.x,
             crighttop.c.y,srighttop.index,srighttop.type);

     dprintf(0,"from u=%d x=%d y=%d index=%d type=%d",
             crightbot.u1,crightbot.c.x,
             crightbot.c.y,srightbot.index,srightbot.type);

#endif

      outputsegments(cright->data.path.path,crightbot.u1,&srightbot,
                                      crightbot.c.x,crightbot.c.y,
                                      crighttop.u1,&srighttop,
                                      crighttop.c.x,crighttop.c.y,
                                      &segp,&ns,&ssize,file);

     }
     else
     {

#ifdef DBUG
     dprintf(0,"from u=%d x=%d y=%d index=%d type=%d",
                    crighttop.u1,crighttop.c.x,
                    crighttop.c.y,srighttop.index,srighttop.type);

     dprintf(0,"to   u=%d x=%d y=%d index=%d type=%d",
                   crightbot.u1,crightbot.c.x,
                   crightbot.c.y,srightbot.index,srightbot.type);
#endif


      outputsegments(cright->data.path.path,crighttop.u1,&srighttop,
                                       crighttop.c.x,crighttop.c.y,
                                       crightbot.u1,&srightbot,
                                       crightbot.c.x,crightbot.c.y,
                                       &segp,&ns,&ssize,file);

     }

     flex_chunk((flex_ptr)&outputpath,(index+ssize)*sizeof(int)+OUTPATHMIN,
                                                               OUTPATHCHUNK);

     index+=outputsegmentpath(outputpath+index,segp,ns,rightbackwards);

     clearsegments(&segp);
    }
   }

   if(ex!=sx || ey!=sy)
   {
    outputpath[index++]=DRAWDRAW;
    outputpath[index++]=sx;
    outputpath[index++]=sy;
   }

   outputpath[index++]=DRAWCLOSE;
   outputpath[index++]=DRAWEND;

   ocurve.type=CPATH;
   err=fob_create(sizeof(pathstr)+index*sizeof(int),file,OPATH,
                                                         (fobjptr)&pathp);
   ocurve.data.path.path=pathp->key;
   XMEMCPYX(pathp->data,outputpath,index*sizeof(int));
   getpathbox(&ocurve.box,pathp->data);


   if(ocurve.box.y!=topy && ocurve.box.h!=(boty-topy))
   {
    cprintf("***topy=%d box.y=%d",topy,ocurve.box.y);
    cprintf("***h=%d boty-topy=%d",ocurve.box.h,(boty-topy));

   }
 /*  ocurve.box.y=topy;
   ocurve.box.h=boty-topy; */
  }


  if(!vboxk)
  {
   err=fob_create(sizeof(textvbox),file,OTEXTVBOX,(fobjptr)&vboxp);
   vboxk=vboxp->key;
  }
  else
  {
   err=fob_change(vboxk,file,sizeof(textvbox)+sizeof(curvestr)*nx,
                                                    (fobjptr)&vboxp);
  }

  vboxp->curve[nx]=ocurve;
  nx++;
  vboxp->nc=nx;
 }

 *newvboxk=vboxk;
 flex_free((flex_ptr)&outputpath);

 return(err);
}



static os_error * stripadd(csbuffstr * csbfo,csbuffstr * csbfi,
                           int tindex,int bindex,int y,
                           curvestr * tcurve,int nc,filestr * file)
{
 os_error * err;
 int        i;

 err=NULL;

 clearcsbuffer(csbfo);

 for(i=0;i<nvcurves;i++)
 {
  err=cshline(&vcurves[i].c,y,file,csbfo,csbfi,tindex,bindex);
 }

 for(i=0;i<nc;i++)
 {
  cshline(&tcurve[i],y,file,csbfo,csbfi,tindex,bindex);
 }

 sortcsbuffer(csbfo);


#ifdef DBUG2
 {
  for(i=0;i<csbfo->n[0];i++)
  {
   dprintf(0,"seg 0 oldindex=%d index=%d",csbfo->c[0][i].s.oldindex,
                                          csbfo->c[0][i].s.index);
  }

  for(i=0;i<csbfo->n[1];i++)
  {
   dprintf(0,"seg 1 oldindex=%d index=%d",csbfo->c[1][i].s.oldindex,
                                          csbfo->c[1][i].s.index);
  }

 }
#endif


 return(err);
}



// tcurve basic text area of the frame typically rectangle which we clip with vcurves[]
// producing vboxes in vboxanchor

static os_error * vicurve(curvestr * tcurve,int * vboxanchor,filestr * file)
{
 os_error     * err;
 textvbox     * vboxq;
 csbuffstr      csbf;
 csbuffstr      csbfx[2];
 int            newvboxk;
 int            newchain;
 int            newcurrent;
 int            tstart;
 int            tend;
 int            bstart;
 int            bend;
 int            novboxes;
 int            swop;
 int            yt;
 int            yb;
 int            i;
 int            j;


/* int            time=clock(); */

 err=NULL;

 *vboxanchor=0;

 err=createcsbuffer(&csbf);
 if(!err)
 {
  err=createcsbuffer(&csbfx[0]);
  if(!err)
  {
   err=createcsbuffer(&csbfx[1]);
   if(!err)
   {
    /* for each strip                             */
    /* scan through vbox objects for the text box */

    newcurrent=newchain=novboxes=0;

    clearcsbuffer(&csbf);

    /* compute intersections etc */


    for(i=0;i<nvcurves;i++)
    {
     if(i==0) cintersections(&csbf,&vcurves[i].c,tcurve,NULL,file);  // compute intersections of icurve and tcurve
     else     cintersections(&csbf,&vcurves[i].c,tcurve,&vcurves[0].c,file); // compute intersections of vcurve[>=1] and tcurve which lie inside icurve

     cextrema(&csbf,&vcurves[i].c,tcurve,1,file);


     if(vcurves[i].bits & CVWIDEST)
     {
      int vlo;
      int vhi;
      int tlo;
      int thi;

      tlo=tcurve->box.x;
      thi=tlo+tcurve->box.w;
      vlo=vcurves[i].c.box.x;
      vhi=vlo+vcurves[i].c.box.w;

      if(tlo<vlo && thi>vhi)
      {
       if((vlo-tlo)>(thi-vhi)) vcurves[i].bits|=CVLEFT;
       else                    vcurves[i].bits|=CVRIGHT;
      }
      else
      if(tlo<vlo) vcurves[i].bits|=CVLEFT;
      else
      if(thi>vhi) vcurves[i].bits|=CVRIGHT;

     }
    }


 /*   dprintf(0,"step 1 %d",clock()-time);time=clock(); */


    /* can optimise this because if i doest not overlap t, 
       no point looking at j */

    for(i=0;i<nvcurves;i++)
    {
     for(j=i+1;j<nvcurves;j++)
     {
      cintersections(&csbf,&vcurves[i].c,&vcurves[j].c,tcurve,file);
     }
    }

 /*   dprintf(0,"step 2 %d",clock()-time);time=clock(); */

    cextrema(&csbf,tcurve,NULL,0,file);

    sortcsbuffer(&csbf);

    /* for each height of interest, create new strips */

    tstart=tend=0;
    bstart=bend=0;
    swop=1;


    if(csbf.n[CSTOP]>0 && csbf.n[CSBOT]>0) 
                           yt=MIN(csbf.c[CSTOP][0].cx.y,csbf.c[CSBOT][0].cx.y);
    else
    if(csbf.n[CSTOP]>0) yt=csbf.c[CSTOP][0].cx.y;
    else
    if(csbf.n[CSBOT]>0) yt=csbf.c[CSBOT][0].cx.y;
    else                yt=0;  /* compiler */

    stripadd(csbfx,&csbf,tstart,bstart,yt,tcurve,1,file);


 /*  dprintf(0,"step 3 %d",clock()-time);time=clock(); */


    while(tend<csbf.n[CSTOP] || bend<csbf.n[CSBOT])
    {
     while(csbf.c[CSTOP][tend].cx.y<=yt && tend<csbf.n[CSTOP]) tend++;
     while(csbf.c[CSBOT][bend].cx.y<=yt && bend<csbf.n[CSBOT]) bend++;

     if(tend>=csbf.n[CSTOP] && bend>=csbf.n[CSBOT]) break;

     if(tend<csbf.n[CSTOP] && bend<csbf.n[CSBOT])
     {
      if(csbf.c[CSTOP][tend].cx.y<csbf.c[CSBOT][bend].cx.y) 
                                                yb=csbf.c[CSTOP][tend].cx.y;
      else                                      yb=csbf.c[CSBOT][bend].cx.y;
     }
     else
     if(tend<csbf.n[CSTOP]) yb=csbf.c[CSTOP][tend].cx.y;
     else                   yb=csbf.c[CSBOT][bend].cx.y;


     stripadd(csbfx+swop,&csbf,tend,bend,yb,tcurve,1,file);

     createstripx(&newvboxk,&csbfx[!swop],&csbfx[swop],tcurve,file);

     if(newvboxk)
     {
      if(!newchain) 
      {
       newcurrent=newchain=newvboxk;
      }
      else
      {
       vboxq=(textvbox*)fob_find(newcurrent,file);
       vboxq->down=newvboxk;
       newcurrent=newvboxk;
      }
     }

     tstart=tend;
     bstart=bend;
     yt=yb;
     swop^=1;
    }

 /* dprintf(0,"step 4 %d",clock()-time);time=clock(); */


    *vboxanchor=newchain;


    deletecsbuffer(&csbfx[1]);

   }
   deletecsbuffer(&csbfx[0]);

  }
  deletecsbuffer(&csbf);

 }

 return(err);
}




/* compute the impact of this object, on the vbox structure */

// sob later object which may overlap textk
// childboxes flag to check children on sob


static os_error * viobject(sobjectstr * sob,int textk,
                                        filestr * file,int childboxes)
{
 os_error     * err;
 objectflowstr  tf;
 int            sobk;
 textboxstr   * textp;
 sobjectstr     sfix;
 int            next;
 transformstr   tr2;
 transformstr   tr3;
 transformstr   tr4;
 transformstr   inv;
 curvestr       ocurve;
 curvestr       scurve;
 int            bits;

 err=NULL;


 cprintf("viobject %d",textk);

 if(sob)
 {
  sobk=sob->key;

  textp=(textboxstr*)fob_find(textk,file);

  if(boxoverlap(&textp->box,&sob->box))
  {
   sfix=*sob;
   scurve=sfix.ocurve;

   tr2=textp->data.transform;

   tr_setshift(&tr3,textp->fcurve.box.x,textp->fcurve.box.y);
   tr_multiply(&tr4,&tr3,&tr2);

   tr_inverse(&tr4,&inv);


   /* transparent ? */

   sob=(sobjectstr*)fob_find(sobk,file); /* horrid, because objectflow() may access 
                               all of object, we can't use sfix         */

   err=objectflow((objhdrstr*)sob,file,&tf,1);
   if(!err)
   {
    if(tf.flow.omode!=FRONONE)
    {
     /* get transform to take o curve into vbox space */

     tr_multiply(&tr2,&tf.tr,&inv);

     /* transform curve */

     copycurve(&ocurve,file,&scurve,file);

     transformcurve(&tr2,&ocurve,file);

//#ifdef DEBUG
     cprintf("after transform curve=%x type=%d path=%d",
                              &ocurve,ocurve.type,ocurve.data.path.path);
//#endif

     bits=0;
     if(tf.flow.fmode==FRFNEITHER) bits|=CVNEITHER;
     else
     if(tf.flow.fmode==FRFLEFT)    bits|=CVLEFT;
     else
     if(tf.flow.fmode==FRFRIGHT)   bits|=CVRIGHT;
     else
     if(tf.flow.fmode==FRFWIDEST)  bits|=CVWIDEST;

     viaddcurve(&ocurve,bits);
    }

    if(childboxes)
    {
     /* sort out child boxes                             */
     /* for opaque objects, these would not count anyway */

     sob=(sobjectstr*)fob_find(sobk,file);
     next=sob->chain.child;
     while(next)
     {
      sob=(sobjectstr*)fob_find(next,file);
      next=sob->chain.next;
      err=viobject(sob,textk,file,childboxes);
      if(err) break;
     }
    }
   }
  }
 }
 return(err);
}



/* create visible areas for text boxes */

os_error * createvboxes(int textk,filestr * file)
{
 os_error      * err;
 textboxstr    * textp;
 sobjectstr    * sob;
 int             vboxk;
 curvestr        fcurve;
 curvestr        icurve;
 curvestr        ocurve;
 curvestr        tcurve;
 transformstr    tr;
 transformstr    tr1;
 transformstr    tr2;
 transformstr    tr3;
 int             n;
 int             columns;

 int             gwidth;
 int             cwidth;
 int             parent;
 int             next;
 int             usize;
 texsub        * texup;
 texhdr        * texhp;
 int             header;
 int             footer;
 int             xcolumns;
 int             xn;
 transformbitstr bits;
 int             width;
 int             height;
 int             doheader;
 int             dofooter;
 int             hof;



#ifdef DBUG
 int time=clock();
 cprintf("create vboxes text=%d\n",textk);
#endif


//  cprintf("create vboxes text=%d",textk);

 err=NULL;

 trashvboxes(textk,file);


 textp=(textboxstr*)fob_find(textk,file);
 fcurve=textp->fcurve;
 tr=textp->transform;
 columns=textp->data.columns;

 tr_getbits(&tr,&bits);
 width=scale(fcurve.box.w,bits.xscale,0x10000);
 height=scale(fcurve.box.h,bits.yscale,0x10000);

 gwidth=guttersize(&textp->data.columndata,columns,width);
 cwidth=(width-(columns-1)*gwidth)/columns;

 header=textp->data.header;
 footer=textp->data.footer;

 hof=(header || footer);

 xcolumns=columns;

 if(hof)
 {
  texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
  header=texhp->header;
  footer=texhp->footer;
  usize=sizeof(textboxstr)+3*sizeof(texsrc)+sizeof(texhdr);

  dohf(textp,0,&doheader,&dofooter,file);

  if(!doheader) header=0;
  if(!dofooter) footer=0;

  xcolumns+=2;
 }
 else 
 {
  usize=sizeof(textboxstr)+sizeof(texsrc);
 }

 xn=0;
 for(n=0;n<xcolumns;n++)
 {
  if(hof && ((n==0 && !header) || (n==1 && !footer))) vboxk=0;
  else
  {
   tcurve.type=CBOX;

   if(hof && n<2)
   {
    tcurve.box.x=0;
    tcurve.box.w=width;

    if(n==0)
    {
     tcurve.box.y=0;
     tcurve.box.h=header;
    }
    else
    {
     tcurve.box.y=height-footer;
     tcurve.box.h=footer;
    }
   }
   else
   {
    tcurve.box.x=xn*(cwidth+gwidth)-50;
    tcurve.box.w=cwidth+100;
    tcurve.box.y=header-50;
    tcurve.box.h=height-footer-header+100;
    xn++;
   }

   if(bits.skewxy)
   {
    curvestr        scurve;
    transformstr    str;

    tr_setbits(&str,&bits,TR_SKEWXY);
    if(bits.skewxy<0) str.e-=scale(height,bits.skewxy,0x10000);

    scurve=tcurve;

    transformcurve(&str,&scurve,file);



    tcurve=scurve;
   }

   /* clip this vbox, against frame i curve */

   textp=(textboxstr*)fob_find(textk,file);
   icurve=textp->icurve;

   tr_setshift(&tr2,-fcurve.box.x,-fcurve.box.y);
   tr_setbits(&tr1,&bits,TR_SCALE|TR_SKEW);
   tr_multiply(&tr3,&tr2,&tr1);

   if(bits.skewxy<0) tr3.e-=scale(height,bits.skewxy,0x10000);

   copycurve(&ocurve,file,&icurve,file);

   transformcurve(&tr3,&ocurve,file);

   cprintf("main after transform curve=%x type=%d path=%d xrad %d yrad %d",
                             &ocurve,ocurve.type,ocurve.data.path.path,ocurve.data.rbox.xradius,ocurve.data.rbox.yradius);


   // we set off with the icurve of the frame we are interested in and add
   // it to a list of curves, then we add the ocurves of any intersecting later frames


   vistartcurves();
   viaddcurve(&ocurve,CVTRANS);

   if(!embededobject(textk,file))
   {
    /* there is a possible optimisation for column frames */
    /* don't add in objects that don't clip the column    */

    textp=(textboxstr*)fob_find(textk,file);   
    next=textp->chain.next;
    parent=textk;
    do
    {
     while(next)
     {
      sob=(sobjectstr*)fob_find(next,file);
      next=sob->chain.next; /* only do child boxes for later frames in chain */
      err=viobject(sob,textk,file,parent!=sob->key);
      if(err) break;
     }

     sob=(sobjectstr*)fob_find(parent,file);
     parent=parentof((chainobject*)sob,file);
     if(!parent) break;

     next=parent;
     sob=(sobjectstr*)fob_find(parent,file);


    } while(sob->type!=OPAGE); /* was && vboxk); */
   }

   // now have a list of curves which we intersect with tcurve which represents the basic
   // text area, typically a rectangle, but presumably may be skewed

   vicurve(&tcurve,&vboxk,file);

   viclearcurves(file);

   deletecurve(&tcurve,file);
  }


  if(!err)
  {
   err=fob_mod(textk,file,(fobjptr)&textp);
   if(!err)
   {
    texup=(texsub*)(((char*)textp)+usize);
    texup[n].vbox=vboxk;
   }
  }
 }


#ifdef DBUG
 cprintf("time=%d",clock()-time);
#endif


//  cprintf("create vboxes exit");

 return(err);
}





os_error * getvbbox(aboxstr * vbbox,int vbox,filestr * file)
{
 textvbox * vboxp;
 int        first;
 int        nc;
 int        i;
 aboxstr    abox;

 first=1;

 while(vbox)
 {
  vboxp=(textvbox*)fob_find(vbox,file);
  vbox=vboxp->down;
  nc=vboxp->nc;

  for(i=0;i<nc;i++)
  {
   box2abox(&vboxp->curve[i].box,&abox);

   if(first) 
   {
    *vbbox=abox;
    first=0;
   }
   else
   {
    getsumabox(vbbox,&abox);
   }
  }
 }                                                                             

 return(NULL);
}




