/*->c.font */

#include <stdafx.h>


#include <stdlib.h>
#include <stdio.h>

#include "os.h"
#include "wimp.h"
#include "flex.h"
#include "font.h"
#include "wimp.h"
#include "bbc.h"

#include "etc.h"

#include "alloc.h"
#include "osglue.h"
#include "oserr.h"
#include "osunits.h"
#include "osreg.h"
#include "transform.h"
#include "osgraphics.h"
#include "wos.h"
#include "deb.h"
#include "truetype.h"
#include "bits.h"
#include "xmath.h"








int font_code16wintab[256]=
{
 0x0,     // 0
 0x1,     // 1
 0x2,     // 2
 0x3,     // 3
 0x4,     // 4
 0x5,     // 5
 0x6,     // 6
 0x7,     // 7
 0x8,     // 8
 0x9,     // 9
 0xa,     // 10
 0xb,     // 11
 0xc,     // 12
 0xd,     // 13
 0xe,     // 14
 0xf,     // 15
 0x10,     // 16
 0x11,     // 17
 0x12,     // 18
 0x13,     // 19
 0x14,     // 20
 0x15,     // 21
 0x16,     // 22
 0x17,     // 23
 0x18,     // 24
 0x19,     // 25
 0x1a,     // 26
 0x1b,     // 27
 0x1c,     // 28
 0x1d,     // 29
 0x1e,     // 30
 0x1f,     // 31
 0x20,     // 32
 0x21,     // 33 !
 0x22,     // 34 "
 0x23,     // 35 #
 0x24,     // 36 $
 0x25,     // 37 %
 0x26,     // 38 &
 0x27,     // 39 '
 0x28,     // 40 (
 0x29,     // 41 )
 0x2a,     // 42 *
 0x2b,     // 43 +
 0x2c,     // 44 ,
 0x2d,     // 45 -
 0x2e,     // 46 .
 0x2f,     // 47 /
 0x30,     // 48 0
 0x31,     // 49 1
 0x32,     // 50 2
 0x33,     // 51 3
 0x34,     // 52 4
 0x35,     // 53 5
 0x36,     // 54 6
 0x37,     // 55 7
 0x38,     // 56 8
 0x39,     // 57 9
 0x3a,     // 58 :
 0x3b,     // 59 ;
 0x3c,     // 60 <
 0x3d,     // 61 =
 0x3e,     // 62 >
 0x3f,     // 63 ?
 0x40,     // 64 @
 0x41,     // 65 A
 0x42,     // 66 B
 0x43,     // 67 C
 0x44,     // 68 D
 0x45,     // 69 E
 0x46,     // 70 F
 0x47,     // 71 G
 0x48,     // 72 H
 0x49,     // 73 I
 0x4a,     // 74 J
 0x4b,     // 75 K
 0x4c,     // 76 L
 0x4d,     // 77 M
 0x4e,     // 78 N
 0x4f,     // 79 O
 0x50,     // 80 P
 0x51,     // 81 Q
 0x52,     // 82 R
 0x53,     // 83 S
 0x54,     // 84 T
 0x55,     // 85 U
 0x56,     // 86 V
 0x57,     // 87 W
 0x58,     // 88 X
 0x59,     // 89 Y
 0x5a,     // 90 Z
 0x5b,     // 91 [
 0x5c,     // 92 \/
 0x5d,     // 93 ]
 0x5e,     // 94 ^
 0x5f,     // 95 _
 0x60,     // 96 `
 0x61,     // 97 a
 0x62,     // 98 b
 0x63,     // 99 c
 0x64,     // 100 d
 0x65,     // 101 e
 0x66,     // 102 f
 0x67,     // 103 g
 0x68,     // 104 h
 0x69,     // 105 i
 0x6a,     // 106 j
 0x6b,     // 107 k
 0x6c,     // 108 l
 0x6d,     // 109 m
 0x6e,     // 110 n
 0x6f,     // 111 o
 0x70,     // 112 p
 0x71,     // 113 q
 0x72,     // 114 r
 0x73,     // 115 s
 0x74,     // 116 t
 0x75,     // 117 u
 0x76,     // 118 v
 0x77,     // 119 w
 0x78,     // 120 x
 0x79,     // 121 y
 0x7a,     // 122 z
 0x7b,     // 123 {
 0x7c,     // 124 |
 0x7d,     // 125 }
 0x7e,     // 126 ~
 0x7f,     // 127 
 0x20ac,     // 128 
 0x81,     // 129 
 0x201a,     // 130 
 0x192,     // 131 
 0x201e,     // 132 
 0x2026,     // 133 
 0x2020,     // 134 
 0x2021,     // 135 
 0x2c6,     // 136 
 0x2030,     // 137 
 0x160,     // 138 
 0x2039,     // 139 
 0x152,     // 140 
 0x8d,     // 141 
 0x17d,     // 142 
 0x8f,     // 143 
 0x90,     // 144 
 0x2018,     // 145 
 0x2019,     // 146 
 0x201c,     // 147 
 0x201d,     // 148 
 0x2022,     // 149 
 0x2013,     // 150 
 0x2014,     // 151 
 0x2dc,     // 152 
 0x2122,     // 153 
 0x161,     // 154 
 0x203a,     // 155 
 0x153,     // 156 
 0x9d,     // 157 
 0x17e,     // 158 P
 0x178,     // 159 
 0xa0,     // 160 
 0xa1,     // 161 
 0xa2,     // 162 
 0xa3,     // 163 
 0xa4,     // 164 
 0xa5,     // 165 
 0xa6,     // 166 
 0xa7,     // 167 
 0xa8,     // 168 
 0xa9,     // 169 
 0xaa,     // 170 
 0xab,     // 171 
 0xac,     // 172 
 0xad,     // 173 
 0xae,     // 174 
 0xaf,     // 175 
 0xb0,     // 176 
 0xb1,     // 177 
 0xb2,     // 178 
 0xb3,     // 179 
 0xb4,     // 180 
 0xb5,     // 181 
 0xb6,     // 182 
 0xb7,     // 183 +
 0xb8,     // 184 +
 0xb9,     // 185 
 0xba,     // 186 
 0xbb,     // 187 +
 0xbc,     // 188 +
 0xbd,     // 189 +
 0xbe,     // 190 +
 0xbf,     // 191 +
 0xc0,     // 192 +
 0xc1,     // 193 -
 0xc2,     // 194 -
 0xc3,     // 195 +
 0xc4,     // 196 -
 0xc5,     // 197 +
 0xc6,     // 198 
 0xc7,     // 199 
 0xc8,     // 200 +
 0xc9,     // 201 +
 0xca,     // 202 -
 0xcb,     // 203 -
 0xcc,     // 204 
 0xcd,     // 205 -
 0xce,     // 206 +
 0xcf,     // 207 -
 0xd0,     // 208 -
 0xd1,     // 209 -
 0xd2,     // 210 -
 0xd3,     // 211 +
 0xd4,     // 212 +
 0xd5,     // 213 +
 0xd6,     // 214 +
 0xd7,     // 215 +
 0xd8,     // 216 +
 0xd9,     // 217 +
 0xda,     // 218 +
 0xdb,     // 219 
 0xdc,     // 220 _
 0xdd,     // 221 
 0xde,     // 222 
 0xdf,     // 223 
 0xe0,     // 224 a
 0xe1,     // 225 
 0xe2,     // 226 G
 0xe3,     // 227 p
 0xe4,     // 228 S
 0xe5,     // 229 s
 0xe6,     // 230 
 0xe7,     // 231 t
 0xe8,     // 232 F
 0xe9,     // 233 T
 0xea,     // 234 O
 0xeb,     // 235 d
 0xec,     // 236 8
 0xed,     // 237 f
 0xee,     // 238 e
 0xef,     // 239 n
 0xf0,     // 240 =
 0xf1,     // 241 
 0xf2,     // 242 =
 0xf3,     // 243 =
 0xf4,     // 244 (
 0xf5,     // 245 )
 0xf6,     // 246 
 0xf7,     // 247 
 0xf8,     // 248 
 0xf9,     // 249 
 0xfa,     // 250 
 0xfb,     // 251 v
 0xfc,     // 252 n
 0xfd,     // 253 
 0xfe,     // 254 
 0xff      // 255 
};







static int font_code16wintabeast[256]=
{

 0x0,     // 0  
 0x1,     // 1  
 0x2,     // 2  
 0x3,     // 3  
 0x4,     // 4  
 0x5,     // 5  
 0x6,     // 6  
 0x7,     // 7  
 0x8,     // 8  
 0x9,     // 9  
 0xa,     // 10  
 0xb,     // 11  
 0xc,     // 12  
 0xd,     // 13  
 0xe,     // 14  
 0xf,     // 15  
 0x10,     // 16  
 0x11,     // 17  
 0x12,     // 18  
 0x13,     // 19  
 0x14,     // 20  
 0x15,     // 21  
 0x16,     // 22  
 0x17,     // 23  
 0x18,     // 24  
 0x19,     // 25  
 0x1a,     // 26  
 0x1b,     // 27  
 0x1c,     // 28  
 0x1d,     // 29  
 0x1e,     // 30  
 0x1f,     // 31  
 0x20,     // 32  
 0x21,     // 33 !
 0x22,     // 34 "
 0x23,     // 35 #
 0x24,     // 36 $
 0x25,     // 37 %
 0x26,     // 38 &
 0x27,     // 39 '
 0x28,     // 40 (
 0x29,     // 41 )
 0x2a,     // 42 *
 0x2b,     // 43 +
 0x2c,     // 44 ,
 0x2d,     // 45 -
 0x2e,     // 46 .
 0x2f,     // 47 /
 0x30,     // 48 0
 0x31,     // 49 1
 0x32,     // 50 2
 0x33,     // 51 3
 0x34,     // 52 4
 0x35,     // 53 5
 0x36,     // 54 6
 0x37,     // 55 7
 0x38,     // 56 8
 0x39,     // 57 9
 0x3a,     // 58 :
 0x3b,     // 59 ;
 0x3c,     // 60 <
 0x3d,     // 61 =
 0x3e,     // 62 >
 0x3f,     // 63 ?
 0x40,     // 64 @
 0x41,     // 65 A
 0x42,     // 66 B
 0x43,     // 67 C
 0x44,     // 68 D
 0x45,     // 69 E
 0x46,     // 70 F
 0x47,     // 71 G
 0x48,     // 72 H
 0x49,     // 73 I
 0x4a,     // 74 J
 0x4b,     // 75 K
 0x4c,     // 76 L
 0x4d,     // 77 M
 0x4e,     // 78 N
 0x4f,     // 79 O
 0x50,     // 80 P
 0x51,     // 81 Q
 0x52,     // 82 R
 0x53,     // 83 S
 0x54,     // 84 T
 0x55,     // 85 U
 0x56,     // 86 V
 0x57,     // 87 W
 0x58,     // 88 X
 0x59,     // 89 Y
 0x5a,     // 90 Z
 0x5b,     // 91 [
 0x5c,     // 92  
 0x5d,     // 93 ]
 0x5e,     // 94 ^
 0x5f,     // 95 _
 0x60,     // 96 `
 0x61,     // 97 a
 0x62,     // 98 b
 0x63,     // 99 c
 0x64,     // 100 d
 0x65,     // 101 e
 0x66,     // 102 f
 0x67,     // 103 g
 0x68,     // 104 h
 0x69,     // 105 i
 0x6a,     // 106 j
 0x6b,     // 107 k
 0x6c,     // 108 l
 0x6d,     // 109 m
 0x6e,     // 110 n
 0x6f,     // 111 o
 0x70,     // 112 p
 0x71,     // 113 q
 0x72,     // 114 r
 0x73,     // 115 s
 0x74,     // 116 t
 0x75,     // 117 u
 0x76,     // 118 v
 0x77,     // 119 w
 0x78,     // 120 x
 0x79,     // 121 y
 0x7a,     // 122 z
 0x7b,     // 123 {
 0x7c,     // 124 |
 0x7d,     // 125 }
 0x7e,     // 126 ~
 0x7f,     // 127  
 0x20ac,     // 128 
 0x81,     // 129 
 0x201a,     // 130 
 0x83,     // 131 
 0x201e,     // 132 
 0x2026,     // 133 
 0x2020,     // 134 
 0x2021,     // 135 
 0x88,     // 136 
 0x2030,     // 137 
 0x160,     // 138 
 0x2039,     // 139 
 0x15a,     // 140 
 0x164,     // 141 
 0x17d,     // 142 
 0x179,     // 143 
 0x90,     // 144 
 0x2018,     // 145 
 0x2019,     // 146 
 0x201c,     // 147 
 0x201d,     // 148 
 0x2022,     // 149 
 0x2013,     // 150 
 0x2014,     // 151 
 0x98,     // 152 
 0x2122,     // 153 
 0x161,     // 154 
 0x203a,     // 155 
 0x15b,     // 156 
 0x165,     // 157 
 0x17e,     // 158 
 0x17a,     // 159 
 0xa0,     // 160 
 0x2c7,     // 161 
 0x2d8,     // 162 
 0x141,     // 163 
 0xa4,     // 164 
 0x104,     // 165 
 0xa6,     // 166 
 0xa7,     // 167 
 0xa8,     // 168 
 0xa9,     // 169 
 0x15e,     // 170 
 0xab,     // 171 
 0xac,     // 172 
 0xad,     // 173 
 0xae,     // 174 
 0x17b,     // 175 
 0xb0,     // 176 
 0xb1,     // 177 
 0x2db,     // 178 
 0x142,     // 179 
 0xb4,     // 180 
 0xb5,     // 181 
 0xb6,     // 182 
 0xb7,     // 183 
 0xb8,     // 184 
 0x105,     // 185 
 0x15f,     // 186 
 0xbb,     // 187 
 0x13d,     // 188 
 0x2dd,     // 189 
 0x13e,     // 190 
 0x17c,     // 191 
 0x154,     // 192 
 0xc1,     // 193 
 0xc2,     // 194 
 0x102,     // 195 
 0xc4,     // 196 
 0x139,     // 197 
 0x106,     // 198 
 0xc7,     // 199 
 0x10c,     // 200 
 0xc9,     // 201 
 0x118,     // 202 
 0xcb,     // 203 
 0x11a,     // 204 
 0xcd,     // 205 
 0xce,     // 206 
 0x10e,     // 207 
 0x110,     // 208 
 0x143,     // 209 
 0x147,     // 210 
 0xd3,     // 211 
 0xd4,     // 212 
 0x150,     // 213 
 0xd6,     // 214 
 0xd7,     // 215 
 0x158,     // 216 
 0x16e,     // 217 
 0xda,     // 218 
 0x170,     // 219 
 0xdc,     // 220 
 0xdd,     // 221 
 0x162,     // 222 
 0xdf,     // 223 
 0x155,     // 224 
 0xe1,     // 225 
 0xe2,     // 226 
 0x103,     // 227 
 0xe4,     // 228 
 0x13a,     // 229 
 0x107,     // 230 
 0xe7,     // 231 
 0x10d,     // 232 
 0xe9,     // 233 
 0x119,     // 234 
 0xeb,     // 235 
 0x11b,     // 236 
 0xed,     // 237 
 0xee,     // 238 
 0x10f,     // 239 
 0x111,     // 240 
 0x144,     // 241 
 0x148,     // 242 
 0xf3,     // 243 
 0xf4,     // 244 
 0x151,     // 245 
 0xf6,     // 246 
 0xf7,     // 247 
 0x159,     // 248 
 0x16f,     // 249 
 0xfa,     // 250 
 0x171,     // 251 
 0xfc,     // 252 
 0xfd,     // 253 
 0x163,     // 254 
 0x2d9,     // 255 
};


static int font_code16wintabrussian[256]=
{

 0x0,     // 0  
 0x1,     // 1  
 0x2,     // 2  
 0x3,     // 3  
 0x4,     // 4  
 0x5,     // 5  
 0x6,     // 6  
 0x7,     // 7  
 0x8,     // 8  
 0x9,     // 9  
 0xa,     // 10  
 0xb,     // 11  
 0xc,     // 12  
 0xd,     // 13  
 0xe,     // 14  
 0xf,     // 15  
 0x10,     // 16  
 0x11,     // 17  
 0x12,     // 18  
 0x13,     // 19  
 0x14,     // 20  
 0x15,     // 21  
 0x16,     // 22  
 0x17,     // 23  
 0x18,     // 24  
 0x19,     // 25  
 0x1a,     // 26  
 0x1b,     // 27  
 0x1c,     // 28  
 0x1d,     // 29  
 0x1e,     // 30  
 0x1f,     // 31  
 0x20,     // 32  
 0x21,     // 33 !
 0x22,     // 34 "
 0x23,     // 35 #
 0x24,     // 36 $
 0x25,     // 37 %
 0x26,     // 38 &
 0x27,     // 39 '
 0x28,     // 40 (
 0x29,     // 41 )
 0x2a,     // 42 *
 0x2b,     // 43 +
 0x2c,     // 44 ,
 0x2d,     // 45 -
 0x2e,     // 46 .
 0x2f,     // 47 /
 0x30,     // 48 0
 0x31,     // 49 1
 0x32,     // 50 2
 0x33,     // 51 3
 0x34,     // 52 4
 0x35,     // 53 5
 0x36,     // 54 6
 0x37,     // 55 7
 0x38,     // 56 8
 0x39,     // 57 9
 0x3a,     // 58 :
 0x3b,     // 59 ;
 0x3c,     // 60 <
 0x3d,     // 61 =
 0x3e,     // 62 >
 0x3f,     // 63 ?
 0x40,     // 64 @
 0x41,     // 65 A
 0x42,     // 66 B
 0x43,     // 67 C
 0x44,     // 68 D
 0x45,     // 69 E
 0x46,     // 70 F
 0x47,     // 71 G
 0x48,     // 72 H
 0x49,     // 73 I
 0x4a,     // 74 J
 0x4b,     // 75 K
 0x4c,     // 76 L
 0x4d,     // 77 M
 0x4e,     // 78 N
 0x4f,     // 79 O
 0x50,     // 80 P
 0x51,     // 81 Q
 0x52,     // 82 R
 0x53,     // 83 S
 0x54,     // 84 T
 0x55,     // 85 U
 0x56,     // 86 V
 0x57,     // 87 W
 0x58,     // 88 X
 0x59,     // 89 Y
 0x5a,     // 90 Z
 0x5b,     // 91 [
 0x5c,     // 92  
 0x5d,     // 93 ]
 0x5e,     // 94 ^
 0x5f,     // 95 _
 0x60,     // 96 `
 0x61,     // 97 a
 0x62,     // 98 b
 0x63,     // 99 c
 0x64,     // 100 d
 0x65,     // 101 e
 0x66,     // 102 f
 0x67,     // 103 g
 0x68,     // 104 h
 0x69,     // 105 i
 0x6a,     // 106 j
 0x6b,     // 107 k
 0x6c,     // 108 l
 0x6d,     // 109 m
 0x6e,     // 110 n
 0x6f,     // 111 o
 0x70,     // 112 p
 0x71,     // 113 q
 0x72,     // 114 r
 0x73,     // 115 s
 0x74,     // 116 t
 0x75,     // 117 u
 0x76,     // 118 v
 0x77,     // 119 w
 0x78,     // 120 x
 0x79,     // 121 y
 0x7a,     // 122 z
 0x7b,     // 123 {
 0x7c,     // 124 |
 0x7d,     // 125 }
 0x7e,     // 126 ~
 0x7f,     // 127  
 0x402,     // 128 
 0x403,     // 129 
 0x201a,     // 130 
 0x453,     // 131 
 0x201e,     // 132 
 0x2026,     // 133 
 0x2020,     // 134 
 0x2021,     // 135 
 0x20ac,     // 136 
 0x2030,     // 137 
 0x409,     // 138 
 0x2039,     // 139 
 0x40a,     // 140 
 0x40c,     // 141 
 0x40b,     // 142 
 0x40f,     // 143 
 0x452,     // 144 
 0x2018,     // 145 
 0x2019,     // 146 
 0x201c,     // 147 
 0x201d,     // 148 
 0x2022,     // 149 
 0x2013,     // 150 
 0x2014,     // 151 
 0x98,     // 152 
 0x2122,     // 153 
 0x459,     // 154 
 0x203a,     // 155 
 0x45a,     // 156 
 0x45c,     // 157 
 0x45b,     // 158 
 0x45f,     // 159 
 0xa0,     // 160 
 0x40e,     // 161 
 0x45e,     // 162 
 0x408,     // 163 
 0xa4,     // 164 
 0x490,     // 165 
 0xa6,     // 166 
 0xa7,     // 167 
 0x401,     // 168 
 0xa9,     // 169 
 0x404,     // 170 
 0xab,     // 171 
 0xac,     // 172 
 0xad,     // 173 
 0xae,     // 174 
 0x407,     // 175 
 0xb0,     // 176 
 0xb1,     // 177 
 0x406,     // 178 
 0x456,     // 179 
 0x491,     // 180 
 0xb5,     // 181 
 0xb6,     // 182 
 0xb7,     // 183 
 0x451,     // 184 
 0x2116,     // 185 
 0x454,     // 186 
 0xbb,     // 187 
 0x458,     // 188 
 0x405,     // 189 
 0x455,     // 190 
 0x457,     // 191 
 0x410,     // 192 
 0x411,     // 193 
 0x412,     // 194 
 0x413,     // 195 
 0x414,     // 196 
 0x415,     // 197 
 0x416,     // 198 
 0x417,     // 199 
 0x418,     // 200 
 0x419,     // 201 
 0x41a,     // 202 
 0x41b,     // 203 
 0x41c,     // 204 
 0x41d,     // 205 
 0x41e,     // 206 
 0x41f,     // 207 
 0x420,     // 208 
 0x421,     // 209 
 0x422,     // 210 
 0x423,     // 211 
 0x424,     // 212 
 0x425,     // 213 
 0x426,     // 214 
 0x427,     // 215 
 0x428,     // 216 
 0x429,     // 217 
 0x42a,     // 218 
 0x42b,     // 219 
 0x42c,     // 220 
 0x42d,     // 221 
 0x42e,     // 222 
 0x42f,     // 223 
 0x430,     // 224 
 0x431,     // 225 
 0x432,     // 226 
 0x433,     // 227 
 0x434,     // 228 
 0x435,     // 229 
 0x436,     // 230 
 0x437,     // 231 
 0x438,     // 232 
 0x439,     // 233 
 0x43a,     // 234 
 0x43b,     // 235 
 0x43c,     // 236 
 0x43d,     // 237 
 0x43e,     // 238 
 0x43f,     // 239 
 0x440,     // 240 
 0x441,     // 241 
 0x442,     // 242 
 0x443,     // 243 
 0x444,     // 244 
 0x445,     // 245 
 0x446,     // 246 
 0x447,     // 247 
 0x448,     // 248 
 0x449,     // 249 
 0x44a,     // 250 
 0x44b,     // 251 
 0x44c,     // 252 
 0x44d,     // 253 
 0x44e,     // 254 
 0x44f,     // 255 
};


static int font_code16wintabgreek[256]=
{

 0x0,     // 0  
 0x1,     // 1  
 0x2,     // 2  
 0x3,     // 3  
 0x4,     // 4  
 0x5,     // 5  
 0x6,     // 6  
 0x7,     // 7  
 0x8,     // 8  
 0x9,     // 9  
 0xa,     // 10  
 0xb,     // 11  
 0xc,     // 12  
 0xd,     // 13  
 0xe,     // 14  
 0xf,     // 15  
 0x10,     // 16  
 0x11,     // 17  
 0x12,     // 18  
 0x13,     // 19  
 0x14,     // 20  
 0x15,     // 21  
 0x16,     // 22  
 0x17,     // 23  
 0x18,     // 24  
 0x19,     // 25  
 0x1a,     // 26  
 0x1b,     // 27  
 0x1c,     // 28  
 0x1d,     // 29  
 0x1e,     // 30  
 0x1f,     // 31  
 0x20,     // 32  
 0x21,     // 33 !
 0x22,     // 34 "
 0x23,     // 35 #
 0x24,     // 36 $
 0x25,     // 37 %
 0x26,     // 38 &
 0x27,     // 39 '
 0x28,     // 40 (
 0x29,     // 41 )
 0x2a,     // 42 *
 0x2b,     // 43 +
 0x2c,     // 44 ,
 0x2d,     // 45 -
 0x2e,     // 46 .
 0x2f,     // 47 /
 0x30,     // 48 0
 0x31,     // 49 1
 0x32,     // 50 2
 0x33,     // 51 3
 0x34,     // 52 4
 0x35,     // 53 5
 0x36,     // 54 6
 0x37,     // 55 7
 0x38,     // 56 8
 0x39,     // 57 9
 0x3a,     // 58 :
 0x3b,     // 59 ;
 0x3c,     // 60 <
 0x3d,     // 61 =
 0x3e,     // 62 >
 0x3f,     // 63 ?
 0x40,     // 64 @
 0x41,     // 65 A
 0x42,     // 66 B
 0x43,     // 67 C
 0x44,     // 68 D
 0x45,     // 69 E
 0x46,     // 70 F
 0x47,     // 71 G
 0x48,     // 72 H
 0x49,     // 73 I
 0x4a,     // 74 J
 0x4b,     // 75 K
 0x4c,     // 76 L
 0x4d,     // 77 M
 0x4e,     // 78 N
 0x4f,     // 79 O
 0x50,     // 80 P
 0x51,     // 81 Q
 0x52,     // 82 R
 0x53,     // 83 S
 0x54,     // 84 T
 0x55,     // 85 U
 0x56,     // 86 V
 0x57,     // 87 W
 0x58,     // 88 X
 0x59,     // 89 Y
 0x5a,     // 90 Z
 0x5b,     // 91 [
 0x5c,     // 92  
 0x5d,     // 93 ]
 0x5e,     // 94 ^
 0x5f,     // 95 _
 0x60,     // 96 `
 0x61,     // 97 a
 0x62,     // 98 b
 0x63,     // 99 c
 0x64,     // 100 d
 0x65,     // 101 e
 0x66,     // 102 f
 0x67,     // 103 g
 0x68,     // 104 h
 0x69,     // 105 i
 0x6a,     // 106 j
 0x6b,     // 107 k
 0x6c,     // 108 l
 0x6d,     // 109 m
 0x6e,     // 110 n
 0x6f,     // 111 o
 0x70,     // 112 p
 0x71,     // 113 q
 0x72,     // 114 r
 0x73,     // 115 s
 0x74,     // 116 t
 0x75,     // 117 u
 0x76,     // 118 v
 0x77,     // 119 w
 0x78,     // 120 x
 0x79,     // 121 y
 0x7a,     // 122 z
 0x7b,     // 123 {
 0x7c,     // 124 |
 0x7d,     // 125 }
 0x7e,     // 126 ~
 0x7f,     // 127  
 0x20ac,     // 128 
 0x81,     // 129 
 0x201a,     // 130 
 0x192,     // 131 
 0x201e,     // 132 
 0x2026,     // 133 
 0x2020,     // 134 
 0x2021,     // 135 
 0x88,     // 136 
 0x2030,     // 137 
 0x8a,     // 138 
 0x2039,     // 139 
 0x8c,     // 140 
 0x8d,     // 141 
 0x8e,     // 142 
 0x8f,     // 143 
 0x90,     // 144 
 0x2018,     // 145 
 0x2019,     // 146 
 0x201c,     // 147 
 0x201d,     // 148 
 0x2022,     // 149 
 0x2013,     // 150 
 0x2014,     // 151 
 0x98,     // 152 
 0x2122,     // 153 
 0x9a,     // 154 
 0x203a,     // 155 
 0x9c,     // 156 
 0x9d,     // 157 
 0x9e,     // 158 
 0x9f,     // 159 
 0xa0,     // 160 
 0x385,     // 161 
 0x386,     // 162 
 0xa3,     // 163 
 0xa4,     // 164 
 0xa5,     // 165 
 0xa6,     // 166 
 0xa7,     // 167 
 0xa8,     // 168 
 0xa9,     // 169 
 0xf8f9,     // 170 
 0xab,     // 171 
 0xac,     // 172 
 0xad,     // 173 
 0xae,     // 174 
 0x2015,     // 175 
 0xb0,     // 176 
 0xb1,     // 177 
 0xb2,     // 178 
 0xb3,     // 179 
 0x384,     // 180 
 0xb5,     // 181 
 0xb6,     // 182 
 0xb7,     // 183 
 0x388,     // 184 
 0x389,     // 185 
 0x38a,     // 186 
 0xbb,     // 187 
 0x38c,     // 188 
 0xbd,     // 189 
 0x38e,     // 190 
 0x38f,     // 191 
 0x390,     // 192 
 0x391,     // 193 
 0x392,     // 194 
 0x393,     // 195 
 0x394,     // 196 
 0x395,     // 197 
 0x396,     // 198 
 0x397,     // 199 
 0x398,     // 200 
 0x399,     // 201 
 0x39a,     // 202 
 0x39b,     // 203 
 0x39c,     // 204 
 0x39d,     // 205 
 0x39e,     // 206 
 0x39f,     // 207 
 0x3a0,     // 208 
 0x3a1,     // 209 
 0xf8fa,     // 210 
 0x3a3,     // 211 
 0x3a4,     // 212 
 0x3a5,     // 213 
 0x3a6,     // 214 
 0x3a7,     // 215 
 0x3a8,     // 216 
 0x3a9,     // 217 
 0x3aa,     // 218 
 0x3ab,     // 219 
 0x3ac,     // 220 
 0x3ad,     // 221 
 0x3ae,     // 222 
 0x3af,     // 223 
 0x3b0,     // 224 
 0x3b1,     // 225 
 0x3b2,     // 226 
 0x3b3,     // 227 
 0x3b4,     // 228 
 0x3b5,     // 229 
 0x3b6,     // 230 
 0x3b7,     // 231 
 0x3b8,     // 232 
 0x3b9,     // 233 
 0x3ba,     // 234 
 0x3bb,     // 235 
 0x3bc,     // 236 
 0x3bd,     // 237 
 0x3be,     // 238 
 0x3bf,     // 239 
 0x3c0,     // 240 
 0x3c1,     // 241 
 0x3c2,     // 242 
 0x3c3,     // 243 
 0x3c4,     // 244 
 0x3c5,     // 245 
 0x3c6,     // 246 
 0x3c7,     // 247 
 0x3c8,     // 248 
 0x3c9,     // 249 
 0x3ca,     // 250 
 0x3cb,     // 251 
 0x3cc,     // 252 
 0x3cd,     // 253 
 0x3ce,     // 254 
 0xf8fb,     // 255 
};


static int font_code16wintabturkish[256]=
{

 0x0,     // 0  
 0x1,     // 1  
 0x2,     // 2  
 0x3,     // 3  
 0x4,     // 4  
 0x5,     // 5  
 0x6,     // 6  
 0x7,     // 7  
 0x8,     // 8  
 0x9,     // 9  
 0xa,     // 10  
 0xb,     // 11  
 0xc,     // 12  
 0xd,     // 13  
 0xe,     // 14  
 0xf,     // 15  
 0x10,     // 16  
 0x11,     // 17  
 0x12,     // 18  
 0x13,     // 19  
 0x14,     // 20  
 0x15,     // 21  
 0x16,     // 22  
 0x17,     // 23  
 0x18,     // 24  
 0x19,     // 25  
 0x1a,     // 26  
 0x1b,     // 27  
 0x1c,     // 28  
 0x1d,     // 29  
 0x1e,     // 30  
 0x1f,     // 31  
 0x20,     // 32  
 0x21,     // 33 !
 0x22,     // 34 "
 0x23,     // 35 #
 0x24,     // 36 $
 0x25,     // 37 %
 0x26,     // 38 &
 0x27,     // 39 '
 0x28,     // 40 (
 0x29,     // 41 )
 0x2a,     // 42 *
 0x2b,     // 43 +
 0x2c,     // 44 ,
 0x2d,     // 45 -
 0x2e,     // 46 .
 0x2f,     // 47 /
 0x30,     // 48 0
 0x31,     // 49 1
 0x32,     // 50 2
 0x33,     // 51 3
 0x34,     // 52 4
 0x35,     // 53 5
 0x36,     // 54 6
 0x37,     // 55 7
 0x38,     // 56 8
 0x39,     // 57 9
 0x3a,     // 58 :
 0x3b,     // 59 ;
 0x3c,     // 60 <
 0x3d,     // 61 =
 0x3e,     // 62 >
 0x3f,     // 63 ?
 0x40,     // 64 @
 0x41,     // 65 A
 0x42,     // 66 B
 0x43,     // 67 C
 0x44,     // 68 D
 0x45,     // 69 E
 0x46,     // 70 F
 0x47,     // 71 G
 0x48,     // 72 H
 0x49,     // 73 I
 0x4a,     // 74 J
 0x4b,     // 75 K
 0x4c,     // 76 L
 0x4d,     // 77 M
 0x4e,     // 78 N
 0x4f,     // 79 O
 0x50,     // 80 P
 0x51,     // 81 Q
 0x52,     // 82 R
 0x53,     // 83 S
 0x54,     // 84 T
 0x55,     // 85 U
 0x56,     // 86 V
 0x57,     // 87 W
 0x58,     // 88 X
 0x59,     // 89 Y
 0x5a,     // 90 Z
 0x5b,     // 91 [
 0x5c,     // 92  
 0x5d,     // 93 ]
 0x5e,     // 94 ^
 0x5f,     // 95 _
 0x60,     // 96 `
 0x61,     // 97 a
 0x62,     // 98 b
 0x63,     // 99 c
 0x64,     // 100 d
 0x65,     // 101 e
 0x66,     // 102 f
 0x67,     // 103 g
 0x68,     // 104 h
 0x69,     // 105 i
 0x6a,     // 106 j
 0x6b,     // 107 k
 0x6c,     // 108 l
 0x6d,     // 109 m
 0x6e,     // 110 n
 0x6f,     // 111 o
 0x70,     // 112 p
 0x71,     // 113 q
 0x72,     // 114 r
 0x73,     // 115 s
 0x74,     // 116 t
 0x75,     // 117 u
 0x76,     // 118 v
 0x77,     // 119 w
 0x78,     // 120 x
 0x79,     // 121 y
 0x7a,     // 122 z
 0x7b,     // 123 {
 0x7c,     // 124 |
 0x7d,     // 125 }
 0x7e,     // 126 ~
 0x7f,     // 127  
 0x20ac,     // 128 
 0x81,     // 129 
 0x201a,     // 130 
 0x192,     // 131 
 0x201e,     // 132 
 0x2026,     // 133 
 0x2020,     // 134 
 0x2021,     // 135 
 0x2c6,     // 136 
 0x2030,     // 137 
 0x160,     // 138 
 0x2039,     // 139 
 0x152,     // 140 
 0x8d,     // 141 
 0x8e,     // 142 
 0x8f,     // 143 
 0x90,     // 144 
 0x2018,     // 145 
 0x2019,     // 146 
 0x201c,     // 147 
 0x201d,     // 148 
 0x2022,     // 149 
 0x2013,     // 150 
 0x2014,     // 151 
 0x2dc,     // 152 
 0x2122,     // 153 
 0x161,     // 154 
 0x203a,     // 155 
 0x153,     // 156 
 0x9d,     // 157 
 0x9e,     // 158 
 0x178,     // 159 
 0xa0,     // 160 
 0xa1,     // 161 
 0xa2,     // 162 
 0xa3,     // 163 
 0xa4,     // 164 
 0xa5,     // 165 
 0xa6,     // 166 
 0xa7,     // 167 
 0xa8,     // 168 
 0xa9,     // 169 
 0xaa,     // 170 
 0xab,     // 171 
 0xac,     // 172 
 0xad,     // 173 
 0xae,     // 174 
 0xaf,     // 175 
 0xb0,     // 176 
 0xb1,     // 177 
 0xb2,     // 178 
 0xb3,     // 179 
 0xb4,     // 180 
 0xb5,     // 181 
 0xb6,     // 182 
 0xb7,     // 183 
 0xb8,     // 184 
 0xb9,     // 185 
 0xba,     // 186 
 0xbb,     // 187 
 0xbc,     // 188 
 0xbd,     // 189 
 0xbe,     // 190 
 0xbf,     // 191 
 0xc0,     // 192 
 0xc1,     // 193 
 0xc2,     // 194 
 0xc3,     // 195 
 0xc4,     // 196 
 0xc5,     // 197 
 0xc6,     // 198 
 0xc7,     // 199 
 0xc8,     // 200 
 0xc9,     // 201 
 0xca,     // 202 
 0xcb,     // 203 
 0xcc,     // 204 
 0xcd,     // 205 
 0xce,     // 206 
 0xcf,     // 207 
 0x11e,     // 208 
 0xd1,     // 209 
 0xd2,     // 210 
 0xd3,     // 211 
 0xd4,     // 212 
 0xd5,     // 213 
 0xd6,     // 214 
 0xd7,     // 215 
 0xd8,     // 216 
 0xd9,     // 217 
 0xda,     // 218 
 0xdb,     // 219 
 0xdc,     // 220 
 0x130,     // 221 
 0x15e,     // 222 
 0xdf,     // 223 
 0xe0,     // 224 
 0xe1,     // 225 
 0xe2,     // 226 
 0xe3,     // 227 
 0xe4,     // 228 
 0xe5,     // 229 
 0xe6,     // 230 
 0xe7,     // 231 
 0xe8,     // 232 
 0xe9,     // 233 
 0xea,     // 234 
 0xeb,     // 235 
 0xec,     // 236 
 0xed,     // 237 
 0xee,     // 238 
 0xef,     // 239 
 0x11f,     // 240 
 0xf1,     // 241 
 0xf2,     // 242 
 0xf3,     // 243 
 0xf4,     // 244 
 0xf5,     // 245 
 0xf6,     // 246 
 0xf7,     // 247 
 0xf8,     // 248 
 0xf9,     // 249 
 0xfa,     // 250 
 0xfb,     // 251 
 0xfc,     // 252 
 0x131,     // 253 
 0x15f,     // 254 
 0xff,     // 255 
};


static int font_code16wintabhebrew[256]=
{

 0x0,     // 0  
 0x1,     // 1  
 0x2,     // 2  
 0x3,     // 3  
 0x4,     // 4  
 0x5,     // 5  
 0x6,     // 6  
 0x7,     // 7  
 0x8,     // 8  
 0x9,     // 9  
 0xa,     // 10  
 0xb,     // 11  
 0xc,     // 12  
 0xd,     // 13  
 0xe,     // 14  
 0xf,     // 15  
 0x10,     // 16  
 0x11,     // 17  
 0x12,     // 18  
 0x13,     // 19  
 0x14,     // 20  
 0x15,     // 21  
 0x16,     // 22  
 0x17,     // 23  
 0x18,     // 24  
 0x19,     // 25  
 0x1a,     // 26  
 0x1b,     // 27  
 0x1c,     // 28  
 0x1d,     // 29  
 0x1e,     // 30  
 0x1f,     // 31  
 0x20,     // 32  
 0x21,     // 33 !
 0x22,     // 34 "
 0x23,     // 35 #
 0x24,     // 36 $
 0x25,     // 37 %
 0x26,     // 38 &
 0x27,     // 39 '
 0x28,     // 40 (
 0x29,     // 41 )
 0x2a,     // 42 *
 0x2b,     // 43 +
 0x2c,     // 44 ,
 0x2d,     // 45 -
 0x2e,     // 46 .
 0x2f,     // 47 /
 0x30,     // 48 0
 0x31,     // 49 1
 0x32,     // 50 2
 0x33,     // 51 3
 0x34,     // 52 4
 0x35,     // 53 5
 0x36,     // 54 6
 0x37,     // 55 7
 0x38,     // 56 8
 0x39,     // 57 9
 0x3a,     // 58 :
 0x3b,     // 59 ;
 0x3c,     // 60 <
 0x3d,     // 61 =
 0x3e,     // 62 >
 0x3f,     // 63 ?
 0x40,     // 64 @
 0x41,     // 65 A
 0x42,     // 66 B
 0x43,     // 67 C
 0x44,     // 68 D
 0x45,     // 69 E
 0x46,     // 70 F
 0x47,     // 71 G
 0x48,     // 72 H
 0x49,     // 73 I
 0x4a,     // 74 J
 0x4b,     // 75 K
 0x4c,     // 76 L
 0x4d,     // 77 M
 0x4e,     // 78 N
 0x4f,     // 79 O
 0x50,     // 80 P
 0x51,     // 81 Q
 0x52,     // 82 R
 0x53,     // 83 S
 0x54,     // 84 T
 0x55,     // 85 U
 0x56,     // 86 V
 0x57,     // 87 W
 0x58,     // 88 X
 0x59,     // 89 Y
 0x5a,     // 90 Z
 0x5b,     // 91 [
 0x5c,     // 92  
 0x5d,     // 93 ]
 0x5e,     // 94 ^
 0x5f,     // 95 _
 0x60,     // 96 `
 0x61,     // 97 a
 0x62,     // 98 b
 0x63,     // 99 c
 0x64,     // 100 d
 0x65,     // 101 e
 0x66,     // 102 f
 0x67,     // 103 g
 0x68,     // 104 h
 0x69,     // 105 i
 0x6a,     // 106 j
 0x6b,     // 107 k
 0x6c,     // 108 l
 0x6d,     // 109 m
 0x6e,     // 110 n
 0x6f,     // 111 o
 0x70,     // 112 p
 0x71,     // 113 q
 0x72,     // 114 r
 0x73,     // 115 s
 0x74,     // 116 t
 0x75,     // 117 u
 0x76,     // 118 v
 0x77,     // 119 w
 0x78,     // 120 x
 0x79,     // 121 y
 0x7a,     // 122 z
 0x7b,     // 123 {
 0x7c,     // 124 |
 0x7d,     // 125 }
 0x7e,     // 126 ~
 0x7f,     // 127  
 0x20ac,     // 128 
 0x81,     // 129 
 0x201a,     // 130 
 0x192,     // 131 
 0x201e,     // 132 
 0x2026,     // 133 
 0x2020,     // 134 
 0x2021,     // 135 
 0x2c6,     // 136 
 0x2030,     // 137 
 0x8a,     // 138 
 0x2039,     // 139 
 0x8c,     // 140 
 0x8d,     // 141 
 0x8e,     // 142 
 0x8f,     // 143 
 0x90,     // 144 
 0x2018,     // 145 
 0x2019,     // 146 
 0x201c,     // 147 
 0x201d,     // 148 
 0x2022,     // 149 
 0x2013,     // 150 
 0x2014,     // 151 
 0x2dc,     // 152 
 0x2122,     // 153 
 0x9a,     // 154 
 0x203a,     // 155 
 0x9c,     // 156 
 0x9d,     // 157 
 0x9e,     // 158 
 0x9f,     // 159 
 0xa0,     // 160 
 0xa1,     // 161 
 0xa2,     // 162 
 0xa3,     // 163 
 0x20aa,     // 164 
 0xa5,     // 165 
 0xa6,     // 166 
 0xa7,     // 167 
 0xa8,     // 168 
 0xa9,     // 169 
 0xd7,     // 170 
 0xab,     // 171 
 0xac,     // 172 
 0xad,     // 173 
 0xae,     // 174 
 0xaf,     // 175 
 0xb0,     // 176 
 0xb1,     // 177 
 0xb2,     // 178 
 0xb3,     // 179 
 0xb4,     // 180 
 0xb5,     // 181 
 0xb6,     // 182 
 0xb7,     // 183 
 0xb8,     // 184 
 0xb9,     // 185 
 0xf7,     // 186 
 0xbb,     // 187 
 0xbc,     // 188 
 0xbd,     // 189 
 0xbe,     // 190 
 0xbf,     // 191 
 0x5b0,     // 192 
 0x5b1,     // 193 
 0x5b2,     // 194 
 0x5b3,     // 195 
 0x5b4,     // 196 
 0x5b5,     // 197 
 0x5b6,     // 198 
 0x5b7,     // 199 
 0x5b8,     // 200 
 0x5b9,     // 201 
 0x5ba,     // 202 
 0x5bb,     // 203 
 0x5bc,     // 204 
 0x5bd,     // 205 
 0x5be,     // 206 
 0x5bf,     // 207 
 0x5c0,     // 208 
 0x5c1,     // 209 
 0x5c2,     // 210 
 0x5c3,     // 211 
 0x5f0,     // 212 
 0x5f1,     // 213 
 0x5f2,     // 214 
 0x5f3,     // 215 
 0x5f4,     // 216 
 0xf88d,     // 217 
 0xf88e,     // 218 
 0xf88f,     // 219 
 0xf890,     // 220 
 0xf891,     // 221 
 0xf892,     // 222 
 0xf893,     // 223 
 0x5d0,     // 224 
 0x5d1,     // 225 
 0x5d2,     // 226 
 0x5d3,     // 227 
 0x5d4,     // 228 
 0x5d5,     // 229 
 0x5d6,     // 230 
 0x5d7,     // 231 
 0x5d8,     // 232 
 0x5d9,     // 233 
 0x5da,     // 234 
 0x5db,     // 235 
 0x5dc,     // 236 
 0x5dd,     // 237 
 0x5de,     // 238 
 0x5df,     // 239 
 0x5e0,     // 240 
 0x5e1,     // 241 
 0x5e2,     // 242 
 0x5e3,     // 243 
 0x5e4,     // 244 
 0x5e5,     // 245 
 0x5e6,     // 246 
 0x5e7,     // 247 
 0x5e8,     // 248 
 0x5e9,     // 249 
 0x5ea,     // 250 
 0xf894,     // 251 
 0xf895,     // 252 
 0x200e,     // 253 
 0x200f,     // 254 
 0xf896,     // 255 
};


static int font_code16wintabarabic[256]=
{

 0x0,     // 0  
 0x1,     // 1  
 0x2,     // 2  
 0x3,     // 3  
 0x4,     // 4  
 0x5,     // 5  
 0x6,     // 6  
 0x7,     // 7  
 0x8,     // 8  
 0x9,     // 9  
 0xa,     // 10  
 0xb,     // 11  
 0xc,     // 12  
 0xd,     // 13  
 0xe,     // 14  
 0xf,     // 15  
 0x10,     // 16  
 0x11,     // 17  
 0x12,     // 18  
 0x13,     // 19  
 0x14,     // 20  
 0x15,     // 21  
 0x16,     // 22  
 0x17,     // 23  
 0x18,     // 24  
 0x19,     // 25  
 0x1a,     // 26  
 0x1b,     // 27  
 0x1c,     // 28  
 0x1d,     // 29  
 0x1e,     // 30  
 0x1f,     // 31  
 0x20,     // 32  
 0x21,     // 33 !
 0x22,     // 34 "
 0x23,     // 35 #
 0x24,     // 36 $
 0x25,     // 37 %
 0x26,     // 38 &
 0x27,     // 39 '
 0x28,     // 40 (
 0x29,     // 41 )
 0x2a,     // 42 *
 0x2b,     // 43 +
 0x2c,     // 44 ,
 0x2d,     // 45 -
 0x2e,     // 46 .
 0x2f,     // 47 /
 0x30,     // 48 0
 0x31,     // 49 1
 0x32,     // 50 2
 0x33,     // 51 3
 0x34,     // 52 4
 0x35,     // 53 5
 0x36,     // 54 6
 0x37,     // 55 7
 0x38,     // 56 8
 0x39,     // 57 9
 0x3a,     // 58 :
 0x3b,     // 59 ;
 0x3c,     // 60 <
 0x3d,     // 61 =
 0x3e,     // 62 >
 0x3f,     // 63 ?
 0x40,     // 64 @
 0x41,     // 65 A
 0x42,     // 66 B
 0x43,     // 67 C
 0x44,     // 68 D
 0x45,     // 69 E
 0x46,     // 70 F
 0x47,     // 71 G
 0x48,     // 72 H
 0x49,     // 73 I
 0x4a,     // 74 J
 0x4b,     // 75 K
 0x4c,     // 76 L
 0x4d,     // 77 M
 0x4e,     // 78 N
 0x4f,     // 79 O
 0x50,     // 80 P
 0x51,     // 81 Q
 0x52,     // 82 R
 0x53,     // 83 S
 0x54,     // 84 T
 0x55,     // 85 U
 0x56,     // 86 V
 0x57,     // 87 W
 0x58,     // 88 X
 0x59,     // 89 Y
 0x5a,     // 90 Z
 0x5b,     // 91 [
 0x5c,     // 92  
 0x5d,     // 93 ]
 0x5e,     // 94 ^
 0x5f,     // 95 _
 0x60,     // 96 `
 0x61,     // 97 a
 0x62,     // 98 b
 0x63,     // 99 c
 0x64,     // 100 d
 0x65,     // 101 e
 0x66,     // 102 f
 0x67,     // 103 g
 0x68,     // 104 h
 0x69,     // 105 i
 0x6a,     // 106 j
 0x6b,     // 107 k
 0x6c,     // 108 l
 0x6d,     // 109 m
 0x6e,     // 110 n
 0x6f,     // 111 o
 0x70,     // 112 p
 0x71,     // 113 q
 0x72,     // 114 r
 0x73,     // 115 s
 0x74,     // 116 t
 0x75,     // 117 u
 0x76,     // 118 v
 0x77,     // 119 w
 0x78,     // 120 x
 0x79,     // 121 y
 0x7a,     // 122 z
 0x7b,     // 123 {
 0x7c,     // 124 |
 0x7d,     // 125 }
 0x7e,     // 126 ~
 0x7f,     // 127  
 0x20ac,     // 128 
 0x67e,     // 129 
 0x201a,     // 130 
 0x192,     // 131 
 0x201e,     // 132 
 0x2026,     // 133 
 0x2020,     // 134 
 0x2021,     // 135 
 0x2c6,     // 136 
 0x2030,     // 137 
 0x8a,     // 138 
 0x2039,     // 139 
 0x152,     // 140 
 0x686,     // 141 
 0x698,     // 142 
 0x8f,     // 143 
 0x6af,     // 144 
 0x2018,     // 145 
 0x2019,     // 146 
 0x201c,     // 147 
 0x201d,     // 148 
 0x2022,     // 149 
 0x2013,     // 150 
 0x2014,     // 151 
 0x98,     // 152 
 0x2122,     // 153 
 0x9a,     // 154 
 0x203a,     // 155 
 0x153,     // 156 
 0x200c,     // 157 
 0x200d,     // 158 
 0x9f,     // 159 
 0xa0,     // 160 
 0x60c,     // 161 
 0xa2,     // 162 
 0xa3,     // 163 
 0xa4,     // 164 
 0xa5,     // 165 
 0xa6,     // 166 
 0xa7,     // 167 
 0xa8,     // 168 
 0xa9,     // 169 
 0xf897,     // 170 
 0xab,     // 171 
 0xac,     // 172 
 0xad,     // 173 
 0xae,     // 174 
 0xaf,     // 175 
 0xb0,     // 176 
 0xb1,     // 177 
 0xb2,     // 178 
 0xb3,     // 179 
 0xb4,     // 180 
 0xb5,     // 181 
 0xb6,     // 182 
 0xb7,     // 183 
 0xb8,     // 184 
 0xb9,     // 185 
 0x61b,     // 186 
 0xbb,     // 187 
 0xbc,     // 188 
 0xbd,     // 189 
 0xbe,     // 190 
 0x61f,     // 191 
 0xf898,     // 192 
 0x621,     // 193 
 0x622,     // 194 
 0x623,     // 195 
 0x624,     // 196 
 0x625,     // 197 
 0x626,     // 198 
 0x627,     // 199 
 0x628,     // 200 
 0x629,     // 201 
 0x62a,     // 202 
 0x62b,     // 203 
 0x62c,     // 204 
 0x62d,     // 205 
 0x62e,     // 206 
 0x62f,     // 207 
 0x630,     // 208 
 0x631,     // 209 
 0x632,     // 210 
 0x633,     // 211 
 0x634,     // 212 
 0x635,     // 213 
 0x636,     // 214 
 0xd7,     // 215 
 0x637,     // 216 
 0x638,     // 217 
 0x639,     // 218 
 0x63a,     // 219 
 0x640,     // 220 
 0x641,     // 221 
 0x642,     // 222 
 0x643,     // 223 
 0xe0,     // 224 
 0x644,     // 225 
 0xe2,     // 226 
 0x645,     // 227 
 0x646,     // 228 
 0x647,     // 229 
 0x648,     // 230 
 0xe7,     // 231 
 0xe8,     // 232 
 0xe9,     // 233 
 0xea,     // 234 
 0xeb,     // 235 
 0x649,     // 236 
 0x64a,     // 237 
 0xee,     // 238 
 0xef,     // 239 
 0x64b,     // 240 
 0x64c,     // 241 
 0x64d,     // 242 
 0x64e,     // 243 
 0xf4,     // 244 
 0x64f,     // 245 
 0x650,     // 246 
 0xf7,     // 247 
 0x651,     // 248 
 0xf9,     // 249 
 0x652,     // 250 
 0xfb,     // 251 
 0xfc,     // 252 
 0x200e,     // 253 
 0x200f,     // 254 
 0xf899,     // 255 
};


static int font_code16wintabbaltic[256]=
{

 0x0,     // 0  
 0x1,     // 1  
 0x2,     // 2  
 0x3,     // 3  
 0x4,     // 4  
 0x5,     // 5  
 0x6,     // 6  
 0x7,     // 7  
 0x8,     // 8  
 0x9,     // 9  
 0xa,     // 10  
 0xb,     // 11  
 0xc,     // 12  
 0xd,     // 13  
 0xe,     // 14  
 0xf,     // 15  
 0x10,     // 16  
 0x11,     // 17  
 0x12,     // 18  
 0x13,     // 19  
 0x14,     // 20  
 0x15,     // 21  
 0x16,     // 22  
 0x17,     // 23  
 0x18,     // 24  
 0x19,     // 25  
 0x1a,     // 26  
 0x1b,     // 27  
 0x1c,     // 28  
 0x1d,     // 29  
 0x1e,     // 30  
 0x1f,     // 31  
 0x20,     // 32  
 0x21,     // 33 !
 0x22,     // 34 "
 0x23,     // 35 #
 0x24,     // 36 $
 0x25,     // 37 %
 0x26,     // 38 &
 0x27,     // 39 '
 0x28,     // 40 (
 0x29,     // 41 )
 0x2a,     // 42 *
 0x2b,     // 43 +
 0x2c,     // 44 ,
 0x2d,     // 45 -
 0x2e,     // 46 .
 0x2f,     // 47 /
 0x30,     // 48 0
 0x31,     // 49 1
 0x32,     // 50 2
 0x33,     // 51 3
 0x34,     // 52 4
 0x35,     // 53 5
 0x36,     // 54 6
 0x37,     // 55 7
 0x38,     // 56 8
 0x39,     // 57 9
 0x3a,     // 58 :
 0x3b,     // 59 ;
 0x3c,     // 60 <
 0x3d,     // 61 =
 0x3e,     // 62 >
 0x3f,     // 63 ?
 0x40,     // 64 @
 0x41,     // 65 A
 0x42,     // 66 B
 0x43,     // 67 C
 0x44,     // 68 D
 0x45,     // 69 E
 0x46,     // 70 F
 0x47,     // 71 G
 0x48,     // 72 H
 0x49,     // 73 I
 0x4a,     // 74 J
 0x4b,     // 75 K
 0x4c,     // 76 L
 0x4d,     // 77 M
 0x4e,     // 78 N
 0x4f,     // 79 O
 0x50,     // 80 P
 0x51,     // 81 Q
 0x52,     // 82 R
 0x53,     // 83 S
 0x54,     // 84 T
 0x55,     // 85 U
 0x56,     // 86 V
 0x57,     // 87 W
 0x58,     // 88 X
 0x59,     // 89 Y
 0x5a,     // 90 Z
 0x5b,     // 91 [
 0x5c,     // 92  
 0x5d,     // 93 ]
 0x5e,     // 94 ^
 0x5f,     // 95 _
 0x60,     // 96 `
 0x61,     // 97 a
 0x62,     // 98 b
 0x63,     // 99 c
 0x64,     // 100 d
 0x65,     // 101 e
 0x66,     // 102 f
 0x67,     // 103 g
 0x68,     // 104 h
 0x69,     // 105 i
 0x6a,     // 106 j
 0x6b,     // 107 k
 0x6c,     // 108 l
 0x6d,     // 109 m
 0x6e,     // 110 n
 0x6f,     // 111 o
 0x70,     // 112 p
 0x71,     // 113 q
 0x72,     // 114 r
 0x73,     // 115 s
 0x74,     // 116 t
 0x75,     // 117 u
 0x76,     // 118 v
 0x77,     // 119 w
 0x78,     // 120 x
 0x79,     // 121 y
 0x7a,     // 122 z
 0x7b,     // 123 {
 0x7c,     // 124 |
 0x7d,     // 125 }
 0x7e,     // 126 ~
 0x7f,     // 127  
 0x20ac,     // 128 
 0x81,     // 129 
 0x201a,     // 130 
 0x83,     // 131 
 0x201e,     // 132 
 0x2026,     // 133 
 0x2020,     // 134 
 0x2021,     // 135 
 0x88,     // 136 
 0x2030,     // 137 
 0x8a,     // 138 
 0x2039,     // 139 
 0x8c,     // 140 
 0xa8,     // 141 
 0x2c7,     // 142 
 0xb8,     // 143 
 0x90,     // 144 
 0x2018,     // 145 
 0x2019,     // 146 
 0x201c,     // 147 
 0x201d,     // 148 
 0x2022,     // 149 
 0x2013,     // 150 
 0x2014,     // 151 
 0x98,     // 152 
 0x2122,     // 153 
 0x9a,     // 154 
 0x203a,     // 155 
 0x9c,     // 156 
 0xaf,     // 157 
 0x2db,     // 158 
 0x9f,     // 159 
 0xa0,     // 160 
 0xf8fc,     // 161 
 0xa2,     // 162 
 0xa3,     // 163 
 0xa4,     // 164 
 0xf8fd,     // 165 
 0xa6,     // 166 
 0xa7,     // 167 
 0xd8,     // 168 
 0xa9,     // 169 
 0x156,     // 170 
 0xab,     // 171 
 0xac,     // 172 
 0xad,     // 173 
 0xae,     // 174 
 0xc6,     // 175 
 0xb0,     // 176 
 0xb1,     // 177 
 0xb2,     // 178 
 0xb3,     // 179 
 0xb4,     // 180 
 0xb5,     // 181 
 0xb6,     // 182 
 0xb7,     // 183 
 0xf8,     // 184 
 0xb9,     // 185 
 0x157,     // 186 
 0xbb,     // 187 
 0xbc,     // 188 
 0xbd,     // 189 
 0xbe,     // 190 
 0xe6,     // 191 
 0x104,     // 192 
 0x12e,     // 193 
 0x100,     // 194 
 0x106,     // 195 
 0xc4,     // 196 
 0xc5,     // 197 
 0x118,     // 198 
 0x112,     // 199 
 0x10c,     // 200 
 0xc9,     // 201 
 0x179,     // 202 
 0x116,     // 203 
 0x122,     // 204 
 0x136,     // 205 
 0x12a,     // 206 
 0x13b,     // 207 
 0x160,     // 208 
 0x143,     // 209 
 0x145,     // 210 
 0xd3,     // 211 
 0x14c,     // 212 
 0xd5,     // 213 
 0xd6,     // 214 
 0xd7,     // 215 
 0x172,     // 216 
 0x141,     // 217 
 0x15a,     // 218 
 0x16a,     // 219 
 0xdc,     // 220 
 0x17b,     // 221 
 0x17d,     // 222 
 0xdf,     // 223 
 0x105,     // 224 
 0x12f,     // 225 
 0x101,     // 226 
 0x107,     // 227 
 0xe4,     // 228 
 0xe5,     // 229 
 0x119,     // 230 
 0x113,     // 231 
 0x10d,     // 232 
 0xe9,     // 233 
 0x17a,     // 234 
 0x117,     // 235 
 0x123,     // 236 
 0x137,     // 237 
 0x12b,     // 238 
 0x13c,     // 239 
 0x161,     // 240 
 0x144,     // 241 
 0x146,     // 242 
 0xf3,     // 243 
 0x14d,     // 244 
 0xf5,     // 245 
 0xf6,     // 246 
 0xf7,     // 247 
 0x173,     // 248 
 0x142,     // 249 
 0x15b,     // 250 
 0x16b,     // 251 
 0xfc,     // 252 
 0x17c,     // 253 
 0x17e,     // 254 
 0x2d9,     // 255 
};





// return UNICODE

int font_code16win(int win8,int charset)
{

	if(win8>=0 && win8<256)
	{
  if(charset==EASTEUROPE_CHARSET) return(font_code16wintabeast[win8]);
  else
  if(charset==RUSSIAN_CHARSET) return(font_code16wintabrussian[win8]);
  else
  if(charset==GREEK_CHARSET) return(font_code16wintabgreek[win8]);
  else
  if(charset==TURKISH_CHARSET) return(font_code16wintabturkish[win8]);
  else
  if(charset==HEBREW_CHARSET) return(font_code16wintabhebrew[win8]);
  else
  if(charset==ARABIC_CHARSET) return(font_code16wintabarabic[win8]);
  else
  if(charset==BALTIC_CHARSET) return(font_code16wintabbaltic[win8]);
  else
  /*if(charset==ANSI_CHARSET)*/ return(font_code16wintab[win8]);
	}

	return(-1);
}


os_error * font_getstandardfont(int type,font * handle)
{

 *handle=(font)GetStockObject(DEFAULT_GUI_FONT);

 return(NULL);
 USE(type);
}



os_error *font_setfont(font f)
{
 graphicssetfont2((HFONT)f,currenthdcptr);

 return(NULL);
}


os_error *font_setfont2(font f,oshdc hdcptr)
{
 graphicssetfont2((HFONT)f,(hdcstr*)hdcptr);

 return(NULL);
}






os_error * font_setcolour(font f, int background, int foreground, int offset)
{
 os_error * err;
 int        prevb;

 err=NULL;

 if(f) err=graphicssetfont2((HFONT)f,currenthdcptr);

 SetTextColor(currenthdcptr->hdc,COLREFFROMPAL(foreground));
 if(background==-1)
 {
  XSetBkMode(currenthdcptr->hdc,TRANSPARENT,&prevb);
 }
 else
 {
  SetBkColor(currenthdcptr->hdc,COLREFFROMPAL(background));
  XSetBkMode(currenthdcptr->hdc,OPAQUE,&prevb);
 }


 return(err);

 USE(offset);
}


os_error * font_setforeground(int foreground)
{

 SetTextColor(currenthdcptr->hdc,COLREFFROMPAL(foreground));

 return(NULL);
}


os_error * font_align(int bits)
{
 int osbits;

 osbits=0;
 
 if(bits & FA_RIGHT)  osbits|=TA_RIGHT;
 else
 if(bits & FA_CENTRE) osbits|=TA_CENTER;
 else                 osbits|=TA_LEFT;  

 if(bits & FA_TOP)    osbits|=TA_TOP;
 else
 if(bits & FA_BOTTOM) osbits|=TA_BOTTOM;
 else                 osbits|=TA_BASELINE;

 if(bits & FA_UPDATE) osbits|=TA_UPDATECP;
 else                 osbits|=TA_NOUPDATECP;

 SetTextAlign(currenthdcptr->hdc,osbits);

 return(NULL);
}




os_error * font_find(char * name,int xsize,int ysize,int xres,int yres,font * fontadd)
{
 os_error * err;
 HFONT      hfont;
 
 err=NULL;

 xsize=(xsize*currenthdcptr->vduxres)/(16*72);
 ysize=(ysize*currenthdcptr->vduyres)/(16*72);

// cprintf("ysize %d",ysize);

 hfont=CreateFont(-ysize,xsize,0,0,FW_NORMAL,0,0,0,ANSI_CHARSET,
	 OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
	 DEFAULT_PITCH | FF_DONTCARE,name);


 *fontadd=(font)hfont;

 return(err);

 USE(xres);
 USE(yres);
}




os_error * font_find1(char * name,int xsize,int ysize,int angle,font * fontadd)
{
 os_error * err;
 HFONT      hfont;
 
 err=NULL;

 xsize=(xsize*currenthdcptr->vduxres)/(16*72);
 ysize=(ysize*currenthdcptr->vduyres)/(16*72);

 angle=(angle*10)/0x10000;

 hfont=CreateFont(-ysize,xsize,angle,angle,FW_NORMAL,0,0,0,ANSI_CHARSET,
	 OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
	 DEFAULT_PITCH | FF_DONTCARE,name);

 *fontadd=(font)hfont;

 return(err);
}






os_error * font_find2(char * name,int xsize,int ysize,int angle,font * fontadd)
{
 os_error * err;
 HFONT      hfont;

 err=NULL;

// cprintf("create font");

//  cprintf("ysize %d",ysize);

 hfont=CreateFont(-ysize,xsize,angle,angle,FW_NORMAL,0,0,0,ANSI_CHARSET,
	 OUT_SCREEN_OUTLINE_PRECIS,CLIP_EMBEDDED,DEFAULT_QUALITY,
	 DEFAULT_PITCH | FF_DONTCARE,name);

 *fontadd=(font)hfont;

 return(err);

}



os_error * font_find3(char * name,int charset,int xsize,int ysize,int angle,font * fontadd)
{
 os_error * err;
 HFONT      hfont;

 err=NULL;

// cprintf("create font");

//  cprintf("ysize %d",ysize);

 hfont=CreateFont(-ysize,xsize,angle,angle,FW_NORMAL,0,0,0,charset,
	 OUT_SCREEN_OUTLINE_PRECIS,CLIP_EMBEDDED,DEFAULT_QUALITY,
	 DEFAULT_PITCH | FF_DONTCARE,name);

 *fontadd=(font)hfont;

 return(err);

}




os_error * font_find4(char * name,int charset,int weight,int italic,int family,int pitch,int xsize,int ysize,int angle,font * fontadd)
{
 os_error * err;
 HFONT      hfont;

 err=NULL;


// cprintf("create font %s charset %d weight %d italic %d family %d pitch %d",name,charset,weight,italic,family,pitch);

//  cprintf("ysize %d",ysize);

 hfont=CreateFont(-ysize,xsize,angle,angle,weight,italic,0,0,charset,
	 OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
	 pitch | (family<<4),name);

 *fontadd=(font)hfont;

 return(err);

}







os_error * font_find_description(font_description * fd,font * fontadd)
{
 os_error * err;
 HFONT      hfont;
 int        xsize;
 int        ysize;
 
 err=NULL;

 xsize=(fd->width*currenthdcptr->vduxres)/(16*72);
 ysize=(fd->height*currenthdcptr->vduyres)/(16*72);

 hfont=CreateFont(-ysize,xsize,0,0,fd->weight,fd->italic,0,0,fd->charset,
	 OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
	 DEFAULT_PITCH | FF_DONTCARE,fd->name);

 *fontadd=(font)hfont;

 return(err);
}


/*
os_error * font_get_description(font_description * fd,font * fonthandle)
{

 XGetObject(fonthandle,sizeof(LOGFONT),&lfont,&osize);

}

*/

os_error * font_embelish(font oldfont,font * newfont,int italic)
{
 os_error * err;
 LOGFONT    lfont;
 int        osize;
 
 err=XGetObject((HFONT)oldfont,sizeof(LOGFONT),&lfont,&osize);
 if(!err)
 {
  lfont.lfItalic=(unsigned char)italic;
  err=XCreateFontIndirect(&lfont,(HFONT*)newfont);
 }

 return(err);
}




os_error *font_lose(font f)
{
 os_error * err;

 err=NULL;

 graphicslosefont((HFONT)f);
 DeleteObject((HFONT)f);

 return(err);
}







os_error *font_paint(char * s,int options,int x,int y)
{

 if(options & font_OSCOORDS)
 {
  x=GRXPIX(x);
  y=GRYPIX(y);
 }
 else
 {
  x=GRFXPIX(x);
  y=GRFYPIX(y);
 }

 TextOut(currenthdcptr->hdc,x,y,s,strlen(s));

 return(NULL);

}


os_error *font_paint16(wchar_t * s,int options,int x,int y)
{

 if(options & font_OSCOORDS)
 {
  x=GRXPIX(x);
  y=GRYPIX(y);
 }
 else
 {
  x=GRFXPIX(x);
  y=GRFYPIX(y);
 }

 TextOutW(currenthdcptr->hdc,x,y,s,wcslen(s));

 return(NULL);

}




os_error *font_painttrans(char * s,int options,int x,int y,font_transform * trans)
{
 transformstr xtr;
 int          wmode;


 xtr=*(transformstr*)trans;
 x+=xtr.e;
 y+=xtr.f;
 xtr.e=0;
 xtr.f=0;


 if(options & font_OSCOORDS)
 {
  x=GRXPIX(x);
  y=GRYPIX(y);
 }
 else
 {
  x=GRFXPIX(x);
  y=GRFYPIX(y);
 }

 xtr.e+=x;
 xtr.f+=y;

 graphicsworld(&xtr,&wmode);

 TextOut(currenthdcptr->hdc,0,0,s,strlen(s));

 graphicsworld(NULL,&wmode);


 return(NULL);
}






os_error * font_paintlen(char * s,int len, int options, int x, int y)
{

 if(options & font_OSCOORDS)
 {
  x=GRXPIX(x);
  y=GRYPIX(y);
 }
 else
 {
  x=GRFXPIX(x);
  y=GRFYPIX(y);
 }

 TextOut(currenthdcptr->hdc,x,y,s,len);

 return(NULL);
 USE(options);
}



os_error * font_paintext(char * s,int len,int options,int x,int y,fontrect * rectp,int * exts)
{
 int winoptions;

 winoptions=0;

 if(options & font_OSCOORDS)
 {
  x=GRXPIX(x);
  y=GRYPIX(y);
 }
 else
 {
  x=GRFXPIX(x);
  y=GRFYPIX(y);
 }

 ExtTextOut(currenthdcptr->hdc,x,y,winoptions,(RECT*)rectp,s,len,exts);

 return(NULL);
}






os_error * font_paintextscale(char * s,int len,int options,int x,int y,fontrect * rectp,int xscale,int yscale,int * exts)
{
 int winoptions;

 winoptions=0;

 if(options & font_OSCOORDS)
 {
  x=GRXPIX(x);
  y=GRYPIX(y);
 }
 else
 {
  x=GRFXPIX(x);
  y=GRFYPIX(y);
 }

	if(xscale!=0x10000 || yscale!=0x10000)
	{
		bbc_scale(0x100,(xscale*0x100)/0x10000,0x100,(yscale*0x100)/0x10000,0,0,x,y);
  ExtTextOut(currenthdcptr->hdc,0,0,winoptions,(RECT*)rectp,s,len,exts);
		bbc_scale(1,1,1,1,0,0,0,0);
	}
	else
	{
  ExtTextOut(currenthdcptr->hdc,x,y,winoptions,(RECT*)rectp,s,len,exts);
	}


 return(NULL);
}









os_error * font_paintexttr(char * s,int len,int options,int x,int y,fontrect * rectp,int * exts,font_transform * tr)
{
 int          winoptions;
 transformstr xtr;
 int          wmode;


 winoptions=0;

 if(tr_type((transformstr*)tr))
 {
  xtr=*(transformstr*)tr;
  x+=xtr.e;
  y+=xtr.f;
  xtr.e=0;
  xtr.f=0;


  if(options & font_OSCOORDS)
  {
   x=GRXPIX(x);
   y=GRYPIX(y);
  }
  else
  {
   x=GRFXPIX(x);
   y=GRFYPIX(y);
  }

  xtr.e+=x;
  xtr.f+=y;

  graphicsworld(&xtr,&wmode);

  ExtTextOut(currenthdcptr->hdc,0,0,winoptions,(RECT*)rectp,s,len,exts);

  graphicsworld(NULL,&wmode);
 }
 else
 {
  if(options & font_OSCOORDS)
  {
   x=GRXPIX(x);
   y=GRYPIX(y);
  }
  else
  {
   x=GRFXPIX(x);
   y=GRFYPIX(y);
  }


  ExtTextOut(currenthdcptr->hdc,x,y,winoptions,(RECT*)rectp,s,len,exts);
 }


 return(NULL);
}







os_error * font_paintext16(wchar_t * s,int len,int options,int x,int y,fontrect * rectp,int * exts)
{
 int winoptions;

 winoptions=0;

 if(options & font_OSCOORDS)
 {
  x=GRXPIX(x);
  y=GRYPIX(y);
 }
 else
 {
  x=GRFXPIX(x);
  y=GRFYPIX(y);
 }

	if(options & font_IGNORE)
	{
		int i;

/*
		GCP_RESULTSW results;

		winoptions|=ETO_GLYPH_INDEX;

	 results.lStructSize=sizeof(results);
		results.lpOutString=NULL;
		results.lpOrder=NULL;
		results.lpDx=NULL;
		results.lpCaretPos=NULL;
		results.lpClass=NULL;
		results.nGlyphs=len;
		results.lpGlyphs=s;
		results.nMaxFit=0;

  GetCharacterPlacementW(currenthdcptr->hdc,s,len,0,&results,0);
*/

		for(i=0;i<len;i++)
		{
	  s[i]=GetTTUnicodeGlyphIndex(currenthdcptr->hdc,(unsigned short)s[i]);
		}
	}

 ExtTextOutW(currenthdcptr->hdc,x,y,winoptions,(RECT*)rectp,s,len,exts);

 return(NULL);
}




os_error * font_paintextscale16(wchar_t * s,int len,int options,int x,int y,fontrect * rectp,int xscale,int yscale,int * exts)
{
 int winoptions;

 winoptions=0;

 if(options & font_OSCOORDS)
 {
  x=GRXPIX(x);
  y=GRYPIX(y);
 }
 else
 {
  x=GRFXPIX(x);
  y=GRFYPIX(y);
 }

	if(xscale!=0x10000 || yscale!=0x10000)
	{
		bbc_scale(0x100,(xscale*0x100)/0x10000,0x100,(yscale*0x100)/0x10000,0,0,x,y);
  ExtTextOutW(currenthdcptr->hdc,0,0,winoptions,(RECT*)rectp,s,len,exts);
		bbc_scale(1,1,1,1,0,0,0,0);
	}
	else
	{
  ExtTextOutW(currenthdcptr->hdc,x,y,winoptions,(RECT*)rectp,s,len,exts);
	}

 return(NULL);
}




os_error * font_paintext16tr(wchar_t * s,int len,int options,int x,int y,fontrect * rectp,int * exts,font_transform * tr)
{
 int          winoptions;
 transformstr xtr;
 int          wmode;

 winoptions=0;

 if(tr_type((transformstr*)tr))
 {
  xtr=*(transformstr*)tr;
  x+=xtr.e;
  y+=xtr.f;
  xtr.e=0;
  xtr.f=0;

  if(options & font_OSCOORDS)
  {
   x=GRXPIX(x);
   y=GRYPIX(y);
  }
  else
  {
   x=GRFXPIX(x);
   y=GRFYPIX(y);
  }

  xtr.e+=x;
  xtr.f+=y;

  graphicsworld(&xtr,&wmode);

  ExtTextOutW(currenthdcptr->hdc,0,0,winoptions,(RECT*)rectp,s,len,exts);

  graphicsworld(NULL,&wmode);
 }
 else
 {
  if(options & font_OSCOORDS)
  {
   x=GRXPIX(x);
   y=GRYPIX(y);
  }
  else
  {
   x=GRFXPIX(x);
   y=GRFYPIX(y);
  }
  
  ExtTextOutW(currenthdcptr->hdc,x,y,winoptions,(RECT*)rectp,s,len,exts);
 }

 return(NULL);
}







os_error *font_painttabbed(char * s,int options,int x,int y,int ntabs,int * tabs,int tx)
{

 if(options & font_OSCOORDS)
 {
  x=GRXPIX(x);
  y=GRYPIX(y);
 }
 else
 {
  x=GRFXPIX(x);
  y=GRFYPIX(y);
 }

 TabbedTextOut(currenthdcptr->hdc,x,y,s,strlen(s),ntabs,tabs,tx);

 return(NULL);
 USE(options);
}








os_error * font_getmetric2(font_metric * metric,oshdc hdcptr)
{
 os_error   * err;
 TEXTMETRIC   osmetric;
 
 err=XGetTextMetrics(((hdcstr*)hdcptr)->hdc,&osmetric);
 if(!err)
 {
  metric->ascent=(osmetric.tmAscent);
  metric->descent=(osmetric.tmDescent);
  metric->height=(osmetric.tmHeight);
  metric->intleading=(osmetric.tmInternalLeading);
  metric->extleading=(osmetric.tmExternalLeading);
  metric->maxwidth=(osmetric.tmMaxCharWidth);
  metric->averagewidth=(osmetric.tmAveCharWidth);
 }

 return(err);
}


os_error * font_getmetric(font_metric * metric)
{
 return(font_getmetric2(metric,(oshdc)currenthdcptr));
}





os_error * font_getmetric_description(font_description * fd,font_metric * metric)
{
 os_error * err;
 font       fonthandle;
 
 err=graphicscheck(0);
 if(!err)
 {
  err=font_find_description(fd,&fonthandle);
  if(!err)
  {
   font_setfont(fonthandle);
   font_getmetric(metric);
 
   font_lose(fonthandle);
  }

  graphicsclear();
 }

 return(err);
}


// nb GetCharWidth32 is not supported on W 95/98

os_error * font_getwidths_description(font_description * fd,int * width)
{
 os_error * err;
 font       fonthandle;
 INT        buffer[256];
 int        i;
 int        w;
 
 err=graphicscheck(0);
 if(!err)
 {
  err=font_find_description(fd,&fonthandle);
  if(!err)
  {
   font_setfont(fonthandle);

   GetCharWidth(currenthdcptr->hdc,32,255,buffer);
   w=buffer[0];
   for(i=1;i<(256-32-1);i++)
   {
    w=MAX(w,buffer[i]);
   }

   *width=w;

   font_lose(fonthandle);
  }

  graphicsclear();
 }

 return(err);
}






static os_error * fnenumerr;

static int CALLBACK EnumFontFamExProc(ENUMLOGFONTEX *lpelfe,NEWTEXTMETRICEX *lpntme,
                                      DWORD FontType,LPARAM lParam)
{

 fontenumfn    fn;
 font_enumdata data;

// cprintf("type %x %s style %s",FontType,(char*)lpelfe->elfLogFont.lfFaceName,lpelfe->elfStyle);
//	cprintf("ntm %x",lpntme->ntmTm.ntmFlags);

 if((FontType & TRUETYPE_FONTTYPE) || (FontType & DEVICE_FONTTYPE))
 {
  fn=(fontenumfn)lParam;
  data.weight=lpelfe->elfLogFont.lfWeight;
  data.italic=lpelfe->elfLogFont.lfItalic;
  data.emheight=lpntme->ntmTm.ntmCellHeight;
  data.emsize=lpntme->ntmTm.ntmSizeEM;
  data.emwidth=lpntme->ntmTm.ntmAvgWidth;
  data.charset=lpelfe->elfLogFont.lfCharSet;
  data.pitch=lpelfe->elfLogFont.lfPitchAndFamily & 0x1;
  data.family=(lpelfe->elfLogFont.lfPitchAndFamily & 0xF0)>>4;
		data.bold=((lpntme->ntmTm.ntmFlags & NTM_BOLD)!=0);
		data.regular=((lpntme->ntmTm.ntmFlags & NTM_REGULAR)!=0);

//#define NTM_PS_OPENTYPE (1<<17)
//#define NTM_TT_OPENTYPE	(1<<18)

		if(FontType & TRUETYPE_FONTTYPE)
		{
   if((lpntme->ntmTm.ntmFlags & NTM_TT_OPENTYPE) ||
						(lpntme->ntmTm.ntmFlags & NTM_PS_OPENTYPE)) data.type=FONTENUM_OT;
			else
			if((lpntme->ntmTm.ntmFlags & NTM_TYPE1))	data.type=FONTENUM_T1;
			else																																					data.type=FONTENUM_TT;
		}
		else
		{
			data.type=FONTENUM_T1;
		}

  fnenumerr=fn((char*)lpelfe->elfLogFont.lfFaceName,(char*)lpelfe->elfFullName,&data);
 }

 return((fnenumerr==NULL)?1:0); //carry on
}



os_error * font_enumerate(font_description * fd,fontenumfn fn)
{
 os_error * err;
 LOGFONT    logf;
 

 err=graphicscheck(0);
 if(!err)
 {
  memset(&logf,0,sizeof(LOGFONT));
  logf.lfCharSet=(unsigned char)fd->charset;

  if(fd->name[0]) strcpy(logf.lfFaceName,fd->name);
// Win 9X needs a null pointer for a null fontname
// nested enum seems to corrupt Arial on Win 9X
// a comment that makes more sense for EnumFontFamilies  27/1/2006

  fnenumerr=NULL;

  EnumFontFamiliesEx(currenthdcptr->hdc,&logf,(FONTENUMPROC)EnumFontFamExProc,(LPARAM)fn,0);

  err=fnenumerr;

  graphicsclear();
 }

 return(err);
}








static char * findsplit(char * s,int len,int split)
{
 char * lt;
 char * last;
 int    ch;

 lt=s+len;
 last=s;

 while(s<=lt)
 {
  if((ch=*s++)==split)
  {
   last=s-1;
  }
 }

 return(last);
}






os_error * font_strwidth2(font_string * fs,oshdc hdcptr)
{
 os_error * err;
 SIZE       size;
 int        count;
 int      * exts;
 char     * s;
 int        len;


 err=NULL;

 len=strlen(fs->s);
 len=MIN(len,fs->term);

// cprintf("strwidth len %d",len);

 if(fs->split<0)
 {
  GetTextExtentExPoint(((hdcstr*)hdcptr)->hdc,fs->s,len,fs->x,&count,NULL,&size);
  fs->term=count;
  fs->y=size.cy;
  fs->x=size.cx;
 }
 else
 {
  err=flex_alloc((flex_ptr)&exts,sizeof(int)*len);
  if(!err)
  {
   GetTextExtentExPoint(((hdcstr*)hdcptr)->hdc,fs->s,len,fs->x,&count,exts,&size);

   if(fs->split>=0 && count<len)
   {
    s=findsplit(fs->s,count,fs->split);
    count=s-fs->s;
   }

   fs->term=count;
   if(count) fs->x=exts[count-1];
   else      fs->x=0;
   fs->y=size.cy;

   flex_free((flex_ptr)&exts);
  }
 }

// cprintf("ex term %d",fs->term);

 return(err);
}



os_error * font_strwidth(font_string * fs)
{
 return(font_strwidth2(fs,(oshdc)currenthdcptr));
}




os_error * font_extent2(font_string * fs,int * exts,oshdc hdcptr)
{
 SIZE size;
 int  count;

 if(GetTextExtentExPoint(((hdcstr*)hdcptr)->hdc,fs->s,fs->term,fs->x,&count,exts,&size)==0) count=0;

 fs->term=count;
 if(count) fs->x=exts[count-1];
 else      fs->x=0;
 fs->y=size.cy;

 return(NULL);
}



os_error * font_extent(font_string * fs,int * exts)
{
 return(font_extent2(fs,exts,(oshdc)currenthdcptr));
}









os_error * font_placement2(font_string * fs,int * exts,int xflags,oshdc hdcptr)
{
 os_error    * err;
 int           flags;
 GCP_RESULTS   results;
 int           i;

 err=NULL;

 flags=0;

 if(xflags & FP_KERNING) flags|=GCP_USEKERNING;
 if(xflags & FP_EXTENT)  flags|=GCP_MAXEXTENT;


 memset(&results,0,sizeof(results));
 results.lStructSize=sizeof(GCP_RESULTS);
 results.lpDx=exts;
 results.nGlyphs=fs->term;
// cprintf("placement %s size %d",fs->s,fs->term);

 if((flags & GCP_MAXEXTENT) && fs->x<=0)
 {
  fs->term=0;
  fs->x=0;
 }
 else
 {
  // seemingly if there is not space for at least one char the number of chars
  // returned is wonky

  err=XGetCharacterPlacement(((hdcstr*)hdcptr)->hdc,fs->s,fs->term,fs->x,&results,flags);
  if(!err)
  {
//   cprintf("nmax %d",results.nMaxFit);
   if((flags & GCP_MAXEXTENT) && fs->x<=exts[0])
   {
    fs->term=0;
    fs->x=0;
   }
   else
   {
    fs->term=results.nMaxFit;
    fs->x=0;
    for(i=0;i<fs->term;i++) fs->x+=exts[i];
   }
  }
 }

 fs->y=0;

 return(err);
}



os_error * font_placement(font_string * fs,int * exts,int xflags)
{
 return(font_placement2(fs,exts,xflags,(oshdc)currenthdcptr));
}



os_error * font_placement162(font_string16 * fs,int * exts,int xflags,oshdc hdcptr)
{
 os_error    * err;
 int           flags;
 GCP_RESULTSW  results;
 int           i;

 err=NULL;

 flags=0;

 if(xflags & FP_KERNING) flags|=GCP_USEKERNING;
 if(xflags & FP_EXTENT)  flags|=GCP_MAXEXTENT;


 memset(&results,0,sizeof(results));
 results.lStructSize=sizeof(GCP_RESULTS);
 results.lpDx=exts;
 results.nGlyphs=fs->term;

 if((flags & GCP_MAXEXTENT) && fs->x<=0)
 {
  fs->term=0;
  fs->x=0;
 }
 else
 {
  // seemingly if there is not space for at least one char the number of chars
  // returned is wonky

  err=XGetCharacterPlacementW(((hdcstr*)hdcptr)->hdc,fs->s,fs->term,fs->x,&results,flags);
  if(!err)
  {
//   cprintf("nmax %d",results.nMaxFit);
   if((flags & GCP_MAXEXTENT) && fs->x<=exts[0])
   {
    fs->term=0;
    fs->x=0;
   }
   else
   {
    fs->term=results.nMaxFit;
    fs->x=0;
    for(i=0;i<fs->term;i++) fs->x+=exts[i];
   }
  }
 }

 fs->y=0;

 return(err);
}




os_error * font_placement16(font_string16 * fs,int * exts,int xflags)
{
 return(font_placement162(fs,exts,xflags,(oshdc)currenthdcptr));
}



os_error * font_stringbbox162(wchar_t * s,font_info * fi,oshdc hdcptr)
{
 os_error  * err;
 SIZE        size;
 wchar_t   * p;
 font_info   fi2;
 int         c;


 err=XGetTextExtentPoint32W(((hdcstr*)hdcptr)->hdc,s,wcslen(s),&size);
 if(!err)
 {
  fi->minx=0;
  fi->miny=0;
  fi->maxx=size.cx;
  fi->maxy=0;

//  graphicsostext2((hdcstr*)hdcptr);

  p=s;
  while(1)
  {
   c=*p++;
   if(c==0) break;
   err=font_chardata162(c,&fi2,NULL,NULL,hdcptr);
   if(err) break;
   fi->miny=MIN(fi->miny,fi2.miny);
   fi->maxy=MAX(fi->maxy,fi2.maxy);
  }

//  graphicsriscos2((hdcstr*)hdcptr);
 }

 return(err);
}



os_error * font_stringbbox2(char * s,font_info * fi,oshdc hdcptr)
{
 os_error  * err;
 SIZE        size;
 char      * p;
 font_info   fi2;
 int         c;


 err=XGetTextExtentPoint32(((hdcstr*)hdcptr)->hdc,s,strlen(s),&size);
 if(!err)
 {
  fi->minx=0;
  fi->miny=0;
  fi->maxx=size.cx;
  fi->maxy=0;

//  graphicsostext2((hdcstr*)hdcptr);

  p=s;
  while(1)
  {
   c=*p++;
   if(c==0) break;
   err=font_chardata2(c,&fi2,NULL,NULL,hdcptr);
   if(err) break;
   fi->miny=MIN(fi->miny,fi2.miny);
   fi->maxy=MAX(fi->maxy,fi2.maxy);
  }

//  graphicsriscos2((hdcstr*)hdcptr);
 }

 return(err);
}






os_error *font_stringbbox(char * s,font_info * fi)
{
 return(font_stringbbox2(s,fi,(oshdc)currenthdcptr));
}



os_error *font_stringbbox16(wchar_t * s,font_info * fi)
{
 return(font_stringbbox162(s,fi,(oshdc)currenthdcptr));
}




os_error * font_chardata2(int c,font_info * i,int * w,int * h,oshdc hdcptr)
{
 GLYPHMETRICS gm;
 MAT2         mat2;
 int          code;

 memset(&mat2,0,sizeof(MAT2));
 mat2.eM11.value=1;
 mat2.eM22.value=1;

 // GetGlyphOutline returns device units

 code=GetGlyphOutline(((hdcstr*)hdcptr)->hdc,c,GGO_METRICS,&gm,0,NULL,&mat2);


 if(i)
 {
  i->maxx=gm.gmptGlyphOrigin.x+(int)gm.gmBlackBoxX;
  i->minx=gm.gmptGlyphOrigin.x;
  i->maxy=gm.gmptGlyphOrigin.y;
  i->miny=gm.gmptGlyphOrigin.y-(int)gm.gmBlackBoxY;
 }

 if(w) *w=gm.gmCellIncX;
 if(h) *h=gm.gmCellIncY;


 return(NULL);
}


os_error * font_chardata162(int c,font_info * i,int * w,int * h,oshdc hdcptr)
{
 GLYPHMETRICS gm;
 MAT2         mat2;
 int          glyph;

 memset(&mat2,0,sizeof(MAT2));
 mat2.eM11.value=1;
 mat2.eM22.value=1;

// there's a problem with Symbol fonts, these don't have Unicode chars
// below 256, if really need to handle codes < 256 direct would need
// a table to convert from code to Unicode index
// need charset mapping on code...

// all this is OK on True Type fonts only


 if(ISW9X)
 {
  if(c>255)
  {
   glyph=GetTTUnicodeGlyphIndex(((hdcstr*)hdcptr)->hdc,(unsigned short)c);
   if(glyph)
   {
   // GetGlyphOutline returns device units

    GetGlyphOutline(((hdcstr*)hdcptr)->hdc,glyph,GGO_GLYPH_INDEX,&gm,0,NULL,&mat2);
   }
   else
   {
    memset(&gm,0,sizeof(gm));
   }
  }
  else
  {
   GetGlyphOutline(((hdcstr*)hdcptr)->hdc,c,GGO_METRICS,&gm,0,NULL,&mat2);
  }
 }
 else
 {
 // GetGlyphOutline returns device units

  GetGlyphOutlineW(((hdcstr*)hdcptr)->hdc,c,GGO_METRICS,&gm,0,NULL,&mat2);
 }

 if(i)
 {
  i->maxx=gm.gmptGlyphOrigin.x+(int)gm.gmBlackBoxX;
  i->minx=gm.gmptGlyphOrigin.x;
  i->maxy=gm.gmptGlyphOrigin.y;
  i->miny=gm.gmptGlyphOrigin.y-(int)gm.gmBlackBoxY;
 }

 if(w) *w=gm.gmCellIncX;
 if(h) *h=gm.gmCellIncY;

 return(NULL);
}


os_error * font_chardata(int c,font_info * i,int * w,int * h)
{
 return(font_chardata2(c,i,w,h,(oshdc)currenthdcptr));
}


os_error * font_chardata16(int c,font_info * i,int * w,int * h)
{
 return(font_chardata162(c,i,w,h,(oshdc)currenthdcptr));
}


/*
typedef struct tagWCRANGE {
  WCHAR  wcLow;
  USHORT cGlyphs;
} WCRANGE, *PWCRANGE;


typedef struct tagGLYPHSET {
  DWORD    cbThis;
  DWORD    flAccel;
  DWORD    cGlyphsSupported;
  DWORD    cRanges;
  WCRANGE  ranges[1];
} GLYPHSET, *PGLYPHSET;

*/

/*

DWORD GetFontUnicodeRanges(
  HDC hdc,         // handle to DC
  PGLYPHSET pgs  // glyph set
);

*/


typedef DWORD (WINAPI * gfnfn)(HDC hdc,PGLYPHSET pgs);

/*
static int gcmpfn(const void * p1,const void * p2)
{
 return((*(int*)p1)-(*(int*)p2));
}
*/


os_error * font_glyphs(oshdc hdcptr,int ** glyphs,int * nglyph)
{
	os_error * err;
	DWORD      size;
	GLYPHSET * gs;  // glyph set
	FARPROC    farproc;
	HMODULE    handle;
	int        i;

	err=NULL;

	*glyphs=NULL;

	farproc=NULL;
 XGetModuleHandle(TEXT("GDI32"),&handle);
	if(handle) XGetProcAddress(handle,TEXT("GetFontUnicodeRanges"),&farproc);
	if(farproc)
	{
  size=((gfnfn)farproc)(((hdcstr*)hdcptr)->hdc,NULL);

 	gs=(GLYPHSET*)malloc(size);
 	if(gs)
		{
   ((gfnfn)(*farproc))(((hdcstr*)hdcptr)->hdc,gs);

			err=salloc((flex_ptr)glyphs,(gs->cRanges+1)*2*sizeof(int));
			if(!err)
			{
				for(i=0;i<(int)gs->cRanges;i++)
				{
					(*glyphs)[i*2]=gs->ranges[i].wcLow;
					(*glyphs)[i*2+1]=gs->ranges[i].cGlyphs;
				}

//				qsort(*glyphs,(int)gs->cRanges,2*sizeof(int),gcmpfn);

    (*glyphs)[i*2]=0;
    (*glyphs)[i*2+1]=0;
    *nglyph=i;
			}

 		free(gs);
		}
	}
	else
	{
  GetTTGlyphs(((hdcstr*)hdcptr)->hdc,glyphs,nglyph);
	}

 return(err);   
}


typedef DWORD (WINAPI * ggifn)(HDC hdc,LPCTSTR lpstr,int c,LPWORD pgi,DWORD fl);


os_error * font_glyphindices16(oshdc hdcptr,wchar_t * s,int n,unsigned short int * indexp)
{
	os_error * err;
	FARPROC farproc;
	HMODULE handle;


	farproc=NULL;
 err=XGetModuleHandle(TEXT("GDI32"),&handle);
	if(!err && handle) err=XGetProcAddress(handle,"GetGlyphIndicesW",&farproc);
	if(!err && farproc)
	{
  ((ggifn)farproc)(((hdcstr*)hdcptr)->hdc,(char*)s,n,indexp,0);

	}

	return(err);
}







os_error * font_setjustification(int space,int brks)
{
 SetTextJustification(currenthdcptr->hdc,space,brks);
 return(NULL);
}



os_error * font_setjustification2(int space,int brks,oshdc hdcptr)
{
 SetTextJustification(((hdcstr*)hdcptr)->hdc,space,brks);
 return(NULL);
}



os_error * font_setextraspace(int space)
{
 SetTextCharacterExtra(currenthdcptr->hdc,space);
 return(NULL);
}



os_error * font_setextraspace2(int space,oshdc hdcptr)
{
 SetTextCharacterExtra(((hdcstr*)hdcptr)->hdc,space);
 return(NULL);
}


os_error * font_kerningdata2(font_kerningdatastr * data,int * npairs,oshdc hdcptr)
{
 if(data==NULL) *npairs=0; // upsets W98 otherwise

 *npairs=GetKerningPairs(((hdcstr*)hdcptr)->hdc,*npairs,(LPKERNINGPAIR)data);

 return(NULL);
}


os_error * font_kerningdata162(font_kerningdatastr * data,int * npairs,oshdc hdcptr)
{
 if(data==NULL) *npairs=0; // upsets W98 otherwise

 if(ISW9X)     // temp fix
 {
  *npairs=GetKerningPairs(((hdcstr*)hdcptr)->hdc,*npairs,(LPKERNINGPAIR)data);
 }
 else
 {
  *npairs=GetKerningPairsW(((hdcstr*)hdcptr)->hdc,*npairs,(LPKERNINGPAIR)data);
 }

 return(NULL);
}


os_error * font_kerningdata(font_kerningdatastr * data,int * npairs)
{
 return(font_kerningdata2(data,npairs,(oshdc)currenthdcptr));
}


os_error * font_kerningdata16(font_kerningdatastr * data,int * npairs)
{
 return(font_kerningdata162(data,npairs,(oshdc)currenthdcptr));
}



static int fxfncalled;

static os_error * fxfn(char * facename,char * fullfontname,font_enumdata * data)
{
 fxfncalled=1;
// cprintf("face %s full %s",facename,fullfontname);
 return(NULL);

 USE(facename);
 USE(fullfontname);
 USE(data);
}


// CreateFont, then read, doesn't return actual font name

os_error * font_exists(char * facename,int * exists)
{
 os_error         * err;
 font_description   fd;

 err=NULL;

 fxfncalled=0;
 fd.charset=DEFAULT_CHARSET;   // was ANSI
 strcpy(fd.name,facename);

 font_enumerate(&fd,fxfn);

 *exists=fxfncalled;

 return(err);
}




static char * fontsubkey="HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\FontSubstitutes";

#define FSCHUNK 0x400


static int ftcmpfn(const void * p1,const void * p2)
{
 return(_tcsicmp(((fontsubtablestr*)p1)->facename,((fontsubtablestr*)p2)->facename));
}



os_error * font_subtable(fontsubtablestr	** tablep,int * ntable)
{
	os_error * err;
	oskeyh     key;
	int        eof;
	int        index;
	TCHAR      value[128];
	int        type;
	int        valuesize;
	TCHAR      data[128];
	int        datasize;
	char     * mem=NULL;
	int        memsize;
	int       	n;
	fontsubtablestr	* table;
	TCHAR    * p;
	int        i;
	TCHAR    * q;

	n=0;
	table=NULL;

	err=regopenkey(fontsubkey,&key,'r');
	if(err)
	{
		err=NULL; // not going to cause trouble over missing key
	}
	else
	{
		index=0;
		memsize=0;

		err=salloc((flex_ptr)&mem,FSCHUNK);
		if(!err)
		{
 		while(1)
 		{
 			valuesize=NITEM(value);
 			datasize=sizeof(data); // NB bytes not TCHARs
 			err=regenumvalue(key,value,&valuesize,&type,data,&datasize,&eof,&index);
 			if(err || eof) break;

 			if(type==REG_SZ)
 			{
 				err=schunk((flex_ptr)&mem,memsize+(valuesize+1)*sizeof(TCHAR)+(datasize+1),FSCHUNK);
	 			if(err) break;

 				ustrcpy((TCHAR*)(mem+memsize),value);
 				memsize+=ustrlen((TCHAR*)(mem+memsize))+sizeof(TCHAR);
 				ustrcpy((TCHAR*)mem+memsize,data);
 				memsize+=ustrlen((TCHAR*)(mem+memsize))+sizeof(TCHAR);
 				n++;
 			}
 		}
 		err=regclosekey(&key,err);

			if(!err)
			{
				err=schunk((flex_ptr)&mem,memsize+n*sizeof(fontsubtablestr),FSCHUNK);
				if(!err)
				{
					memmove(mem+n*sizeof(fontsubtablestr),mem,memsize);

					p=(TCHAR*)(mem+n*sizeof(fontsubtablestr));
     table=(fontsubtablestr*)mem;

					for(i=0;i<n;i++)
					{
						table[i].facename=p;
						p+=ustrlen(p)+1;
						table[i].subname=p;
						p+=ustrlen(p)+1;

						q=_tcschr(table[i].facename,',');
						if(q) *q=0;
						q=_tcschr(table[i].subname,',');
						if(q) *q=0;
					}

					qsort(table,n,sizeof(fontsubtablestr),ftcmpfn);
				}
			}




//					for(i=0;i<n;i++)
//					{
//						cprintf("face %s sub %s",table[i].facename,table[i].subname);
//					}


			if(err) sfree((flex_ptr)&mem);
		}
	}

	*tablep=table;
	*ntable=n;

	return(err);
}


os_error * font_subtablefree(fontsubtablestr	** tablep)
{
	return(sfree((flex_ptr)tablep));
}

