
#include <stdafx.h>

#include <stdio.h>
#include <stdlib.h>


#include "resource.h"

#include "commctrl.h"

#include "os.h"
#include "wimp.h"
#include "fsx.h"
#include "etc.h"
#include "userdraw.h"
#include "wos.h"
#include "poll.h"
#include "comctls.h"
#include "temp.h"
#include "deb.h"
#include "bits.h"
#include "fs_dirutils.h"

#include "getdir.h"



#define MAX_DRIVE _MAX_DRIVE


static getdirfn getdirgetdirfn;


static listboxh  listboxhandle;
static comboboxh comboboxhandle;
static char getdirpath[MAX_PATH];
static int  getdirpathlevel;
static wimp_w getdirparent;







static os_error * createlistboxcontents(char * path)
{
 os_error * err;
 int        tabn;
 char     * p;
 char       temp[256];
 char       temp1[256];
 char       rpath[MAX_PATH];
 fstat2   * dirstat2;
 char     * dirstring;
 int        dirstringn;
 int        i;
 SHFILEINFO shfi;
 HIMAGELIST hSysImgList;


 err=NULL;

 tabn=0;
 p=path;
 rpath[0]=0;
 while(1)
 {
  p=getpathitem(p,temp,sizeof(temp)/sizeof(TCHAR));
  if(!p) break;

  strcat(rpath,temp);
  if(tabn==0)
  {
   strcat(rpath,"\\");
   strcat(temp,"\\");
  }

  hSysImgList=(HIMAGELIST)SHGetFileInfo(rpath, 0, &shfi, sizeof(SHFILEINFO), 
                                           SHGFI_SMALLICON | SHGFI_ICON | SHGFI_LINKOVERLAY | SHGFI_SYSICONINDEX |SHGFI_OPENICON);

  unquoteicontext(temp1,temp,sizeof(temp1)/sizeof(TCHAR));
  xsprintf(sizeof(temp)/sizeof(TCHAR),NULL,temp,"\\t%d\\l%d %d\\s%s",tabn*8,hSysImgList,shfi.iIcon,temp1);
  cc_addlistboxstring(listboxhandle,temp);

  if(tabn>0) strcat(rpath,"\\");
  tabn++;
 }

 cprintf("getdirectory %s",path);

 err=getdirectory(&dirstringn,&dirstring,&dirstat2,path,"*.*",GETDIRDIR|GETDIRHIDDEN|GETDIRSYSTEM);
 if(!err)
 {
  sortdirectory(dirstringn,dirstring,dirstat2);
  p=rpath+strlen(rpath);
  for(i=0;i<dirstringn;i++)
  {
   unquoteicontext(temp1,dirstring+dirstat2[i].name,sizeof(temp1)/sizeof(TCHAR));
   strcpy(p,dirstring+dirstat2[i].name);
   hSysImgList=(HIMAGELIST)SHGetFileInfo(rpath, 0, &shfi, sizeof(SHFILEINFO), 
                                           SHGFI_SMALLICON | SHGFI_ICON | SHGFI_LINKOVERLAY | SHGFI_SYSICONINDEX);

   // this gives the dir name at an offset of 16 chars
   xsprintf(sizeof(temp)/sizeof(TCHAR),NULL,temp,"\\t%d\\l%d %d\\s%s",tabn*8,hSysImgList,shfi.iIcon,temp1);

   cc_addlistboxstring(listboxhandle,temp);
  }
  freedirectory(&dirstring,&dirstat2);
 }

 return(err);
}







static os_error * createcomboboxcontents(char * path,wimp_w handle)
{
 os_error * err;
 char       drivestring[256];
 char     * p;
 char       temp[64];
 char       temp1[64];
 char       drive[MAX_DRIVE];
 int        index;
 int        n;

 err=NULL;

 getdrive(path,drive);

 index=0;
 n=0;

 GetLogicalDriveStrings(sizeof(drivestring)/sizeof(TCHAR),drivestring);
 p=drivestring;
 while(*p)
 {
  SHFILEINFO shfi;
  HIMAGELIST hSysImgList;

  hSysImgList=(HIMAGELIST)SHGetFileInfo(p, 0, &shfi, sizeof(SHFILEINFO), 
                                           SHGFI_SMALLICON | SHGFI_ICON | SHGFI_LINKOVERLAY | SHGFI_SYSICONINDEX);

  unquoteicontext(temp1,p,sizeof(temp1)/sizeof(TCHAR));
  xsprintf(sizeof(temp)/sizeof(TCHAR),NULL,temp,"\\l%d %d\\s%s",hSysImgList,shfi.iIcon,temp1);
//  cprintf("list %s",temp);
  cc_addcomboboxstring(comboboxhandle,temp);

  if(!_stricmp(drive,p))
  {
   index=n;
  }

  p=p+strlen(p)+1;
  n++;
 }

 cc_selectcombobox(comboboxhandle,index);

 return(err);

 USE(handle);
}







static os_error * listboxevent(int event,wimp_w handle,uservalue userhandle,int data,void * datap)
{
 os_error * err;
 char       string[MAX_PATH];
 char     * p;
 int        newindex=0;

 err=NULL;

 if(event==CC_LISTBOXDBLE)
 {
  cc_getlistboxstring(listboxhandle,data,string,sizeof(string)/sizeof(TCHAR));
//  cprintf("dble %d pathlevel %d %s",data,getdirpathlevel,string);
  if(data<getdirpathlevel)
  {
   p=pathleveln(getdirpath,data+1);
   newindex=data;
   if(data==0) *p=0;
   else        *(p-1)=0;
  }
  else
  if(data>getdirpathlevel)   // problem here is that you can get double "\\"
  {
   if(getdirpathlevel>0) strcat(getdirpath,"\\");
   p=strstr(string,"\\s");
   if(p)
   {
    strcat(getdirpath,p+2);
    newindex=getdirpathlevel+1;
   }
  }
  else
  {
//   if(getdirgetdirfn) getdirgetdirfn(getdirpath);
   newindex=-1;
  }

  if(newindex>=0)
  {
   err=parsepath(getdirpath,&getdirpathlevel);
   cc_clearlistbox(listboxhandle);
   createlistboxcontents(getdirpath);
   cc_selectlistbox(listboxhandle,newindex);
   writeicon(handle,IDC_GETDIR_NAME,getdirpath);
  }
 }


 return(err);

 USE(datap);
 USE(userhandle);
}




static os_error * comboboxevent(int event,wimp_w handle,uservalue userhandle,int data,void * datap)
{
 os_error * err;
 char     * p;
 int        itype;
 char       itemtext[512];
 char       temp[512];

 err=NULL;

 if(event==CC_COMBOBOXSELECT)
 {
  readicon(handle,IDC_GETDIR_DRIVE,temp,sizeof(temp)/sizeof(TCHAR));

  p=temp;

  while(*p)
  {
   p=getitem(p,&itype,itemtext);
   if(itype=='s')
   {
    xzstrncpy(getdirpath,itemtext,sizeof(getdirpath)/sizeof(TCHAR)); // here getdirpath gets asigned things like C:/
   }
  }                     

  err=parsepath(getdirpath,&getdirpathlevel);
  cc_clearlistbox(listboxhandle);
  createlistboxcontents(getdirpath);
  writeicon(handle,IDC_GETDIR_NAME,getdirpath); 
 }

 return(err);

 USE(datap);
 USE(data);
 USE(userhandle);
}


static os_error * getdirclick(wimp_w handle,uservalue userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {

  case IDCANCEL:
      case IDOK:
                err=enablewindow(getdirparent,1,0);
                cc_remlistbox(listboxhandle);
                cc_remcombobox(comboboxhandle);
                remclickevent(getdirclick,handle,0);
                closedown(&handle);
                if(getdirgetdirfn && m->i==IDOK) getdirgetdirfn(getdirpath);
                break;
 }

 return(NULL);
 USE(userhandle);
}









// copy to dest, as much of src as exists on disc.

static os_error * validatepath(char * dest,char * src)
{
 char * p;
 char   item[MAX_PATH];
 char * q;
 int    type;


 *dest=0;

 p=getpathitem(src,item,sizeof(item)/sizeof(TCHAR));
 if(p)
 {
  strcpy(dest,item);
  strcat(dest,"\\");

  // good disc drive?

  fs_exists(dest,&type);
  if(type)
  {
   while(1)
   {
    q=dest+strlen(dest);
    p=getpathitem(p,item,sizeof(item)/sizeof(TCHAR));
    if(!p) break;

    if(*(q-1)!='\\')
    {
     strcpy(q,"\\");
    }
    strcat(q,item);
    fs_exists(dest,&type);
    if(type==0)
    {
     *q=0;
     break;
    // does dest exist?
    }
   }
  }
 }

 if(*dest==0)
 {
  strcpy(dest,"c:\\");
 }

 return(NULL);
}





os_error * getdir(wimp_w parent,char * path,getdirfn xgetdirfn)
{
 os_error * err;
 wimp_w     handle;

 getdirgetdirfn=xgetdirfn;
 validatepath(getdirpath,path);
 getdirparent=parent;

 err=createwindow(TGETDIR,&handle);
 if(!err)
 {
           err=addclickevent(getdirclick,handle,0);
  if(!err) err=writeicon(handle,IDC_GETDIR_NAME,path);
  if(!err) err=cc_addcombobox(handle,0,IDC_GETDIR_DRIVE,&comboboxhandle,comboboxevent);
  if(!err) err=cc_addlistbox(handle,0,IDC_GETDIR_LIST,&listboxhandle,listboxevent);
  if(!err) err=parsepath(getdirpath,&getdirpathlevel);
  if(!err) err=createcomboboxcontents(path,handle);
  if(!err) err=createlistboxcontents(path);
  if(!err) err=enablewindow(getdirparent,0,0);

  if(!err) err=popup(handle,0);
  if(!err) err=iecarrot(handle,IDC_GETDIR_NAME);
 }

 return(err);
}



static templates temptable[]=
{
 TGETDIR,1,0,"GetDir",

 TLAST,  0,0,""
};


static templink templatelink;



os_error * getdirinit(void)
{
 return(addtemplates(NULL,NULL,temptable,&templatelink));
}
