#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>


#include "os.h"


#include "flex.h"
#include "alloc.h"
#include "wimpt.h"
#include "wimp.h"


#include "fsx.h"
#include "bf.h"
#include "wos.h"
#include "task.h"
#include "oserr.h"
#include "deb.h"
#include "osglue.h"
#include "bits.h"
#include "etc.h"


#include "icons.h"





icon_area * icons;




#define ICSIZE (sizeof(icon_area)+32*sizeof(icon_header))




static BOOL CALLBACK iconload(
  HMODULE hModule,   // module handle
  LPCTSTR lpszType, // pointer to resource type
  LPTSTR lpszName,  // pointer to resource name
  LPARAM lParam       // application-defined parameter
)
{
 os_error     * err;
 icon_area    * spa;
 icon_header  * sph;
 void         * ptr=NULL;     // compiler
 HANDLE         hDialog=NULL; // compiler
 HRSRC          hRsrc=NULL;   // compiler



 spa=*((icon_area**)lParam);

 err=flex_chunk((flex_ptr)lParam,
                sizeof(icon_area)+spa->nicons*sizeof(icon_header),ICSIZE);

 if(!err) err=XFindResource(hModule,lpszName,lpszType,&hRsrc);
 if(!err) err=XLoadResource(hModule,hRsrc,(HGLOBAL*)&hDialog);
 if(!err) err=XLockResource(hDialog,(LPVOID*)&ptr);
 if(!err)
 {
  spa=*((icon_area**)lParam);

  sph=spa->icon+spa->nicons;
  strcpy(sph->name,lpszName);
  sph->ptr=ptr;

 cprintf("icon name %s ptr %x",lpszName,ptr);


  spa->nicons++;
 }
 return(TRUE);
}
 


static os_error * addiconss(char * path,char * leaf,icon_area ** icons)
{
 os_error  *   err;

 if(path)
 {
  err=NULL;
  USE(leaf);
 }
 else
 {
  err=XEnumResourceNames(AppInstance,RT_GROUP_ICON,iconload,(LPARAM)icons);
 }

 return(err);
}




os_error * addiconsxs(char * path,char * leaf,icon_area ** icons)
{
 os_error * err;

 err=addiconss(path,leaf,icons);

 return(err);
}



os_error * addiconsx(char * path,char * leaf)
{
 return(addiconsxs(path,leaf,(icon_area**)&icons));
}






os_error * initiconss(icon_area ** icons)
{
 os_error     * err;
 icon_area    * xspa;

 err=flex_alloc((flex_ptr)icons,ICSIZE);
 if(!err)
 {
  xspa=(icon_area*)(*icons);
  xspa->nicons=0;
 }

 return(err); 
}



os_error * initicons(void)
{
 return(initiconss((icon_area**)&icons));
}






int * iconfind(icon_area * areap,char * name)
{
 int              nicons;
 int              i;
 icon_area      * xspa;
 icon_header    * xsph;

 xspa=(icon_area*)areap;

 nicons=xspa->nicons;
 xsph=xspa->icon;

 for(i=0;i<nicons;i++)
 {
  if(!cstrncmp(xsph->name,name,ICHDRNAMELEN))
  {
   return((int*)xsph->ptr);
  }
  xsph++;
 }

 return(NULL);
}




