
#define WRHDCUPDATE 0x1


typedef struct hdcstr
{
 HDC         hdc;
 PAINTSTRUCT paintstruct;
 HPEN        currentpen;
 HPEN        basepen;
 HBRUSH      currentbrush;
 HBRUSH      basebrush;
 HFONT       currentfont;
 HFONT       basefont;
 int         cgox;
 int         cgoy;
 int         osxres;
 int         osyres;
 int         vduxres;
 int         vduyres;

 int         flags;
 int         x0;
 int         x1;
 int         y0;
 int         y1;

 int         ox;
 int         oy;
 int         vx;
 int         vy;

 hdcstr    * next;
 hdcstr    * prev;

} hdcstr;



typedef struct graphicssavestr
{
 int         osxres;
 int         osyres;
 int         vduxres;
 int         vduyres;

 int         ox;
 int         oy;
 int         vx;
 int         vy;

}	graphicssavestr;






#define GRXPIX(x) (scalenr((x)-currenthdcptr->ox,currenthdcptr->vduxres,currenthdcptr->osxres)+currenthdcptr->vx)
#define GRYPIX(y) (scalenr((y)-currenthdcptr->oy,currenthdcptr->vduyres,-currenthdcptr->osyres)+currenthdcptr->vy)
#define GRFXPIX(x) (scalenr((x)-400*currenthdcptr->ox,currenthdcptr->vduxres,400*currenthdcptr->osxres)+currenthdcptr->vx)
#define GRFYPIX(y) (scalenr((y)-400*currenthdcptr->oy,currenthdcptr->vduyres,-400*currenthdcptr->osyres)+currenthdcptr->vy)
#define GRDXPIX(x) (scalenr((x)-256*currenthdcptr->ox,currenthdcptr->vduxres,256*currenthdcptr->osxres)+currenthdcptr->vx)
#define GRDYPIX(y) (scalenr((y)-256*currenthdcptr->oy,currenthdcptr->vduyres,-256*currenthdcptr->osyres)+currenthdcptr->vy)



#define GRINVXPIX(x) (scalenr((x)-currenthdcptr->vx,currenthdcptr->osxres,currenthdcptr->vduxres)+currenthdcptr->ox)
#define GRINVYPIX(y) (scalenr((y)-currenthdcptr->vy,currenthdcptr->osyres,-currenthdcptr->vduyres)+currenthdcptr->oy)

#define GRINVDXPIX(x) (scalenr((x)-currenthdcptr->vx,256*currenthdcptr->osxres,currenthdcptr->vduxres)+256*currenthdcptr->ox)
#define GRINVDYPIX(y) (scalenr((y)-currenthdcptr->vy,256*currenthdcptr->osyres,-currenthdcptr->vduyres)+256*currenthdcptr->oy)

#define GRINVFXPIX(x) (scalenr((x)-currenthdcptr->vx,400*currenthdcptr->osxres,currenthdcptr->vduxres)+400*currenthdcptr->ox)
#define GRINVFYPIX(y) (scalenr((y)-currenthdcptr->vy,400*currenthdcptr->osyres,-currenthdcptr->vduyres)+400*currenthdcptr->oy)


extern hdcstr * currenthdcptr;


extern os_error * graphicsnewhdc(hdcstr ** hdcptr);
extern os_error * graphicsdeletehdc(hdcstr * hdcptr);
extern os_error * graphicssetfont2(HFONT newfont,hdcstr * hdcptr);
extern os_error * graphicslosefont(HFONT font);
extern os_error * graphicscreatepen2(int fnPenStyle,int nWidth,COLORREF crColor,hdcstr * hdcptr);
extern os_error * graphicscreatepenext2(DWORD dwPenStyle,DWORD dwWidth,CONST LOGBRUSH *lplb,
                                DWORD dwStyleCount,CONST DWORD *lpStyle,hdcstr * hdcptr);
extern os_error * graphicscreatesolidbrush2(COLORREF crColor,hdcstr * hdcptr);
extern os_error * graphicsfinit2(hdcstr * hdcptr);
extern os_error * graphicsriscos2(hdcstr * hdcptr);
extern os_error * graphicsscale2(int xres,int yres,hdcstr * hdcptr);
extern os_error * graphicsostext2(hdcstr * hdcptr);
extern os_error * graphicsscaleboth2(int xres,int yres,int vxres,int vyres,hdcstr * hdcptr);

extern os_error * graphicsbaseinit2(hdcstr * hdcptr);
extern os_error * graphicsinit2(int gox,int goy,hdcstr * hdcptr);

extern os_error * graphicssetcurrent(hdcstr * hdcptr);
extern os_error * graphicsclearcurrent(hdcstr * hdcptr);

extern os_error * graphicscreatehdcptr(hdcstr ** hdcptrp);
extern os_error * graphicsdeletehdcptr(hdcstr ** hdcptrp);

extern os_error * graphicscheck(int dc);
extern os_error * graphicsclear(void);

extern os_error * vduenterprintmode(hdcstr * hdcptr);
extern os_error * vduexitprintmode(void);


extern os_error * graphicspixel(hdcstr * hdcptr);
extern os_error * graphicsospixel(hdcstr * hdcptr);


extern os_error * graphicssave(hdcstr * hdcptr,graphicssavestr * saves);
extern os_error * graphicsload(hdcstr * hdcptr,graphicssavestr * saves);

extern os_error * grossave(graphicssavestr * saves);
extern os_error * grosload(graphicssavestr * saves);
extern os_error * grospixel(void);

extern os_error * graphicsworld(transformstr * tr,int * wmode);
