/*->c.werr */


#include <stdafx.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>
#include <stdarg.h>


#include "os.h"
#include "wimpt.h"

#include "trans.h"
#include "err.h"
#include "etc.h"
#include "deb.h"


#include "werr.h"



typedef int wimp_errflags;


static int werrlevel;


int errorlevel(void)
{
 return(werrlevel);
}



static int myreporterror(os_error* er,wimp_errflags flags)
{
// char string[sizeof(er->errmess)];

 if(er->errnum==EREPORTED) return(0);

//	*(int*)0=0;

// MessageBox(NULL,er->errmess,NULL,MB_OK);

// sprintf(string,"%s (%d)",er->errmess,er->errnum);

// we need TASKMODAL because	code is not multithreaded
// e.g. click on button bar button get error, don't clear error
// click on another button

 werrlevel++;

 MessageBox(NULL,er->errmess,wimpt_programtextname(),
            MB_OK | ((flags==0)?MB_ICONERROR:MB_ICONWARNING) | MB_TASKMODAL);	

 werrlevel--;

 return(0);
}




static int myreporterrors(char * message,wimp_errflags flags)
{
 os_error e;

 e.errnum=0;
 strcpy(&e.errmess[0],message);
 trans(e.errmess,sizeof(e.errmess));
 return(myreporterror(&e,flags));
}



static werrexitfn werrexit;

void werrsetexit(werrexitfn xwerrexit)
{
 werrexit=xwerrexit;
}


static void werrcallexit(int code)
{
 if(werrexit) werrexit(code);
 exit(code);
}


void werr(int flags,char* format,...)
{
 va_list va;
 os_error e;
 char     buff[256];
 int      len;



 e.errnum=0;
 va_start(va,format);

 strcpy(buff,format);
 trans(buff,sizeof(buff));

 VSNPRINTF(&e.errmess[0],sizeof(e.errmess),buff,va,len);

 va_end(va);

 trans(e.errmess,sizeof(e.errmess));


 myreporterror(&e,(wimp_errflags)(flags==WERRMSG?(16+1):0));

 if(flags==WERRFTL) werrcallexit(1);

}



void errorbox(char * message)
{
 myreporterrors(message,(wimp_errflags)0);
}


int messagebox(char * message)
{
 return(myreporterrors(message,(wimp_errflags)(1+16)));
}


void fatalerror(char * message)
{
 errorbox(message);
 werrcallexit(1);
}

void abend(os_error * e)
{
 /* if e is true, abend */
 if(e)
 {
  myreporterror(e,(wimp_errflags)0);
  werrcallexit(1);
 }
}


void report(os_error * e)
{
 if(e)
 {
  myreporterror(e,(wimp_errflags)0);
 }
}




void * errsave(os_error * err)
{
 void * eh;
 
 if(err)
 {
  eh=malloc(sizeof(os_error));
  if(eh)
  {
   *((os_error*)eh)=*err;
   return(eh);
  }
 }

 return(NULL);
}


os_error * errload(void * eh,os_error * err)
{
 static os_error eb;
 
 if(eh)
 {
  eb=*(os_error*)eh;
  free(eh);
  return(&eb);
 }

 return(err);
}